// $ANTLR 3.1.3 Mar 17, 2009 19:23:44 org\\apache\\uima\\ruta\\parser\\RutaParser.g 2013-05-07 11:06:29

/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
*/

package org.apache.uima.ruta.parser;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Stack;

import org.antlr.runtime.BaseRecognizer;
import org.antlr.runtime.BitSet;
import org.antlr.runtime.CommonToken;
import org.antlr.runtime.DFA;
import org.antlr.runtime.EarlyExitException;
import org.antlr.runtime.FailedPredicateException;
import org.antlr.runtime.IntStream;
import org.antlr.runtime.MismatchedSetException;
import org.antlr.runtime.NoViableAltException;
import org.antlr.runtime.Parser;
import org.antlr.runtime.RecognitionException;
import org.antlr.runtime.RecognizerSharedState;
import org.antlr.runtime.Token;
import org.antlr.runtime.TokenStream;
import org.apache.uima.resource.metadata.TypeSystemDescription;

import org.apache.uima.ruta.action.AbstractRutaAction;
import org.apache.uima.ruta.action.ActionFactory;
import org.apache.uima.ruta.condition.AbstractRutaCondition;
import org.apache.uima.ruta.condition.ConditionFactory;
import org.apache.uima.ruta.RutaAutomataBlock;
import org.apache.uima.ruta.RutaBlock;
import org.apache.uima.ruta.RutaModule;
import org.apache.uima.ruta.RutaScriptBlock;
import org.apache.uima.ruta.RutaScriptFactory;
import org.apache.uima.ruta.RutaAutomataFactory;
import org.apache.uima.ruta.RutaStatement;
import org.apache.uima.ruta.expression.ExpressionFactory;
import org.apache.uima.ruta.expression.RutaExpression;
import org.apache.uima.ruta.expression.bool.BooleanExpression;
import org.apache.uima.ruta.expression.list.BooleanListExpression;
import org.apache.uima.ruta.expression.list.ListExpression;
import org.apache.uima.ruta.expression.list.NumberListExpression;
import org.apache.uima.ruta.expression.list.StringListExpression;
import org.apache.uima.ruta.expression.list.TypeListExpression;
import org.apache.uima.ruta.expression.number.NumberExpression;
import org.apache.uima.ruta.expression.resource.WordListExpression;
import org.apache.uima.ruta.expression.resource.WordTableExpression;
import org.apache.uima.ruta.expression.string.StringExpression;
import org.apache.uima.ruta.expression.string.StringFunctionFactory;
import org.apache.uima.ruta.expression.type.TypeExpression;
import org.apache.uima.ruta.extensions.RutaExternalFactory;
import org.apache.uima.ruta.rule.AbstractRuleElement;
import org.apache.uima.ruta.rule.ComposedRuleElement;
import org.apache.uima.ruta.rule.RegExpRule;
import org.apache.uima.ruta.rule.RuleElement;
import org.apache.uima.ruta.rule.RuleElementContainer;
import org.apache.uima.ruta.rule.RuleElementIsolator;
import org.apache.uima.ruta.rule.RutaRule;
import org.apache.uima.ruta.rule.RutaRuleElement;
import org.apache.uima.ruta.rule.quantifier.RuleElementQuantifier;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
public class RutaParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "DocComment", "Annotation", "ListIdentifier", "TRIE", "CONTAINS", "DECLARE", "WORDLIST", "WORDTABLE", "AND", "CONTEXTCOUNT", "COUNT", "TOTALCOUNT", "CURRENTCOUNT", "INLIST", "LAST", "MOFN", "NEAR", "OR", "PARTOF", "PARTOFNEQ", "POSITION", "REGEXP", "SCORE", "VOTE", "IF", "FEATURE", "PARSE", "CREATE", "GATHER", "FILL", "ATTRIBUTE", "COLOR", "DEL", "LOG", "MARK", "MARKSCORE", "MARKONCE", "MARKFAST", "MARKTABLE", "MARKLAST", "REPLACE", "RETAINTYPE", "FILTERTYPE", "CALL", "EXEC", "CONFIGURE", "ASSIGN", "SETFEATURE", "GETFEATURE", "UNMARK", "UNMARKALL", "TRANSFER", "SHIFT", "DYNAMICANCHORING", "TRIM", "BEFORE", "AFTER", "IS", "STARTSWITH", "ENDSWITH", "ADDRETAINTYPE", "REMOVERETAINTYPE", "ADDFILTERTYPE", "REMOVEFILTERTYPE", "NOT", "ADD", "REMOVE", "REMOVEDUPLICATE", "MERGE", "GET", "GETLIST", "SIZE", "MATCHEDTEXT", "REMOVESTRING", "CLEAR", "THEN", "LogLevel", "OldColor", "PackageString", "ScriptString", "EngineString", "BlockString", "AutomataBlockString", "TypeString", "IntString", "DoubleString", "FloatString", "StringString", "BooleanString", "TypeSystemString", "SymbolString", "CONDITION", "ACTION", "BOOLEANLIST", "INTLIST", "DOUBLELIST", "FLOATLIST", "STRINGLIST", "TYPELIST", "EXP", "LOGN", "SIN", "COS", "TAN", "XOR", "TRUE", "FALSE", "HexDigit", "IntegerTypeSuffix", "HexLiteral", "DecimalLiteral", "OctalLiteral", "Exponent", "FloatTypeSuffix", "FloatingPointLiteral", "EscapeSequence", "CharacterLiteral", "StringLiteral", "RessourceLiteral", "UnicodeEscape", "OctalEscape", "Letter", "JavaIDDigit", "Identifier", "LPAREN", "RPAREN", "LBRACK", "RBRACK", "LCURLY", "RCURLY", "CIRCUMFLEX", "AT", "DOT", "COLON", "COMMA", "SEMI", "PLUS", "MINUS", "STAR", "SLASH", "VBAR", "AMPER", "LESS", "GREATER", "ASSIGN_EQUAL", "PERCENT", "QUESTION", "EQUAL", "NOTEQUAL", "ALT_NOTEQUAL", "LESSEQUAL", "GREATEREQUAL", "WILDCARD", "WS", "COMMENT", "LINE_COMMENT"
    };
    public static final int STAR=142;
    public static final int FloatTypeSuffix=117;
    public static final int OctalLiteral=115;
    public static final int LOG=37;
    public static final int CONTAINS=8;
    public static final int REMOVE=70;
    public static final int GREATEREQUAL=155;
    public static final int MARKFAST=41;
    public static final int CONDITION=95;
    public static final int MATCHEDTEXT=76;
    public static final int COUNT=14;
    public static final int LOGN=104;
    public static final int DYNAMICANCHORING=57;
    public static final int NOT=68;
    public static final int EOF=-1;
    public static final int Identifier=127;
    public static final int ACTION=96;
    public static final int CLEAR=78;
    public static final int NOTEQUAL=152;
    public static final int ENDSWITH=63;
    public static final int DOUBLELIST=99;
    public static final int VBAR=144;
    public static final int RPAREN=129;
    public static final int CREATE=31;
    public static final int GREATER=147;
    public static final int SIN=105;
    public static final int EXP=103;
    public static final int CURRENTCOUNT=16;
    public static final int COS=106;
    public static final int TAN=107;
    public static final int TYPELIST=102;
    public static final int FloatString=90;
    public static final int LESS=146;
    public static final int REGEXP=25;
    public static final int GET=73;
    public static final int UNMARK=53;
    public static final int PARTOF=22;
    public static final int LAST=18;
    public static final int COMMENT=158;
    public static final int REMOVEDUPLICATE=71;
    public static final int UNMARKALL=54;
    public static final int RBRACK=131;
    public static final int NEAR=20;
    public static final int LINE_COMMENT=159;
    public static final int IntegerTypeSuffix=112;
    public static final int MARKSCORE=39;
    public static final int REMOVESTRING=77;
    public static final int TRANSFER=55;
    public static final int LCURLY=132;
    public static final int TRIE=7;
    public static final int FILTERTYPE=46;
    public static final int STRINGLIST=101;
    public static final int MARKONCE=40;
    public static final int ScriptString=83;
    public static final int EngineString=84;
    public static final int WS=157;
    public static final int WORDTABLE=11;
    public static final int WORDLIST=10;
    public static final int AutomataBlockString=86;
    public static final int FloatingPointLiteral=118;
    public static final int INTLIST=98;
    public static final int OR=21;
    public static final int TRIM=58;
    public static final int JavaIDDigit=126;
    public static final int FLOATLIST=100;
    public static final int CALL=47;
    public static final int Annotation=5;
    public static final int FALSE=110;
    public static final int LESSEQUAL=154;
    public static final int RessourceLiteral=122;
    public static final int VOTE=27;
    public static final int Letter=125;
    public static final int EscapeSequence=119;
    public static final int SIZE=75;
    public static final int REMOVEFILTERTYPE=67;
    public static final int LBRACK=130;
    public static final int CharacterLiteral=120;
    public static final int DEL=36;
    public static final int ATTRIBUTE=34;
    public static final int TypeString=87;
    public static final int SHIFT=56;
    public static final int Exponent=116;
    public static final int ASSIGN_EQUAL=148;
    public static final int RETAINTYPE=45;
    public static final int TypeSystemString=93;
    public static final int AND=12;
    public static final int ADDFILTERTYPE=66;
    public static final int BlockString=85;
    public static final int IntString=88;
    public static final int HexDigit=111;
    public static final int COLOR=35;
    public static final int POSITION=24;
    public static final int LPAREN=128;
    public static final int IF=28;
    public static final int AT=135;
    public static final int LogLevel=80;
    public static final int CONFIGURE=49;
    public static final int SLASH=143;
    public static final int THEN=79;
    public static final int FILL=33;
    public static final int COMMA=138;
    public static final int IS=61;
    public static final int GETLIST=74;
    public static final int REPLACE=44;
    public static final int AMPER=145;
    public static final int WILDCARD=156;
    public static final int EQUAL=151;
    public static final int GATHER=32;
    public static final int INLIST=17;
    public static final int PLUS=140;
    public static final int BooleanString=92;
    public static final int GETFEATURE=52;
    public static final int DOT=136;
    public static final int ListIdentifier=6;
    public static final int PARTOFNEQ=23;
    public static final int ADD=69;
    public static final int BOOLEANLIST=97;
    public static final int MARKTABLE=42;
    public static final int HexLiteral=113;
    public static final int XOR=108;
    public static final int MARK=38;
    public static final int PERCENT=149;
    public static final int PackageString=82;
    public static final int PARSE=30;
    public static final int OldColor=81;
    public static final int MERGE=72;
    public static final int MARKLAST=43;
    public static final int CONTEXTCOUNT=13;
    public static final int BEFORE=59;
    public static final int EXEC=48;
    public static final int AFTER=60;
    public static final int MINUS=141;
    public static final int DecimalLiteral=114;
    public static final int TRUE=109;
    public static final int SEMI=139;
    public static final int FEATURE=29;
    public static final int SymbolString=94;
    public static final int StringString=91;
    public static final int StringLiteral=121;
    public static final int COLON=137;
    public static final int SCORE=26;
    public static final int QUESTION=150;
    public static final int ADDRETAINTYPE=64;
    public static final int UnicodeEscape=123;
    public static final int STARTSWITH=62;
    public static final int RCURLY=133;
    public static final int ASSIGN=50;
    public static final int REMOVERETAINTYPE=65;
    public static final int TOTALCOUNT=15;
    public static final int DECLARE=9;
    public static final int DocComment=4;
    public static final int MOFN=19;
    public static final int SETFEATURE=51;
    public static final int OctalEscape=124;
    public static final int DoubleString=89;
    public static final int CIRCUMFLEX=134;
    public static final int ALT_NOTEQUAL=153;

    // delegates
    // delegators


        public RutaParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public RutaParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return RutaParser.tokenNames; }
    public String getGrammarFileName() { return "org\\apache\\uima\\ruta\\parser\\RutaParser.g"; }


    private List vars = new ArrayList();	
    private int level = 0;
    private RutaScriptFactory factory = new RutaScriptFactory();
    private RutaScriptFactory automataFactory = new RutaAutomataFactory();
    private RutaExternalFactory external;


    public void setExternalFactory(RutaExternalFactory factory) {
    	external = factory;
    }

    public void emitErrorMessage(String msg) {
    		System.out.println(msg);
    	}
    	public void reportError(RecognitionException e) {
    		System.out.println(e);
    	}

    	//public void addVariable(String var, IntStream input) throws NoViableAltException {
    	//	if(!vars.contains(var)) {
    	//		vars.add(var);
    	//	} else {
    	//		throw new NoViableAltException("already declared \"" + var + "\"", 3, 0, input);
    	//	}
    	//}
    	public void addVariable(RutaBlock parent, String name, String type) {
    		parent.getEnvironment().addVariable(name, type);
    	}
    	
    	public boolean ownsVariable(RutaBlock parent, String name) {
    		return parent.getEnvironment().ownsVariable(name);
    	}
    	public boolean isVariable(RutaBlock parent, String name) {
    		return parent.getEnvironment().isVariable(name);
    	}
    	
    	public void setValue(RutaBlock parent, List<String> names, Object obj) {
    		for(String name : names) {
    			setValue(parent,name,obj);
    		}
    	}
    	
    	public void setValue(RutaBlock parent, String name, Object obj) {
    		if(obj != null) {
    			Object value = parent.getEnvironment().getLiteralValue(name, obj);
    			parent.getEnvironment().setVariableValue(name, value);
    			parent.getEnvironment().setInitialVariableValue(name, value);
    		}
    	}
    	
    	public boolean ownsVariableOfType(RutaBlock parent, String name, String type) {
    		return parent.getEnvironment().ownsVariableOfType(name,type);
    	}
    	
    	public boolean isVariableOfType(RutaBlock parent, String name, String type) {
    		return parent.getEnvironment().isVariableOfType(name,type);
    	}
    	
    	public void addType(RutaBlock parent, String type) {
    	}
    	
    	public void addType(RutaBlock parent, String name, String parentType, List featuresTypes, List featuresNames) {
        	}
    	
    	public boolean isType(RutaBlock parent, String type) {
    		return parent.getEnvironment().getType(type) != null || type.equals("Document");
    	}
    	
    	public void checkVariable(String var, IntStream input) throws NoViableAltException {
    		if(!vars.contains(var)) {
    			throw new NoViableAltException("not declared \"" + var + "\"", 3, 0, input);
    		}
    	}
    	
    	public void addImportTypeSystem(RutaBlock parent, String descriptor) {
    		//parent.getEnvironment().addTypeSystem(descriptor);
    	}
    	public void addImportScript(RutaBlock parent, String namespace) {
    		parent.getScript().addScript(namespace, null);
    	}
    	public void addImportEngine(RutaBlock parent, String namespace) {
    		parent.getScript().addEngine(namespace, null);
    	}
    	
    	
    	protected static final int[] getBounds(Token t) {
        		if (t instanceof CommonToken) {
        			CommonToken ct = (CommonToken) t;
        			int[] bounds = {ct.getStartIndex(), ct.getStopIndex()}; 
        			return bounds;
        		}
        		return null;
        	}
    	
    	private TypeSystemDescription localTSD;
    	private String[] resourcePaths;
    	

    	public void setResourcePaths(String[] resourcePaths) {
    		this.resourcePaths = resourcePaths;
    	}
    	
    	 public void setLocalTSD(TypeSystemDescription localTSD) {
          		this.localTSD = localTSD;
       	 }



    // $ANTLR start "file_input"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:207:1: file_input[String moduleName] returns [RutaModule module] : p= packageDeclaration gs= globalStatements s= statements EOF ;
    public final RutaModule file_input(String moduleName) throws RecognitionException {
        RutaModule module = null;

        String p = null;

        List<RutaStatement> gs = null;

        List<RutaStatement> s = null;



        RutaScriptBlock rootBlock = null;
        List<RutaStatement> stmts = new ArrayList<RutaStatement>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:212:2: (p= packageDeclaration gs= globalStatements s= statements EOF )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:213:2: p= packageDeclaration gs= globalStatements s= statements EOF
            {
            pushFollow(FOLLOW_packageDeclaration_in_file_input75);
            p=packageDeclaration();

            state._fsp--;
            if (state.failed) return module;
            if ( state.backtracking==0 ) {

              	rootBlock = factory.createRootScriptBlock(moduleName, p, localTSD);
                      rootBlock.getEnvironment().setResourcePaths(resourcePaths);
              	rootBlock.setElements(stmts);
              	module = new RutaModule(rootBlock);
              	rootBlock.setScript(module);
              	
            }
            if ( state.backtracking==0 ) {
              blockDeclaration_stack.push(new blockDeclaration_scope());((blockDeclaration_scope)blockDeclaration_stack.peek()).env = rootBlock;
            }
            pushFollow(FOLLOW_globalStatements_in_file_input91);
            gs=globalStatements();

            state._fsp--;
            if (state.failed) return module;
            if ( state.backtracking==0 ) {
              stmts.addAll(gs);
            }
            pushFollow(FOLLOW_statements_in_file_input100);
            s=statements();

            state._fsp--;
            if (state.failed) return module;
            if ( state.backtracking==0 ) {
              stmts.addAll(s);
            }
            match(input,EOF,FOLLOW_EOF_in_file_input108); if (state.failed) return module;

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return module;
    }
    // $ANTLR end "file_input"


    // $ANTLR start "packageDeclaration"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:229:1: packageDeclaration returns [String pack = \"\"] : PackageString p= dottedIdentifier SEMI ;
    public final String packageDeclaration() throws RecognitionException {
        String pack =  "";

        String p = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:230:2: ( PackageString p= dottedIdentifier SEMI )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:230:4: PackageString p= dottedIdentifier SEMI
            {
            match(input,PackageString,FOLLOW_PackageString_in_packageDeclaration123); if (state.failed) return pack;
            pushFollow(FOLLOW_dottedIdentifier_in_packageDeclaration129);
            p=dottedIdentifier();

            state._fsp--;
            if (state.failed) return pack;
            match(input,SEMI,FOLLOW_SEMI_in_packageDeclaration131); if (state.failed) return pack;
            if ( state.backtracking==0 ) {
              pack = p;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return pack;
    }
    // $ANTLR end "packageDeclaration"


    // $ANTLR start "statements"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:233:1: statements returns [List<RutaStatement> stmts = new ArrayList<RutaStatement>()] : (stmt= statement )* ;
    public final List<RutaStatement> statements() throws RecognitionException {
        List<RutaStatement> stmts =  new ArrayList<RutaStatement>();

        RutaStatement stmt = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:234:2: ( (stmt= statement )* )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:235:2: (stmt= statement )*
            {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:235:2: (stmt= statement )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( ((LA1_0>=DECLARE && LA1_0<=WORDTABLE)||LA1_0==REMOVESTRING||(LA1_0>=BlockString && LA1_0<=BooleanString)||(LA1_0>=BOOLEANLIST && LA1_0<=TYPELIST)||LA1_0==StringLiteral||(LA1_0>=Identifier && LA1_0<=LPAREN)||LA1_0==WILDCARD) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:235:3: stmt= statement
            	    {
            	    pushFollow(FOLLOW_statement_in_statements154);
            	    stmt=statement();

            	    state._fsp--;
            	    if (state.failed) return stmts;
            	    if(stmt != null) {stmts.add(stmt);}

            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return stmts;
    }
    // $ANTLR end "statements"


    // $ANTLR start "globalStatements"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:238:1: globalStatements returns [List<RutaStatement> stmts = new ArrayList<RutaStatement>()] : (morestmts= globalStatement )* ;
    public final List<RutaStatement> globalStatements() throws RecognitionException {
        List<RutaStatement> stmts =  new ArrayList<RutaStatement>();

        List<RutaStatement> morestmts = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:239:2: ( (morestmts= globalStatement )* )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:240:2: (morestmts= globalStatement )*
            {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:240:2: (morestmts= globalStatement )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( ((LA2_0>=ScriptString && LA2_0<=EngineString)||LA2_0==TypeSystemString) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:240:3: morestmts= globalStatement
            	    {
            	    pushFollow(FOLLOW_globalStatement_in_globalStatements179);
            	    morestmts=globalStatement();

            	    state._fsp--;
            	    if (state.failed) return stmts;
            	    if ( state.backtracking==0 ) {
            	      if(morestmts != null) {stmts.addAll(morestmts);}
            	    }

            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);


            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return stmts;
    }
    // $ANTLR end "globalStatements"


    // $ANTLR start "globalStatement"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:243:1: globalStatement returns [List<RutaStatement> stmts = new ArrayList<RutaStatement>()] : stmtImport= importStatement ;
    public final List<RutaStatement> globalStatement() throws RecognitionException {
        List<RutaStatement> stmts =  new ArrayList<RutaStatement>();

        RutaStatement stmtImport = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:244:2: (stmtImport= importStatement )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:245:2: stmtImport= importStatement
            {
            pushFollow(FOLLOW_importStatement_in_globalStatement203);
            stmtImport=importStatement();

            state._fsp--;
            if (state.failed) return stmts;
            if ( state.backtracking==0 ) {
              stmts.add(stmtImport);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return stmts;
    }
    // $ANTLR end "globalStatement"


    // $ANTLR start "statement"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:248:1: statement returns [RutaStatement stmt = null] : (stmtDecl= declaration | stmtVariable= variableDeclaration | stmtRule= simpleStatement | stmtBlock= blockDeclaration | stmtAutomata= automataDeclaration ) ;
    public final RutaStatement statement() throws RecognitionException {
        RutaStatement stmt =  null;

        RutaStatement stmtDecl = null;

        RutaStatement stmtVariable = null;

        RutaStatement stmtRule = null;

        RutaBlock stmtBlock = null;

        RutaBlock stmtAutomata = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:249:2: ( (stmtDecl= declaration | stmtVariable= variableDeclaration | stmtRule= simpleStatement | stmtBlock= blockDeclaration | stmtAutomata= automataDeclaration ) )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:250:2: (stmtDecl= declaration | stmtVariable= variableDeclaration | stmtRule= simpleStatement | stmtBlock= blockDeclaration | stmtAutomata= automataDeclaration )
            {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:250:2: (stmtDecl= declaration | stmtVariable= variableDeclaration | stmtRule= simpleStatement | stmtBlock= blockDeclaration | stmtAutomata= automataDeclaration )
            int alt3=5;
            switch ( input.LA(1) ) {
            case DECLARE:
                {
                alt3=1;
                }
                break;
            case WORDLIST:
            case WORDTABLE:
            case TypeString:
            case IntString:
            case DoubleString:
            case FloatString:
            case StringString:
            case BooleanString:
            case BOOLEANLIST:
            case INTLIST:
            case DOUBLELIST:
            case FLOATLIST:
            case STRINGLIST:
            case TYPELIST:
                {
                alt3=2;
                }
                break;
            case REMOVESTRING:
            case StringLiteral:
            case Identifier:
            case LPAREN:
            case WILDCARD:
                {
                alt3=3;
                }
                break;
            case BlockString:
                {
                alt3=4;
                }
                break;
            case AutomataBlockString:
                {
                alt3=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return stmt;}
                NoViableAltException nvae =
                    new NoViableAltException("", 3, 0, input);

                throw nvae;
            }

            switch (alt3) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:250:4: stmtDecl= declaration
                    {
                    pushFollow(FOLLOW_declaration_in_statement229);
                    stmtDecl=declaration();

                    state._fsp--;
                    if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      stmt = stmtDecl;
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:251:4: stmtVariable= variableDeclaration
                    {
                    pushFollow(FOLLOW_variableDeclaration_in_statement240);
                    stmtVariable=variableDeclaration();

                    state._fsp--;
                    if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      stmt = stmtVariable;
                    }

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:252:4: stmtRule= simpleStatement
                    {
                    pushFollow(FOLLOW_simpleStatement_in_statement251);
                    stmtRule=simpleStatement();

                    state._fsp--;
                    if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      stmt = stmtRule;
                    }

                    }
                    break;
                case 4 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:253:4: stmtBlock= blockDeclaration
                    {
                    pushFollow(FOLLOW_blockDeclaration_in_statement262);
                    stmtBlock=blockDeclaration();

                    state._fsp--;
                    if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      stmt = stmtBlock;
                    }

                    }
                    break;
                case 5 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:254:4: stmtAutomata= automataDeclaration
                    {
                    pushFollow(FOLLOW_automataDeclaration_in_statement273);
                    stmtAutomata=automataDeclaration();

                    state._fsp--;
                    if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      stmt = stmtBlock;
                    }

                    }
                    break;

            }


            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return stmt;
    }
    // $ANTLR end "statement"


    // $ANTLR start "variableDeclaration"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:258:1: variableDeclaration returns [RutaStatement stmt = null] : (type= IntString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value1= numberExpression )? SEMI | type= DoubleString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value2= numberExpression )? SEMI | type= FloatString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value2= numberExpression )? SEMI | type= StringString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value3= stringExpression )? SEMI | type= BooleanString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value4= booleanExpression )? SEMI | type= TypeString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value5= typeExpression )? SEMI | type= WORDLIST {...}?name= Identifier ( ASSIGN_EQUAL list= wordListExpression )? SEMI | type= WORDTABLE {...}?name= Identifier ( ASSIGN_EQUAL table= wordTableExpression )? SEMI | type= BOOLEANLIST {...}?name= Identifier ( ASSIGN_EQUAL bl= booleanListExpression )? SEMI | type= STRINGLIST {...}?name= Identifier ( ASSIGN_EQUAL sl= stringListExpression )? SEMI | type= INTLIST {...}?name= Identifier ( ASSIGN_EQUAL il= numberListExpression )? SEMI | type= DOUBLELIST {...}?name= Identifier ( ASSIGN_EQUAL dl= numberListExpression )? SEMI | type= FLOATLIST {...}?name= Identifier ( ASSIGN_EQUAL dl= numberListExpression )? SEMI | type= TYPELIST {...}?name= Identifier ( ASSIGN_EQUAL tl= typeListExpression )? SEMI );
    public final RutaStatement variableDeclaration() throws RecognitionException {
        RutaStatement stmt =  null;

        Token type=null;
        Token id=null;
        Token name=null;
        NumberExpression value1 = null;

        NumberExpression value2 = null;

        StringExpression value3 = null;

        BooleanExpression value4 = null;

        TypeExpression value5 = null;

        WordListExpression list = null;

        WordTableExpression table = null;

        BooleanListExpression bl = null;

        StringListExpression sl = null;

        NumberListExpression il = null;

        NumberListExpression dl = null;

        TypeListExpression tl = null;



        List<String> vars = new ArrayList<String>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:262:2: (type= IntString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value1= numberExpression )? SEMI | type= DoubleString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value2= numberExpression )? SEMI | type= FloatString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value2= numberExpression )? SEMI | type= StringString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value3= stringExpression )? SEMI | type= BooleanString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value4= booleanExpression )? SEMI | type= TypeString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value5= typeExpression )? SEMI | type= WORDLIST {...}?name= Identifier ( ASSIGN_EQUAL list= wordListExpression )? SEMI | type= WORDTABLE {...}?name= Identifier ( ASSIGN_EQUAL table= wordTableExpression )? SEMI | type= BOOLEANLIST {...}?name= Identifier ( ASSIGN_EQUAL bl= booleanListExpression )? SEMI | type= STRINGLIST {...}?name= Identifier ( ASSIGN_EQUAL sl= stringListExpression )? SEMI | type= INTLIST {...}?name= Identifier ( ASSIGN_EQUAL il= numberListExpression )? SEMI | type= DOUBLELIST {...}?name= Identifier ( ASSIGN_EQUAL dl= numberListExpression )? SEMI | type= FLOATLIST {...}?name= Identifier ( ASSIGN_EQUAL dl= numberListExpression )? SEMI | type= TYPELIST {...}?name= Identifier ( ASSIGN_EQUAL tl= typeListExpression )? SEMI )
            int alt24=14;
            switch ( input.LA(1) ) {
            case IntString:
                {
                alt24=1;
                }
                break;
            case DoubleString:
                {
                alt24=2;
                }
                break;
            case FloatString:
                {
                alt24=3;
                }
                break;
            case StringString:
                {
                alt24=4;
                }
                break;
            case BooleanString:
                {
                alt24=5;
                }
                break;
            case TypeString:
                {
                alt24=6;
                }
                break;
            case WORDLIST:
                {
                alt24=7;
                }
                break;
            case WORDTABLE:
                {
                alt24=8;
                }
                break;
            case BOOLEANLIST:
                {
                alt24=9;
                }
                break;
            case STRINGLIST:
                {
                alt24=10;
                }
                break;
            case INTLIST:
                {
                alt24=11;
                }
                break;
            case DOUBLELIST:
                {
                alt24=12;
                }
                break;
            case FLOATLIST:
                {
                alt24=13;
                }
                break;
            case TYPELIST:
                {
                alt24=14;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return stmt;}
                NoViableAltException nvae =
                    new NoViableAltException("", 24, 0, input);

                throw nvae;
            }

            switch (alt24) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:263:2: type= IntString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value1= numberExpression )? SEMI
                    {
                    type=(Token)match(input,IntString,FOLLOW_IntString_in_variableDeclaration303); if (state.failed) return stmt;
                    if ( !((!ownsVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!ownsVariable($blockDeclaration::env, input.LT(1).getText())");
                    }
                    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration312); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      vars.add(id.getText());addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, id.getText(), type.getText());
                    }
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:265:3: ( COMMA {...}?id= Identifier )*
                    loop4:
                    do {
                        int alt4=2;
                        int LA4_0 = input.LA(1);

                        if ( (LA4_0==COMMA) ) {
                            alt4=1;
                        }


                        switch (alt4) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:265:4: COMMA {...}?id= Identifier
                    	    {
                    	    match(input,COMMA,FOLLOW_COMMA_in_variableDeclaration319); if (state.failed) return stmt;
                    	    if ( !((!ownsVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                    	        if (state.backtracking>0) {state.failed=true; return stmt;}
                    	        throw new FailedPredicateException(input, "variableDeclaration", "!ownsVariable($blockDeclaration::env, input.LT(1).getText())");
                    	    }
                    	    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration327); if (state.failed) return stmt;
                    	    if ( state.backtracking==0 ) {
                    	      vars.add(id.getText());addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, id.getText(), type.getText());
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    break loop4;
                        }
                    } while (true);

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:266:6: ( ASSIGN_EQUAL value1= numberExpression )?
                    int alt5=2;
                    int LA5_0 = input.LA(1);

                    if ( (LA5_0==ASSIGN_EQUAL) ) {
                        alt5=1;
                    }
                    switch (alt5) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:266:7: ASSIGN_EQUAL value1= numberExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration337); if (state.failed) return stmt;
                            pushFollow(FOLLOW_numberExpression_in_variableDeclaration343);
                            value1=numberExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                      setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, vars, value1);
                    }
                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration350); if (state.failed) return stmt;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:268:2: type= DoubleString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value2= numberExpression )? SEMI
                    {
                    type=(Token)match(input,DoubleString,FOLLOW_DoubleString_in_variableDeclaration360); if (state.failed) return stmt;
                    if ( !((!ownsVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!ownsVariable($blockDeclaration::env, input.LT(1).getText())");
                    }
                    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration369); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      vars.add(id.getText());addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, id.getText(), type.getText());
                    }
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:270:3: ( COMMA {...}?id= Identifier )*
                    loop6:
                    do {
                        int alt6=2;
                        int LA6_0 = input.LA(1);

                        if ( (LA6_0==COMMA) ) {
                            alt6=1;
                        }


                        switch (alt6) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:270:4: COMMA {...}?id= Identifier
                    	    {
                    	    match(input,COMMA,FOLLOW_COMMA_in_variableDeclaration376); if (state.failed) return stmt;
                    	    if ( !((!ownsVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                    	        if (state.backtracking>0) {state.failed=true; return stmt;}
                    	        throw new FailedPredicateException(input, "variableDeclaration", "!ownsVariable($blockDeclaration::env, input.LT(1).getText())");
                    	    }
                    	    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration384); if (state.failed) return stmt;
                    	    if ( state.backtracking==0 ) {
                    	      vars.add(id.getText());addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, id.getText(), type.getText());
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    break loop6;
                        }
                    } while (true);

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:271:7: ( ASSIGN_EQUAL value2= numberExpression )?
                    int alt7=2;
                    int LA7_0 = input.LA(1);

                    if ( (LA7_0==ASSIGN_EQUAL) ) {
                        alt7=1;
                    }
                    switch (alt7) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:271:8: ASSIGN_EQUAL value2= numberExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration395); if (state.failed) return stmt;
                            pushFollow(FOLLOW_numberExpression_in_variableDeclaration401);
                            value2=numberExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                      setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, vars, value2);
                    }
                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration407); if (state.failed) return stmt;

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:273:2: type= FloatString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value2= numberExpression )? SEMI
                    {
                    type=(Token)match(input,FloatString,FOLLOW_FloatString_in_variableDeclaration417); if (state.failed) return stmt;
                    if ( !((!ownsVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!ownsVariable($blockDeclaration::env, input.LT(1).getText())");
                    }
                    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration426); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      vars.add(id.getText());addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, id.getText(), type.getText());
                    }
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:275:3: ( COMMA {...}?id= Identifier )*
                    loop8:
                    do {
                        int alt8=2;
                        int LA8_0 = input.LA(1);

                        if ( (LA8_0==COMMA) ) {
                            alt8=1;
                        }


                        switch (alt8) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:275:4: COMMA {...}?id= Identifier
                    	    {
                    	    match(input,COMMA,FOLLOW_COMMA_in_variableDeclaration433); if (state.failed) return stmt;
                    	    if ( !((!ownsVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                    	        if (state.backtracking>0) {state.failed=true; return stmt;}
                    	        throw new FailedPredicateException(input, "variableDeclaration", "!ownsVariable($blockDeclaration::env, input.LT(1).getText())");
                    	    }
                    	    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration441); if (state.failed) return stmt;
                    	    if ( state.backtracking==0 ) {
                    	      vars.add(id.getText());addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, id.getText(), type.getText());
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    break loop8;
                        }
                    } while (true);

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:276:7: ( ASSIGN_EQUAL value2= numberExpression )?
                    int alt9=2;
                    int LA9_0 = input.LA(1);

                    if ( (LA9_0==ASSIGN_EQUAL) ) {
                        alt9=1;
                    }
                    switch (alt9) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:276:8: ASSIGN_EQUAL value2= numberExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration452); if (state.failed) return stmt;
                            pushFollow(FOLLOW_numberExpression_in_variableDeclaration458);
                            value2=numberExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                      setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, vars, value2);
                    }
                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration464); if (state.failed) return stmt;

                    }
                    break;
                case 4 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:278:2: type= StringString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value3= stringExpression )? SEMI
                    {
                    type=(Token)match(input,StringString,FOLLOW_StringString_in_variableDeclaration474); if (state.failed) return stmt;
                    if ( !((!ownsVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!ownsVariable($blockDeclaration::env, input.LT(1).getText())");
                    }
                    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration483); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      vars.add(id.getText());addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, id.getText(), type.getText());
                    }
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:280:3: ( COMMA {...}?id= Identifier )*
                    loop10:
                    do {
                        int alt10=2;
                        int LA10_0 = input.LA(1);

                        if ( (LA10_0==COMMA) ) {
                            alt10=1;
                        }


                        switch (alt10) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:280:4: COMMA {...}?id= Identifier
                    	    {
                    	    match(input,COMMA,FOLLOW_COMMA_in_variableDeclaration490); if (state.failed) return stmt;
                    	    if ( !((!ownsVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                    	        if (state.backtracking>0) {state.failed=true; return stmt;}
                    	        throw new FailedPredicateException(input, "variableDeclaration", "!ownsVariable($blockDeclaration::env, input.LT(1).getText())");
                    	    }
                    	    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration498); if (state.failed) return stmt;
                    	    if ( state.backtracking==0 ) {
                    	      vars.add(id.getText());addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, id.getText(), type.getText());
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    break loop10;
                        }
                    } while (true);

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:281:7: ( ASSIGN_EQUAL value3= stringExpression )?
                    int alt11=2;
                    int LA11_0 = input.LA(1);

                    if ( (LA11_0==ASSIGN_EQUAL) ) {
                        alt11=1;
                    }
                    switch (alt11) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:281:8: ASSIGN_EQUAL value3= stringExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration509); if (state.failed) return stmt;
                            pushFollow(FOLLOW_stringExpression_in_variableDeclaration515);
                            value3=stringExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                      setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, vars, value3);
                    }
                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration521); if (state.failed) return stmt;

                    }
                    break;
                case 5 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:283:2: type= BooleanString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value4= booleanExpression )? SEMI
                    {
                    type=(Token)match(input,BooleanString,FOLLOW_BooleanString_in_variableDeclaration531); if (state.failed) return stmt;
                    if ( !((!ownsVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!ownsVariable($blockDeclaration::env, input.LT(1).getText())");
                    }
                    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration540); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      vars.add(id.getText());addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, id.getText(), type.getText());
                    }
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:285:3: ( COMMA {...}?id= Identifier )*
                    loop12:
                    do {
                        int alt12=2;
                        int LA12_0 = input.LA(1);

                        if ( (LA12_0==COMMA) ) {
                            alt12=1;
                        }


                        switch (alt12) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:285:4: COMMA {...}?id= Identifier
                    	    {
                    	    match(input,COMMA,FOLLOW_COMMA_in_variableDeclaration547); if (state.failed) return stmt;
                    	    if ( !((!ownsVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                    	        if (state.backtracking>0) {state.failed=true; return stmt;}
                    	        throw new FailedPredicateException(input, "variableDeclaration", "!ownsVariable($blockDeclaration::env, input.LT(1).getText())");
                    	    }
                    	    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration555); if (state.failed) return stmt;
                    	    if ( state.backtracking==0 ) {
                    	      vars.add(id.getText());addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, id.getText(), type.getText());
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    break loop12;
                        }
                    } while (true);

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:286:7: ( ASSIGN_EQUAL value4= booleanExpression )?
                    int alt13=2;
                    int LA13_0 = input.LA(1);

                    if ( (LA13_0==ASSIGN_EQUAL) ) {
                        alt13=1;
                    }
                    switch (alt13) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:286:8: ASSIGN_EQUAL value4= booleanExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration566); if (state.failed) return stmt;
                            pushFollow(FOLLOW_booleanExpression_in_variableDeclaration572);
                            value4=booleanExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                      setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, vars, value4);
                    }
                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration578); if (state.failed) return stmt;

                    }
                    break;
                case 6 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:288:2: type= TypeString {...}?id= Identifier ( COMMA {...}?id= Identifier )* ( ASSIGN_EQUAL value5= typeExpression )? SEMI
                    {
                    type=(Token)match(input,TypeString,FOLLOW_TypeString_in_variableDeclaration588); if (state.failed) return stmt;
                    if ( !((!ownsVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!ownsVariable($blockDeclaration::env, input.LT(1).getText())");
                    }
                    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration597); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      vars.add(id.getText());addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, id.getText(), type.getText());
                    }
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:290:3: ( COMMA {...}?id= Identifier )*
                    loop14:
                    do {
                        int alt14=2;
                        int LA14_0 = input.LA(1);

                        if ( (LA14_0==COMMA) ) {
                            alt14=1;
                        }


                        switch (alt14) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:290:4: COMMA {...}?id= Identifier
                    	    {
                    	    match(input,COMMA,FOLLOW_COMMA_in_variableDeclaration604); if (state.failed) return stmt;
                    	    if ( !((!ownsVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                    	        if (state.backtracking>0) {state.failed=true; return stmt;}
                    	        throw new FailedPredicateException(input, "variableDeclaration", "!ownsVariable($blockDeclaration::env, input.LT(1).getText())");
                    	    }
                    	    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration612); if (state.failed) return stmt;
                    	    if ( state.backtracking==0 ) {
                    	      vars.add(id.getText());addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, id.getText(), type.getText());
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    break loop14;
                        }
                    } while (true);

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:291:7: ( ASSIGN_EQUAL value5= typeExpression )?
                    int alt15=2;
                    int LA15_0 = input.LA(1);

                    if ( (LA15_0==ASSIGN_EQUAL) ) {
                        alt15=1;
                    }
                    switch (alt15) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:291:8: ASSIGN_EQUAL value5= typeExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration623); if (state.failed) return stmt;
                            pushFollow(FOLLOW_typeExpression_in_variableDeclaration629);
                            value5=typeExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                      setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, vars, value5);
                    }
                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration635); if (state.failed) return stmt;

                    }
                    break;
                case 7 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:293:2: type= WORDLIST {...}?name= Identifier ( ASSIGN_EQUAL list= wordListExpression )? SEMI
                    {
                    type=(Token)match(input,WORDLIST,FOLLOW_WORDLIST_in_variableDeclaration645); if (state.failed) return stmt;
                    if ( !((!isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), type.getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!isVariableOfType($blockDeclaration::env, input.LT(1).getText(), type.getText())");
                    }
                    name=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration657); if (state.failed) return stmt;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:295:20: ( ASSIGN_EQUAL list= wordListExpression )?
                    int alt16=2;
                    int LA16_0 = input.LA(1);

                    if ( (LA16_0==ASSIGN_EQUAL) ) {
                        alt16=1;
                    }
                    switch (alt16) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:295:21: ASSIGN_EQUAL list= wordListExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration660); if (state.failed) return stmt;
                            pushFollow(FOLLOW_wordListExpression_in_variableDeclaration666);
                            list=wordListExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration670); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), type.getText());if(list != null){setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), list);}
                    }

                    }
                    break;
                case 8 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:297:2: type= WORDTABLE {...}?name= Identifier ( ASSIGN_EQUAL table= wordTableExpression )? SEMI
                    {
                    type=(Token)match(input,WORDTABLE,FOLLOW_WORDTABLE_in_variableDeclaration684); if (state.failed) return stmt;
                    if ( !((!isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), type.getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!isVariableOfType($blockDeclaration::env, input.LT(1).getText(), type.getText())");
                    }
                    name=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration696); if (state.failed) return stmt;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:299:20: ( ASSIGN_EQUAL table= wordTableExpression )?
                    int alt17=2;
                    int LA17_0 = input.LA(1);

                    if ( (LA17_0==ASSIGN_EQUAL) ) {
                        alt17=1;
                    }
                    switch (alt17) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:299:21: ASSIGN_EQUAL table= wordTableExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration699); if (state.failed) return stmt;
                            pushFollow(FOLLOW_wordTableExpression_in_variableDeclaration705);
                            table=wordTableExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration709); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), type.getText());if(table != null){setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), table);}
                    }

                    }
                    break;
                case 9 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:301:2: type= BOOLEANLIST {...}?name= Identifier ( ASSIGN_EQUAL bl= booleanListExpression )? SEMI
                    {
                    type=(Token)match(input,BOOLEANLIST,FOLLOW_BOOLEANLIST_in_variableDeclaration721); if (state.failed) return stmt;
                    if ( !((!isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), type.getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!isVariableOfType($blockDeclaration::env, input.LT(1).getText(), type.getText())");
                    }
                    name=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration733); if (state.failed) return stmt;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:303:20: ( ASSIGN_EQUAL bl= booleanListExpression )?
                    int alt18=2;
                    int LA18_0 = input.LA(1);

                    if ( (LA18_0==ASSIGN_EQUAL) ) {
                        alt18=1;
                    }
                    switch (alt18) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:303:21: ASSIGN_EQUAL bl= booleanListExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration736); if (state.failed) return stmt;
                            pushFollow(FOLLOW_booleanListExpression_in_variableDeclaration742);
                            bl=booleanListExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration746); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), type.getText());if(bl != null){setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), bl);}
                    }

                    }
                    break;
                case 10 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:305:2: type= STRINGLIST {...}?name= Identifier ( ASSIGN_EQUAL sl= stringListExpression )? SEMI
                    {
                    type=(Token)match(input,STRINGLIST,FOLLOW_STRINGLIST_in_variableDeclaration759); if (state.failed) return stmt;
                    if ( !((!isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), type.getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!isVariableOfType($blockDeclaration::env, input.LT(1).getText(), type.getText())");
                    }
                    name=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration771); if (state.failed) return stmt;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:307:20: ( ASSIGN_EQUAL sl= stringListExpression )?
                    int alt19=2;
                    int LA19_0 = input.LA(1);

                    if ( (LA19_0==ASSIGN_EQUAL) ) {
                        alt19=1;
                    }
                    switch (alt19) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:307:21: ASSIGN_EQUAL sl= stringListExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration774); if (state.failed) return stmt;
                            pushFollow(FOLLOW_stringListExpression_in_variableDeclaration780);
                            sl=stringListExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration784); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), type.getText());if(sl != null){setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), sl);}
                    }

                    }
                    break;
                case 11 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:309:2: type= INTLIST {...}?name= Identifier ( ASSIGN_EQUAL il= numberListExpression )? SEMI
                    {
                    type=(Token)match(input,INTLIST,FOLLOW_INTLIST_in_variableDeclaration797); if (state.failed) return stmt;
                    if ( !((!isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), type.getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!isVariableOfType($blockDeclaration::env, input.LT(1).getText(), type.getText())");
                    }
                    name=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration809); if (state.failed) return stmt;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:311:20: ( ASSIGN_EQUAL il= numberListExpression )?
                    int alt20=2;
                    int LA20_0 = input.LA(1);

                    if ( (LA20_0==ASSIGN_EQUAL) ) {
                        alt20=1;
                    }
                    switch (alt20) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:311:21: ASSIGN_EQUAL il= numberListExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration812); if (state.failed) return stmt;
                            pushFollow(FOLLOW_numberListExpression_in_variableDeclaration818);
                            il=numberListExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration822); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), type.getText());if(il != null){setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), il);}
                    }

                    }
                    break;
                case 12 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:313:2: type= DOUBLELIST {...}?name= Identifier ( ASSIGN_EQUAL dl= numberListExpression )? SEMI
                    {
                    type=(Token)match(input,DOUBLELIST,FOLLOW_DOUBLELIST_in_variableDeclaration835); if (state.failed) return stmt;
                    if ( !((!isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), type.getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!isVariableOfType($blockDeclaration::env, input.LT(1).getText(), type.getText())");
                    }
                    name=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration847); if (state.failed) return stmt;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:315:20: ( ASSIGN_EQUAL dl= numberListExpression )?
                    int alt21=2;
                    int LA21_0 = input.LA(1);

                    if ( (LA21_0==ASSIGN_EQUAL) ) {
                        alt21=1;
                    }
                    switch (alt21) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:315:21: ASSIGN_EQUAL dl= numberListExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration850); if (state.failed) return stmt;
                            pushFollow(FOLLOW_numberListExpression_in_variableDeclaration856);
                            dl=numberListExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration860); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), type.getText());if(dl != null){setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), dl);}
                    }

                    }
                    break;
                case 13 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:317:2: type= FLOATLIST {...}?name= Identifier ( ASSIGN_EQUAL dl= numberListExpression )? SEMI
                    {
                    type=(Token)match(input,FLOATLIST,FOLLOW_FLOATLIST_in_variableDeclaration873); if (state.failed) return stmt;
                    if ( !((!isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), type.getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!isVariableOfType($blockDeclaration::env, input.LT(1).getText(), type.getText())");
                    }
                    name=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration885); if (state.failed) return stmt;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:319:20: ( ASSIGN_EQUAL dl= numberListExpression )?
                    int alt22=2;
                    int LA22_0 = input.LA(1);

                    if ( (LA22_0==ASSIGN_EQUAL) ) {
                        alt22=1;
                    }
                    switch (alt22) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:319:21: ASSIGN_EQUAL dl= numberListExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration888); if (state.failed) return stmt;
                            pushFollow(FOLLOW_numberListExpression_in_variableDeclaration894);
                            dl=numberListExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration898); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), type.getText());if(dl != null){setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), dl);}
                    }

                    }
                    break;
                case 14 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:321:2: type= TYPELIST {...}?name= Identifier ( ASSIGN_EQUAL tl= typeListExpression )? SEMI
                    {
                    type=(Token)match(input,TYPELIST,FOLLOW_TYPELIST_in_variableDeclaration911); if (state.failed) return stmt;
                    if ( !((!isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), type.getText()))) ) {
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        throw new FailedPredicateException(input, "variableDeclaration", "!isVariableOfType($blockDeclaration::env, input.LT(1).getText(), type.getText())");
                    }
                    name=(Token)match(input,Identifier,FOLLOW_Identifier_in_variableDeclaration923); if (state.failed) return stmt;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:323:20: ( ASSIGN_EQUAL tl= typeListExpression )?
                    int alt23=2;
                    int LA23_0 = input.LA(1);

                    if ( (LA23_0==ASSIGN_EQUAL) ) {
                        alt23=1;
                    }
                    switch (alt23) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:323:21: ASSIGN_EQUAL tl= typeListExpression
                            {
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_variableDeclaration926); if (state.failed) return stmt;
                            pushFollow(FOLLOW_typeListExpression_in_variableDeclaration932);
                            tl=typeListExpression();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    match(input,SEMI,FOLLOW_SEMI_in_variableDeclaration936); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      addVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), type.getText());if(tl != null){setValue(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, name.getText(), tl);}
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return stmt;
    }
    // $ANTLR end "variableDeclaration"


    // $ANTLR start "importStatement"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:348:1: importStatement returns [RutaStatement stmt = null] : ( TypeSystemString ts= dottedIdentifier2 SEMI | ScriptString ns= dottedIdentifier2 SEMI | EngineString ns= dottedIdentifier2 SEMI );
    public final RutaStatement importStatement() throws RecognitionException {
        RutaStatement stmt =  null;

        String ts = null;

        String ns = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:349:2: ( TypeSystemString ts= dottedIdentifier2 SEMI | ScriptString ns= dottedIdentifier2 SEMI | EngineString ns= dottedIdentifier2 SEMI )
            int alt25=3;
            switch ( input.LA(1) ) {
            case TypeSystemString:
                {
                alt25=1;
                }
                break;
            case ScriptString:
                {
                alt25=2;
                }
                break;
            case EngineString:
                {
                alt25=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return stmt;}
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }

            switch (alt25) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:350:2: TypeSystemString ts= dottedIdentifier2 SEMI
                    {
                    match(input,TypeSystemString,FOLLOW_TypeSystemString_in_importStatement983); if (state.failed) return stmt;
                    pushFollow(FOLLOW_dottedIdentifier2_in_importStatement989);
                    ts=dottedIdentifier2();

                    state._fsp--;
                    if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      addImportTypeSystem(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, ts);
                    }
                    match(input,SEMI,FOLLOW_SEMI_in_importStatement992); if (state.failed) return stmt;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:351:4: ScriptString ns= dottedIdentifier2 SEMI
                    {
                    match(input,ScriptString,FOLLOW_ScriptString_in_importStatement997); if (state.failed) return stmt;
                    pushFollow(FOLLOW_dottedIdentifier2_in_importStatement1003);
                    ns=dottedIdentifier2();

                    state._fsp--;
                    if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      addImportScript(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, ns);
                    }
                    match(input,SEMI,FOLLOW_SEMI_in_importStatement1006); if (state.failed) return stmt;

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:352:4: EngineString ns= dottedIdentifier2 SEMI
                    {
                    match(input,EngineString,FOLLOW_EngineString_in_importStatement1011); if (state.failed) return stmt;
                    pushFollow(FOLLOW_dottedIdentifier2_in_importStatement1017);
                    ns=dottedIdentifier2();

                    state._fsp--;
                    if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      addImportEngine(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, ns);
                    }
                    match(input,SEMI,FOLLOW_SEMI_in_importStatement1020); if (state.failed) return stmt;

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return stmt;
    }
    // $ANTLR end "importStatement"


    // $ANTLR start "declaration"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:355:1: declaration returns [RutaStatement stmt = null] : ( DECLARE (lazyParent= annotationType )? id= Identifier ( COMMA id= Identifier )* SEMI | DECLARE type= annotationType newName= Identifier ( LPAREN (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier ( COMMA (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier )* RPAREN ) SEMI ) ;
    public final RutaStatement declaration() throws RecognitionException {
        RutaStatement stmt =  null;

        Token id=null;
        Token newName=null;
        Token obj2=null;
        Token obj3=null;
        Token obj6=null;
        Token obj4=null;
        Token obj5=null;
        Token fname=null;
        Token lazyParent = null;

        Token type = null;

        Token obj1 = null;



        List featureTypes = new ArrayList();
        List featureNames = new ArrayList();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:360:2: ( ( DECLARE (lazyParent= annotationType )? id= Identifier ( COMMA id= Identifier )* SEMI | DECLARE type= annotationType newName= Identifier ( LPAREN (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier ( COMMA (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier )* RPAREN ) SEMI ) )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:361:2: ( DECLARE (lazyParent= annotationType )? id= Identifier ( COMMA id= Identifier )* SEMI | DECLARE type= annotationType newName= Identifier ( LPAREN (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier ( COMMA (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier )* RPAREN ) SEMI )
            {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:361:2: ( DECLARE (lazyParent= annotationType )? id= Identifier ( COMMA id= Identifier )* SEMI | DECLARE type= annotationType newName= Identifier ( LPAREN (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier ( COMMA (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier )* RPAREN ) SEMI )
            int alt31=2;
            alt31 = dfa31.predict(input);
            switch (alt31) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:362:2: DECLARE (lazyParent= annotationType )? id= Identifier ( COMMA id= Identifier )* SEMI
                    {
                    match(input,DECLARE,FOLLOW_DECLARE_in_declaration1044); if (state.failed) return stmt;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:364:13: (lazyParent= annotationType )?
                    int alt26=2;
                    int LA26_0 = input.LA(1);

                    if ( (LA26_0==Identifier) ) {
                        int LA26_1 = input.LA(2);

                        if ( (LA26_1==Identifier||LA26_1==DOT) ) {
                            alt26=1;
                        }
                    }
                    switch (alt26) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:364:13: lazyParent= annotationType
                            {
                            pushFollow(FOLLOW_annotationType_in_declaration1054);
                            lazyParent=annotationType();

                            state._fsp--;
                            if (state.failed) return stmt;

                            }
                            break;

                    }

                    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_declaration1062); if (state.failed) return stmt;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:366:4: ( COMMA id= Identifier )*
                    loop27:
                    do {
                        int alt27=2;
                        int LA27_0 = input.LA(1);

                        if ( (LA27_0==COMMA) ) {
                            alt27=1;
                        }


                        switch (alt27) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:366:5: COMMA id= Identifier
                    	    {
                    	    match(input,COMMA,FOLLOW_COMMA_in_declaration1069); if (state.failed) return stmt;
                    	    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_declaration1083); if (state.failed) return stmt;

                    	    }
                    	    break;

                    	default :
                    	    break loop27;
                        }
                    } while (true);

                    match(input,SEMI,FOLLOW_SEMI_in_declaration1092); if (state.failed) return stmt;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:371:2: DECLARE type= annotationType newName= Identifier ( LPAREN (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier ( COMMA (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier )* RPAREN ) SEMI
                    {
                    match(input,DECLARE,FOLLOW_DECLARE_in_declaration1099); if (state.failed) return stmt;
                    pushFollow(FOLLOW_annotationType_in_declaration1105);
                    type=annotationType();

                    state._fsp--;
                    if (state.failed) return stmt;
                    newName=(Token)match(input,Identifier,FOLLOW_Identifier_in_declaration1111); if (state.failed) return stmt;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:372:3: ( LPAREN (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier ( COMMA (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier )* RPAREN )
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:372:4: LPAREN (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier ( COMMA (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier )* RPAREN
                    {
                    match(input,LPAREN,FOLLOW_LPAREN_in_declaration1117); if (state.failed) return stmt;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:373:4: (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString )
                    int alt28=6;
                    switch ( input.LA(1) ) {
                    case Identifier:
                        {
                        alt28=1;
                        }
                        break;
                    case StringString:
                        {
                        alt28=2;
                        }
                        break;
                    case DoubleString:
                        {
                        alt28=3;
                        }
                        break;
                    case FloatString:
                        {
                        alt28=4;
                        }
                        break;
                    case IntString:
                        {
                        alt28=5;
                        }
                        break;
                    case BooleanString:
                        {
                        alt28=6;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return stmt;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 28, 0, input);

                        throw nvae;
                    }

                    switch (alt28) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:374:4: obj1= annotationType
                            {
                            pushFollow(FOLLOW_annotationType_in_declaration1132);
                            obj1=annotationType();

                            state._fsp--;
                            if (state.failed) return stmt;
                            if ( state.backtracking==0 ) {
                              featureTypes.add(obj1.getText());
                            }

                            }
                            break;
                        case 2 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:375:6: obj2= StringString
                            {
                            obj2=(Token)match(input,StringString,FOLLOW_StringString_in_declaration1145); if (state.failed) return stmt;
                            if ( state.backtracking==0 ) {
                              featureTypes.add(obj2.getText());
                            }

                            }
                            break;
                        case 3 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:376:6: obj3= DoubleString
                            {
                            obj3=(Token)match(input,DoubleString,FOLLOW_DoubleString_in_declaration1158); if (state.failed) return stmt;
                            if ( state.backtracking==0 ) {
                              featureTypes.add(obj3.getText());
                            }

                            }
                            break;
                        case 4 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:377:6: obj6= FloatString
                            {
                            obj6=(Token)match(input,FloatString,FOLLOW_FloatString_in_declaration1170); if (state.failed) return stmt;
                            if ( state.backtracking==0 ) {
                              featureTypes.add(obj6.getText());
                            }

                            }
                            break;
                        case 5 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:378:6: obj4= IntString
                            {
                            obj4=(Token)match(input,IntString,FOLLOW_IntString_in_declaration1182); if (state.failed) return stmt;
                            if ( state.backtracking==0 ) {
                              featureTypes.add(obj4.getText());
                            }

                            }
                            break;
                        case 6 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:379:6: obj5= BooleanString
                            {
                            obj5=(Token)match(input,BooleanString,FOLLOW_BooleanString_in_declaration1194); if (state.failed) return stmt;
                            if ( state.backtracking==0 ) {
                              featureTypes.add(obj5.getText());
                            }

                            }
                            break;

                    }

                    fname=(Token)match(input,Identifier,FOLLOW_Identifier_in_declaration1210); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      featureNames.add(fname.getText());
                    }
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:382:4: ( COMMA (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier )*
                    loop30:
                    do {
                        int alt30=2;
                        int LA30_0 = input.LA(1);

                        if ( (LA30_0==COMMA) ) {
                            alt30=1;
                        }


                        switch (alt30) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:383:4: COMMA (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier
                    	    {
                    	    match(input,COMMA,FOLLOW_COMMA_in_declaration1222); if (state.failed) return stmt;
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:384:4: (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString )
                    	    int alt29=6;
                    	    switch ( input.LA(1) ) {
                    	    case Identifier:
                    	        {
                    	        alt29=1;
                    	        }
                    	        break;
                    	    case StringString:
                    	        {
                    	        alt29=2;
                    	        }
                    	        break;
                    	    case DoubleString:
                    	        {
                    	        alt29=3;
                    	        }
                    	        break;
                    	    case FloatString:
                    	        {
                    	        alt29=4;
                    	        }
                    	        break;
                    	    case IntString:
                    	        {
                    	        alt29=5;
                    	        }
                    	        break;
                    	    case BooleanString:
                    	        {
                    	        alt29=6;
                    	        }
                    	        break;
                    	    default:
                    	        if (state.backtracking>0) {state.failed=true; return stmt;}
                    	        NoViableAltException nvae =
                    	            new NoViableAltException("", 29, 0, input);

                    	        throw nvae;
                    	    }

                    	    switch (alt29) {
                    	        case 1 :
                    	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:385:4: obj1= annotationType
                    	            {
                    	            pushFollow(FOLLOW_annotationType_in_declaration1237);
                    	            obj1=annotationType();

                    	            state._fsp--;
                    	            if (state.failed) return stmt;
                    	            if ( state.backtracking==0 ) {
                    	              featureTypes.add(obj1.getText());
                    	            }

                    	            }
                    	            break;
                    	        case 2 :
                    	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:386:6: obj2= StringString
                    	            {
                    	            obj2=(Token)match(input,StringString,FOLLOW_StringString_in_declaration1250); if (state.failed) return stmt;
                    	            if ( state.backtracking==0 ) {
                    	              featureTypes.add(obj2.getText());
                    	            }

                    	            }
                    	            break;
                    	        case 3 :
                    	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:387:6: obj3= DoubleString
                    	            {
                    	            obj3=(Token)match(input,DoubleString,FOLLOW_DoubleString_in_declaration1263); if (state.failed) return stmt;
                    	            if ( state.backtracking==0 ) {
                    	              featureTypes.add(obj3.getText());
                    	            }

                    	            }
                    	            break;
                    	        case 4 :
                    	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:388:6: obj6= FloatString
                    	            {
                    	            obj6=(Token)match(input,FloatString,FOLLOW_FloatString_in_declaration1275); if (state.failed) return stmt;
                    	            if ( state.backtracking==0 ) {
                    	              featureTypes.add(obj6.getText());
                    	            }

                    	            }
                    	            break;
                    	        case 5 :
                    	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:389:6: obj4= IntString
                    	            {
                    	            obj4=(Token)match(input,IntString,FOLLOW_IntString_in_declaration1287); if (state.failed) return stmt;
                    	            if ( state.backtracking==0 ) {
                    	              featureTypes.add(obj4.getText());
                    	            }

                    	            }
                    	            break;
                    	        case 6 :
                    	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:390:6: obj5= BooleanString
                    	            {
                    	            obj5=(Token)match(input,BooleanString,FOLLOW_BooleanString_in_declaration1299); if (state.failed) return stmt;
                    	            if ( state.backtracking==0 ) {
                    	              featureTypes.add(obj5.getText());
                    	            }

                    	            }
                    	            break;

                    	    }

                    	    fname=(Token)match(input,Identifier,FOLLOW_Identifier_in_declaration1315); if (state.failed) return stmt;
                    	    if ( state.backtracking==0 ) {
                    	      featureNames.add(fname.getText());
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    break loop30;
                        }
                    } while (true);

                    match(input,RPAREN,FOLLOW_RPAREN_in_declaration1323); if (state.failed) return stmt;

                    }

                    match(input,SEMI,FOLLOW_SEMI_in_declaration1326); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      addType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, newName.getText(), type.getText(), featureTypes, featureNames);
                    }

                    }
                    break;

            }


            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return stmt;
    }
    // $ANTLR end "declaration"

    protected static class blockDeclaration_scope {
        RutaBlock env;
    }
    protected Stack blockDeclaration_stack = new Stack();


    // $ANTLR start "blockDeclaration"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:399:1: blockDeclaration returns [RutaBlock block = null] options {backtrack=true; } : type= BlockString LPAREN id= Identifier RPAREN re1= ruleElementWithCA[container] LCURLY body= statements RCURLY ;
    public final RutaBlock blockDeclaration() throws RecognitionException {
        blockDeclaration_stack.push(new blockDeclaration_scope());
        RutaBlock block =  null;

        Token type=null;
        Token id=null;
        RutaRuleElement re1 = null;

        List<RutaStatement> body = null;



        RutaRuleElement re = null;
        RuleElementIsolator container = null;
        level++;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:416:2: (type= BlockString LPAREN id= Identifier RPAREN re1= ruleElementWithCA[container] LCURLY body= statements RCURLY )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:417:2: type= BlockString LPAREN id= Identifier RPAREN re1= ruleElementWithCA[container] LCURLY body= statements RCURLY
            {
            type=(Token)match(input,BlockString,FOLLOW_BlockString_in_blockDeclaration1384); if (state.failed) return block;
            match(input,LPAREN,FOLLOW_LPAREN_in_blockDeclaration1388); if (state.failed) return block;
            id=(Token)match(input,Identifier,FOLLOW_Identifier_in_blockDeclaration1395); if (state.failed) return block;
            match(input,RPAREN,FOLLOW_RPAREN_in_blockDeclaration1399); if (state.failed) return block;
            if ( state.backtracking==0 ) {
              block = factory.createScriptBlock(id, re, body, ((blockDeclaration_scope)blockDeclaration_stack.elementAt(level - 1)).env);
            }
            if ( state.backtracking==0 ) {
              ((blockDeclaration_scope)blockDeclaration_stack.peek()).env = block;
              	container = new RuleElementIsolator();
            }
            pushFollow(FOLLOW_ruleElementWithCA_in_blockDeclaration1412);
            re1=ruleElementWithCA(container);

            state._fsp--;
            if (state.failed) return block;
            if ( state.backtracking==0 ) {
              re = re1;	 
            }
            if ( state.backtracking==0 ) {
              RutaRule rule = factory.createRule(re, block);
              	if(block instanceof RutaScriptBlock) {
              	((RutaScriptBlock)block).setRule(rule);
              	}
              	container.setContainer(rule);
              	
            }
            match(input,LCURLY,FOLLOW_LCURLY_in_blockDeclaration1423); if (state.failed) return block;
            pushFollow(FOLLOW_statements_in_blockDeclaration1429);
            body=statements();

            state._fsp--;
            if (state.failed) return block;
            match(input,RCURLY,FOLLOW_RCURLY_in_blockDeclaration1431); if (state.failed) return block;
            if ( state.backtracking==0 ) {
              block.setElements(body);
              	((blockDeclaration_scope)blockDeclaration_stack.peek()).env.getScript().addBlock(id.getText(),block);
              	
            }

            }

            if ( state.backtracking==0 ) {

              level--;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
            blockDeclaration_stack.pop();
        }
        return block;
    }
    // $ANTLR end "blockDeclaration"

    protected static class automataDeclaration_scope {
        RutaBlock env;
    }
    protected Stack automataDeclaration_stack = new Stack();


    // $ANTLR start "automataDeclaration"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:438:1: automataDeclaration returns [RutaBlock block = null] options {backtrack=true; } : type= AutomataBlockString LPAREN id= Identifier RPAREN re1= ruleElementWithCA[container] LCURLY body= statements RCURLY ;
    public final RutaBlock automataDeclaration() throws RecognitionException {
        automataDeclaration_stack.push(new automataDeclaration_scope());
        RutaBlock block =  null;

        Token type=null;
        Token id=null;
        RutaRuleElement re1 = null;

        List<RutaStatement> body = null;



        RutaRuleElement re = null;
        RuleElementIsolator container = null;
        RutaScriptFactory oldFactory = factory;
        factory = automataFactory; 
        level++;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:457:2: (type= AutomataBlockString LPAREN id= Identifier RPAREN re1= ruleElementWithCA[container] LCURLY body= statements RCURLY )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:459:2: type= AutomataBlockString LPAREN id= Identifier RPAREN re1= ruleElementWithCA[container] LCURLY body= statements RCURLY
            {
            type=(Token)match(input,AutomataBlockString,FOLLOW_AutomataBlockString_in_automataDeclaration1483); if (state.failed) return block;
            match(input,LPAREN,FOLLOW_LPAREN_in_automataDeclaration1487); if (state.failed) return block;
            id=(Token)match(input,Identifier,FOLLOW_Identifier_in_automataDeclaration1494); if (state.failed) return block;
            match(input,RPAREN,FOLLOW_RPAREN_in_automataDeclaration1498); if (state.failed) return block;
            if ( state.backtracking==0 ) {
              block = factory.createAutomataBlock(id, re, body, ((blockDeclaration_scope)blockDeclaration_stack.elementAt(level - 1)).env);
            }
            if ( state.backtracking==0 ) {
              ((blockDeclaration_scope)blockDeclaration_stack.peek()).env = block;
              	container = new RuleElementIsolator();
            }
            pushFollow(FOLLOW_ruleElementWithCA_in_automataDeclaration1511);
            re1=ruleElementWithCA(container);

            state._fsp--;
            if (state.failed) return block;
            if ( state.backtracking==0 ) {
              re = re1;
            }
            if ( state.backtracking==0 ) {
              RutaRule rule = factory.createRule(re, block);
              	if(block instanceof RutaAutomataBlock) {
              	((RutaAutomataBlock)block).setMatchRule(rule);
              	}
              	container.setContainer(rule);
              	
            }
            match(input,LCURLY,FOLLOW_LCURLY_in_automataDeclaration1520); if (state.failed) return block;
            pushFollow(FOLLOW_statements_in_automataDeclaration1526);
            body=statements();

            state._fsp--;
            if (state.failed) return block;
            match(input,RCURLY,FOLLOW_RCURLY_in_automataDeclaration1528); if (state.failed) return block;
            if ( state.backtracking==0 ) {
              block.setElements(body);
              	((blockDeclaration_scope)blockDeclaration_stack.peek()).env.getScript().addBlock(id.getText(),block);

              	
            }

            }

            if ( state.backtracking==0 ) {

              factory = oldFactory;
              level--;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
            automataDeclaration_stack.pop();
        }
        return block;
    }
    // $ANTLR end "automataDeclaration"


    // $ANTLR start "ruleElementWithCA"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:481:1: ruleElementWithCA[RuleElementContainer container] returns [RutaRuleElement re = null] : idRef= typeExpression (q= quantifierPart )? LCURLY (c= conditions )? ( THEN a= actions )? RCURLY ;
    public final RutaRuleElement ruleElementWithCA(RuleElementContainer container) throws RecognitionException {
        RutaRuleElement re =  null;

        TypeExpression idRef = null;

        RuleElementQuantifier q = null;

        List<AbstractRutaCondition> c = null;

        List<AbstractRutaAction> a = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:482:5: (idRef= typeExpression (q= quantifierPart )? LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:484:5: idRef= typeExpression (q= quantifierPart )? LCURLY (c= conditions )? ( THEN a= actions )? RCURLY
            {
            pushFollow(FOLLOW_typeExpression_in_ruleElementWithCA1565);
            idRef=typeExpression();

            state._fsp--;
            if (state.failed) return re;
            if ( state.backtracking==0 ) {
              re = factory.createRuleElement(idRef,null,null,null, container, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:486:7: (q= quantifierPart )?
            int alt32=2;
            int LA32_0 = input.LA(1);

            if ( (LA32_0==LBRACK||LA32_0==PLUS||LA32_0==STAR||LA32_0==QUESTION) ) {
                alt32=1;
            }
            switch (alt32) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:486:7: q= quantifierPart
                    {
                    pushFollow(FOLLOW_quantifierPart_in_ruleElementWithCA1582);
                    q=quantifierPart();

                    state._fsp--;
                    if (state.failed) return re;

                    }
                    break;

            }

            match(input,LCURLY,FOLLOW_LCURLY_in_ruleElementWithCA1594); if (state.failed) return re;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:487:18: (c= conditions )?
            int alt33=2;
            int LA33_0 = input.LA(1);

            if ( (LA33_0==CONTAINS||(LA33_0>=AND && LA33_0<=PARSE)||(LA33_0>=BEFORE && LA33_0<=ENDSWITH)||LA33_0==NOT||LA33_0==SIZE||LA33_0==Identifier||LA33_0==MINUS) ) {
                alt33=1;
            }
            switch (alt33) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:487:18: c= conditions
                    {
                    pushFollow(FOLLOW_conditions_in_ruleElementWithCA1600);
                    c=conditions();

                    state._fsp--;
                    if (state.failed) return re;

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:487:32: ( THEN a= actions )?
            int alt34=2;
            int LA34_0 = input.LA(1);

            if ( (LA34_0==THEN) ) {
                alt34=1;
            }
            switch (alt34) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:487:33: THEN a= actions
                    {
                    match(input,THEN,FOLLOW_THEN_in_ruleElementWithCA1604); if (state.failed) return re;
                    pushFollow(FOLLOW_actions_in_ruleElementWithCA1610);
                    a=actions();

                    state._fsp--;
                    if (state.failed) return re;

                    }
                    break;

            }

            match(input,RCURLY,FOLLOW_RCURLY_in_ruleElementWithCA1614); if (state.failed) return re;
            if ( state.backtracking==0 ) {

              	if(q != null) {
              		re.setQuantifier(q);
              	}
              	if(c!= null) {
              		re.setConditions(c);
              	}
              	if(a != null) {
              		re.setActions(a);
              	}
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return re;
    }
    // $ANTLR end "ruleElementWithCA"


    // $ANTLR start "simpleStatement"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:503:1: simpleStatement returns [RutaStatement stmt = null] options {backtrack=true; } : ( ( regexpRule )=>rer= regexpRule | elements= ruleElements[((RutaRule)stmt).getRoot()] SEMI );
    public final RutaStatement simpleStatement() throws RecognitionException {
        RutaStatement stmt =  null;

        RegExpRule rer = null;

        List<RuleElement> elements = null;



        	//RegExpRule rer = null;
        	Map<TypeExpression, RutaExpression> map = new HashMap<TypeExpression, RutaExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:511:2: ( ( regexpRule )=>rer= regexpRule | elements= ruleElements[((RutaRule)stmt).getRoot()] SEMI )
            int alt35=2;
            int LA35_0 = input.LA(1);

            if ( (LA35_0==StringLiteral) ) {
                int LA35_1 = input.LA(2);

                if ( (synpred1_RutaParser()) ) {
                    alt35=1;
                }
                else if ( (true) ) {
                    alt35=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return stmt;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 35, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA35_0==Identifier) ) {
                int LA35_2 = input.LA(2);

                if ( (synpred1_RutaParser()) ) {
                    alt35=1;
                }
                else if ( (true) ) {
                    alt35=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return stmt;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 35, 2, input);

                    throw nvae;
                }
            }
            else if ( (LA35_0==REMOVESTRING) && (synpred1_RutaParser())) {
                alt35=1;
            }
            else if ( (LA35_0==LPAREN||LA35_0==WILDCARD) ) {
                alt35=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return stmt;}
                NoViableAltException nvae =
                    new NoViableAltException("", 35, 0, input);

                throw nvae;
            }
            switch (alt35) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:513:2: ( regexpRule )=>rer= regexpRule
                    {
                    pushFollow(FOLLOW_regexpRule_in_simpleStatement1674);
                    rer=regexpRule();

                    state._fsp--;
                    if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      stmt = rer;
                    }
                    if ( state.backtracking==0 ) {
                      stmt = rer;
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:518:2: elements= ruleElements[((RutaRule)stmt).getRoot()] SEMI
                    {
                    if ( state.backtracking==0 ) {
                      stmt = factory.createRule(elements, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
                    }
                    pushFollow(FOLLOW_ruleElements_in_simpleStatement1696);
                    elements=ruleElements(((RutaRule)stmt).getRoot());

                    state._fsp--;
                    if (state.failed) return stmt;
                    match(input,SEMI,FOLLOW_SEMI_in_simpleStatement1699); if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      ((RutaRule)stmt).setRuleElements(elements);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return stmt;
    }
    // $ANTLR end "simpleStatement"


    // $ANTLR start "regexpRule"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:526:1: regexpRule returns [RegExpRule stmt = null] : regexp= stringExpression THEN ( ( numberExpression ASSIGN_EQUAL )=>indexCG= numberExpression ASSIGN_EQUAL indexTE= typeExpression | te= typeExpression ) ( COMMA ( ( numberExpression ASSIGN_EQUAL )=>indexCG= numberExpression ASSIGN_EQUAL indexTE= typeExpression | te= typeExpression ) )* SEMI ;
    public final RegExpRule regexpRule() throws RecognitionException {
        RegExpRule stmt =  null;

        StringExpression regexp = null;

        NumberExpression indexCG = null;

        TypeExpression indexTE = null;

        TypeExpression te = null;



        	Map<TypeExpression, NumberExpression> map = new HashMap<TypeExpression, NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:530:2: (regexp= stringExpression THEN ( ( numberExpression ASSIGN_EQUAL )=>indexCG= numberExpression ASSIGN_EQUAL indexTE= typeExpression | te= typeExpression ) ( COMMA ( ( numberExpression ASSIGN_EQUAL )=>indexCG= numberExpression ASSIGN_EQUAL indexTE= typeExpression | te= typeExpression ) )* SEMI )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:531:2: regexp= stringExpression THEN ( ( numberExpression ASSIGN_EQUAL )=>indexCG= numberExpression ASSIGN_EQUAL indexTE= typeExpression | te= typeExpression ) ( COMMA ( ( numberExpression ASSIGN_EQUAL )=>indexCG= numberExpression ASSIGN_EQUAL indexTE= typeExpression | te= typeExpression ) )* SEMI
            {
            if ( state.backtracking==0 ) {

              	stmt = factory.createRegExpRule(((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }
            pushFollow(FOLLOW_stringExpression_in_regexpRule1735);
            regexp=stringExpression();

            state._fsp--;
            if (state.failed) return stmt;
            match(input,THEN,FOLLOW_THEN_in_regexpRule1737); if (state.failed) return stmt;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:535:2: ( ( numberExpression ASSIGN_EQUAL )=>indexCG= numberExpression ASSIGN_EQUAL indexTE= typeExpression | te= typeExpression )
            int alt36=2;
            int LA36_0 = input.LA(1);

            if ( (LA36_0==MINUS) && (synpred2_RutaParser())) {
                alt36=1;
            }
            else if ( (LA36_0==DecimalLiteral) && (synpred2_RutaParser())) {
                alt36=1;
            }
            else if ( (LA36_0==FloatingPointLiteral) && (synpred2_RutaParser())) {
                alt36=1;
            }
            else if ( (LA36_0==Identifier) ) {
                int LA36_4 = input.LA(2);

                if ( (((synpred2_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INT")))||(synpred2_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLE")))||(synpred2_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOAT")))||synpred2_RutaParser())) ) {
                    alt36=1;
                }
                else if ( (true) ) {
                    alt36=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return stmt;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 36, 4, input);

                    throw nvae;
                }
            }
            else if ( (LA36_0==LPAREN) && (synpred2_RutaParser())) {
                alt36=1;
            }
            else if ( ((LA36_0>=EXP && LA36_0<=TAN)) && (synpred2_RutaParser())) {
                alt36=1;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return stmt;}
                NoViableAltException nvae =
                    new NoViableAltException("", 36, 0, input);

                throw nvae;
            }
            switch (alt36) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:536:2: ( numberExpression ASSIGN_EQUAL )=>indexCG= numberExpression ASSIGN_EQUAL indexTE= typeExpression
                    {
                    pushFollow(FOLLOW_numberExpression_in_regexpRule1754);
                    indexCG=numberExpression();

                    state._fsp--;
                    if (state.failed) return stmt;
                    match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_regexpRule1756); if (state.failed) return stmt;
                    pushFollow(FOLLOW_typeExpression_in_regexpRule1762);
                    indexTE=typeExpression();

                    state._fsp--;
                    if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      map.put(indexTE, indexCG);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:538:2: te= typeExpression
                    {
                    pushFollow(FOLLOW_typeExpression_in_regexpRule1774);
                    te=typeExpression();

                    state._fsp--;
                    if (state.failed) return stmt;
                    if ( state.backtracking==0 ) {
                      map.put(te, null);
                    }

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:540:2: ( COMMA ( ( numberExpression ASSIGN_EQUAL )=>indexCG= numberExpression ASSIGN_EQUAL indexTE= typeExpression | te= typeExpression ) )*
            loop38:
            do {
                int alt38=2;
                int LA38_0 = input.LA(1);

                if ( (LA38_0==COMMA) ) {
                    alt38=1;
                }


                switch (alt38) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:541:2: COMMA ( ( numberExpression ASSIGN_EQUAL )=>indexCG= numberExpression ASSIGN_EQUAL indexTE= typeExpression | te= typeExpression )
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_regexpRule1785); if (state.failed) return stmt;
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:542:2: ( ( numberExpression ASSIGN_EQUAL )=>indexCG= numberExpression ASSIGN_EQUAL indexTE= typeExpression | te= typeExpression )
            	    int alt37=2;
            	    int LA37_0 = input.LA(1);

            	    if ( (LA37_0==MINUS) && (synpred3_RutaParser())) {
            	        alt37=1;
            	    }
            	    else if ( (LA37_0==DecimalLiteral) && (synpred3_RutaParser())) {
            	        alt37=1;
            	    }
            	    else if ( (LA37_0==FloatingPointLiteral) && (synpred3_RutaParser())) {
            	        alt37=1;
            	    }
            	    else if ( (LA37_0==Identifier) ) {
            	        int LA37_4 = input.LA(2);

            	        if ( (((synpred3_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INT")))||synpred3_RutaParser()||(synpred3_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOAT")))||(synpred3_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLE"))))) ) {
            	            alt37=1;
            	        }
            	        else if ( (true) ) {
            	            alt37=2;
            	        }
            	        else {
            	            if (state.backtracking>0) {state.failed=true; return stmt;}
            	            NoViableAltException nvae =
            	                new NoViableAltException("", 37, 4, input);

            	            throw nvae;
            	        }
            	    }
            	    else if ( (LA37_0==LPAREN) && (synpred3_RutaParser())) {
            	        alt37=1;
            	    }
            	    else if ( ((LA37_0>=EXP && LA37_0<=TAN)) && (synpred3_RutaParser())) {
            	        alt37=1;
            	    }
            	    else {
            	        if (state.backtracking>0) {state.failed=true; return stmt;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 37, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt37) {
            	        case 1 :
            	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:543:2: ( numberExpression ASSIGN_EQUAL )=>indexCG= numberExpression ASSIGN_EQUAL indexTE= typeExpression
            	            {
            	            pushFollow(FOLLOW_numberExpression_in_regexpRule1802);
            	            indexCG=numberExpression();

            	            state._fsp--;
            	            if (state.failed) return stmt;
            	            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_regexpRule1804); if (state.failed) return stmt;
            	            pushFollow(FOLLOW_typeExpression_in_regexpRule1810);
            	            indexTE=typeExpression();

            	            state._fsp--;
            	            if (state.failed) return stmt;
            	            if ( state.backtracking==0 ) {
            	              map.put(indexTE, indexCG);
            	            }

            	            }
            	            break;
            	        case 2 :
            	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:545:2: te= typeExpression
            	            {
            	            pushFollow(FOLLOW_typeExpression_in_regexpRule1822);
            	            te=typeExpression();

            	            state._fsp--;
            	            if (state.failed) return stmt;
            	            if ( state.backtracking==0 ) {
            	              map.put(te, null);
            	            }

            	            }
            	            break;

            	    }


            	    }
            	    break;

            	default :
            	    break loop38;
                }
            } while (true);

            match(input,SEMI,FOLLOW_SEMI_in_regexpRule1837); if (state.failed) return stmt;
            if ( state.backtracking==0 ) {
              stmt.setRegExp(regexp);
              	stmt.setTypeMap(map);
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return stmt;
    }
    // $ANTLR end "regexpRule"


    // $ANTLR start "ruleElements"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:559:1: ruleElements[RuleElementContainer container] returns [List<RuleElement> elements = new ArrayList<RuleElement>()] : re= ruleElement[container] (re= ruleElement[container] )* ;
    public final List<RuleElement> ruleElements(RuleElementContainer container) throws RecognitionException {
        List<RuleElement> elements =  new ArrayList<RuleElement>();

        RuleElement re = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:560:2: (re= ruleElement[container] (re= ruleElement[container] )* )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:561:2: re= ruleElement[container] (re= ruleElement[container] )*
            {
            pushFollow(FOLLOW_ruleElement_in_ruleElements1866);
            re=ruleElement(container);

            state._fsp--;
            if (state.failed) return elements;
            if ( state.backtracking==0 ) {
              elements.add(re);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:561:50: (re= ruleElement[container] )*
            loop39:
            do {
                int alt39=2;
                int LA39_0 = input.LA(1);

                if ( (LA39_0==StringLiteral||(LA39_0>=Identifier && LA39_0<=LPAREN)||LA39_0==WILDCARD) ) {
                    alt39=1;
                }


                switch (alt39) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:561:51: re= ruleElement[container]
            	    {
            	    pushFollow(FOLLOW_ruleElement_in_ruleElements1876);
            	    re=ruleElement(container);

            	    state._fsp--;
            	    if (state.failed) return elements;
            	    if ( state.backtracking==0 ) {
            	      elements.add(re);
            	    }

            	    }
            	    break;

            	default :
            	    break loop39;
                }
            } while (true);


            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return elements;
    }
    // $ANTLR end "ruleElements"


    // $ANTLR start "ruleElement"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:565:1: ruleElement[RuleElementContainer container] returns [RuleElement re = null] : (re1= ruleElementType[container] | re2= ruleElementLiteral[container] | ( ruleElementComposed[null] )=>re3= ruleElementComposed[container] | ( ruleElementDisjunctive[null] )=>re4= ruleElementDisjunctive[container] | ( ruleElementWildCard[null] )=>re5= ruleElementWildCard[container] );
    public final RuleElement ruleElement(RuleElementContainer container) throws RecognitionException {
        RuleElement re =  null;

        RutaRuleElement re1 = null;

        RutaRuleElement re2 = null;

        ComposedRuleElement re3 = null;

        RutaRuleElement re4 = null;

        AbstractRuleElement re5 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:566:2: (re1= ruleElementType[container] | re2= ruleElementLiteral[container] | ( ruleElementComposed[null] )=>re3= ruleElementComposed[container] | ( ruleElementDisjunctive[null] )=>re4= ruleElementDisjunctive[container] | ( ruleElementWildCard[null] )=>re5= ruleElementWildCard[container] )
            int alt40=5;
            int LA40_0 = input.LA(1);

            if ( (LA40_0==Identifier) ) {
                int LA40_1 = input.LA(2);

                if ( (!(((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRING"))))) ) {
                    alt40=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRING"))) ) {
                    alt40=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return re;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 40, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA40_0==StringLiteral) ) {
                alt40=2;
            }
            else if ( (LA40_0==LPAREN) ) {
                int LA40_3 = input.LA(2);

                if ( (synpred4_RutaParser()) ) {
                    alt40=3;
                }
                else if ( (synpred5_RutaParser()) ) {
                    alt40=4;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return re;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 40, 3, input);

                    throw nvae;
                }
            }
            else if ( (LA40_0==WILDCARD) && (synpred6_RutaParser())) {
                alt40=5;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return re;}
                NoViableAltException nvae =
                    new NoViableAltException("", 40, 0, input);

                throw nvae;
            }
            switch (alt40) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:567:2: re1= ruleElementType[container]
                    {
                    pushFollow(FOLLOW_ruleElementType_in_ruleElement1905);
                    re1=ruleElementType(container);

                    state._fsp--;
                    if (state.failed) return re;
                    if ( state.backtracking==0 ) {
                      re = re1;
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:568:4: re2= ruleElementLiteral[container]
                    {
                    pushFollow(FOLLOW_ruleElementLiteral_in_ruleElement1917);
                    re2=ruleElementLiteral(container);

                    state._fsp--;
                    if (state.failed) return re;
                    if ( state.backtracking==0 ) {
                      re = re2;
                    }

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:569:4: ( ruleElementComposed[null] )=>re3= ruleElementComposed[container]
                    {
                    pushFollow(FOLLOW_ruleElementComposed_in_ruleElement1934);
                    re3=ruleElementComposed(container);

                    state._fsp--;
                    if (state.failed) return re;
                    if ( state.backtracking==0 ) {
                      re = re3;
                    }

                    }
                    break;
                case 4 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:570:4: ( ruleElementDisjunctive[null] )=>re4= ruleElementDisjunctive[container]
                    {
                    pushFollow(FOLLOW_ruleElementDisjunctive_in_ruleElement1952);
                    re4=ruleElementDisjunctive(container);

                    state._fsp--;
                    if (state.failed) return re;
                    if ( state.backtracking==0 ) {
                      re = re4;
                    }

                    }
                    break;
                case 5 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:571:4: ( ruleElementWildCard[null] )=>re5= ruleElementWildCard[container]
                    {
                    pushFollow(FOLLOW_ruleElementWildCard_in_ruleElement1970);
                    re5=ruleElementWildCard(container);

                    state._fsp--;
                    if (state.failed) return re;
                    if ( state.backtracking==0 ) {
                      re = re5;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return re;
    }
    // $ANTLR end "ruleElement"


    // $ANTLR start "ruleElementWildCard"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:574:1: ruleElementWildCard[RuleElementContainer container] returns [AbstractRuleElement re = null] : w= WILDCARD ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )? ;
    public final AbstractRuleElement ruleElementWildCard(RuleElementContainer container) throws RecognitionException {
        AbstractRuleElement re =  null;

        Token w=null;
        List<AbstractRutaCondition> c = null;

        List<AbstractRutaAction> a = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:575:5: (w= WILDCARD ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )? )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:577:5: w= WILDCARD ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )?
            {
            w=(Token)match(input,WILDCARD,FOLLOW_WILDCARD_in_ruleElementWildCard2007); if (state.failed) return re;
            if ( state.backtracking==0 ) {
              re = factory.createWildCardRuleElement(null, null, container, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:579:9: ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )?
            int alt43=2;
            int LA43_0 = input.LA(1);

            if ( (LA43_0==LCURLY) ) {
                alt43=1;
            }
            switch (alt43) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:579:10: LCURLY (c= conditions )? ( THEN a= actions )? RCURLY
                    {
                    match(input,LCURLY,FOLLOW_LCURLY_in_ruleElementWildCard2027); if (state.failed) return re;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:579:19: (c= conditions )?
                    int alt41=2;
                    int LA41_0 = input.LA(1);

                    if ( (LA41_0==CONTAINS||(LA41_0>=AND && LA41_0<=PARSE)||(LA41_0>=BEFORE && LA41_0<=ENDSWITH)||LA41_0==NOT||LA41_0==SIZE||LA41_0==Identifier||LA41_0==MINUS) ) {
                        alt41=1;
                    }
                    switch (alt41) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:579:19: c= conditions
                            {
                            pushFollow(FOLLOW_conditions_in_ruleElementWildCard2033);
                            c=conditions();

                            state._fsp--;
                            if (state.failed) return re;

                            }
                            break;

                    }

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:579:33: ( THEN a= actions )?
                    int alt42=2;
                    int LA42_0 = input.LA(1);

                    if ( (LA42_0==THEN) ) {
                        alt42=1;
                    }
                    switch (alt42) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:579:34: THEN a= actions
                            {
                            match(input,THEN,FOLLOW_THEN_in_ruleElementWildCard2037); if (state.failed) return re;
                            pushFollow(FOLLOW_actions_in_ruleElementWildCard2043);
                            a=actions();

                            state._fsp--;
                            if (state.failed) return re;

                            }
                            break;

                    }

                    match(input,RCURLY,FOLLOW_RCURLY_in_ruleElementWildCard2047); if (state.failed) return re;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {

              	if(c!= null) {
              		re.setConditions(c);
              	}
              	if(a != null) {
              		re.setActions(a);
              	}
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return re;
    }
    // $ANTLR end "ruleElementWildCard"


    // $ANTLR start "ruleElementDisjunctive"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:591:1: ruleElementDisjunctive[RuleElementContainer container] returns [RutaRuleElement re = null] : LPAREN ( ( typeExpression | simpleStringExpression ) VBAR )=> (e11= typeExpression | e12= simpleStringExpression ) VBAR (e21= typeExpression | e22= simpleStringExpression ) ( VBAR (e31= typeExpression | e32= simpleStringExpression ) )* RPAREN (q= quantifierPart )? ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )? ;
    public final RutaRuleElement ruleElementDisjunctive(RuleElementContainer container) throws RecognitionException {
        RutaRuleElement re =  null;

        TypeExpression e11 = null;

        StringExpression e12 = null;

        TypeExpression e21 = null;

        StringExpression e22 = null;

        TypeExpression e31 = null;

        StringExpression e32 = null;

        RuleElementQuantifier q = null;

        List<AbstractRutaCondition> c = null;

        List<AbstractRutaAction> a = null;



        	List<RutaExpression> exprs = new ArrayList<RutaExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:595:5: ( LPAREN ( ( typeExpression | simpleStringExpression ) VBAR )=> (e11= typeExpression | e12= simpleStringExpression ) VBAR (e21= typeExpression | e22= simpleStringExpression ) ( VBAR (e31= typeExpression | e32= simpleStringExpression ) )* RPAREN (q= quantifierPart )? ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )? )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:596:5: LPAREN ( ( typeExpression | simpleStringExpression ) VBAR )=> (e11= typeExpression | e12= simpleStringExpression ) VBAR (e21= typeExpression | e22= simpleStringExpression ) ( VBAR (e31= typeExpression | e32= simpleStringExpression ) )* RPAREN (q= quantifierPart )? ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )?
            {
            match(input,LPAREN,FOLLOW_LPAREN_in_ruleElementDisjunctive2086); if (state.failed) return re;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:597:57: (e11= typeExpression | e12= simpleStringExpression )
            int alt44=2;
            int LA44_0 = input.LA(1);

            if ( (LA44_0==Identifier) ) {
                int LA44_1 = input.LA(2);

                if ( (!(((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRING"))))) ) {
                    alt44=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRING"))) ) {
                    alt44=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return re;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 44, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA44_0==StringLiteral) ) {
                alt44=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return re;}
                NoViableAltException nvae =
                    new NoViableAltException("", 44, 0, input);

                throw nvae;
            }
            switch (alt44) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:597:58: e11= typeExpression
                    {
                    pushFollow(FOLLOW_typeExpression_in_ruleElementDisjunctive2110);
                    e11=typeExpression();

                    state._fsp--;
                    if (state.failed) return re;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:597:80: e12= simpleStringExpression
                    {
                    pushFollow(FOLLOW_simpleStringExpression_in_ruleElementDisjunctive2117);
                    e12=simpleStringExpression();

                    state._fsp--;
                    if (state.failed) return re;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
              if(e11 != null) exprs.add(e11);if(e12 != null) exprs.add(e12);
            }
            match(input,VBAR,FOLLOW_VBAR_in_ruleElementDisjunctive2132); if (state.failed) return re;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:599:10: (e21= typeExpression | e22= simpleStringExpression )
            int alt45=2;
            int LA45_0 = input.LA(1);

            if ( (LA45_0==Identifier) ) {
                int LA45_1 = input.LA(2);

                if ( (!(((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRING"))))) ) {
                    alt45=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRING"))) ) {
                    alt45=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return re;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 45, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA45_0==StringLiteral) ) {
                alt45=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return re;}
                NoViableAltException nvae =
                    new NoViableAltException("", 45, 0, input);

                throw nvae;
            }
            switch (alt45) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:599:11: e21= typeExpression
                    {
                    pushFollow(FOLLOW_typeExpression_in_ruleElementDisjunctive2138);
                    e21=typeExpression();

                    state._fsp--;
                    if (state.failed) return re;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:599:33: e22= simpleStringExpression
                    {
                    pushFollow(FOLLOW_simpleStringExpression_in_ruleElementDisjunctive2145);
                    e22=simpleStringExpression();

                    state._fsp--;
                    if (state.failed) return re;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
              if(e21 != null) exprs.add(e21);if(e22 != null) exprs.add(e22);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:601:5: ( VBAR (e31= typeExpression | e32= simpleStringExpression ) )*
            loop47:
            do {
                int alt47=2;
                int LA47_0 = input.LA(1);

                if ( (LA47_0==VBAR) ) {
                    alt47=1;
                }


                switch (alt47) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:602:5: VBAR (e31= typeExpression | e32= simpleStringExpression )
            	    {
            	    match(input,VBAR,FOLLOW_VBAR_in_ruleElementDisjunctive2166); if (state.failed) return re;
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:602:11: (e31= typeExpression | e32= simpleStringExpression )
            	    int alt46=2;
            	    int LA46_0 = input.LA(1);

            	    if ( (LA46_0==Identifier) ) {
            	        int LA46_1 = input.LA(2);

            	        if ( (!(((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRING"))))) ) {
            	            alt46=1;
            	        }
            	        else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRING"))) ) {
            	            alt46=2;
            	        }
            	        else {
            	            if (state.backtracking>0) {state.failed=true; return re;}
            	            NoViableAltException nvae =
            	                new NoViableAltException("", 46, 1, input);

            	            throw nvae;
            	        }
            	    }
            	    else if ( (LA46_0==StringLiteral) ) {
            	        alt46=2;
            	    }
            	    else {
            	        if (state.backtracking>0) {state.failed=true; return re;}
            	        NoViableAltException nvae =
            	            new NoViableAltException("", 46, 0, input);

            	        throw nvae;
            	    }
            	    switch (alt46) {
            	        case 1 :
            	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:602:12: e31= typeExpression
            	            {
            	            pushFollow(FOLLOW_typeExpression_in_ruleElementDisjunctive2173);
            	            e31=typeExpression();

            	            state._fsp--;
            	            if (state.failed) return re;

            	            }
            	            break;
            	        case 2 :
            	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:602:34: e32= simpleStringExpression
            	            {
            	            pushFollow(FOLLOW_simpleStringExpression_in_ruleElementDisjunctive2180);
            	            e32=simpleStringExpression();

            	            state._fsp--;
            	            if (state.failed) return re;

            	            }
            	            break;

            	    }

            	    if ( state.backtracking==0 ) {
            	      if(e31 != null) exprs.add(e31);if(e32 != null) exprs.add(e32);
            	    }

            	    }
            	    break;

            	default :
            	    break loop47;
                }
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_ruleElementDisjunctive2202); if (state.failed) return re;
            if ( state.backtracking==0 ) {
               re = factory.createRuleElement(exprs, null, null, null, container, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:608:8: (q= quantifierPart )?
            int alt48=2;
            int LA48_0 = input.LA(1);

            if ( (LA48_0==LBRACK||LA48_0==PLUS||LA48_0==STAR||LA48_0==QUESTION) ) {
                alt48=1;
            }
            switch (alt48) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:608:8: q= quantifierPart
                    {
                    pushFollow(FOLLOW_quantifierPart_in_ruleElementDisjunctive2228);
                    q=quantifierPart();

                    state._fsp--;
                    if (state.failed) return re;

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:609:9: ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )?
            int alt51=2;
            int LA51_0 = input.LA(1);

            if ( (LA51_0==LCURLY) ) {
                alt51=1;
            }
            switch (alt51) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:609:10: LCURLY (c= conditions )? ( THEN a= actions )? RCURLY
                    {
                    match(input,LCURLY,FOLLOW_LCURLY_in_ruleElementDisjunctive2241); if (state.failed) return re;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:609:19: (c= conditions )?
                    int alt49=2;
                    int LA49_0 = input.LA(1);

                    if ( (LA49_0==CONTAINS||(LA49_0>=AND && LA49_0<=PARSE)||(LA49_0>=BEFORE && LA49_0<=ENDSWITH)||LA49_0==NOT||LA49_0==SIZE||LA49_0==Identifier||LA49_0==MINUS) ) {
                        alt49=1;
                    }
                    switch (alt49) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:609:19: c= conditions
                            {
                            pushFollow(FOLLOW_conditions_in_ruleElementDisjunctive2247);
                            c=conditions();

                            state._fsp--;
                            if (state.failed) return re;

                            }
                            break;

                    }

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:609:33: ( THEN a= actions )?
                    int alt50=2;
                    int LA50_0 = input.LA(1);

                    if ( (LA50_0==THEN) ) {
                        alt50=1;
                    }
                    switch (alt50) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:609:34: THEN a= actions
                            {
                            match(input,THEN,FOLLOW_THEN_in_ruleElementDisjunctive2251); if (state.failed) return re;
                            pushFollow(FOLLOW_actions_in_ruleElementDisjunctive2257);
                            a=actions();

                            state._fsp--;
                            if (state.failed) return re;

                            }
                            break;

                    }

                    match(input,RCURLY,FOLLOW_RCURLY_in_ruleElementDisjunctive2261); if (state.failed) return re;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {

              	if(q != null) {
              		re.setQuantifier(q);
              	}
              	if(c!= null) {
              		re.setConditions(c);
              	}
              	if(a != null) {
              		re.setActions(a);
              	}
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return re;
    }
    // $ANTLR end "ruleElementDisjunctive"

    protected static class ruleElementComposed_scope {
        RuleElementContainer con;
    }
    protected Stack ruleElementComposed_stack = new Stack();


    // $ANTLR start "ruleElementComposed"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:623:1: ruleElementComposed[RuleElementContainer container] returns [ComposedRuleElement re = null] : LPAREN ( ( ruleElements[$ruleElementComposed::con] )=>res= ruleElements[$ruleElementComposed::con] ) RPAREN (q= quantifierPart )? ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )? ;
    public final ComposedRuleElement ruleElementComposed(RuleElementContainer container) throws RecognitionException {
        ruleElementComposed_stack.push(new ruleElementComposed_scope());
        ComposedRuleElement re =  null;

        List<RuleElement> res = null;

        RuleElementQuantifier q = null;

        List<AbstractRutaCondition> c = null;

        List<AbstractRutaAction> a = null;





        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:630:2: ( LPAREN ( ( ruleElements[$ruleElementComposed::con] )=>res= ruleElements[$ruleElementComposed::con] ) RPAREN (q= quantifierPart )? ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )? )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:631:2: LPAREN ( ( ruleElements[$ruleElementComposed::con] )=>res= ruleElements[$ruleElementComposed::con] ) RPAREN (q= quantifierPart )? ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )?
            {
            if ( state.backtracking==0 ) {
              re = factory.createComposedRuleElement(container, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
              	// dre = factory.createDisjunctiveRuleElement(container, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
              	((ruleElementComposed_scope)ruleElementComposed_stack.peek()).con = re;
            }
            match(input,LPAREN,FOLLOW_LPAREN_in_ruleElementComposed2302); if (state.failed) return re;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:636:2: ( ( ruleElements[$ruleElementComposed::con] )=>res= ruleElements[$ruleElementComposed::con] )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:642:2: ( ruleElements[$ruleElementComposed::con] )=>res= ruleElements[$ruleElementComposed::con]
            {
            pushFollow(FOLLOW_ruleElements_in_ruleElementComposed2330);
            res=ruleElements(((ruleElementComposed_scope)ruleElementComposed_stack.peek()).con);

            state._fsp--;
            if (state.failed) return re;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_ruleElementComposed2340); if (state.failed) return re;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:645:11: (q= quantifierPart )?
            int alt52=2;
            int LA52_0 = input.LA(1);

            if ( (LA52_0==LBRACK||LA52_0==PLUS||LA52_0==STAR||LA52_0==QUESTION) ) {
                alt52=1;
            }
            switch (alt52) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:645:11: q= quantifierPart
                    {
                    pushFollow(FOLLOW_quantifierPart_in_ruleElementComposed2346);
                    q=quantifierPart();

                    state._fsp--;
                    if (state.failed) return re;

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:645:29: ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )?
            int alt55=2;
            int LA55_0 = input.LA(1);

            if ( (LA55_0==LCURLY) ) {
                alt55=1;
            }
            switch (alt55) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:645:30: LCURLY (c= conditions )? ( THEN a= actions )? RCURLY
                    {
                    match(input,LCURLY,FOLLOW_LCURLY_in_ruleElementComposed2350); if (state.failed) return re;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:645:39: (c= conditions )?
                    int alt53=2;
                    int LA53_0 = input.LA(1);

                    if ( (LA53_0==CONTAINS||(LA53_0>=AND && LA53_0<=PARSE)||(LA53_0>=BEFORE && LA53_0<=ENDSWITH)||LA53_0==NOT||LA53_0==SIZE||LA53_0==Identifier||LA53_0==MINUS) ) {
                        alt53=1;
                    }
                    switch (alt53) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:645:39: c= conditions
                            {
                            pushFollow(FOLLOW_conditions_in_ruleElementComposed2356);
                            c=conditions();

                            state._fsp--;
                            if (state.failed) return re;

                            }
                            break;

                    }

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:645:53: ( THEN a= actions )?
                    int alt54=2;
                    int LA54_0 = input.LA(1);

                    if ( (LA54_0==THEN) ) {
                        alt54=1;
                    }
                    switch (alt54) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:645:54: THEN a= actions
                            {
                            match(input,THEN,FOLLOW_THEN_in_ruleElementComposed2360); if (state.failed) return re;
                            pushFollow(FOLLOW_actions_in_ruleElementComposed2366);
                            a=actions();

                            state._fsp--;
                            if (state.failed) return re;

                            }
                            break;

                    }

                    match(input,RCURLY,FOLLOW_RCURLY_in_ruleElementComposed2370); if (state.failed) return re;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {

              	re.setRuleElements(res);
              	if(q != null) {
              		re.setQuantifier(q);
              	}
              	if(c!= null) {
              		re.setConditions(c);
              	}
              	if(a != null) {
              		re.setActions(a);
              	}
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
            ruleElementComposed_stack.pop();
        }
        return re;
    }
    // $ANTLR end "ruleElementComposed"


    // $ANTLR start "ruleElementType"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:661:1: ruleElementType[RuleElementContainer container] returns [RutaRuleElement re = null] : ( typeExpression )=>typeExpr= typeExpression (q= quantifierPart )? ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )? ;
    public final RutaRuleElement ruleElementType(RuleElementContainer container) throws RecognitionException {
        RutaRuleElement re =  null;

        TypeExpression typeExpr = null;

        RuleElementQuantifier q = null;

        List<AbstractRutaCondition> c = null;

        List<AbstractRutaAction> a = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:662:5: ( ( typeExpression )=>typeExpr= typeExpression (q= quantifierPart )? ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )? )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:664:5: ( typeExpression )=>typeExpr= typeExpression (q= quantifierPart )? ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )?
            {
            pushFollow(FOLLOW_typeExpression_in_ruleElementType2413);
            typeExpr=typeExpression();

            state._fsp--;
            if (state.failed) return re;
            if ( state.backtracking==0 ) {
              re = factory.createRuleElement(typeExpr, null, null, null, container, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:666:7: (q= quantifierPart )?
            int alt56=2;
            int LA56_0 = input.LA(1);

            if ( (LA56_0==LBRACK||LA56_0==PLUS||LA56_0==STAR||LA56_0==QUESTION) ) {
                alt56=1;
            }
            switch (alt56) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:666:7: q= quantifierPart
                    {
                    pushFollow(FOLLOW_quantifierPart_in_ruleElementType2432);
                    q=quantifierPart();

                    state._fsp--;
                    if (state.failed) return re;

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:667:9: ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )?
            int alt59=2;
            int LA59_0 = input.LA(1);

            if ( (LA59_0==LCURLY) ) {
                alt59=1;
            }
            switch (alt59) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:667:10: LCURLY (c= conditions )? ( THEN a= actions )? RCURLY
                    {
                    match(input,LCURLY,FOLLOW_LCURLY_in_ruleElementType2445); if (state.failed) return re;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:667:19: (c= conditions )?
                    int alt57=2;
                    int LA57_0 = input.LA(1);

                    if ( (LA57_0==CONTAINS||(LA57_0>=AND && LA57_0<=PARSE)||(LA57_0>=BEFORE && LA57_0<=ENDSWITH)||LA57_0==NOT||LA57_0==SIZE||LA57_0==Identifier||LA57_0==MINUS) ) {
                        alt57=1;
                    }
                    switch (alt57) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:667:19: c= conditions
                            {
                            pushFollow(FOLLOW_conditions_in_ruleElementType2451);
                            c=conditions();

                            state._fsp--;
                            if (state.failed) return re;

                            }
                            break;

                    }

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:667:33: ( THEN a= actions )?
                    int alt58=2;
                    int LA58_0 = input.LA(1);

                    if ( (LA58_0==THEN) ) {
                        alt58=1;
                    }
                    switch (alt58) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:667:34: THEN a= actions
                            {
                            match(input,THEN,FOLLOW_THEN_in_ruleElementType2455); if (state.failed) return re;
                            pushFollow(FOLLOW_actions_in_ruleElementType2461);
                            a=actions();

                            state._fsp--;
                            if (state.failed) return re;

                            }
                            break;

                    }

                    match(input,RCURLY,FOLLOW_RCURLY_in_ruleElementType2465); if (state.failed) return re;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {

              	if(q != null) {
              		re.setQuantifier(q);
              	}
              	if(c!= null) {
              		re.setConditions(c);
              	}
              	if(a != null) {
              		re.setActions(a);
              	}
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return re;
    }
    // $ANTLR end "ruleElementType"


    // $ANTLR start "ruleElementLiteral"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:681:1: ruleElementLiteral[RuleElementContainer container] returns [RutaRuleElement re = null] : ( simpleStringExpression )=>stringExpr= simpleStringExpression (q= quantifierPart )? ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )? ;
    public final RutaRuleElement ruleElementLiteral(RuleElementContainer container) throws RecognitionException {
        RutaRuleElement re =  null;

        StringExpression stringExpr = null;

        RuleElementQuantifier q = null;

        List<AbstractRutaCondition> c = null;

        List<AbstractRutaAction> a = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:682:5: ( ( simpleStringExpression )=>stringExpr= simpleStringExpression (q= quantifierPart )? ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )? )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:684:5: ( simpleStringExpression )=>stringExpr= simpleStringExpression (q= quantifierPart )? ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )?
            {
            pushFollow(FOLLOW_simpleStringExpression_in_ruleElementLiteral2512);
            stringExpr=simpleStringExpression();

            state._fsp--;
            if (state.failed) return re;
            if ( state.backtracking==0 ) {
              re = factory.createRuleElement(stringExpr, null, null, null, container, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:687:7: (q= quantifierPart )?
            int alt60=2;
            int LA60_0 = input.LA(1);

            if ( (LA60_0==LBRACK||LA60_0==PLUS||LA60_0==STAR||LA60_0==QUESTION) ) {
                alt60=1;
            }
            switch (alt60) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:687:7: q= quantifierPart
                    {
                    pushFollow(FOLLOW_quantifierPart_in_ruleElementLiteral2536);
                    q=quantifierPart();

                    state._fsp--;
                    if (state.failed) return re;

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:688:9: ( LCURLY (c= conditions )? ( THEN a= actions )? RCURLY )?
            int alt63=2;
            int LA63_0 = input.LA(1);

            if ( (LA63_0==LCURLY) ) {
                alt63=1;
            }
            switch (alt63) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:688:10: LCURLY (c= conditions )? ( THEN a= actions )? RCURLY
                    {
                    match(input,LCURLY,FOLLOW_LCURLY_in_ruleElementLiteral2549); if (state.failed) return re;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:688:19: (c= conditions )?
                    int alt61=2;
                    int LA61_0 = input.LA(1);

                    if ( (LA61_0==CONTAINS||(LA61_0>=AND && LA61_0<=PARSE)||(LA61_0>=BEFORE && LA61_0<=ENDSWITH)||LA61_0==NOT||LA61_0==SIZE||LA61_0==Identifier||LA61_0==MINUS) ) {
                        alt61=1;
                    }
                    switch (alt61) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:688:19: c= conditions
                            {
                            pushFollow(FOLLOW_conditions_in_ruleElementLiteral2555);
                            c=conditions();

                            state._fsp--;
                            if (state.failed) return re;

                            }
                            break;

                    }

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:688:33: ( THEN a= actions )?
                    int alt62=2;
                    int LA62_0 = input.LA(1);

                    if ( (LA62_0==THEN) ) {
                        alt62=1;
                    }
                    switch (alt62) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:688:34: THEN a= actions
                            {
                            match(input,THEN,FOLLOW_THEN_in_ruleElementLiteral2559); if (state.failed) return re;
                            pushFollow(FOLLOW_actions_in_ruleElementLiteral2565);
                            a=actions();

                            state._fsp--;
                            if (state.failed) return re;

                            }
                            break;

                    }

                    match(input,RCURLY,FOLLOW_RCURLY_in_ruleElementLiteral2569); if (state.failed) return re;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {

              	if(q != null) {
              		re.setQuantifier(q);
              	}
              	if(c!= null) {
              		re.setConditions(c);
              	}
              	if(a != null) {
              		re.setActions(a);
              	}
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return re;
    }
    // $ANTLR end "ruleElementLiteral"


    // $ANTLR start "conditions"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:702:1: conditions returns [List<AbstractRutaCondition> conds = new ArrayList<AbstractRutaCondition>()] : c= condition ( COMMA c= condition )* ;
    public final List<AbstractRutaCondition> conditions() throws RecognitionException {
        List<AbstractRutaCondition> conds =  new ArrayList<AbstractRutaCondition>();

        AbstractRutaCondition c = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:703:5: (c= condition ( COMMA c= condition )* )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:704:5: c= condition ( COMMA c= condition )*
            {
            pushFollow(FOLLOW_condition_in_conditions2607);
            c=condition();

            state._fsp--;
            if (state.failed) return conds;
            if ( state.backtracking==0 ) {
              conds.add(c);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:704:35: ( COMMA c= condition )*
            loop64:
            do {
                int alt64=2;
                int LA64_0 = input.LA(1);

                if ( (LA64_0==COMMA) ) {
                    alt64=1;
                }


                switch (alt64) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:704:36: COMMA c= condition
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_conditions2612); if (state.failed) return conds;
            	    pushFollow(FOLLOW_condition_in_conditions2618);
            	    c=condition();

            	    state._fsp--;
            	    if (state.failed) return conds;
            	    if ( state.backtracking==0 ) {
            	      conds.add(c);
            	    }

            	    }
            	    break;

            	default :
            	    break loop64;
                }
            } while (true);


            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return conds;
    }
    // $ANTLR end "conditions"


    // $ANTLR start "actions"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:707:1: actions returns [List<AbstractRutaAction> actions = new ArrayList<AbstractRutaAction>()] : a= action ( COMMA a= action )* ;
    public final List<AbstractRutaAction> actions() throws RecognitionException {
        List<AbstractRutaAction> actions =  new ArrayList<AbstractRutaAction>();

        AbstractRutaAction a = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:708:5: (a= action ( COMMA a= action )* )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:709:5: a= action ( COMMA a= action )*
            {
            pushFollow(FOLLOW_action_in_actions2656);
            a=action();

            state._fsp--;
            if (state.failed) return actions;
            if ( state.backtracking==0 ) {
              actions.add(a);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:709:34: ( COMMA a= action )*
            loop65:
            do {
                int alt65=2;
                int LA65_0 = input.LA(1);

                if ( (LA65_0==COMMA) ) {
                    alt65=1;
                }


                switch (alt65) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:709:35: COMMA a= action
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actions2661); if (state.failed) return actions;
            	    pushFollow(FOLLOW_action_in_actions2667);
            	    a=action();

            	    state._fsp--;
            	    if (state.failed) return actions;
            	    if ( state.backtracking==0 ) {
            	      actions.add(a);
            	    }

            	    }
            	    break;

            	default :
            	    break loop65;
                }
            } while (true);


            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return actions;
    }
    // $ANTLR end "actions"


    // $ANTLR start "listExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:713:1: listExpression returns [ListExpression expr = null] : ( ( booleanListExpression )=>bl= booleanListExpression | ( intListExpression )=>il= intListExpression | ( doubleListExpression )=>dl= doubleListExpression | ( floatListExpression )=>dl= floatListExpression | ( stringListExpression )=>sl= stringListExpression | ( typeListExpression )=>tl= typeListExpression );
    public final ListExpression listExpression() throws RecognitionException {
        ListExpression expr =  null;

        BooleanListExpression bl = null;

        NumberListExpression il = null;

        NumberListExpression dl = null;

        StringListExpression sl = null;

        TypeListExpression tl = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:714:2: ( ( booleanListExpression )=>bl= booleanListExpression | ( intListExpression )=>il= intListExpression | ( doubleListExpression )=>dl= doubleListExpression | ( floatListExpression )=>dl= floatListExpression | ( stringListExpression )=>sl= stringListExpression | ( typeListExpression )=>tl= typeListExpression )
            int alt66=6;
            int LA66_0 = input.LA(1);

            if ( (LA66_0==LCURLY) ) {
                int LA66_1 = input.LA(2);

                if ( (synpred11_RutaParser()) ) {
                    alt66=1;
                }
                else if ( (synpred12_RutaParser()) ) {
                    alt66=2;
                }
                else if ( (synpred13_RutaParser()) ) {
                    alt66=3;
                }
                else if ( (synpred14_RutaParser()) ) {
                    alt66=4;
                }
                else if ( (synpred15_RutaParser()) ) {
                    alt66=5;
                }
                else if ( (synpred16_RutaParser()) ) {
                    alt66=6;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return expr;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 66, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA66_0==Identifier) ) {
                int LA66_2 = input.LA(2);

                if ( ((synpred11_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEANLIST")))) ) {
                    alt66=1;
                }
                else if ( ((synpred12_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INTLIST")))) ) {
                    alt66=2;
                }
                else if ( ((synpred13_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLELIST")))) ) {
                    alt66=3;
                }
                else if ( ((synpred14_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOATLIST")))) ) {
                    alt66=4;
                }
                else if ( ((synpred15_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRINGLIST")))) ) {
                    alt66=5;
                }
                else if ( ((synpred16_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST")))) ) {
                    alt66=6;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return expr;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 66, 2, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 66, 0, input);

                throw nvae;
            }
            switch (alt66) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:715:2: ( booleanListExpression )=>bl= booleanListExpression
                    {
                    pushFollow(FOLLOW_booleanListExpression_in_listExpression2703);
                    bl=booleanListExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = bl;
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:716:4: ( intListExpression )=>il= intListExpression
                    {
                    pushFollow(FOLLOW_intListExpression_in_listExpression2719);
                    il=intListExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = il;
                    }

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:717:4: ( doubleListExpression )=>dl= doubleListExpression
                    {
                    pushFollow(FOLLOW_doubleListExpression_in_listExpression2735);
                    dl=doubleListExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = dl;
                    }

                    }
                    break;
                case 4 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:718:4: ( floatListExpression )=>dl= floatListExpression
                    {
                    pushFollow(FOLLOW_floatListExpression_in_listExpression2751);
                    dl=floatListExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = dl;
                    }

                    }
                    break;
                case 5 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:719:4: ( stringListExpression )=>sl= stringListExpression
                    {
                    pushFollow(FOLLOW_stringListExpression_in_listExpression2767);
                    sl=stringListExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = sl;
                    }

                    }
                    break;
                case 6 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:720:4: ( typeListExpression )=>tl= typeListExpression
                    {
                    pushFollow(FOLLOW_typeListExpression_in_listExpression2783);
                    tl=typeListExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = tl;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "listExpression"


    // $ANTLR start "booleanListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:723:1: booleanListExpression returns [BooleanListExpression expr = null] : e= simpleBooleanListExpression ;
    public final BooleanListExpression booleanListExpression() throws RecognitionException {
        BooleanListExpression expr =  null;

        BooleanListExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:724:2: (e= simpleBooleanListExpression )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:725:2: e= simpleBooleanListExpression
            {
            pushFollow(FOLLOW_simpleBooleanListExpression_in_booleanListExpression2805);
            e=simpleBooleanListExpression();

            state._fsp--;
            if (state.failed) return expr;
            if ( state.backtracking==0 ) {
              expr = e;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "booleanListExpression"


    // $ANTLR start "simpleBooleanListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:728:1: simpleBooleanListExpression returns [BooleanListExpression expr = null] : ( LCURLY (e= simpleBooleanExpression ( COMMA e= simpleBooleanExpression )* )? RCURLY | {...}?var= Identifier );
    public final BooleanListExpression simpleBooleanListExpression() throws RecognitionException {
        BooleanListExpression expr =  null;

        Token var=null;
        BooleanExpression e = null;



        	List<BooleanExpression> list = new ArrayList<BooleanExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:731:3: ( LCURLY (e= simpleBooleanExpression ( COMMA e= simpleBooleanExpression )* )? RCURLY | {...}?var= Identifier )
            int alt69=2;
            int LA69_0 = input.LA(1);

            if ( (LA69_0==LCURLY) ) {
                alt69=1;
            }
            else if ( (LA69_0==Identifier) ) {
                alt69=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 69, 0, input);

                throw nvae;
            }
            switch (alt69) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:732:2: LCURLY (e= simpleBooleanExpression ( COMMA e= simpleBooleanExpression )* )? RCURLY
                    {
                    match(input,LCURLY,FOLLOW_LCURLY_in_simpleBooleanListExpression2826); if (state.failed) return expr;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:732:9: (e= simpleBooleanExpression ( COMMA e= simpleBooleanExpression )* )?
                    int alt68=2;
                    int LA68_0 = input.LA(1);

                    if ( ((LA68_0>=TRUE && LA68_0<=FALSE)||LA68_0==Identifier) ) {
                        alt68=1;
                    }
                    switch (alt68) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:732:10: e= simpleBooleanExpression ( COMMA e= simpleBooleanExpression )*
                            {
                            pushFollow(FOLLOW_simpleBooleanExpression_in_simpleBooleanListExpression2833);
                            e=simpleBooleanExpression();

                            state._fsp--;
                            if (state.failed) return expr;
                            if ( state.backtracking==0 ) {
                              list.add(e);
                            }
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:732:53: ( COMMA e= simpleBooleanExpression )*
                            loop67:
                            do {
                                int alt67=2;
                                int LA67_0 = input.LA(1);

                                if ( (LA67_0==COMMA) ) {
                                    alt67=1;
                                }


                                switch (alt67) {
                            	case 1 :
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:732:54: COMMA e= simpleBooleanExpression
                            	    {
                            	    match(input,COMMA,FOLLOW_COMMA_in_simpleBooleanListExpression2838); if (state.failed) return expr;
                            	    pushFollow(FOLLOW_simpleBooleanExpression_in_simpleBooleanListExpression2844);
                            	    e=simpleBooleanExpression();

                            	    state._fsp--;
                            	    if (state.failed) return expr;
                            	    if ( state.backtracking==0 ) {
                            	      list.add(e);
                            	    }

                            	    }
                            	    break;

                            	default :
                            	    break loop67;
                                }
                            } while (true);


                            }
                            break;

                    }

                    match(input,RCURLY,FOLLOW_RCURLY_in_simpleBooleanListExpression2853); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createBooleanListExpression(list);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:735:2: {...}?var= Identifier
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEANLIST"))) ) {
                        if (state.backtracking>0) {state.failed=true; return expr;}
                        throw new FailedPredicateException(input, "simpleBooleanListExpression", "isVariableOfType($blockDeclaration::env,input.LT(1).getText(), \"BOOLEANLIST\")");
                    }
                    var=(Token)match(input,Identifier,FOLLOW_Identifier_in_simpleBooleanListExpression2868); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createReferenceBooleanListExpression(var);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "simpleBooleanListExpression"


    // $ANTLR start "intListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:740:1: intListExpression returns [NumberListExpression expr = null] : e= simpleIntListExpression ;
    public final NumberListExpression intListExpression() throws RecognitionException {
        NumberListExpression expr =  null;

        NumberListExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:741:2: (e= simpleIntListExpression )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:742:2: e= simpleIntListExpression
            {
            pushFollow(FOLLOW_simpleIntListExpression_in_intListExpression2893);
            e=simpleIntListExpression();

            state._fsp--;
            if (state.failed) return expr;
            if ( state.backtracking==0 ) {
              expr = e;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "intListExpression"


    // $ANTLR start "simpleIntListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:745:1: simpleIntListExpression returns [NumberListExpression expr = null] : ( LCURLY (e= simpleNumberExpression ( COMMA e= simpleNumberExpression )* )? RCURLY | {...}?var= Identifier );
    public final NumberListExpression simpleIntListExpression() throws RecognitionException {
        NumberListExpression expr =  null;

        Token var=null;
        NumberExpression e = null;



        	List<NumberExpression> list = new ArrayList<NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:748:3: ( LCURLY (e= simpleNumberExpression ( COMMA e= simpleNumberExpression )* )? RCURLY | {...}?var= Identifier )
            int alt72=2;
            int LA72_0 = input.LA(1);

            if ( (LA72_0==LCURLY) ) {
                alt72=1;
            }
            else if ( (LA72_0==Identifier) ) {
                alt72=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 72, 0, input);

                throw nvae;
            }
            switch (alt72) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:749:2: LCURLY (e= simpleNumberExpression ( COMMA e= simpleNumberExpression )* )? RCURLY
                    {
                    match(input,LCURLY,FOLLOW_LCURLY_in_simpleIntListExpression2914); if (state.failed) return expr;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:749:9: (e= simpleNumberExpression ( COMMA e= simpleNumberExpression )* )?
                    int alt71=2;
                    int LA71_0 = input.LA(1);

                    if ( (LA71_0==DecimalLiteral||LA71_0==FloatingPointLiteral||(LA71_0>=Identifier && LA71_0<=LPAREN)||LA71_0==MINUS) ) {
                        alt71=1;
                    }
                    switch (alt71) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:749:10: e= simpleNumberExpression ( COMMA e= simpleNumberExpression )*
                            {
                            pushFollow(FOLLOW_simpleNumberExpression_in_simpleIntListExpression2921);
                            e=simpleNumberExpression();

                            state._fsp--;
                            if (state.failed) return expr;
                            if ( state.backtracking==0 ) {
                              list.add(e);
                            }
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:749:52: ( COMMA e= simpleNumberExpression )*
                            loop70:
                            do {
                                int alt70=2;
                                int LA70_0 = input.LA(1);

                                if ( (LA70_0==COMMA) ) {
                                    alt70=1;
                                }


                                switch (alt70) {
                            	case 1 :
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:749:53: COMMA e= simpleNumberExpression
                            	    {
                            	    match(input,COMMA,FOLLOW_COMMA_in_simpleIntListExpression2926); if (state.failed) return expr;
                            	    pushFollow(FOLLOW_simpleNumberExpression_in_simpleIntListExpression2932);
                            	    e=simpleNumberExpression();

                            	    state._fsp--;
                            	    if (state.failed) return expr;
                            	    if ( state.backtracking==0 ) {
                            	      list.add(e);
                            	    }

                            	    }
                            	    break;

                            	default :
                            	    break loop70;
                                }
                            } while (true);


                            }
                            break;

                    }

                    match(input,RCURLY,FOLLOW_RCURLY_in_simpleIntListExpression2941); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createNumberListExpression(list);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:752:2: {...}?var= Identifier
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INTLIST"))) ) {
                        if (state.backtracking>0) {state.failed=true; return expr;}
                        throw new FailedPredicateException(input, "simpleIntListExpression", "isVariableOfType($blockDeclaration::env,input.LT(1).getText(), \"INTLIST\")");
                    }
                    var=(Token)match(input,Identifier,FOLLOW_Identifier_in_simpleIntListExpression2956); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createReferenceIntListExpression(var);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "simpleIntListExpression"


    // $ANTLR start "numberListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:757:1: numberListExpression returns [NumberListExpression expr = null] : ( (e1= doubleListExpression )=>e1= doubleListExpression | (e1= floatListExpression )=>e1= floatListExpression | e2= intListExpression );
    public final NumberListExpression numberListExpression() throws RecognitionException {
        NumberListExpression expr =  null;

        NumberListExpression e1 = null;

        NumberListExpression e2 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:758:2: ( (e1= doubleListExpression )=>e1= doubleListExpression | (e1= floatListExpression )=>e1= floatListExpression | e2= intListExpression )
            int alt73=3;
            int LA73_0 = input.LA(1);

            if ( (LA73_0==LCURLY) ) {
                int LA73_1 = input.LA(2);

                if ( (synpred17_RutaParser()) ) {
                    alt73=1;
                }
                else if ( (synpred18_RutaParser()) ) {
                    alt73=2;
                }
                else if ( (true) ) {
                    alt73=3;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return expr;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 73, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA73_0==Identifier) ) {
                int LA73_2 = input.LA(2);

                if ( ((synpred17_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLELIST")))) ) {
                    alt73=1;
                }
                else if ( ((synpred18_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOATLIST")))) ) {
                    alt73=2;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INTLIST"))) ) {
                    alt73=3;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return expr;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 73, 2, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 73, 0, input);

                throw nvae;
            }
            switch (alt73) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:759:2: (e1= doubleListExpression )=>e1= doubleListExpression
                    {
                    pushFollow(FOLLOW_doubleListExpression_in_numberListExpression2990);
                    e1=doubleListExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e1;
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:761:2: (e1= floatListExpression )=>e1= floatListExpression
                    {
                    pushFollow(FOLLOW_floatListExpression_in_numberListExpression3011);
                    e1=floatListExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e1;
                    }

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:763:2: e2= intListExpression
                    {
                    pushFollow(FOLLOW_intListExpression_in_numberListExpression3023);
                    e2=intListExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e2;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "numberListExpression"


    // $ANTLR start "doubleListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:766:1: doubleListExpression returns [NumberListExpression expr = null] : e= simpleDoubleListExpression ;
    public final NumberListExpression doubleListExpression() throws RecognitionException {
        NumberListExpression expr =  null;

        NumberListExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:767:2: (e= simpleDoubleListExpression )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:768:2: e= simpleDoubleListExpression
            {
            pushFollow(FOLLOW_simpleDoubleListExpression_in_doubleListExpression3046);
            e=simpleDoubleListExpression();

            state._fsp--;
            if (state.failed) return expr;
            if ( state.backtracking==0 ) {
              expr = e;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "doubleListExpression"


    // $ANTLR start "simpleDoubleListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:771:1: simpleDoubleListExpression returns [NumberListExpression expr = null] : ( LCURLY (e= simpleNumberExpression ( COMMA e= simpleNumberExpression )* )? RCURLY | {...}?var= Identifier );
    public final NumberListExpression simpleDoubleListExpression() throws RecognitionException {
        NumberListExpression expr =  null;

        Token var=null;
        NumberExpression e = null;



        	List<NumberExpression> list = new ArrayList<NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:774:3: ( LCURLY (e= simpleNumberExpression ( COMMA e= simpleNumberExpression )* )? RCURLY | {...}?var= Identifier )
            int alt76=2;
            int LA76_0 = input.LA(1);

            if ( (LA76_0==LCURLY) ) {
                alt76=1;
            }
            else if ( (LA76_0==Identifier) ) {
                alt76=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 76, 0, input);

                throw nvae;
            }
            switch (alt76) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:775:2: LCURLY (e= simpleNumberExpression ( COMMA e= simpleNumberExpression )* )? RCURLY
                    {
                    match(input,LCURLY,FOLLOW_LCURLY_in_simpleDoubleListExpression3067); if (state.failed) return expr;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:775:9: (e= simpleNumberExpression ( COMMA e= simpleNumberExpression )* )?
                    int alt75=2;
                    int LA75_0 = input.LA(1);

                    if ( (LA75_0==DecimalLiteral||LA75_0==FloatingPointLiteral||(LA75_0>=Identifier && LA75_0<=LPAREN)||LA75_0==MINUS) ) {
                        alt75=1;
                    }
                    switch (alt75) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:775:10: e= simpleNumberExpression ( COMMA e= simpleNumberExpression )*
                            {
                            pushFollow(FOLLOW_simpleNumberExpression_in_simpleDoubleListExpression3074);
                            e=simpleNumberExpression();

                            state._fsp--;
                            if (state.failed) return expr;
                            if ( state.backtracking==0 ) {
                              list.add(e);
                            }
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:775:52: ( COMMA e= simpleNumberExpression )*
                            loop74:
                            do {
                                int alt74=2;
                                int LA74_0 = input.LA(1);

                                if ( (LA74_0==COMMA) ) {
                                    alt74=1;
                                }


                                switch (alt74) {
                            	case 1 :
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:775:53: COMMA e= simpleNumberExpression
                            	    {
                            	    match(input,COMMA,FOLLOW_COMMA_in_simpleDoubleListExpression3079); if (state.failed) return expr;
                            	    pushFollow(FOLLOW_simpleNumberExpression_in_simpleDoubleListExpression3085);
                            	    e=simpleNumberExpression();

                            	    state._fsp--;
                            	    if (state.failed) return expr;
                            	    if ( state.backtracking==0 ) {
                            	      list.add(e);
                            	    }

                            	    }
                            	    break;

                            	default :
                            	    break loop74;
                                }
                            } while (true);


                            }
                            break;

                    }

                    match(input,RCURLY,FOLLOW_RCURLY_in_simpleDoubleListExpression3094); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createNumberListExpression(list);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:778:2: {...}?var= Identifier
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLELIST"))) ) {
                        if (state.backtracking>0) {state.failed=true; return expr;}
                        throw new FailedPredicateException(input, "simpleDoubleListExpression", "isVariableOfType($blockDeclaration::env,input.LT(1).getText(), \"DOUBLELIST\")");
                    }
                    var=(Token)match(input,Identifier,FOLLOW_Identifier_in_simpleDoubleListExpression3109); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createReferenceDoubleListExpression(var);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "simpleDoubleListExpression"


    // $ANTLR start "floatListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:783:1: floatListExpression returns [NumberListExpression expr = null] : e= simpleFloatListExpression ;
    public final NumberListExpression floatListExpression() throws RecognitionException {
        NumberListExpression expr =  null;

        NumberListExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:784:2: (e= simpleFloatListExpression )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:785:2: e= simpleFloatListExpression
            {
            pushFollow(FOLLOW_simpleFloatListExpression_in_floatListExpression3135);
            e=simpleFloatListExpression();

            state._fsp--;
            if (state.failed) return expr;
            if ( state.backtracking==0 ) {
              expr = e;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "floatListExpression"


    // $ANTLR start "simpleFloatListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:788:1: simpleFloatListExpression returns [NumberListExpression expr = null] : ( LCURLY (e= simpleNumberExpression ( COMMA e= simpleNumberExpression )* )? RCURLY | {...}?var= Identifier );
    public final NumberListExpression simpleFloatListExpression() throws RecognitionException {
        NumberListExpression expr =  null;

        Token var=null;
        NumberExpression e = null;



        	List<NumberExpression> list = new ArrayList<NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:791:3: ( LCURLY (e= simpleNumberExpression ( COMMA e= simpleNumberExpression )* )? RCURLY | {...}?var= Identifier )
            int alt79=2;
            int LA79_0 = input.LA(1);

            if ( (LA79_0==LCURLY) ) {
                alt79=1;
            }
            else if ( (LA79_0==Identifier) ) {
                alt79=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 79, 0, input);

                throw nvae;
            }
            switch (alt79) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:792:2: LCURLY (e= simpleNumberExpression ( COMMA e= simpleNumberExpression )* )? RCURLY
                    {
                    match(input,LCURLY,FOLLOW_LCURLY_in_simpleFloatListExpression3156); if (state.failed) return expr;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:792:9: (e= simpleNumberExpression ( COMMA e= simpleNumberExpression )* )?
                    int alt78=2;
                    int LA78_0 = input.LA(1);

                    if ( (LA78_0==DecimalLiteral||LA78_0==FloatingPointLiteral||(LA78_0>=Identifier && LA78_0<=LPAREN)||LA78_0==MINUS) ) {
                        alt78=1;
                    }
                    switch (alt78) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:792:10: e= simpleNumberExpression ( COMMA e= simpleNumberExpression )*
                            {
                            pushFollow(FOLLOW_simpleNumberExpression_in_simpleFloatListExpression3163);
                            e=simpleNumberExpression();

                            state._fsp--;
                            if (state.failed) return expr;
                            if ( state.backtracking==0 ) {
                              list.add(e);
                            }
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:792:52: ( COMMA e= simpleNumberExpression )*
                            loop77:
                            do {
                                int alt77=2;
                                int LA77_0 = input.LA(1);

                                if ( (LA77_0==COMMA) ) {
                                    alt77=1;
                                }


                                switch (alt77) {
                            	case 1 :
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:792:53: COMMA e= simpleNumberExpression
                            	    {
                            	    match(input,COMMA,FOLLOW_COMMA_in_simpleFloatListExpression3168); if (state.failed) return expr;
                            	    pushFollow(FOLLOW_simpleNumberExpression_in_simpleFloatListExpression3174);
                            	    e=simpleNumberExpression();

                            	    state._fsp--;
                            	    if (state.failed) return expr;
                            	    if ( state.backtracking==0 ) {
                            	      list.add(e);
                            	    }

                            	    }
                            	    break;

                            	default :
                            	    break loop77;
                                }
                            } while (true);


                            }
                            break;

                    }

                    match(input,RCURLY,FOLLOW_RCURLY_in_simpleFloatListExpression3183); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createNumberListExpression(list);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:795:2: {...}?var= Identifier
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOATLIST"))) ) {
                        if (state.backtracking>0) {state.failed=true; return expr;}
                        throw new FailedPredicateException(input, "simpleFloatListExpression", "isVariableOfType($blockDeclaration::env,input.LT(1).getText(), \"FLOATLIST\")");
                    }
                    var=(Token)match(input,Identifier,FOLLOW_Identifier_in_simpleFloatListExpression3198); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createReferenceFloatListExpression(var);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "simpleFloatListExpression"


    // $ANTLR start "stringListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:799:1: stringListExpression returns [StringListExpression expr = null] : e= simpleStringListExpression ;
    public final StringListExpression stringListExpression() throws RecognitionException {
        StringListExpression expr =  null;

        StringListExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:800:2: (e= simpleStringListExpression )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:801:2: e= simpleStringListExpression
            {
            pushFollow(FOLLOW_simpleStringListExpression_in_stringListExpression3222);
            e=simpleStringListExpression();

            state._fsp--;
            if (state.failed) return expr;
            if ( state.backtracking==0 ) {
              expr = e;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "stringListExpression"


    // $ANTLR start "simpleStringListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:804:1: simpleStringListExpression returns [StringListExpression expr = null] : ( LCURLY (e= simpleStringExpression ( COMMA e= simpleStringExpression )* )? RCURLY | {...}?var= Identifier );
    public final StringListExpression simpleStringListExpression() throws RecognitionException {
        StringListExpression expr =  null;

        Token var=null;
        StringExpression e = null;



        	List<StringExpression> list = new ArrayList<StringExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:807:3: ( LCURLY (e= simpleStringExpression ( COMMA e= simpleStringExpression )* )? RCURLY | {...}?var= Identifier )
            int alt82=2;
            int LA82_0 = input.LA(1);

            if ( (LA82_0==LCURLY) ) {
                alt82=1;
            }
            else if ( (LA82_0==Identifier) ) {
                alt82=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 82, 0, input);

                throw nvae;
            }
            switch (alt82) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:808:2: LCURLY (e= simpleStringExpression ( COMMA e= simpleStringExpression )* )? RCURLY
                    {
                    match(input,LCURLY,FOLLOW_LCURLY_in_simpleStringListExpression3243); if (state.failed) return expr;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:808:9: (e= simpleStringExpression ( COMMA e= simpleStringExpression )* )?
                    int alt81=2;
                    int LA81_0 = input.LA(1);

                    if ( (LA81_0==StringLiteral||LA81_0==Identifier) ) {
                        alt81=1;
                    }
                    switch (alt81) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:808:10: e= simpleStringExpression ( COMMA e= simpleStringExpression )*
                            {
                            pushFollow(FOLLOW_simpleStringExpression_in_simpleStringListExpression3250);
                            e=simpleStringExpression();

                            state._fsp--;
                            if (state.failed) return expr;
                            if ( state.backtracking==0 ) {
                              list.add(e);
                            }
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:808:52: ( COMMA e= simpleStringExpression )*
                            loop80:
                            do {
                                int alt80=2;
                                int LA80_0 = input.LA(1);

                                if ( (LA80_0==COMMA) ) {
                                    alt80=1;
                                }


                                switch (alt80) {
                            	case 1 :
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:808:53: COMMA e= simpleStringExpression
                            	    {
                            	    match(input,COMMA,FOLLOW_COMMA_in_simpleStringListExpression3255); if (state.failed) return expr;
                            	    pushFollow(FOLLOW_simpleStringExpression_in_simpleStringListExpression3261);
                            	    e=simpleStringExpression();

                            	    state._fsp--;
                            	    if (state.failed) return expr;
                            	    if ( state.backtracking==0 ) {
                            	      list.add(e);
                            	    }

                            	    }
                            	    break;

                            	default :
                            	    break loop80;
                                }
                            } while (true);


                            }
                            break;

                    }

                    match(input,RCURLY,FOLLOW_RCURLY_in_simpleStringListExpression3270); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createStringListExpression(list);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:811:2: {...}?var= Identifier
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRINGLIST"))) ) {
                        if (state.backtracking>0) {state.failed=true; return expr;}
                        throw new FailedPredicateException(input, "simpleStringListExpression", "isVariableOfType($blockDeclaration::env,input.LT(1).getText(), \"STRINGLIST\")");
                    }
                    var=(Token)match(input,Identifier,FOLLOW_Identifier_in_simpleStringListExpression3286); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createReferenceStringListExpression(var);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "simpleStringListExpression"


    // $ANTLR start "typeListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:816:1: typeListExpression returns [TypeListExpression expr = null] : e= simpleTypeListExpression ;
    public final TypeListExpression typeListExpression() throws RecognitionException {
        TypeListExpression expr =  null;

        TypeListExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:817:2: (e= simpleTypeListExpression )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:818:2: e= simpleTypeListExpression
            {
            pushFollow(FOLLOW_simpleTypeListExpression_in_typeListExpression3311);
            e=simpleTypeListExpression();

            state._fsp--;
            if (state.failed) return expr;
            if ( state.backtracking==0 ) {
              expr = e;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "typeListExpression"


    // $ANTLR start "simpleTypeListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:821:1: simpleTypeListExpression returns [TypeListExpression expr = null] : ( LCURLY (e= simpleTypeExpression ( COMMA e= simpleTypeExpression )* )? RCURLY | {...}?var= Identifier );
    public final TypeListExpression simpleTypeListExpression() throws RecognitionException {
        TypeListExpression expr =  null;

        Token var=null;
        TypeExpression e = null;



        	List<TypeExpression> list = new ArrayList<TypeExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:824:3: ( LCURLY (e= simpleTypeExpression ( COMMA e= simpleTypeExpression )* )? RCURLY | {...}?var= Identifier )
            int alt85=2;
            int LA85_0 = input.LA(1);

            if ( (LA85_0==LCURLY) ) {
                alt85=1;
            }
            else if ( (LA85_0==Identifier) ) {
                alt85=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 85, 0, input);

                throw nvae;
            }
            switch (alt85) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:825:2: LCURLY (e= simpleTypeExpression ( COMMA e= simpleTypeExpression )* )? RCURLY
                    {
                    match(input,LCURLY,FOLLOW_LCURLY_in_simpleTypeListExpression3332); if (state.failed) return expr;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:825:9: (e= simpleTypeExpression ( COMMA e= simpleTypeExpression )* )?
                    int alt84=2;
                    int LA84_0 = input.LA(1);

                    if ( (LA84_0==Identifier) ) {
                        alt84=1;
                    }
                    switch (alt84) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:825:10: e= simpleTypeExpression ( COMMA e= simpleTypeExpression )*
                            {
                            pushFollow(FOLLOW_simpleTypeExpression_in_simpleTypeListExpression3339);
                            e=simpleTypeExpression();

                            state._fsp--;
                            if (state.failed) return expr;
                            if ( state.backtracking==0 ) {
                              list.add(e);
                            }
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:825:50: ( COMMA e= simpleTypeExpression )*
                            loop83:
                            do {
                                int alt83=2;
                                int LA83_0 = input.LA(1);

                                if ( (LA83_0==COMMA) ) {
                                    alt83=1;
                                }


                                switch (alt83) {
                            	case 1 :
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:825:51: COMMA e= simpleTypeExpression
                            	    {
                            	    match(input,COMMA,FOLLOW_COMMA_in_simpleTypeListExpression3344); if (state.failed) return expr;
                            	    pushFollow(FOLLOW_simpleTypeExpression_in_simpleTypeListExpression3350);
                            	    e=simpleTypeExpression();

                            	    state._fsp--;
                            	    if (state.failed) return expr;
                            	    if ( state.backtracking==0 ) {
                            	      list.add(e);
                            	    }

                            	    }
                            	    break;

                            	default :
                            	    break loop83;
                                }
                            } while (true);


                            }
                            break;

                    }

                    match(input,RCURLY,FOLLOW_RCURLY_in_simpleTypeListExpression3359); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createTypeListExpression(list);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:828:2: {...}?var= Identifier
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))) ) {
                        if (state.backtracking>0) {state.failed=true; return expr;}
                        throw new FailedPredicateException(input, "simpleTypeListExpression", "isVariableOfType($blockDeclaration::env,input.LT(1).getText(), \"TYPELIST\")");
                    }
                    var=(Token)match(input,Identifier,FOLLOW_Identifier_in_simpleTypeListExpression3374); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createReferenceTypeListExpression(var);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "simpleTypeListExpression"


    // $ANTLR start "typeExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:833:1: typeExpression returns [TypeExpression type = null] options {backtrack=true; } : (tf= typeFunction | st= simpleTypeExpression );
    public final TypeExpression typeExpression() throws RecognitionException {
        TypeExpression type =  null;

        TypeExpression tf = null;

        TypeExpression st = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:837:2: (tf= typeFunction | st= simpleTypeExpression )
            int alt86=2;
            int LA86_0 = input.LA(1);

            if ( (LA86_0==Identifier) ) {
                int LA86_1 = input.LA(2);

                if ( (synpred19_RutaParser()) ) {
                    alt86=1;
                }
                else if ( (true) ) {
                    alt86=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return type;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 86, 1, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return type;}
                NoViableAltException nvae =
                    new NoViableAltException("", 86, 0, input);

                throw nvae;
            }
            switch (alt86) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:838:2: tf= typeFunction
                    {
                    pushFollow(FOLLOW_typeFunction_in_typeExpression3411);
                    tf=typeFunction();

                    state._fsp--;
                    if (state.failed) return type;
                    if ( state.backtracking==0 ) {
                      type = tf;
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:839:4: st= simpleTypeExpression
                    {
                    pushFollow(FOLLOW_simpleTypeExpression_in_typeExpression3422);
                    st=simpleTypeExpression();

                    state._fsp--;
                    if (state.failed) return type;
                    if ( state.backtracking==0 ) {
                      type = st;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return type;
    }
    // $ANTLR end "typeExpression"


    // $ANTLR start "typeFunction"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:844:1: typeFunction returns [TypeExpression expr = null] : (e= externalTypeFunction )=>e= externalTypeFunction ;
    public final TypeExpression typeFunction() throws RecognitionException {
        TypeExpression expr =  null;

        TypeExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:845:2: ( (e= externalTypeFunction )=>e= externalTypeFunction )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:846:2: (e= externalTypeFunction )=>e= externalTypeFunction
            {
            pushFollow(FOLLOW_externalTypeFunction_in_typeFunction3456);
            e=externalTypeFunction();

            state._fsp--;
            if (state.failed) return expr;
            if ( state.backtracking==0 ) {
              expr = e;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "typeFunction"


    // $ANTLR start "externalTypeFunction"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:850:1: externalTypeFunction returns [TypeExpression expr = null] : id= Identifier LPAREN (args= varArgumentList )? RPAREN ;
    public final TypeExpression externalTypeFunction() throws RecognitionException {
        TypeExpression expr =  null;

        Token id=null;
        List args = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:851:2: (id= Identifier LPAREN (args= varArgumentList )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:853:2: id= Identifier LPAREN (args= varArgumentList )? RPAREN
            {
            id=(Token)match(input,Identifier,FOLLOW_Identifier_in_externalTypeFunction3481); if (state.failed) return expr;
            match(input,LPAREN,FOLLOW_LPAREN_in_externalTypeFunction3483); if (state.failed) return expr;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:854:7: (args= varArgumentList )?
            int alt87=2;
            int LA87_0 = input.LA(1);

            if ( (LA87_0==REMOVESTRING||(LA87_0>=EXP && LA87_0<=FALSE)||LA87_0==DecimalLiteral||LA87_0==FloatingPointLiteral||LA87_0==StringLiteral||(LA87_0>=Identifier && LA87_0<=LPAREN)||LA87_0==MINUS) ) {
                alt87=1;
            }
            switch (alt87) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:854:7: args= varArgumentList
                    {
                    pushFollow(FOLLOW_varArgumentList_in_externalTypeFunction3490);
                    args=varArgumentList();

                    state._fsp--;
                    if (state.failed) return expr;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_externalTypeFunction3493); if (state.failed) return expr;
            if ( state.backtracking==0 ) {

              		expr = external.createExternalTypeFunction(id, args);
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "externalTypeFunction"


    // $ANTLR start "simpleTypeExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:860:1: simpleTypeExpression returns [TypeExpression type = null] : ({...}?var= Identifier | at= annotationType );
    public final TypeExpression simpleTypeExpression() throws RecognitionException {
        TypeExpression type =  null;

        Token var=null;
        Token at = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:861:2: ({...}?var= Identifier | at= annotationType )
            int alt88=2;
            int LA88_0 = input.LA(1);

            if ( (LA88_0==Identifier) ) {
                int LA88_1 = input.LA(2);

                if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPE"))) ) {
                    alt88=1;
                }
                else if ( (true) ) {
                    alt88=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return type;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 88, 1, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return type;}
                NoViableAltException nvae =
                    new NoViableAltException("", 88, 0, input);

                throw nvae;
            }
            switch (alt88) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:862:2: {...}?var= Identifier
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPE"))) ) {
                        if (state.backtracking>0) {state.failed=true; return type;}
                        throw new FailedPredicateException(input, "simpleTypeExpression", "isVariableOfType($blockDeclaration::env,input.LT(1).getText(), \"TYPE\")");
                    }
                    var=(Token)match(input,Identifier,FOLLOW_Identifier_in_simpleTypeExpression3518); if (state.failed) return type;
                    if ( state.backtracking==0 ) {
                      type = ExpressionFactory.createReferenceTypeExpression(var);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:865:2: at= annotationType
                    {
                    pushFollow(FOLLOW_annotationType_in_simpleTypeExpression3532);
                    at=annotationType();

                    state._fsp--;
                    if (state.failed) return type;
                    if ( state.backtracking==0 ) {
                      type = ExpressionFactory.createSimpleTypeExpression(at, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return type;
    }
    // $ANTLR end "simpleTypeExpression"


    // $ANTLR start "variable"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:870:1: variable returns [Token var = null] : {...}?v= Identifier ;
    public final Token variable() throws RecognitionException {
        Token var =  null;

        Token v=null;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:871:2: ({...}?v= Identifier )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:872:2: {...}?v= Identifier
            {
            if ( !((isVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                if (state.backtracking>0) {state.failed=true; return var;}
                throw new FailedPredicateException(input, "variable", "isVariable($blockDeclaration::env, input.LT(1).getText())");
            }
            v=(Token)match(input,Identifier,FOLLOW_Identifier_in_variable3558); if (state.failed) return var;
            if ( state.backtracking==0 ) {
              var = v;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return var;
    }
    // $ANTLR end "variable"


    // $ANTLR start "listVariable"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:875:1: listVariable returns [Token var = null] : {...}?v= Identifier ;
    public final Token listVariable() throws RecognitionException {
        Token var =  null;

        Token v=null;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:876:2: ({...}?v= Identifier )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:877:2: {...}?v= Identifier
            {
            if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "BOOLEANLIST")
            	||isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "INTLIST")
            	||isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "DOUBLELIST")
            	||isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "FLOATLIST")
            	||isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "STRINGLIST")
            	||isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "TYPELIST")
            	)) ) {
                if (state.backtracking>0) {state.failed=true; return var;}
                throw new FailedPredicateException(input, "listVariable", "isVariableOfType($blockDeclaration::env, input.LT(1).getText(), \"BOOLEANLIST\")\r\n\t||isVariableOfType($blockDeclaration::env, input.LT(1).getText(), \"INTLIST\")\r\n\t||isVariableOfType($blockDeclaration::env, input.LT(1).getText(), \"DOUBLELIST\")\r\n\t||isVariableOfType($blockDeclaration::env, input.LT(1).getText(), \"FLOATLIST\")\r\n\t||isVariableOfType($blockDeclaration::env, input.LT(1).getText(), \"STRINGLIST\")\r\n\t||isVariableOfType($blockDeclaration::env, input.LT(1).getText(), \"TYPELIST\")\r\n\t");
            }
            v=(Token)match(input,Identifier,FOLLOW_Identifier_in_listVariable3582); if (state.failed) return var;
            if ( state.backtracking==0 ) {
              var = v;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return var;
    }
    // $ANTLR end "listVariable"


    // $ANTLR start "quantifierPart"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:901:1: quantifierPart returns [RuleElementQuantifier quantifier = null] : ( STAR (q= QUESTION )? | PLUS (q= QUESTION )? | QUESTION (q= QUESTION )? | LBRACK min= numberExpression (comma= COMMA (max= numberExpression )? )? RBRACK (q= QUESTION )? );
    public final RuleElementQuantifier quantifierPart() throws RecognitionException {
        RuleElementQuantifier quantifier =  null;

        Token q=null;
        Token comma=null;
        NumberExpression min = null;

        NumberExpression max = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:902:2: ( STAR (q= QUESTION )? | PLUS (q= QUESTION )? | QUESTION (q= QUESTION )? | LBRACK min= numberExpression (comma= COMMA (max= numberExpression )? )? RBRACK (q= QUESTION )? )
            int alt95=4;
            switch ( input.LA(1) ) {
            case STAR:
                {
                alt95=1;
                }
                break;
            case PLUS:
                {
                alt95=2;
                }
                break;
            case QUESTION:
                {
                alt95=3;
                }
                break;
            case LBRACK:
                {
                alt95=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return quantifier;}
                NoViableAltException nvae =
                    new NoViableAltException("", 95, 0, input);

                throw nvae;
            }

            switch (alt95) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:903:3: STAR (q= QUESTION )?
                    {
                    match(input,STAR,FOLLOW_STAR_in_quantifierPart3616); if (state.failed) return quantifier;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:903:10: (q= QUESTION )?
                    int alt89=2;
                    int LA89_0 = input.LA(1);

                    if ( (LA89_0==QUESTION) ) {
                        alt89=1;
                    }
                    switch (alt89) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:903:10: q= QUESTION
                            {
                            q=(Token)match(input,QUESTION,FOLLOW_QUESTION_in_quantifierPart3622); if (state.failed) return quantifier;

                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                      if(q != null) {quantifier = RutaScriptFactory.createStarReluctantQuantifier();} 
                      	 	else{quantifier = RutaScriptFactory.createStarGreedyQuantifier();}
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:906:4: PLUS (q= QUESTION )?
                    {
                    match(input,PLUS,FOLLOW_PLUS_in_quantifierPart3633); if (state.failed) return quantifier;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:906:11: (q= QUESTION )?
                    int alt90=2;
                    int LA90_0 = input.LA(1);

                    if ( (LA90_0==QUESTION) ) {
                        alt90=1;
                    }
                    switch (alt90) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:906:11: q= QUESTION
                            {
                            q=(Token)match(input,QUESTION,FOLLOW_QUESTION_in_quantifierPart3639); if (state.failed) return quantifier;

                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                      if(q != null) {quantifier = RutaScriptFactory.createPlusReluctantQuantifier();}
                      	 else {quantifier = RutaScriptFactory.createPlusGreedyQuantifier();}
                    }

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:909:4: QUESTION (q= QUESTION )?
                    {
                    match(input,QUESTION,FOLLOW_QUESTION_in_quantifierPart3649); if (state.failed) return quantifier;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:909:15: (q= QUESTION )?
                    int alt91=2;
                    int LA91_0 = input.LA(1);

                    if ( (LA91_0==QUESTION) ) {
                        alt91=1;
                    }
                    switch (alt91) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:909:15: q= QUESTION
                            {
                            q=(Token)match(input,QUESTION,FOLLOW_QUESTION_in_quantifierPart3655); if (state.failed) return quantifier;

                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                      if(q != null) {quantifier = RutaScriptFactory.createQuestionReluctantQuantifier();} 
                      	 else {quantifier = RutaScriptFactory.createQuestionGreedyQuantifier();}
                    }

                    }
                    break;
                case 4 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:912:4: LBRACK min= numberExpression (comma= COMMA (max= numberExpression )? )? RBRACK (q= QUESTION )?
                    {
                    match(input,LBRACK,FOLLOW_LBRACK_in_quantifierPart3666); if (state.failed) return quantifier;
                    pushFollow(FOLLOW_numberExpression_in_quantifierPart3672);
                    min=numberExpression();

                    state._fsp--;
                    if (state.failed) return quantifier;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:912:34: (comma= COMMA (max= numberExpression )? )?
                    int alt93=2;
                    int LA93_0 = input.LA(1);

                    if ( (LA93_0==COMMA) ) {
                        alt93=1;
                    }
                    switch (alt93) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:912:35: comma= COMMA (max= numberExpression )?
                            {
                            comma=(Token)match(input,COMMA,FOLLOW_COMMA_in_quantifierPart3679); if (state.failed) return quantifier;
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:912:49: (max= numberExpression )?
                            int alt92=2;
                            int LA92_0 = input.LA(1);

                            if ( ((LA92_0>=EXP && LA92_0<=TAN)||LA92_0==DecimalLiteral||LA92_0==FloatingPointLiteral||(LA92_0>=Identifier && LA92_0<=LPAREN)||LA92_0==MINUS) ) {
                                alt92=1;
                            }
                            switch (alt92) {
                                case 1 :
                                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:912:50: max= numberExpression
                                    {
                                    pushFollow(FOLLOW_numberExpression_in_quantifierPart3686);
                                    max=numberExpression();

                                    state._fsp--;
                                    if (state.failed) return quantifier;

                                    }
                                    break;

                            }


                            }
                            break;

                    }

                    match(input,RBRACK,FOLLOW_RBRACK_in_quantifierPart3692); if (state.failed) return quantifier;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:912:86: (q= QUESTION )?
                    int alt94=2;
                    int LA94_0 = input.LA(1);

                    if ( (LA94_0==QUESTION) ) {
                        alt94=1;
                    }
                    switch (alt94) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:912:86: q= QUESTION
                            {
                            q=(Token)match(input,QUESTION,FOLLOW_QUESTION_in_quantifierPart3698); if (state.failed) return quantifier;

                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                      if(q != null) {quantifier = RutaScriptFactory.createMinMaxReluctantQuantifier(min,max,comma);} 
                      	 else {quantifier = RutaScriptFactory.createMinMaxGreedyQuantifier(min,max,comma);}
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return quantifier;
    }
    // $ANTLR end "quantifierPart"


    // $ANTLR start "condition"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:918:1: condition returns [AbstractRutaCondition result = null] : (c= conditionAnd | c= conditionContains | c= conditionContextCount | c= conditionCount | c= conditionCurrentCount | c= conditionInList | c= conditionLast | c= conditionMofN | c= conditionNear | c= conditionNot | c= conditionOr | c= conditionPartOf | c= conditionPosition | c= conditionRegExp | c= conditionScore | c= conditionTotalCount | c= conditionVote | c= conditionIf | c= conditionFeature | c= conditionParse | c= conditionIs | c= conditionBefore | c= conditionAfter | c= conditionStartsWith | c= conditionEndsWith | c= conditionPartOfNeq | c= conditionSize | (c= externalCondition )=>c= externalCondition ) ;
    public final AbstractRutaCondition condition() throws RecognitionException {
        AbstractRutaCondition result =  null;

        AbstractRutaCondition c = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:919:2: ( (c= conditionAnd | c= conditionContains | c= conditionContextCount | c= conditionCount | c= conditionCurrentCount | c= conditionInList | c= conditionLast | c= conditionMofN | c= conditionNear | c= conditionNot | c= conditionOr | c= conditionPartOf | c= conditionPosition | c= conditionRegExp | c= conditionScore | c= conditionTotalCount | c= conditionVote | c= conditionIf | c= conditionFeature | c= conditionParse | c= conditionIs | c= conditionBefore | c= conditionAfter | c= conditionStartsWith | c= conditionEndsWith | c= conditionPartOfNeq | c= conditionSize | (c= externalCondition )=>c= externalCondition ) )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:920:2: (c= conditionAnd | c= conditionContains | c= conditionContextCount | c= conditionCount | c= conditionCurrentCount | c= conditionInList | c= conditionLast | c= conditionMofN | c= conditionNear | c= conditionNot | c= conditionOr | c= conditionPartOf | c= conditionPosition | c= conditionRegExp | c= conditionScore | c= conditionTotalCount | c= conditionVote | c= conditionIf | c= conditionFeature | c= conditionParse | c= conditionIs | c= conditionBefore | c= conditionAfter | c= conditionStartsWith | c= conditionEndsWith | c= conditionPartOfNeq | c= conditionSize | (c= externalCondition )=>c= externalCondition )
            {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:920:2: (c= conditionAnd | c= conditionContains | c= conditionContextCount | c= conditionCount | c= conditionCurrentCount | c= conditionInList | c= conditionLast | c= conditionMofN | c= conditionNear | c= conditionNot | c= conditionOr | c= conditionPartOf | c= conditionPosition | c= conditionRegExp | c= conditionScore | c= conditionTotalCount | c= conditionVote | c= conditionIf | c= conditionFeature | c= conditionParse | c= conditionIs | c= conditionBefore | c= conditionAfter | c= conditionStartsWith | c= conditionEndsWith | c= conditionPartOfNeq | c= conditionSize | (c= externalCondition )=>c= externalCondition )
            int alt96=28;
            alt96 = dfa96.predict(input);
            switch (alt96) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:921:2: c= conditionAnd
                    {
                    pushFollow(FOLLOW_conditionAnd_in_condition3729);
                    c=conditionAnd();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:922:4: c= conditionContains
                    {
                    pushFollow(FOLLOW_conditionContains_in_condition3738);
                    c=conditionContains();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:923:4: c= conditionContextCount
                    {
                    pushFollow(FOLLOW_conditionContextCount_in_condition3747);
                    c=conditionContextCount();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 4 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:924:4: c= conditionCount
                    {
                    pushFollow(FOLLOW_conditionCount_in_condition3756);
                    c=conditionCount();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 5 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:925:4: c= conditionCurrentCount
                    {
                    pushFollow(FOLLOW_conditionCurrentCount_in_condition3765);
                    c=conditionCurrentCount();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 6 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:926:4: c= conditionInList
                    {
                    pushFollow(FOLLOW_conditionInList_in_condition3774);
                    c=conditionInList();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 7 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:927:4: c= conditionLast
                    {
                    pushFollow(FOLLOW_conditionLast_in_condition3783);
                    c=conditionLast();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 8 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:928:4: c= conditionMofN
                    {
                    pushFollow(FOLLOW_conditionMofN_in_condition3792);
                    c=conditionMofN();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 9 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:929:4: c= conditionNear
                    {
                    pushFollow(FOLLOW_conditionNear_in_condition3801);
                    c=conditionNear();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 10 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:930:4: c= conditionNot
                    {
                    pushFollow(FOLLOW_conditionNot_in_condition3810);
                    c=conditionNot();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 11 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:931:4: c= conditionOr
                    {
                    pushFollow(FOLLOW_conditionOr_in_condition3819);
                    c=conditionOr();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 12 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:932:4: c= conditionPartOf
                    {
                    pushFollow(FOLLOW_conditionPartOf_in_condition3828);
                    c=conditionPartOf();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 13 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:933:4: c= conditionPosition
                    {
                    pushFollow(FOLLOW_conditionPosition_in_condition3837);
                    c=conditionPosition();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 14 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:934:4: c= conditionRegExp
                    {
                    pushFollow(FOLLOW_conditionRegExp_in_condition3846);
                    c=conditionRegExp();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 15 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:935:4: c= conditionScore
                    {
                    pushFollow(FOLLOW_conditionScore_in_condition3855);
                    c=conditionScore();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 16 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:936:4: c= conditionTotalCount
                    {
                    pushFollow(FOLLOW_conditionTotalCount_in_condition3864);
                    c=conditionTotalCount();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 17 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:937:4: c= conditionVote
                    {
                    pushFollow(FOLLOW_conditionVote_in_condition3873);
                    c=conditionVote();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 18 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:938:4: c= conditionIf
                    {
                    pushFollow(FOLLOW_conditionIf_in_condition3882);
                    c=conditionIf();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 19 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:939:4: c= conditionFeature
                    {
                    pushFollow(FOLLOW_conditionFeature_in_condition3891);
                    c=conditionFeature();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 20 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:940:4: c= conditionParse
                    {
                    pushFollow(FOLLOW_conditionParse_in_condition3900);
                    c=conditionParse();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 21 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:941:4: c= conditionIs
                    {
                    pushFollow(FOLLOW_conditionIs_in_condition3909);
                    c=conditionIs();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 22 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:942:4: c= conditionBefore
                    {
                    pushFollow(FOLLOW_conditionBefore_in_condition3918);
                    c=conditionBefore();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 23 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:943:4: c= conditionAfter
                    {
                    pushFollow(FOLLOW_conditionAfter_in_condition3927);
                    c=conditionAfter();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 24 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:944:4: c= conditionStartsWith
                    {
                    pushFollow(FOLLOW_conditionStartsWith_in_condition3937);
                    c=conditionStartsWith();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 25 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:945:4: c= conditionEndsWith
                    {
                    pushFollow(FOLLOW_conditionEndsWith_in_condition3946);
                    c=conditionEndsWith();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 26 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:946:4: c= conditionPartOfNeq
                    {
                    pushFollow(FOLLOW_conditionPartOfNeq_in_condition3955);
                    c=conditionPartOfNeq();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 27 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:947:4: c= conditionSize
                    {
                    pushFollow(FOLLOW_conditionSize_in_condition3964);
                    c=conditionSize();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 28 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:948:4: (c= externalCondition )=>c= externalCondition
                    {
                    pushFollow(FOLLOW_externalCondition_in_condition3983);
                    c=externalCondition();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
              result = c;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return result;
    }
    // $ANTLR end "condition"


    // $ANTLR start "externalCondition"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:963:1: externalCondition returns [AbstractRutaCondition condition = null] : id= Identifier LPAREN (args= varArgumentList )? RPAREN ;
    public final AbstractRutaCondition externalCondition() throws RecognitionException {
        AbstractRutaCondition condition =  null;

        Token id=null;
        List args = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:964:2: (id= Identifier LPAREN (args= varArgumentList )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:966:2: id= Identifier LPAREN (args= varArgumentList )? RPAREN
            {
            id=(Token)match(input,Identifier,FOLLOW_Identifier_in_externalCondition4023); if (state.failed) return condition;
            match(input,LPAREN,FOLLOW_LPAREN_in_externalCondition4025); if (state.failed) return condition;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:966:30: (args= varArgumentList )?
            int alt97=2;
            int LA97_0 = input.LA(1);

            if ( (LA97_0==REMOVESTRING||(LA97_0>=EXP && LA97_0<=FALSE)||LA97_0==DecimalLiteral||LA97_0==FloatingPointLiteral||LA97_0==StringLiteral||(LA97_0>=Identifier && LA97_0<=LPAREN)||LA97_0==MINUS) ) {
                alt97=1;
            }
            switch (alt97) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:966:30: args= varArgumentList
                    {
                    pushFollow(FOLLOW_varArgumentList_in_externalCondition4031);
                    args=varArgumentList();

                    state._fsp--;
                    if (state.failed) return condition;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_externalCondition4034); if (state.failed) return condition;
            if ( state.backtracking==0 ) {

              		condition = external.createExternalCondition(id, args);
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return condition;
    }
    // $ANTLR end "externalCondition"


    // $ANTLR start "conditionAnd"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:972:1: conditionAnd returns [AbstractRutaCondition cond = null] : AND LPAREN conds= conditions RPAREN ;
    public final AbstractRutaCondition conditionAnd() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        List<AbstractRutaCondition> conds = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:973:5: ( AND LPAREN conds= conditions RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:974:5: AND LPAREN conds= conditions RPAREN
            {
            match(input,AND,FOLLOW_AND_in_conditionAnd4063); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionAnd4065); if (state.failed) return cond;
            pushFollow(FOLLOW_conditions_in_conditionAnd4071);
            conds=conditions();

            state._fsp--;
            if (state.failed) return cond;
            match(input,RPAREN,FOLLOW_RPAREN_in_conditionAnd4073); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionAnd(conds, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionAnd"


    // $ANTLR start "conditionContains"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:978:1: conditionContains returns [AbstractRutaCondition cond = null] options {backtrack=true; } : CONTAINS LPAREN (type= typeExpression | list= listExpression COMMA a= argument ) ( COMMA min= numberExpression COMMA max= numberExpression ( COMMA percent= booleanExpression )? )? RPAREN ;
    public final AbstractRutaCondition conditionContains() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type = null;

        ListExpression list = null;

        RutaExpression a = null;

        NumberExpression min = null;

        NumberExpression max = null;

        BooleanExpression percent = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:982:5: ( CONTAINS LPAREN (type= typeExpression | list= listExpression COMMA a= argument ) ( COMMA min= numberExpression COMMA max= numberExpression ( COMMA percent= booleanExpression )? )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:983:5: CONTAINS LPAREN (type= typeExpression | list= listExpression COMMA a= argument ) ( COMMA min= numberExpression COMMA max= numberExpression ( COMMA percent= booleanExpression )? )? RPAREN
            {
            match(input,CONTAINS,FOLLOW_CONTAINS_in_conditionContains4125); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionContains4127); if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:983:21: (type= typeExpression | list= listExpression COMMA a= argument )
            int alt98=2;
            int LA98_0 = input.LA(1);

            if ( (LA98_0==Identifier) ) {
                int LA98_1 = input.LA(2);

                if ( (!((((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLELIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOATLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRINGLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEANLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INTLIST")))))) ) {
                    alt98=1;
                }
                else if ( (((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLELIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOATLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRINGLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEANLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INTLIST")))) ) {
                    alt98=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return cond;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 98, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA98_0==LCURLY) ) {
                alt98=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return cond;}
                NoViableAltException nvae =
                    new NoViableAltException("", 98, 0, input);

                throw nvae;
            }
            switch (alt98) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:983:22: type= typeExpression
                    {
                    pushFollow(FOLLOW_typeExpression_in_conditionContains4134);
                    type=typeExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:983:46: list= listExpression COMMA a= argument
                    {
                    pushFollow(FOLLOW_listExpression_in_conditionContains4142);
                    list=listExpression();

                    state._fsp--;
                    if (state.failed) return cond;
                    match(input,COMMA,FOLLOW_COMMA_in_conditionContains4144); if (state.failed) return cond;
                    pushFollow(FOLLOW_argument_in_conditionContains4150);
                    a=argument();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:984:5: ( COMMA min= numberExpression COMMA max= numberExpression ( COMMA percent= booleanExpression )? )?
            int alt100=2;
            int LA100_0 = input.LA(1);

            if ( (LA100_0==COMMA) ) {
                alt100=1;
            }
            switch (alt100) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:984:6: COMMA min= numberExpression COMMA max= numberExpression ( COMMA percent= booleanExpression )?
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionContains4159); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberExpression_in_conditionContains4165);
                    min=numberExpression();

                    state._fsp--;
                    if (state.failed) return cond;
                    match(input,COMMA,FOLLOW_COMMA_in_conditionContains4167); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberExpression_in_conditionContains4173);
                    max=numberExpression();

                    state._fsp--;
                    if (state.failed) return cond;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:984:64: ( COMMA percent= booleanExpression )?
                    int alt99=2;
                    int LA99_0 = input.LA(1);

                    if ( (LA99_0==COMMA) ) {
                        alt99=1;
                    }
                    switch (alt99) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:984:65: COMMA percent= booleanExpression
                            {
                            match(input,COMMA,FOLLOW_COMMA_in_conditionContains4176); if (state.failed) return cond;
                            pushFollow(FOLLOW_booleanExpression_in_conditionContains4182);
                            percent=booleanExpression();

                            state._fsp--;
                            if (state.failed) return cond;

                            }
                            break;

                    }


                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionContains4188); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              if(type != null) {cond = ConditionFactory.createConditionContains(type, min, max, percent,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);}
                  else {cond = ConditionFactory.createConditionContains(list,a, min, max, percent, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);};
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionContains"


    // $ANTLR start "conditionContextCount"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:988:1: conditionContextCount returns [AbstractRutaCondition cond = null] : CONTEXTCOUNT LPAREN type= typeExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN ;
    public final AbstractRutaCondition conditionContextCount() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type = null;

        NumberExpression min = null;

        NumberExpression max = null;

        Token var = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:989:5: ( CONTEXTCOUNT LPAREN type= typeExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:990:5: CONTEXTCOUNT LPAREN type= typeExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN
            {
            match(input,CONTEXTCOUNT,FOLLOW_CONTEXTCOUNT_in_conditionContextCount4221); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionContextCount4223); if (state.failed) return cond;
            pushFollow(FOLLOW_typeExpression_in_conditionContextCount4229);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:990:47: ( COMMA min= numberExpression COMMA max= numberExpression )?
            int alt101=2;
            int LA101_0 = input.LA(1);

            if ( (LA101_0==COMMA) ) {
                int LA101_1 = input.LA(2);

                if ( ((LA101_1>=EXP && LA101_1<=TAN)||LA101_1==DecimalLiteral||LA101_1==FloatingPointLiteral||LA101_1==LPAREN||LA101_1==MINUS) ) {
                    alt101=1;
                }
                else if ( (LA101_1==Identifier) ) {
                    int LA101_4 = input.LA(3);

                    if ( (LA101_4==LPAREN||LA101_4==COMMA||(LA101_4>=PLUS && LA101_4<=SLASH)||LA101_4==PERCENT) ) {
                        alt101=1;
                    }
                }
            }
            switch (alt101) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:990:48: COMMA min= numberExpression COMMA max= numberExpression
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionContextCount4232); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberExpression_in_conditionContextCount4238);
                    min=numberExpression();

                    state._fsp--;
                    if (state.failed) return cond;
                    match(input,COMMA,FOLLOW_COMMA_in_conditionContextCount4240); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberExpression_in_conditionContextCount4246);
                    max=numberExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:991:5: ( COMMA var= numberVariable )?
            int alt102=2;
            int LA102_0 = input.LA(1);

            if ( (LA102_0==COMMA) ) {
                alt102=1;
            }
            switch (alt102) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:991:6: COMMA var= numberVariable
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionContextCount4256); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberVariable_in_conditionContextCount4262);
                    var=numberVariable();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionContextCount4266); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionContextCount(type, min, max, var, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionContextCount"


    // $ANTLR start "conditionCount"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:994:1: conditionCount returns [AbstractRutaCondition cond = null] options {backtrack=true; } : ( COUNT LPAREN type= listExpression COMMA a= argument ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN | COUNT LPAREN list= typeExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN );
    public final AbstractRutaCondition conditionCount() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        ListExpression type = null;

        RutaExpression a = null;

        NumberExpression min = null;

        NumberExpression max = null;

        Token var = null;

        TypeExpression list = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:998:5: ( COUNT LPAREN type= listExpression COMMA a= argument ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN | COUNT LPAREN list= typeExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN )
            int alt107=2;
            int LA107_0 = input.LA(1);

            if ( (LA107_0==COUNT) ) {
                int LA107_1 = input.LA(2);

                if ( (synpred22_RutaParser()) ) {
                    alt107=1;
                }
                else if ( (true) ) {
                    alt107=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return cond;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 107, 1, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return cond;}
                NoViableAltException nvae =
                    new NoViableAltException("", 107, 0, input);

                throw nvae;
            }
            switch (alt107) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:999:5: COUNT LPAREN type= listExpression COMMA a= argument ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN
                    {
                    match(input,COUNT,FOLLOW_COUNT_in_conditionCount4312); if (state.failed) return cond;
                    match(input,LPAREN,FOLLOW_LPAREN_in_conditionCount4314); if (state.failed) return cond;
                    pushFollow(FOLLOW_listExpression_in_conditionCount4320);
                    type=listExpression();

                    state._fsp--;
                    if (state.failed) return cond;
                    match(input,COMMA,FOLLOW_COMMA_in_conditionCount4322); if (state.failed) return cond;
                    pushFollow(FOLLOW_argument_in_conditionCount4328);
                    a=argument();

                    state._fsp--;
                    if (state.failed) return cond;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:999:59: ( COMMA min= numberExpression COMMA max= numberExpression )?
                    int alt103=2;
                    int LA103_0 = input.LA(1);

                    if ( (LA103_0==COMMA) ) {
                        int LA103_1 = input.LA(2);

                        if ( (LA103_1==Identifier) ) {
                            int LA103_3 = input.LA(3);

                            if ( (LA103_3==LPAREN||LA103_3==COMMA||(LA103_3>=PLUS && LA103_3<=SLASH)||LA103_3==PERCENT) ) {
                                alt103=1;
                            }
                        }
                        else if ( ((LA103_1>=EXP && LA103_1<=TAN)||LA103_1==DecimalLiteral||LA103_1==FloatingPointLiteral||LA103_1==LPAREN||LA103_1==MINUS) ) {
                            alt103=1;
                        }
                    }
                    switch (alt103) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:999:60: COMMA min= numberExpression COMMA max= numberExpression
                            {
                            match(input,COMMA,FOLLOW_COMMA_in_conditionCount4331); if (state.failed) return cond;
                            pushFollow(FOLLOW_numberExpression_in_conditionCount4337);
                            min=numberExpression();

                            state._fsp--;
                            if (state.failed) return cond;
                            match(input,COMMA,FOLLOW_COMMA_in_conditionCount4339); if (state.failed) return cond;
                            pushFollow(FOLLOW_numberExpression_in_conditionCount4345);
                            max=numberExpression();

                            state._fsp--;
                            if (state.failed) return cond;

                            }
                            break;

                    }

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1000:5: ( COMMA var= numberVariable )?
                    int alt104=2;
                    int LA104_0 = input.LA(1);

                    if ( (LA104_0==COMMA) ) {
                        alt104=1;
                    }
                    switch (alt104) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1000:6: COMMA var= numberVariable
                            {
                            match(input,COMMA,FOLLOW_COMMA_in_conditionCount4355); if (state.failed) return cond;
                            pushFollow(FOLLOW_numberVariable_in_conditionCount4361);
                            var=numberVariable();

                            state._fsp--;
                            if (state.failed) return cond;

                            }
                            break;

                    }

                    match(input,RPAREN,FOLLOW_RPAREN_in_conditionCount4365); if (state.failed) return cond;
                    if ( state.backtracking==0 ) {
                      cond = ConditionFactory.createConditionCount(type, a, min, max, var,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1003:5: COUNT LPAREN list= typeExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN
                    {
                    match(input,COUNT,FOLLOW_COUNT_in_conditionCount4383); if (state.failed) return cond;
                    match(input,LPAREN,FOLLOW_LPAREN_in_conditionCount4385); if (state.failed) return cond;
                    pushFollow(FOLLOW_typeExpression_in_conditionCount4391);
                    list=typeExpression();

                    state._fsp--;
                    if (state.failed) return cond;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1003:40: ( COMMA min= numberExpression COMMA max= numberExpression )?
                    int alt105=2;
                    int LA105_0 = input.LA(1);

                    if ( (LA105_0==COMMA) ) {
                        int LA105_1 = input.LA(2);

                        if ( (LA105_1==Identifier) ) {
                            int LA105_3 = input.LA(3);

                            if ( (LA105_3==LPAREN||LA105_3==COMMA||(LA105_3>=PLUS && LA105_3<=SLASH)||LA105_3==PERCENT) ) {
                                alt105=1;
                            }
                        }
                        else if ( ((LA105_1>=EXP && LA105_1<=TAN)||LA105_1==DecimalLiteral||LA105_1==FloatingPointLiteral||LA105_1==LPAREN||LA105_1==MINUS) ) {
                            alt105=1;
                        }
                    }
                    switch (alt105) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1003:41: COMMA min= numberExpression COMMA max= numberExpression
                            {
                            match(input,COMMA,FOLLOW_COMMA_in_conditionCount4394); if (state.failed) return cond;
                            pushFollow(FOLLOW_numberExpression_in_conditionCount4400);
                            min=numberExpression();

                            state._fsp--;
                            if (state.failed) return cond;
                            match(input,COMMA,FOLLOW_COMMA_in_conditionCount4402); if (state.failed) return cond;
                            pushFollow(FOLLOW_numberExpression_in_conditionCount4408);
                            max=numberExpression();

                            state._fsp--;
                            if (state.failed) return cond;

                            }
                            break;

                    }

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1004:5: ( COMMA var= numberVariable )?
                    int alt106=2;
                    int LA106_0 = input.LA(1);

                    if ( (LA106_0==COMMA) ) {
                        alt106=1;
                    }
                    switch (alt106) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1004:6: COMMA var= numberVariable
                            {
                            match(input,COMMA,FOLLOW_COMMA_in_conditionCount4418); if (state.failed) return cond;
                            pushFollow(FOLLOW_numberVariable_in_conditionCount4424);
                            var=numberVariable();

                            state._fsp--;
                            if (state.failed) return cond;

                            }
                            break;

                    }

                    match(input,RPAREN,FOLLOW_RPAREN_in_conditionCount4428); if (state.failed) return cond;
                    if ( state.backtracking==0 ) {
                      cond = ConditionFactory.createConditionCount(list, min, max, var,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionCount"


    // $ANTLR start "conditionTotalCount"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1007:1: conditionTotalCount returns [AbstractRutaCondition cond = null] : TOTALCOUNT LPAREN type= typeExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN ;
    public final AbstractRutaCondition conditionTotalCount() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type = null;

        NumberExpression min = null;

        NumberExpression max = null;

        Token var = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1008:5: ( TOTALCOUNT LPAREN type= typeExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1009:5: TOTALCOUNT LPAREN type= typeExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN
            {
            match(input,TOTALCOUNT,FOLLOW_TOTALCOUNT_in_conditionTotalCount4464); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionTotalCount4466); if (state.failed) return cond;
            pushFollow(FOLLOW_typeExpression_in_conditionTotalCount4472);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1009:45: ( COMMA min= numberExpression COMMA max= numberExpression )?
            int alt108=2;
            int LA108_0 = input.LA(1);

            if ( (LA108_0==COMMA) ) {
                int LA108_1 = input.LA(2);

                if ( (LA108_1==Identifier) ) {
                    int LA108_3 = input.LA(3);

                    if ( (LA108_3==LPAREN||LA108_3==COMMA||(LA108_3>=PLUS && LA108_3<=SLASH)||LA108_3==PERCENT) ) {
                        alt108=1;
                    }
                }
                else if ( ((LA108_1>=EXP && LA108_1<=TAN)||LA108_1==DecimalLiteral||LA108_1==FloatingPointLiteral||LA108_1==LPAREN||LA108_1==MINUS) ) {
                    alt108=1;
                }
            }
            switch (alt108) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1009:46: COMMA min= numberExpression COMMA max= numberExpression
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionTotalCount4475); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberExpression_in_conditionTotalCount4481);
                    min=numberExpression();

                    state._fsp--;
                    if (state.failed) return cond;
                    match(input,COMMA,FOLLOW_COMMA_in_conditionTotalCount4483); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberExpression_in_conditionTotalCount4489);
                    max=numberExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1010:5: ( COMMA var= numberVariable )?
            int alt109=2;
            int LA109_0 = input.LA(1);

            if ( (LA109_0==COMMA) ) {
                alt109=1;
            }
            switch (alt109) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1010:6: COMMA var= numberVariable
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionTotalCount4498); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberVariable_in_conditionTotalCount4504);
                    var=numberVariable();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionTotalCount4508); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionTotalCount(type, min, max, var, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionTotalCount"


    // $ANTLR start "conditionCurrentCount"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1013:1: conditionCurrentCount returns [AbstractRutaCondition cond = null] : CURRENTCOUNT LPAREN type= typeExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN ;
    public final AbstractRutaCondition conditionCurrentCount() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type = null;

        NumberExpression min = null;

        NumberExpression max = null;

        Token var = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1014:5: ( CURRENTCOUNT LPAREN type= typeExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1015:5: CURRENTCOUNT LPAREN type= typeExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN
            {
            match(input,CURRENTCOUNT,FOLLOW_CURRENTCOUNT_in_conditionCurrentCount4541); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionCurrentCount4543); if (state.failed) return cond;
            pushFollow(FOLLOW_typeExpression_in_conditionCurrentCount4549);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1015:47: ( COMMA min= numberExpression COMMA max= numberExpression )?
            int alt110=2;
            int LA110_0 = input.LA(1);

            if ( (LA110_0==COMMA) ) {
                int LA110_1 = input.LA(2);

                if ( (LA110_1==Identifier) ) {
                    int LA110_3 = input.LA(3);

                    if ( (LA110_3==LPAREN||LA110_3==COMMA||(LA110_3>=PLUS && LA110_3<=SLASH)||LA110_3==PERCENT) ) {
                        alt110=1;
                    }
                }
                else if ( ((LA110_1>=EXP && LA110_1<=TAN)||LA110_1==DecimalLiteral||LA110_1==FloatingPointLiteral||LA110_1==LPAREN||LA110_1==MINUS) ) {
                    alt110=1;
                }
            }
            switch (alt110) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1015:48: COMMA min= numberExpression COMMA max= numberExpression
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionCurrentCount4552); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberExpression_in_conditionCurrentCount4558);
                    min=numberExpression();

                    state._fsp--;
                    if (state.failed) return cond;
                    match(input,COMMA,FOLLOW_COMMA_in_conditionCurrentCount4560); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberExpression_in_conditionCurrentCount4566);
                    max=numberExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1016:5: ( COMMA var= numberVariable )?
            int alt111=2;
            int LA111_0 = input.LA(1);

            if ( (LA111_0==COMMA) ) {
                alt111=1;
            }
            switch (alt111) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1016:6: COMMA var= numberVariable
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionCurrentCount4576); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberVariable_in_conditionCurrentCount4582);
                    var=numberVariable();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionCurrentCount4586); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionCurrentCount(type, min, max, var,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionCurrentCount"


    // $ANTLR start "conditionInList"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1019:1: conditionInList returns [AbstractRutaCondition cond = null] options {backtrack=true; } : INLIST LPAREN ( (list2= stringListExpression )=>list2= stringListExpression | list1= wordListExpression ) ( COMMA dist= numberExpression ( COMMA rel= booleanExpression )? )? RPAREN ;
    public final AbstractRutaCondition conditionInList() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        StringListExpression list2 = null;

        WordListExpression list1 = null;

        NumberExpression dist = null;

        BooleanExpression rel = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1023:5: ( INLIST LPAREN ( (list2= stringListExpression )=>list2= stringListExpression | list1= wordListExpression ) ( COMMA dist= numberExpression ( COMMA rel= booleanExpression )? )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1024:5: INLIST LPAREN ( (list2= stringListExpression )=>list2= stringListExpression | list1= wordListExpression ) ( COMMA dist= numberExpression ( COMMA rel= booleanExpression )? )? RPAREN
            {
            match(input,INLIST,FOLLOW_INLIST_in_conditionInList4629); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionInList4631); if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1024:19: ( (list2= stringListExpression )=>list2= stringListExpression | list1= wordListExpression )
            int alt112=2;
            int LA112_0 = input.LA(1);

            if ( (LA112_0==LCURLY) && (synpred23_RutaParser())) {
                alt112=1;
            }
            else if ( (LA112_0==Identifier) ) {
                int LA112_2 = input.LA(2);

                if ( ((synpred23_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRINGLIST")))) ) {
                    alt112=1;
                }
                else if ( (true) ) {
                    alt112=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return cond;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 112, 2, input);

                    throw nvae;
                }
            }
            else if ( (LA112_0==RessourceLiteral) ) {
                alt112=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return cond;}
                NoViableAltException nvae =
                    new NoViableAltException("", 112, 0, input);

                throw nvae;
            }
            switch (alt112) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1024:20: (list2= stringListExpression )=>list2= stringListExpression
                    {
                    pushFollow(FOLLOW_stringListExpression_in_conditionInList4646);
                    list2=stringListExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1024:83: list1= wordListExpression
                    {
                    pushFollow(FOLLOW_wordListExpression_in_conditionInList4654);
                    list1=wordListExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1024:111: ( COMMA dist= numberExpression ( COMMA rel= booleanExpression )? )?
            int alt114=2;
            int LA114_0 = input.LA(1);

            if ( (LA114_0==COMMA) ) {
                alt114=1;
            }
            switch (alt114) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1024:112: COMMA dist= numberExpression ( COMMA rel= booleanExpression )?
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionInList4658); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberExpression_in_conditionInList4664);
                    dist=numberExpression();

                    state._fsp--;
                    if (state.failed) return cond;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1024:142: ( COMMA rel= booleanExpression )?
                    int alt113=2;
                    int LA113_0 = input.LA(1);

                    if ( (LA113_0==COMMA) ) {
                        alt113=1;
                    }
                    switch (alt113) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1024:143: COMMA rel= booleanExpression
                            {
                            match(input,COMMA,FOLLOW_COMMA_in_conditionInList4667); if (state.failed) return cond;
                            pushFollow(FOLLOW_booleanExpression_in_conditionInList4673);
                            rel=booleanExpression();

                            state._fsp--;
                            if (state.failed) return cond;

                            }
                            break;

                    }


                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionInList4679); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              if(list1 != null) {cond = ConditionFactory.createConditionInList(list1, dist, rel,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);}
                  else {cond = ConditionFactory.createConditionInList(list2, dist, rel,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);};
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionInList"


    // $ANTLR start "conditionLast"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1030:1: conditionLast returns [AbstractRutaCondition cond = null] : LAST LPAREN type= typeExpression RPAREN ;
    public final AbstractRutaCondition conditionLast() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1031:5: ( LAST LPAREN type= typeExpression RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1032:5: LAST LPAREN type= typeExpression RPAREN
            {
            match(input,LAST,FOLLOW_LAST_in_conditionLast4718); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionLast4720); if (state.failed) return cond;
            pushFollow(FOLLOW_typeExpression_in_conditionLast4726);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return cond;
            match(input,RPAREN,FOLLOW_RPAREN_in_conditionLast4728); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionLast(type, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionLast"


    // $ANTLR start "conditionMofN"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1037:1: conditionMofN returns [AbstractRutaCondition cond = null] : MOFN LPAREN min= numberExpression COMMA max= numberExpression COMMA conds= conditions RPAREN ;
    public final AbstractRutaCondition conditionMofN() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        NumberExpression min = null;

        NumberExpression max = null;

        List<AbstractRutaCondition> conds = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1038:5: ( MOFN LPAREN min= numberExpression COMMA max= numberExpression COMMA conds= conditions RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1039:5: MOFN LPAREN min= numberExpression COMMA max= numberExpression COMMA conds= conditions RPAREN
            {
            match(input,MOFN,FOLLOW_MOFN_in_conditionMofN4775); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionMofN4777); if (state.failed) return cond;
            pushFollow(FOLLOW_numberExpression_in_conditionMofN4783);
            min=numberExpression();

            state._fsp--;
            if (state.failed) return cond;
            match(input,COMMA,FOLLOW_COMMA_in_conditionMofN4785); if (state.failed) return cond;
            pushFollow(FOLLOW_numberExpression_in_conditionMofN4791);
            max=numberExpression();

            state._fsp--;
            if (state.failed) return cond;
            match(input,COMMA,FOLLOW_COMMA_in_conditionMofN4793); if (state.failed) return cond;
            pushFollow(FOLLOW_conditions_in_conditionMofN4799);
            conds=conditions();

            state._fsp--;
            if (state.failed) return cond;
            match(input,RPAREN,FOLLOW_RPAREN_in_conditionMofN4801); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionMOfN(conds, min, max, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionMofN"


    // $ANTLR start "conditionNear"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1043:1: conditionNear returns [AbstractRutaCondition cond = null] : NEAR LPAREN type= typeExpression COMMA min= numberExpression COMMA max= numberExpression ( COMMA direction= booleanExpression ( COMMA filtered= booleanExpression )? )? RPAREN ;
    public final AbstractRutaCondition conditionNear() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type = null;

        NumberExpression min = null;

        NumberExpression max = null;

        BooleanExpression direction = null;

        BooleanExpression filtered = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1044:5: ( NEAR LPAREN type= typeExpression COMMA min= numberExpression COMMA max= numberExpression ( COMMA direction= booleanExpression ( COMMA filtered= booleanExpression )? )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1045:5: NEAR LPAREN type= typeExpression COMMA min= numberExpression COMMA max= numberExpression ( COMMA direction= booleanExpression ( COMMA filtered= booleanExpression )? )? RPAREN
            {
            match(input,NEAR,FOLLOW_NEAR_in_conditionNear4836); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionNear4838); if (state.failed) return cond;
            pushFollow(FOLLOW_typeExpression_in_conditionNear4844);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return cond;
            match(input,COMMA,FOLLOW_COMMA_in_conditionNear4846); if (state.failed) return cond;
            pushFollow(FOLLOW_numberExpression_in_conditionNear4852);
            min=numberExpression();

            state._fsp--;
            if (state.failed) return cond;
            match(input,COMMA,FOLLOW_COMMA_in_conditionNear4854); if (state.failed) return cond;
            pushFollow(FOLLOW_numberExpression_in_conditionNear4860);
            max=numberExpression();

            state._fsp--;
            if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1045:97: ( COMMA direction= booleanExpression ( COMMA filtered= booleanExpression )? )?
            int alt116=2;
            int LA116_0 = input.LA(1);

            if ( (LA116_0==COMMA) ) {
                alt116=1;
            }
            switch (alt116) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1045:98: COMMA direction= booleanExpression ( COMMA filtered= booleanExpression )?
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionNear4863); if (state.failed) return cond;
                    pushFollow(FOLLOW_booleanExpression_in_conditionNear4869);
                    direction=booleanExpression();

                    state._fsp--;
                    if (state.failed) return cond;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1045:134: ( COMMA filtered= booleanExpression )?
                    int alt115=2;
                    int LA115_0 = input.LA(1);

                    if ( (LA115_0==COMMA) ) {
                        alt115=1;
                    }
                    switch (alt115) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1045:135: COMMA filtered= booleanExpression
                            {
                            match(input,COMMA,FOLLOW_COMMA_in_conditionNear4872); if (state.failed) return cond;
                            pushFollow(FOLLOW_booleanExpression_in_conditionNear4878);
                            filtered=booleanExpression();

                            state._fsp--;
                            if (state.failed) return cond;

                            }
                            break;

                    }


                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionNear4884); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionNear(type, min, max, direction, filtered, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionNear"


    // $ANTLR start "conditionNot"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1048:1: conditionNot returns [AbstractRutaCondition cond = null] : ( ( MINUS c= condition ) | ( NOT LPAREN c= condition RPAREN ) ) ;
    public final AbstractRutaCondition conditionNot() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        AbstractRutaCondition c = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1049:5: ( ( ( MINUS c= condition ) | ( NOT LPAREN c= condition RPAREN ) ) )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1050:5: ( ( MINUS c= condition ) | ( NOT LPAREN c= condition RPAREN ) )
            {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1050:5: ( ( MINUS c= condition ) | ( NOT LPAREN c= condition RPAREN ) )
            int alt117=2;
            int LA117_0 = input.LA(1);

            if ( (LA117_0==MINUS) ) {
                alt117=1;
            }
            else if ( (LA117_0==NOT) ) {
                alt117=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return cond;}
                NoViableAltException nvae =
                    new NoViableAltException("", 117, 0, input);

                throw nvae;
            }
            switch (alt117) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1050:6: ( MINUS c= condition )
                    {
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1050:6: ( MINUS c= condition )
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1050:7: MINUS c= condition
                    {
                    match(input,MINUS,FOLLOW_MINUS_in_conditionNot4920); if (state.failed) return cond;
                    pushFollow(FOLLOW_condition_in_conditionNot4926);
                    c=condition();

                    state._fsp--;
                    if (state.failed) return cond;

                    }


                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1050:31: ( NOT LPAREN c= condition RPAREN )
                    {
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1050:31: ( NOT LPAREN c= condition RPAREN )
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1050:32: NOT LPAREN c= condition RPAREN
                    {
                    match(input,NOT,FOLLOW_NOT_in_conditionNot4933); if (state.failed) return cond;
                    match(input,LPAREN,FOLLOW_LPAREN_in_conditionNot4935); if (state.failed) return cond;
                    pushFollow(FOLLOW_condition_in_conditionNot4941);
                    c=condition();

                    state._fsp--;
                    if (state.failed) return cond;
                    match(input,RPAREN,FOLLOW_RPAREN_in_conditionNot4943); if (state.failed) return cond;

                    }


                    }
                    break;

            }

            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionNot(c, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionNot"


    // $ANTLR start "conditionOr"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1053:1: conditionOr returns [AbstractRutaCondition cond = null] : OR LPAREN conds= conditions RPAREN ;
    public final AbstractRutaCondition conditionOr() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        List<AbstractRutaCondition> conds = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1054:5: ( OR LPAREN conds= conditions RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1055:5: OR LPAREN conds= conditions RPAREN
            {
            match(input,OR,FOLLOW_OR_in_conditionOr4982); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionOr4984); if (state.failed) return cond;
            pushFollow(FOLLOW_conditions_in_conditionOr4990);
            conds=conditions();

            state._fsp--;
            if (state.failed) return cond;
            match(input,RPAREN,FOLLOW_RPAREN_in_conditionOr4992); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionOr(conds, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionOr"


    // $ANTLR start "conditionPartOf"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1058:1: conditionPartOf returns [AbstractRutaCondition cond = null] : PARTOF LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN ;
    public final AbstractRutaCondition conditionPartOf() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type1 = null;

        TypeListExpression type2 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1059:5: ( PARTOF LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1060:5: PARTOF LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN
            {
            match(input,PARTOF,FOLLOW_PARTOF_in_conditionPartOf5022); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionPartOf5024); if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1060:19: (type1= typeExpression | type2= typeListExpression )
            int alt118=2;
            int LA118_0 = input.LA(1);

            if ( (LA118_0==Identifier) ) {
                int LA118_1 = input.LA(2);

                if ( (!(((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))))) ) {
                    alt118=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))) ) {
                    alt118=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return cond;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 118, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA118_0==LCURLY) ) {
                alt118=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return cond;}
                NoViableAltException nvae =
                    new NoViableAltException("", 118, 0, input);

                throw nvae;
            }
            switch (alt118) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1060:20: type1= typeExpression
                    {
                    pushFollow(FOLLOW_typeExpression_in_conditionPartOf5031);
                    type1=typeExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1060:43: type2= typeListExpression
                    {
                    pushFollow(FOLLOW_typeListExpression_in_conditionPartOf5037);
                    type2=typeListExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionPartOf5040); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionPartOf(type1, type2, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionPartOf"


    // $ANTLR start "conditionPartOfNeq"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1063:1: conditionPartOfNeq returns [AbstractRutaCondition cond = null] : PARTOFNEQ LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN ;
    public final AbstractRutaCondition conditionPartOfNeq() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type1 = null;

        TypeListExpression type2 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1064:5: ( PARTOFNEQ LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1065:5: PARTOFNEQ LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN
            {
            match(input,PARTOFNEQ,FOLLOW_PARTOFNEQ_in_conditionPartOfNeq5070); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionPartOfNeq5072); if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1065:22: (type1= typeExpression | type2= typeListExpression )
            int alt119=2;
            int LA119_0 = input.LA(1);

            if ( (LA119_0==Identifier) ) {
                int LA119_1 = input.LA(2);

                if ( (!(((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))))) ) {
                    alt119=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))) ) {
                    alt119=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return cond;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 119, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA119_0==LCURLY) ) {
                alt119=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return cond;}
                NoViableAltException nvae =
                    new NoViableAltException("", 119, 0, input);

                throw nvae;
            }
            switch (alt119) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1065:23: type1= typeExpression
                    {
                    pushFollow(FOLLOW_typeExpression_in_conditionPartOfNeq5079);
                    type1=typeExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1065:46: type2= typeListExpression
                    {
                    pushFollow(FOLLOW_typeListExpression_in_conditionPartOfNeq5085);
                    type2=typeListExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionPartOfNeq5088); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionPartOfNeq(type1, type2, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionPartOfNeq"


    // $ANTLR start "conditionPosition"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1069:1: conditionPosition returns [AbstractRutaCondition cond = null] : POSITION LPAREN type= typeExpression COMMA pos= numberExpression ( COMMA rel= booleanExpression )? RPAREN ;
    public final AbstractRutaCondition conditionPosition() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type = null;

        NumberExpression pos = null;

        BooleanExpression rel = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1070:5: ( POSITION LPAREN type= typeExpression COMMA pos= numberExpression ( COMMA rel= booleanExpression )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1071:5: POSITION LPAREN type= typeExpression COMMA pos= numberExpression ( COMMA rel= booleanExpression )? RPAREN
            {
            match(input,POSITION,FOLLOW_POSITION_in_conditionPosition5122); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionPosition5124); if (state.failed) return cond;
            pushFollow(FOLLOW_typeExpression_in_conditionPosition5130);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return cond;
            match(input,COMMA,FOLLOW_COMMA_in_conditionPosition5132); if (state.failed) return cond;
            pushFollow(FOLLOW_numberExpression_in_conditionPosition5138);
            pos=numberExpression();

            state._fsp--;
            if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1071:72: ( COMMA rel= booleanExpression )?
            int alt120=2;
            int LA120_0 = input.LA(1);

            if ( (LA120_0==COMMA) ) {
                alt120=1;
            }
            switch (alt120) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1071:73: COMMA rel= booleanExpression
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionPosition5141); if (state.failed) return cond;
                    pushFollow(FOLLOW_booleanExpression_in_conditionPosition5147);
                    rel=booleanExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionPosition5151); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionPosition(type, pos, rel, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionPosition"


    // $ANTLR start "conditionRegExp"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1074:1: conditionRegExp returns [AbstractRutaCondition cond = null] : REGEXP LPAREN (v= variable COMMA )? pattern= stringExpression ( COMMA caseSensitive= booleanExpression )? RPAREN ;
    public final AbstractRutaCondition conditionRegExp() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        Token v = null;

        StringExpression pattern = null;

        BooleanExpression caseSensitive = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1075:5: ( REGEXP LPAREN (v= variable COMMA )? pattern= stringExpression ( COMMA caseSensitive= booleanExpression )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1076:5: REGEXP LPAREN (v= variable COMMA )? pattern= stringExpression ( COMMA caseSensitive= booleanExpression )? RPAREN
            {
            match(input,REGEXP,FOLLOW_REGEXP_in_conditionRegExp5181); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionRegExp5183); if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1076:19: (v= variable COMMA )?
            int alt121=2;
            int LA121_0 = input.LA(1);

            if ( (LA121_0==Identifier) ) {
                int LA121_1 = input.LA(2);

                if ( (LA121_1==COMMA) ) {
                    int LA121_3 = input.LA(3);

                    if ( (LA121_3==REMOVESTRING||LA121_3==StringLiteral) ) {
                        alt121=1;
                    }
                    else if ( (LA121_3==Identifier) ) {
                        int LA121_5 = input.LA(4);

                        if ( ((isVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText()))) ) {
                            alt121=1;
                        }
                    }
                }
            }
            switch (alt121) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1076:20: v= variable COMMA
                    {
                    pushFollow(FOLLOW_variable_in_conditionRegExp5190);
                    v=variable();

                    state._fsp--;
                    if (state.failed) return cond;
                    match(input,COMMA,FOLLOW_COMMA_in_conditionRegExp5192); if (state.failed) return cond;

                    }
                    break;

            }

            pushFollow(FOLLOW_stringExpression_in_conditionRegExp5200);
            pattern=stringExpression();

            state._fsp--;
            if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1076:68: ( COMMA caseSensitive= booleanExpression )?
            int alt122=2;
            int LA122_0 = input.LA(1);

            if ( (LA122_0==COMMA) ) {
                alt122=1;
            }
            switch (alt122) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1076:69: COMMA caseSensitive= booleanExpression
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionRegExp5203); if (state.failed) return cond;
                    pushFollow(FOLLOW_booleanExpression_in_conditionRegExp5209);
                    caseSensitive=booleanExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionRegExp5213); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionRegExp(v, pattern, caseSensitive, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionRegExp"


    // $ANTLR start "conditionScore"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1080:1: conditionScore returns [AbstractRutaCondition cond = null] : SCORE LPAREN min= numberExpression ( COMMA max= numberExpression ( COMMA var= numberVariable )? )? RPAREN ;
    public final AbstractRutaCondition conditionScore() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        NumberExpression min = null;

        NumberExpression max = null;

        Token var = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1081:5: ( SCORE LPAREN min= numberExpression ( COMMA max= numberExpression ( COMMA var= numberVariable )? )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1082:5: SCORE LPAREN min= numberExpression ( COMMA max= numberExpression ( COMMA var= numberVariable )? )? RPAREN
            {
            match(input,SCORE,FOLLOW_SCORE_in_conditionScore5248); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionScore5250); if (state.failed) return cond;
            pushFollow(FOLLOW_numberExpression_in_conditionScore5256);
            min=numberExpression();

            state._fsp--;
            if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1082:41: ( COMMA max= numberExpression ( COMMA var= numberVariable )? )?
            int alt124=2;
            int LA124_0 = input.LA(1);

            if ( (LA124_0==COMMA) ) {
                alt124=1;
            }
            switch (alt124) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1082:42: COMMA max= numberExpression ( COMMA var= numberVariable )?
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionScore5259); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberExpression_in_conditionScore5265);
                    max=numberExpression();

                    state._fsp--;
                    if (state.failed) return cond;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1083:5: ( COMMA var= numberVariable )?
                    int alt123=2;
                    int LA123_0 = input.LA(1);

                    if ( (LA123_0==COMMA) ) {
                        alt123=1;
                    }
                    switch (alt123) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1083:6: COMMA var= numberVariable
                            {
                            match(input,COMMA,FOLLOW_COMMA_in_conditionScore5272); if (state.failed) return cond;
                            pushFollow(FOLLOW_numberVariable_in_conditionScore5278);
                            var=numberVariable();

                            state._fsp--;
                            if (state.failed) return cond;

                            }
                            break;

                    }


                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionScore5285); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionScore(min, max, var, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionScore"


    // $ANTLR start "conditionVote"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1088:1: conditionVote returns [AbstractRutaCondition cond = null] : VOTE LPAREN type1= typeExpression COMMA type2= typeExpression RPAREN ;
    public final AbstractRutaCondition conditionVote() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type1 = null;

        TypeExpression type2 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1089:5: ( VOTE LPAREN type1= typeExpression COMMA type2= typeExpression RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1090:5: VOTE LPAREN type1= typeExpression COMMA type2= typeExpression RPAREN
            {
            match(input,VOTE,FOLLOW_VOTE_in_conditionVote5320); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionVote5322); if (state.failed) return cond;
            pushFollow(FOLLOW_typeExpression_in_conditionVote5328);
            type1=typeExpression();

            state._fsp--;
            if (state.failed) return cond;
            match(input,COMMA,FOLLOW_COMMA_in_conditionVote5330); if (state.failed) return cond;
            pushFollow(FOLLOW_typeExpression_in_conditionVote5336);
            type2=typeExpression();

            state._fsp--;
            if (state.failed) return cond;
            match(input,RPAREN,FOLLOW_RPAREN_in_conditionVote5338); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionVote(type1, type2, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionVote"


    // $ANTLR start "conditionIf"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1094:1: conditionIf returns [AbstractRutaCondition cond = null] : IF LPAREN e= booleanExpression RPAREN ;
    public final AbstractRutaCondition conditionIf() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        BooleanExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1095:5: ( IF LPAREN e= booleanExpression RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1096:5: IF LPAREN e= booleanExpression RPAREN
            {
            match(input,IF,FOLLOW_IF_in_conditionIf5376); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionIf5378); if (state.failed) return cond;
            pushFollow(FOLLOW_booleanExpression_in_conditionIf5384);
            e=booleanExpression();

            state._fsp--;
            if (state.failed) return cond;
            match(input,RPAREN,FOLLOW_RPAREN_in_conditionIf5386); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionIf(e, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionIf"


    // $ANTLR start "conditionFeature"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1100:1: conditionFeature returns [AbstractRutaCondition cond = null] : FEATURE LPAREN se= stringExpression COMMA v= argument RPAREN ;
    public final AbstractRutaCondition conditionFeature() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        StringExpression se = null;

        RutaExpression v = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1101:5: ( FEATURE LPAREN se= stringExpression COMMA v= argument RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1102:5: FEATURE LPAREN se= stringExpression COMMA v= argument RPAREN
            {
            match(input,FEATURE,FOLLOW_FEATURE_in_conditionFeature5420); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionFeature5422); if (state.failed) return cond;
            pushFollow(FOLLOW_stringExpression_in_conditionFeature5428);
            se=stringExpression();

            state._fsp--;
            if (state.failed) return cond;
            match(input,COMMA,FOLLOW_COMMA_in_conditionFeature5430); if (state.failed) return cond;
            pushFollow(FOLLOW_argument_in_conditionFeature5436);
            v=argument();

            state._fsp--;
            if (state.failed) return cond;
            match(input,RPAREN,FOLLOW_RPAREN_in_conditionFeature5438); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionFeature(se, v, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionFeature"


    // $ANTLR start "conditionParse"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1106:1: conditionParse returns [AbstractRutaCondition cond = null] : PARSE LPAREN {...}?id= Identifier RPAREN ;
    public final AbstractRutaCondition conditionParse() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        Token id=null;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1107:5: ( PARSE LPAREN {...}?id= Identifier RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1108:5: PARSE LPAREN {...}?id= Identifier RPAREN
            {
            match(input,PARSE,FOLLOW_PARSE_in_conditionParse5472); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionParse5474); if (state.failed) return cond;
            if ( !((isVariable(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText()))) ) {
                if (state.backtracking>0) {state.failed=true; return cond;}
                throw new FailedPredicateException(input, "conditionParse", "isVariable($blockDeclaration::env,input.LT(1).getText())");
            }
            id=(Token)match(input,Identifier,FOLLOW_Identifier_in_conditionParse5482); if (state.failed) return cond;
            match(input,RPAREN,FOLLOW_RPAREN_in_conditionParse5484); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionParse(id, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionParse"


    // $ANTLR start "conditionIs"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1112:1: conditionIs returns [AbstractRutaCondition cond = null] : IS LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN ;
    public final AbstractRutaCondition conditionIs() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type1 = null;

        TypeListExpression type2 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1113:5: ( IS LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1114:5: IS LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN
            {
            match(input,IS,FOLLOW_IS_in_conditionIs5515); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionIs5517); if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1114:15: (type1= typeExpression | type2= typeListExpression )
            int alt125=2;
            int LA125_0 = input.LA(1);

            if ( (LA125_0==Identifier) ) {
                int LA125_1 = input.LA(2);

                if ( (!(((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))))) ) {
                    alt125=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))) ) {
                    alt125=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return cond;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 125, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA125_0==LCURLY) ) {
                alt125=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return cond;}
                NoViableAltException nvae =
                    new NoViableAltException("", 125, 0, input);

                throw nvae;
            }
            switch (alt125) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1114:16: type1= typeExpression
                    {
                    pushFollow(FOLLOW_typeExpression_in_conditionIs5524);
                    type1=typeExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1114:39: type2= typeListExpression
                    {
                    pushFollow(FOLLOW_typeListExpression_in_conditionIs5530);
                    type2=typeListExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionIs5533); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionIs(type1, type2, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionIs"


    // $ANTLR start "conditionBefore"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1118:1: conditionBefore returns [AbstractRutaCondition cond = null] : BEFORE LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN ;
    public final AbstractRutaCondition conditionBefore() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type1 = null;

        TypeListExpression type2 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1119:5: ( BEFORE LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1120:5: BEFORE LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN
            {
            match(input,BEFORE,FOLLOW_BEFORE_in_conditionBefore5564); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionBefore5566); if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1120:19: (type1= typeExpression | type2= typeListExpression )
            int alt126=2;
            int LA126_0 = input.LA(1);

            if ( (LA126_0==Identifier) ) {
                int LA126_1 = input.LA(2);

                if ( (!(((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))))) ) {
                    alt126=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))) ) {
                    alt126=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return cond;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 126, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA126_0==LCURLY) ) {
                alt126=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return cond;}
                NoViableAltException nvae =
                    new NoViableAltException("", 126, 0, input);

                throw nvae;
            }
            switch (alt126) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1120:20: type1= typeExpression
                    {
                    pushFollow(FOLLOW_typeExpression_in_conditionBefore5573);
                    type1=typeExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1120:43: type2= typeListExpression
                    {
                    pushFollow(FOLLOW_typeListExpression_in_conditionBefore5579);
                    type2=typeListExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionBefore5582); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionBefore(type1,type2, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionBefore"


    // $ANTLR start "conditionAfter"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1124:1: conditionAfter returns [AbstractRutaCondition cond = null] : AFTER LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN ;
    public final AbstractRutaCondition conditionAfter() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type1 = null;

        TypeListExpression type2 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1125:5: ( AFTER LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1126:5: AFTER LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN
            {
            match(input,AFTER,FOLLOW_AFTER_in_conditionAfter5613); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionAfter5615); if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1126:18: (type1= typeExpression | type2= typeListExpression )
            int alt127=2;
            int LA127_0 = input.LA(1);

            if ( (LA127_0==Identifier) ) {
                int LA127_1 = input.LA(2);

                if ( (!(((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))))) ) {
                    alt127=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))) ) {
                    alt127=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return cond;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 127, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA127_0==LCURLY) ) {
                alt127=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return cond;}
                NoViableAltException nvae =
                    new NoViableAltException("", 127, 0, input);

                throw nvae;
            }
            switch (alt127) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1126:19: type1= typeExpression
                    {
                    pushFollow(FOLLOW_typeExpression_in_conditionAfter5622);
                    type1=typeExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1126:42: type2= typeListExpression
                    {
                    pushFollow(FOLLOW_typeListExpression_in_conditionAfter5628);
                    type2=typeListExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionAfter5631); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionAfter(type1,type2,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionAfter"


    // $ANTLR start "conditionStartsWith"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1130:1: conditionStartsWith returns [AbstractRutaCondition cond = null] : STARTSWITH LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN ;
    public final AbstractRutaCondition conditionStartsWith() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type1 = null;

        TypeListExpression type2 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1131:5: ( STARTSWITH LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1132:5: STARTSWITH LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN
            {
            match(input,STARTSWITH,FOLLOW_STARTSWITH_in_conditionStartsWith5662); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionStartsWith5664); if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1132:23: (type1= typeExpression | type2= typeListExpression )
            int alt128=2;
            int LA128_0 = input.LA(1);

            if ( (LA128_0==Identifier) ) {
                int LA128_1 = input.LA(2);

                if ( (!(((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))))) ) {
                    alt128=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))) ) {
                    alt128=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return cond;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 128, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA128_0==LCURLY) ) {
                alt128=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return cond;}
                NoViableAltException nvae =
                    new NoViableAltException("", 128, 0, input);

                throw nvae;
            }
            switch (alt128) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1132:24: type1= typeExpression
                    {
                    pushFollow(FOLLOW_typeExpression_in_conditionStartsWith5671);
                    type1=typeExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1132:47: type2= typeListExpression
                    {
                    pushFollow(FOLLOW_typeListExpression_in_conditionStartsWith5677);
                    type2=typeListExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionStartsWith5680); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionStartsWith(type1,type2, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionStartsWith"


    // $ANTLR start "conditionEndsWith"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1136:1: conditionEndsWith returns [AbstractRutaCondition cond = null] : ENDSWITH LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN ;
    public final AbstractRutaCondition conditionEndsWith() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        TypeExpression type1 = null;

        TypeListExpression type2 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1137:5: ( ENDSWITH LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1138:5: ENDSWITH LPAREN (type1= typeExpression | type2= typeListExpression ) RPAREN
            {
            match(input,ENDSWITH,FOLLOW_ENDSWITH_in_conditionEndsWith5711); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionEndsWith5713); if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1138:21: (type1= typeExpression | type2= typeListExpression )
            int alt129=2;
            int LA129_0 = input.LA(1);

            if ( (LA129_0==Identifier) ) {
                int LA129_1 = input.LA(2);

                if ( (!(((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))))) ) {
                    alt129=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))) ) {
                    alt129=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return cond;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 129, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA129_0==LCURLY) ) {
                alt129=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return cond;}
                NoViableAltException nvae =
                    new NoViableAltException("", 129, 0, input);

                throw nvae;
            }
            switch (alt129) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1138:22: type1= typeExpression
                    {
                    pushFollow(FOLLOW_typeExpression_in_conditionEndsWith5720);
                    type1=typeExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1138:45: type2= typeListExpression
                    {
                    pushFollow(FOLLOW_typeListExpression_in_conditionEndsWith5726);
                    type2=typeListExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionEndsWith5729); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionEndsWith(type1,type2,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionEndsWith"


    // $ANTLR start "conditionSize"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1142:1: conditionSize returns [AbstractRutaCondition cond = null] : SIZE LPAREN list= listExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN ;
    public final AbstractRutaCondition conditionSize() throws RecognitionException {
        AbstractRutaCondition cond =  null;

        ListExpression list = null;

        NumberExpression min = null;

        NumberExpression max = null;

        Token var = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1143:5: ( SIZE LPAREN list= listExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1144:5: SIZE LPAREN list= listExpression ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN
            {
            match(input,SIZE,FOLLOW_SIZE_in_conditionSize5760); if (state.failed) return cond;
            match(input,LPAREN,FOLLOW_LPAREN_in_conditionSize5762); if (state.failed) return cond;
            pushFollow(FOLLOW_listExpression_in_conditionSize5768);
            list=listExpression();

            state._fsp--;
            if (state.failed) return cond;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1144:39: ( COMMA min= numberExpression COMMA max= numberExpression )?
            int alt130=2;
            int LA130_0 = input.LA(1);

            if ( (LA130_0==COMMA) ) {
                int LA130_1 = input.LA(2);

                if ( (LA130_1==Identifier) ) {
                    int LA130_3 = input.LA(3);

                    if ( (LA130_3==LPAREN||LA130_3==COMMA||(LA130_3>=PLUS && LA130_3<=SLASH)||LA130_3==PERCENT) ) {
                        alt130=1;
                    }
                }
                else if ( ((LA130_1>=EXP && LA130_1<=TAN)||LA130_1==DecimalLiteral||LA130_1==FloatingPointLiteral||LA130_1==LPAREN||LA130_1==MINUS) ) {
                    alt130=1;
                }
            }
            switch (alt130) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1144:40: COMMA min= numberExpression COMMA max= numberExpression
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionSize5771); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberExpression_in_conditionSize5777);
                    min=numberExpression();

                    state._fsp--;
                    if (state.failed) return cond;
                    match(input,COMMA,FOLLOW_COMMA_in_conditionSize5779); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberExpression_in_conditionSize5785);
                    max=numberExpression();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1144:100: ( COMMA var= numberVariable )?
            int alt131=2;
            int LA131_0 = input.LA(1);

            if ( (LA131_0==COMMA) ) {
                alt131=1;
            }
            switch (alt131) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1144:101: COMMA var= numberVariable
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_conditionSize5790); if (state.failed) return cond;
                    pushFollow(FOLLOW_numberVariable_in_conditionSize5796);
                    var=numberVariable();

                    state._fsp--;
                    if (state.failed) return cond;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_conditionSize5800); if (state.failed) return cond;
            if ( state.backtracking==0 ) {
              cond = ConditionFactory.createConditionSize(list, min, max, var,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return cond;
    }
    // $ANTLR end "conditionSize"


    // $ANTLR start "action"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1148:1: action returns [AbstractRutaAction result = null] : (a= actionColor | a= actionDel | a= actionLog | a= actionMark | a= actionMarkScore | a= actionMarkFast | a= actionMarkLast | a= actionReplace | a= actionFilterType | a= actionRetainType | a= actionCreate | a= actionFill | a= actionCall | a= actionAssign | a= actionSetFeature | a= actionGetFeature | a= actionUnmark | a= actionUnmarkAll | a= actionTransfer | a= actionMarkOnce | a= actionTrie | a= actionGather | a= actionExec | a= actionMarkTable | a= actionAdd | a= actionRemove | a= actionRemoveDuplicate | a= actionMerge | a= actionGet | a= actionGetList | a= actionMatchedText | a= actionClear | a= actionShift | a= actionConfigure | a= actionDynamicAnchoring | a= actionTrim | a= actionAddRetainType | a= actionRemoveRetainType | a= actionAddFilterType | a= actionRemoveFilterType | (a= externalAction )=>a= externalAction ) ;
    public final AbstractRutaAction action() throws RecognitionException {
        AbstractRutaAction result =  null;

        AbstractRutaAction a = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1149:2: ( (a= actionColor | a= actionDel | a= actionLog | a= actionMark | a= actionMarkScore | a= actionMarkFast | a= actionMarkLast | a= actionReplace | a= actionFilterType | a= actionRetainType | a= actionCreate | a= actionFill | a= actionCall | a= actionAssign | a= actionSetFeature | a= actionGetFeature | a= actionUnmark | a= actionUnmarkAll | a= actionTransfer | a= actionMarkOnce | a= actionTrie | a= actionGather | a= actionExec | a= actionMarkTable | a= actionAdd | a= actionRemove | a= actionRemoveDuplicate | a= actionMerge | a= actionGet | a= actionGetList | a= actionMatchedText | a= actionClear | a= actionShift | a= actionConfigure | a= actionDynamicAnchoring | a= actionTrim | a= actionAddRetainType | a= actionRemoveRetainType | a= actionAddFilterType | a= actionRemoveFilterType | (a= externalAction )=>a= externalAction ) )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1150:2: (a= actionColor | a= actionDel | a= actionLog | a= actionMark | a= actionMarkScore | a= actionMarkFast | a= actionMarkLast | a= actionReplace | a= actionFilterType | a= actionRetainType | a= actionCreate | a= actionFill | a= actionCall | a= actionAssign | a= actionSetFeature | a= actionGetFeature | a= actionUnmark | a= actionUnmarkAll | a= actionTransfer | a= actionMarkOnce | a= actionTrie | a= actionGather | a= actionExec | a= actionMarkTable | a= actionAdd | a= actionRemove | a= actionRemoveDuplicate | a= actionMerge | a= actionGet | a= actionGetList | a= actionMatchedText | a= actionClear | a= actionShift | a= actionConfigure | a= actionDynamicAnchoring | a= actionTrim | a= actionAddRetainType | a= actionRemoveRetainType | a= actionAddFilterType | a= actionRemoveFilterType | (a= externalAction )=>a= externalAction )
            {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1150:2: (a= actionColor | a= actionDel | a= actionLog | a= actionMark | a= actionMarkScore | a= actionMarkFast | a= actionMarkLast | a= actionReplace | a= actionFilterType | a= actionRetainType | a= actionCreate | a= actionFill | a= actionCall | a= actionAssign | a= actionSetFeature | a= actionGetFeature | a= actionUnmark | a= actionUnmarkAll | a= actionTransfer | a= actionMarkOnce | a= actionTrie | a= actionGather | a= actionExec | a= actionMarkTable | a= actionAdd | a= actionRemove | a= actionRemoveDuplicate | a= actionMerge | a= actionGet | a= actionGetList | a= actionMatchedText | a= actionClear | a= actionShift | a= actionConfigure | a= actionDynamicAnchoring | a= actionTrim | a= actionAddRetainType | a= actionRemoveRetainType | a= actionAddFilterType | a= actionRemoveFilterType | (a= externalAction )=>a= externalAction )
            int alt132=41;
            alt132 = dfa132.predict(input);
            switch (alt132) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1151:2: a= actionColor
                    {
                    pushFollow(FOLLOW_actionColor_in_action5833);
                    a=actionColor();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1152:4: a= actionDel
                    {
                    pushFollow(FOLLOW_actionDel_in_action5842);
                    a=actionDel();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1153:4: a= actionLog
                    {
                    pushFollow(FOLLOW_actionLog_in_action5851);
                    a=actionLog();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 4 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1154:4: a= actionMark
                    {
                    pushFollow(FOLLOW_actionMark_in_action5860);
                    a=actionMark();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 5 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1155:4: a= actionMarkScore
                    {
                    pushFollow(FOLLOW_actionMarkScore_in_action5869);
                    a=actionMarkScore();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 6 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1156:4: a= actionMarkFast
                    {
                    pushFollow(FOLLOW_actionMarkFast_in_action5878);
                    a=actionMarkFast();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 7 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1157:4: a= actionMarkLast
                    {
                    pushFollow(FOLLOW_actionMarkLast_in_action5887);
                    a=actionMarkLast();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 8 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1158:4: a= actionReplace
                    {
                    pushFollow(FOLLOW_actionReplace_in_action5896);
                    a=actionReplace();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 9 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1159:4: a= actionFilterType
                    {
                    pushFollow(FOLLOW_actionFilterType_in_action5905);
                    a=actionFilterType();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 10 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1160:4: a= actionRetainType
                    {
                    pushFollow(FOLLOW_actionRetainType_in_action5914);
                    a=actionRetainType();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 11 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1161:4: a= actionCreate
                    {
                    pushFollow(FOLLOW_actionCreate_in_action5923);
                    a=actionCreate();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 12 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1162:4: a= actionFill
                    {
                    pushFollow(FOLLOW_actionFill_in_action5932);
                    a=actionFill();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 13 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1163:4: a= actionCall
                    {
                    pushFollow(FOLLOW_actionCall_in_action5941);
                    a=actionCall();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 14 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1164:4: a= actionAssign
                    {
                    pushFollow(FOLLOW_actionAssign_in_action5950);
                    a=actionAssign();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 15 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1165:4: a= actionSetFeature
                    {
                    pushFollow(FOLLOW_actionSetFeature_in_action5959);
                    a=actionSetFeature();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 16 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1166:4: a= actionGetFeature
                    {
                    pushFollow(FOLLOW_actionGetFeature_in_action5968);
                    a=actionGetFeature();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 17 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1167:4: a= actionUnmark
                    {
                    pushFollow(FOLLOW_actionUnmark_in_action5977);
                    a=actionUnmark();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 18 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1168:4: a= actionUnmarkAll
                    {
                    pushFollow(FOLLOW_actionUnmarkAll_in_action5986);
                    a=actionUnmarkAll();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 19 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1169:4: a= actionTransfer
                    {
                    pushFollow(FOLLOW_actionTransfer_in_action5995);
                    a=actionTransfer();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 20 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1170:4: a= actionMarkOnce
                    {
                    pushFollow(FOLLOW_actionMarkOnce_in_action6004);
                    a=actionMarkOnce();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 21 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1171:4: a= actionTrie
                    {
                    pushFollow(FOLLOW_actionTrie_in_action6013);
                    a=actionTrie();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 22 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1172:4: a= actionGather
                    {
                    pushFollow(FOLLOW_actionGather_in_action6022);
                    a=actionGather();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 23 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1173:4: a= actionExec
                    {
                    pushFollow(FOLLOW_actionExec_in_action6031);
                    a=actionExec();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 24 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1174:4: a= actionMarkTable
                    {
                    pushFollow(FOLLOW_actionMarkTable_in_action6040);
                    a=actionMarkTable();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 25 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1175:4: a= actionAdd
                    {
                    pushFollow(FOLLOW_actionAdd_in_action6049);
                    a=actionAdd();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 26 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1176:4: a= actionRemove
                    {
                    pushFollow(FOLLOW_actionRemove_in_action6058);
                    a=actionRemove();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 27 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1177:4: a= actionRemoveDuplicate
                    {
                    pushFollow(FOLLOW_actionRemoveDuplicate_in_action6067);
                    a=actionRemoveDuplicate();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 28 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1178:4: a= actionMerge
                    {
                    pushFollow(FOLLOW_actionMerge_in_action6076);
                    a=actionMerge();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 29 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1179:4: a= actionGet
                    {
                    pushFollow(FOLLOW_actionGet_in_action6085);
                    a=actionGet();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 30 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1180:4: a= actionGetList
                    {
                    pushFollow(FOLLOW_actionGetList_in_action6094);
                    a=actionGetList();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 31 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1181:4: a= actionMatchedText
                    {
                    pushFollow(FOLLOW_actionMatchedText_in_action6103);
                    a=actionMatchedText();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 32 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1182:4: a= actionClear
                    {
                    pushFollow(FOLLOW_actionClear_in_action6112);
                    a=actionClear();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 33 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1183:4: a= actionShift
                    {
                    pushFollow(FOLLOW_actionShift_in_action6121);
                    a=actionShift();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 34 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1184:4: a= actionConfigure
                    {
                    pushFollow(FOLLOW_actionConfigure_in_action6130);
                    a=actionConfigure();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 35 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1185:4: a= actionDynamicAnchoring
                    {
                    pushFollow(FOLLOW_actionDynamicAnchoring_in_action6139);
                    a=actionDynamicAnchoring();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 36 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1186:4: a= actionTrim
                    {
                    pushFollow(FOLLOW_actionTrim_in_action6148);
                    a=actionTrim();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 37 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1187:4: a= actionAddRetainType
                    {
                    pushFollow(FOLLOW_actionAddRetainType_in_action6158);
                    a=actionAddRetainType();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 38 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1188:4: a= actionRemoveRetainType
                    {
                    pushFollow(FOLLOW_actionRemoveRetainType_in_action6167);
                    a=actionRemoveRetainType();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 39 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1189:4: a= actionAddFilterType
                    {
                    pushFollow(FOLLOW_actionAddFilterType_in_action6176);
                    a=actionAddFilterType();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 40 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1190:4: a= actionRemoveFilterType
                    {
                    pushFollow(FOLLOW_actionRemoveFilterType_in_action6185);
                    a=actionRemoveFilterType();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;
                case 41 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1191:4: (a= externalAction )=>a= externalAction
                    {
                    pushFollow(FOLLOW_externalAction_in_action6203);
                    a=externalAction();

                    state._fsp--;
                    if (state.failed) return result;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
              result = a;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return result;
    }
    // $ANTLR end "action"


    // $ANTLR start "externalAction"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1206:1: externalAction returns [AbstractRutaAction action = null] : id= Identifier LPAREN (args= varArgumentList )? RPAREN ;
    public final AbstractRutaAction externalAction() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token id=null;
        List args = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1207:2: (id= Identifier LPAREN (args= varArgumentList )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1209:2: id= Identifier LPAREN (args= varArgumentList )? RPAREN
            {
            id=(Token)match(input,Identifier,FOLLOW_Identifier_in_externalAction6243); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_externalAction6245); if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1209:30: (args= varArgumentList )?
            int alt133=2;
            int LA133_0 = input.LA(1);

            if ( (LA133_0==REMOVESTRING||(LA133_0>=EXP && LA133_0<=FALSE)||LA133_0==DecimalLiteral||LA133_0==FloatingPointLiteral||LA133_0==StringLiteral||(LA133_0>=Identifier && LA133_0<=LPAREN)||LA133_0==MINUS) ) {
                alt133=1;
            }
            switch (alt133) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1209:30: args= varArgumentList
                    {
                    pushFollow(FOLLOW_varArgumentList_in_externalAction6251);
                    args=varArgumentList();

                    state._fsp--;
                    if (state.failed) return action;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_externalAction6254); if (state.failed) return action;
            if ( state.backtracking==0 ) {

              		action = external.createExternalAction(id, args);
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "externalAction"


    // $ANTLR start "actionCreate"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1217:1: actionCreate returns [AbstractRutaAction action = null] : name= CREATE LPAREN structure= typeExpression ( COMMA ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )? (fname= stringExpression ASSIGN_EQUAL obj1= argument ( COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument )* )? )? RPAREN ;
    public final AbstractRutaAction actionCreate() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        TypeExpression structure = null;

        NumberExpression index = null;

        StringExpression fname = null;

        RutaExpression obj1 = null;



        	Map<StringExpression, RutaExpression> map = new HashMap<StringExpression, RutaExpression>();
            	List<NumberExpression> indexes = new ArrayList<NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1222:5: (name= CREATE LPAREN structure= typeExpression ( COMMA ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )? (fname= stringExpression ASSIGN_EQUAL obj1= argument ( COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument )* )? )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1223:5: name= CREATE LPAREN structure= typeExpression ( COMMA ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )? (fname= stringExpression ASSIGN_EQUAL obj1= argument ( COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument )* )? )? RPAREN
            {
            name=(Token)match(input,CREATE,FOLLOW_CREATE_in_actionCreate6290); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionCreate6292); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionCreate6298);
            structure=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1224:4: ( COMMA ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )? (fname= stringExpression ASSIGN_EQUAL obj1= argument ( COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument )* )? )?
            int alt138=2;
            int LA138_0 = input.LA(1);

            if ( (LA138_0==COMMA) ) {
                alt138=1;
            }
            switch (alt138) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1224:5: COMMA ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )? (fname= stringExpression ASSIGN_EQUAL obj1= argument ( COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument )* )?
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_actionCreate6305); if (state.failed) return action;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1225:5: ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )?
                    int alt135=2;
                    alt135 = dfa135.predict(input);
                    switch (alt135) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1226:5: (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA
                            {
                            pushFollow(FOLLOW_numberExpression_in_actionCreate6330);
                            index=numberExpression();

                            state._fsp--;
                            if (state.failed) return action;
                            if ( state.backtracking==0 ) {
                              indexes.add(index);
                            }
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1226:80: ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )*
                            loop134:
                            do {
                                int alt134=2;
                                int LA134_0 = input.LA(1);

                                if ( (LA134_0==COMMA) ) {
                                    int LA134_1 = input.LA(2);

                                    if ( (synpred26_RutaParser()) ) {
                                        alt134=1;
                                    }


                                }


                                switch (alt134) {
                            	case 1 :
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1226:81: ( COMMA index= numberExpression )=> ( COMMA index= numberExpression )
                            	    {
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1226:116: ( COMMA index= numberExpression )
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1226:117: COMMA index= numberExpression
                            	    {
                            	    match(input,COMMA,FOLLOW_COMMA_in_actionCreate6347); if (state.failed) return action;
                            	    pushFollow(FOLLOW_numberExpression_in_actionCreate6353);
                            	    index=numberExpression();

                            	    state._fsp--;
                            	    if (state.failed) return action;

                            	    }

                            	    if ( state.backtracking==0 ) {
                            	      indexes.add(index);
                            	    }

                            	    }
                            	    break;

                            	default :
                            	    break loop134;
                                }
                            } while (true);

                            match(input,COMMA,FOLLOW_COMMA_in_actionCreate6360); if (state.failed) return action;

                            }
                            break;

                    }

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1227:5: (fname= stringExpression ASSIGN_EQUAL obj1= argument ( COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument )* )?
                    int alt137=2;
                    int LA137_0 = input.LA(1);

                    if ( (LA137_0==REMOVESTRING||LA137_0==StringLiteral||LA137_0==Identifier) ) {
                        alt137=1;
                    }
                    switch (alt137) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1227:6: fname= stringExpression ASSIGN_EQUAL obj1= argument ( COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument )*
                            {
                            pushFollow(FOLLOW_stringExpression_in_actionCreate6373);
                            fname=stringExpression();

                            state._fsp--;
                            if (state.failed) return action;
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_actionCreate6375); if (state.failed) return action;
                            pushFollow(FOLLOW_argument_in_actionCreate6381);
                            obj1=argument();

                            state._fsp--;
                            if (state.failed) return action;
                            if ( state.backtracking==0 ) {
                              map.put(fname,obj1);
                            }
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1228:5: ( COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument )*
                            loop136:
                            do {
                                int alt136=2;
                                int LA136_0 = input.LA(1);

                                if ( (LA136_0==COMMA) ) {
                                    alt136=1;
                                }


                                switch (alt136) {
                            	case 1 :
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1228:6: COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument
                            	    {
                            	    match(input,COMMA,FOLLOW_COMMA_in_actionCreate6391); if (state.failed) return action;
                            	    pushFollow(FOLLOW_stringExpression_in_actionCreate6397);
                            	    fname=stringExpression();

                            	    state._fsp--;
                            	    if (state.failed) return action;
                            	    match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_actionCreate6399); if (state.failed) return action;
                            	    pushFollow(FOLLOW_argument_in_actionCreate6405);
                            	    obj1=argument();

                            	    state._fsp--;
                            	    if (state.failed) return action;
                            	    if ( state.backtracking==0 ) {
                            	      map.put(fname,obj1);
                            	    }

                            	    }
                            	    break;

                            	default :
                            	    break loop136;
                                }
                            } while (true);


                            }
                            break;

                    }


                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_actionCreate6420); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createCreateAction(structure, map, indexes, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionCreate"


    // $ANTLR start "actionMarkTable"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1234:1: actionMarkTable returns [AbstractRutaAction action = null] : name= MARKTABLE LPAREN structure= typeExpression COMMA index= numberExpression COMMA table= wordTableExpression COMMA ( (ignoreCase= booleanExpression )=>ignoreCase= booleanExpression COMMA ignoreLength= numberExpression COMMA ignoreChar= stringExpression COMMA maxIgnoreChar= numberExpression COMMA )? key= stringExpression ASSIGN_EQUAL value= numberExpression ( COMMA key= stringExpression ASSIGN_EQUAL value= numberExpression )* RPAREN ;
    public final AbstractRutaAction actionMarkTable() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        TypeExpression structure = null;

        NumberExpression index = null;

        WordTableExpression table = null;

        BooleanExpression ignoreCase = null;

        NumberExpression ignoreLength = null;

        StringExpression ignoreChar = null;

        NumberExpression maxIgnoreChar = null;

        StringExpression key = null;

        NumberExpression value = null;



        	Map<StringExpression, NumberExpression> map = new HashMap<StringExpression, NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1238:5: (name= MARKTABLE LPAREN structure= typeExpression COMMA index= numberExpression COMMA table= wordTableExpression COMMA ( (ignoreCase= booleanExpression )=>ignoreCase= booleanExpression COMMA ignoreLength= numberExpression COMMA ignoreChar= stringExpression COMMA maxIgnoreChar= numberExpression COMMA )? key= stringExpression ASSIGN_EQUAL value= numberExpression ( COMMA key= stringExpression ASSIGN_EQUAL value= numberExpression )* RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1239:5: name= MARKTABLE LPAREN structure= typeExpression COMMA index= numberExpression COMMA table= wordTableExpression COMMA ( (ignoreCase= booleanExpression )=>ignoreCase= booleanExpression COMMA ignoreLength= numberExpression COMMA ignoreChar= stringExpression COMMA maxIgnoreChar= numberExpression COMMA )? key= stringExpression ASSIGN_EQUAL value= numberExpression ( COMMA key= stringExpression ASSIGN_EQUAL value= numberExpression )* RPAREN
            {
            name=(Token)match(input,MARKTABLE,FOLLOW_MARKTABLE_in_actionMarkTable6461); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionMarkTable6463); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionMarkTable6474);
            structure=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionMarkTable6476); if (state.failed) return action;
            pushFollow(FOLLOW_numberExpression_in_actionMarkTable6487);
            index=numberExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionMarkTable6489); if (state.failed) return action;
            pushFollow(FOLLOW_wordTableExpression_in_actionMarkTable6499);
            table=wordTableExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionMarkTable6506); if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1243:12: ( (ignoreCase= booleanExpression )=>ignoreCase= booleanExpression COMMA ignoreLength= numberExpression COMMA ignoreChar= stringExpression COMMA maxIgnoreChar= numberExpression COMMA )?
            int alt139=2;
            int LA139_0 = input.LA(1);

            if ( (LA139_0==TRUE) && (synpred27_RutaParser())) {
                alt139=1;
            }
            else if ( (LA139_0==FALSE) && (synpred27_RutaParser())) {
                alt139=1;
            }
            else if ( (LA139_0==Identifier) ) {
                int LA139_3 = input.LA(2);

                if ( (((synpred27_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEAN")))||(synpred27_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPE")))||synpred27_RutaParser()||(synpred27_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEAN"))))) ) {
                    alt139=1;
                }
            }
            else if ( (LA139_0==LPAREN) && (synpred27_RutaParser())) {
                alt139=1;
            }
            else if ( (LA139_0==XOR) && (synpred27_RutaParser())) {
                alt139=1;
            }
            switch (alt139) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1243:14: (ignoreCase= booleanExpression )=>ignoreCase= booleanExpression COMMA ignoreLength= numberExpression COMMA ignoreChar= stringExpression COMMA maxIgnoreChar= numberExpression COMMA
                    {
                    pushFollow(FOLLOW_booleanExpression_in_actionMarkTable6522);
                    ignoreCase=booleanExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    match(input,COMMA,FOLLOW_COMMA_in_actionMarkTable6529); if (state.failed) return action;
                    pushFollow(FOLLOW_numberExpression_in_actionMarkTable6535);
                    ignoreLength=numberExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    match(input,COMMA,FOLLOW_COMMA_in_actionMarkTable6542); if (state.failed) return action;
                    pushFollow(FOLLOW_stringExpression_in_actionMarkTable6548);
                    ignoreChar=stringExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    match(input,COMMA,FOLLOW_COMMA_in_actionMarkTable6554); if (state.failed) return action;
                    pushFollow(FOLLOW_numberExpression_in_actionMarkTable6560);
                    maxIgnoreChar=numberExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    match(input,COMMA,FOLLOW_COMMA_in_actionMarkTable6562); if (state.failed) return action;

                    }
                    break;

            }

            pushFollow(FOLLOW_stringExpression_in_actionMarkTable6575);
            key=stringExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_actionMarkTable6577); if (state.failed) return action;
            pushFollow(FOLLOW_numberExpression_in_actionMarkTable6583);
            value=numberExpression();

            state._fsp--;
            if (state.failed) return action;
            if ( state.backtracking==0 ) {
              map.put(key,value);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1248:5: ( COMMA key= stringExpression ASSIGN_EQUAL value= numberExpression )*
            loop140:
            do {
                int alt140=2;
                int LA140_0 = input.LA(1);

                if ( (LA140_0==COMMA) ) {
                    alt140=1;
                }


                switch (alt140) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1248:7: COMMA key= stringExpression ASSIGN_EQUAL value= numberExpression
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionMarkTable6593); if (state.failed) return action;
            	    pushFollow(FOLLOW_stringExpression_in_actionMarkTable6599);
            	    key=stringExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_actionMarkTable6601); if (state.failed) return action;
            	    pushFollow(FOLLOW_numberExpression_in_actionMarkTable6607);
            	    value=numberExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      map.put(key,value);
            	    }

            	    }
            	    break;

            	default :
            	    break loop140;
                }
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionMarkTable6618); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createMarkTableAction(structure, index, table, map, ignoreCase, ignoreLength, ignoreChar, maxIgnoreChar,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionMarkTable"


    // $ANTLR start "actionGather"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1256:1: actionGather returns [AbstractRutaAction action = null] : name= GATHER LPAREN structure= typeExpression ( COMMA ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )? (fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) ( COMMA fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) )* )? )? RPAREN ;
    public final AbstractRutaAction actionGather() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        TypeExpression structure = null;

        NumberExpression index = null;

        StringExpression fname = null;

        NumberExpression obj1 = null;

        NumberListExpression obj2 = null;



        	Map<StringExpression, RutaExpression> map = new HashMap<StringExpression, RutaExpression>();
            	List<NumberExpression> indexes = new ArrayList<NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1261:5: (name= GATHER LPAREN structure= typeExpression ( COMMA ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )? (fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) ( COMMA fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) )* )? )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1262:5: name= GATHER LPAREN structure= typeExpression ( COMMA ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )? (fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) ( COMMA fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) )* )? )? RPAREN
            {
            name=(Token)match(input,GATHER,FOLLOW_GATHER_in_actionGather6661); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionGather6663); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionGather6669);
            structure=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1263:4: ( COMMA ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )? (fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) ( COMMA fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) )* )? )?
            int alt147=2;
            int LA147_0 = input.LA(1);

            if ( (LA147_0==COMMA) ) {
                alt147=1;
            }
            switch (alt147) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1263:5: COMMA ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )? (fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) ( COMMA fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) )* )?
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_actionGather6676); if (state.failed) return action;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1264:5: ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )?
                    int alt142=2;
                    alt142 = dfa142.predict(input);
                    switch (alt142) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1264:6: (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA
                            {
                            pushFollow(FOLLOW_numberExpression_in_actionGather6696);
                            index=numberExpression();

                            state._fsp--;
                            if (state.failed) return action;
                            if ( state.backtracking==0 ) {
                              indexes.add(index);
                            }
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1264:81: ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )*
                            loop141:
                            do {
                                int alt141=2;
                                int LA141_0 = input.LA(1);

                                if ( (LA141_0==COMMA) ) {
                                    int LA141_1 = input.LA(2);

                                    if ( (synpred29_RutaParser()) ) {
                                        alt141=1;
                                    }


                                }


                                switch (alt141) {
                            	case 1 :
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1264:82: ( COMMA index= numberExpression )=> ( COMMA index= numberExpression )
                            	    {
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1264:116: ( COMMA index= numberExpression )
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1264:117: COMMA index= numberExpression
                            	    {
                            	    match(input,COMMA,FOLLOW_COMMA_in_actionGather6712); if (state.failed) return action;
                            	    pushFollow(FOLLOW_numberExpression_in_actionGather6718);
                            	    index=numberExpression();

                            	    state._fsp--;
                            	    if (state.failed) return action;

                            	    }

                            	    if ( state.backtracking==0 ) {
                            	      indexes.add(index);
                            	    }

                            	    }
                            	    break;

                            	default :
                            	    break loop141;
                                }
                            } while (true);

                            match(input,COMMA,FOLLOW_COMMA_in_actionGather6725); if (state.failed) return action;

                            }
                            break;

                    }

                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1265:5: (fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) ( COMMA fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) )* )?
                    int alt146=2;
                    int LA146_0 = input.LA(1);

                    if ( (LA146_0==REMOVESTRING||LA146_0==StringLiteral||LA146_0==Identifier) ) {
                        alt146=1;
                    }
                    switch (alt146) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1265:6: fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) ( COMMA fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) )*
                            {
                            pushFollow(FOLLOW_stringExpression_in_actionGather6738);
                            fname=stringExpression();

                            state._fsp--;
                            if (state.failed) return action;
                            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_actionGather6740); if (state.failed) return action;
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1265:44: (obj1= numberExpression | obj2= numberListExpression )
                            int alt143=2;
                            switch ( input.LA(1) ) {
                            case EXP:
                            case LOGN:
                            case SIN:
                            case COS:
                            case TAN:
                            case DecimalLiteral:
                            case FloatingPointLiteral:
                            case LPAREN:
                            case MINUS:
                                {
                                alt143=1;
                                }
                                break;
                            case Identifier:
                                {
                                int LA143_2 = input.LA(2);

                                if ( (!((((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLELIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOATLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INTLIST")))))) ) {
                                    alt143=1;
                                }
                                else if ( (((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLELIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOATLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INTLIST")))) ) {
                                    alt143=2;
                                }
                                else {
                                    if (state.backtracking>0) {state.failed=true; return action;}
                                    NoViableAltException nvae =
                                        new NoViableAltException("", 143, 2, input);

                                    throw nvae;
                                }
                                }
                                break;
                            case LCURLY:
                                {
                                alt143=2;
                                }
                                break;
                            default:
                                if (state.backtracking>0) {state.failed=true; return action;}
                                NoViableAltException nvae =
                                    new NoViableAltException("", 143, 0, input);

                                throw nvae;
                            }

                            switch (alt143) {
                                case 1 :
                                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1265:45: obj1= numberExpression
                                    {
                                    pushFollow(FOLLOW_numberExpression_in_actionGather6747);
                                    obj1=numberExpression();

                                    state._fsp--;
                                    if (state.failed) return action;

                                    }
                                    break;
                                case 2 :
                                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1265:71: obj2= numberListExpression
                                    {
                                    pushFollow(FOLLOW_numberListExpression_in_actionGather6755);
                                    obj2=numberListExpression();

                                    state._fsp--;
                                    if (state.failed) return action;

                                    }
                                    break;

                            }

                            if ( state.backtracking==0 ) {
                              map.put(fname,obj1 != null? obj1 : obj2);
                            }
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1266:5: ( COMMA fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression ) )*
                            loop145:
                            do {
                                int alt145=2;
                                int LA145_0 = input.LA(1);

                                if ( (LA145_0==COMMA) ) {
                                    alt145=1;
                                }


                                switch (alt145) {
                            	case 1 :
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1266:6: COMMA fname= stringExpression ASSIGN_EQUAL (obj1= numberExpression | obj2= numberListExpression )
                            	    {
                            	    match(input,COMMA,FOLLOW_COMMA_in_actionGather6766); if (state.failed) return action;
                            	    pushFollow(FOLLOW_stringExpression_in_actionGather6772);
                            	    fname=stringExpression();

                            	    state._fsp--;
                            	    if (state.failed) return action;
                            	    match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_actionGather6774); if (state.failed) return action;
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1266:50: (obj1= numberExpression | obj2= numberListExpression )
                            	    int alt144=2;
                            	    switch ( input.LA(1) ) {
                            	    case EXP:
                            	    case LOGN:
                            	    case SIN:
                            	    case COS:
                            	    case TAN:
                            	    case DecimalLiteral:
                            	    case FloatingPointLiteral:
                            	    case LPAREN:
                            	    case MINUS:
                            	        {
                            	        alt144=1;
                            	        }
                            	        break;
                            	    case Identifier:
                            	        {
                            	        int LA144_2 = input.LA(2);

                            	        if ( (!((((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLELIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOATLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INTLIST")))))) ) {
                            	            alt144=1;
                            	        }
                            	        else if ( (((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLELIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOATLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INTLIST")))) ) {
                            	            alt144=2;
                            	        }
                            	        else {
                            	            if (state.backtracking>0) {state.failed=true; return action;}
                            	            NoViableAltException nvae =
                            	                new NoViableAltException("", 144, 2, input);

                            	            throw nvae;
                            	        }
                            	        }
                            	        break;
                            	    case LCURLY:
                            	        {
                            	        alt144=2;
                            	        }
                            	        break;
                            	    default:
                            	        if (state.backtracking>0) {state.failed=true; return action;}
                            	        NoViableAltException nvae =
                            	            new NoViableAltException("", 144, 0, input);

                            	        throw nvae;
                            	    }

                            	    switch (alt144) {
                            	        case 1 :
                            	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1266:51: obj1= numberExpression
                            	            {
                            	            pushFollow(FOLLOW_numberExpression_in_actionGather6781);
                            	            obj1=numberExpression();

                            	            state._fsp--;
                            	            if (state.failed) return action;

                            	            }
                            	            break;
                            	        case 2 :
                            	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1266:77: obj2= numberListExpression
                            	            {
                            	            pushFollow(FOLLOW_numberListExpression_in_actionGather6789);
                            	            obj2=numberListExpression();

                            	            state._fsp--;
                            	            if (state.failed) return action;

                            	            }
                            	            break;

                            	    }

                            	    if ( state.backtracking==0 ) {
                            	      map.put(fname,obj1 != null? obj1 : obj2);
                            	    }

                            	    }
                            	    break;

                            	default :
                            	    break loop145;
                                }
                            } while (true);


                            }
                            break;

                    }


                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_actionGather6805); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createGatherAction(structure, map, indexes, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionGather"


    // $ANTLR start "actionFill"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1273:1: actionFill returns [AbstractRutaAction action = null] : FILL LPAREN type= typeExpression ( COMMA fname= stringExpression ASSIGN_EQUAL (obj1= argument ) )+ RPAREN ;
    public final AbstractRutaAction actionFill() throws RecognitionException {
        AbstractRutaAction action =  null;

        TypeExpression type = null;

        StringExpression fname = null;

        RutaExpression obj1 = null;



        Map<StringExpression, RutaExpression> map = new HashMap<StringExpression, RutaExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1277:5: ( FILL LPAREN type= typeExpression ( COMMA fname= stringExpression ASSIGN_EQUAL (obj1= argument ) )+ RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1278:5: FILL LPAREN type= typeExpression ( COMMA fname= stringExpression ASSIGN_EQUAL (obj1= argument ) )+ RPAREN
            {
            match(input,FILL,FOLLOW_FILL_in_actionFill6847); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionFill6849); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionFill6855);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1278:39: ( COMMA fname= stringExpression ASSIGN_EQUAL (obj1= argument ) )+
            int cnt148=0;
            loop148:
            do {
                int alt148=2;
                int LA148_0 = input.LA(1);

                if ( (LA148_0==COMMA) ) {
                    alt148=1;
                }


                switch (alt148) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1278:40: COMMA fname= stringExpression ASSIGN_EQUAL (obj1= argument )
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionFill6858); if (state.failed) return action;
            	    pushFollow(FOLLOW_stringExpression_in_actionFill6864);
            	    fname=stringExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_actionFill6866); if (state.failed) return action;
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1279:5: (obj1= argument )
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1280:5: obj1= argument
            	    {
            	    pushFollow(FOLLOW_argument_in_actionFill6883);
            	    obj1=argument();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      map.put(fname,obj1);
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    if ( cnt148 >= 1 ) break loop148;
            	    if (state.backtracking>0) {state.failed=true; return action;}
                        EarlyExitException eee =
                            new EarlyExitException(148, input);
                        throw eee;
                }
                cnt148++;
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionFill6900); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createFillAction(type, map, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionFill"


    // $ANTLR start "actionColor"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1286:1: actionColor returns [AbstractRutaAction action = null] : COLOR LPAREN type= typeExpression COMMA bgcolor= stringExpression ( COMMA fgcolor= stringExpression ( COMMA selected= booleanExpression )? )? RPAREN ;
    public final AbstractRutaAction actionColor() throws RecognitionException {
        AbstractRutaAction action =  null;

        TypeExpression type = null;

        StringExpression bgcolor = null;

        StringExpression fgcolor = null;

        BooleanExpression selected = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1287:5: ( COLOR LPAREN type= typeExpression COMMA bgcolor= stringExpression ( COMMA fgcolor= stringExpression ( COMMA selected= booleanExpression )? )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1288:5: COLOR LPAREN type= typeExpression COMMA bgcolor= stringExpression ( COMMA fgcolor= stringExpression ( COMMA selected= booleanExpression )? )? RPAREN
            {
            match(input,COLOR,FOLLOW_COLOR_in_actionColor6938); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionColor6940); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionColor6946);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionColor6958); if (state.failed) return action;
            pushFollow(FOLLOW_stringExpression_in_actionColor6969);
            bgcolor=stringExpression();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1292:5: ( COMMA fgcolor= stringExpression ( COMMA selected= booleanExpression )? )?
            int alt150=2;
            int LA150_0 = input.LA(1);

            if ( (LA150_0==COMMA) ) {
                alt150=1;
            }
            switch (alt150) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1292:6: COMMA fgcolor= stringExpression ( COMMA selected= booleanExpression )?
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_actionColor6977); if (state.failed) return action;
                    pushFollow(FOLLOW_stringExpression_in_actionColor6987);
                    fgcolor=stringExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1294:5: ( COMMA selected= booleanExpression )?
                    int alt149=2;
                    int LA149_0 = input.LA(1);

                    if ( (LA149_0==COMMA) ) {
                        alt149=1;
                    }
                    switch (alt149) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1294:6: COMMA selected= booleanExpression
                            {
                            match(input,COMMA,FOLLOW_COMMA_in_actionColor6995); if (state.failed) return action;
                            pushFollow(FOLLOW_booleanExpression_in_actionColor7005);
                            selected=booleanExpression();

                            state._fsp--;
                            if (state.failed) return action;

                            }
                            break;

                    }


                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_actionColor7015); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createColorAction(type, bgcolor, fgcolor, selected, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionColor"


    // $ANTLR start "actionDel"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1300:1: actionDel returns [AbstractRutaAction action = null] : DEL ;
    public final AbstractRutaAction actionDel() throws RecognitionException {
        AbstractRutaAction action =  null;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1301:5: ( DEL )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1302:5: DEL
            {
            match(input,DEL,FOLLOW_DEL_in_actionDel7049); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createDelAction(((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionDel"


    // $ANTLR start "actionLog"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1306:1: actionLog returns [AbstractRutaAction action = null] : LOG LPAREN lit= stringExpression ( COMMA log= LogLevel )? RPAREN ;
    public final AbstractRutaAction actionLog() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token log=null;
        StringExpression lit = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1307:5: ( LOG LPAREN lit= stringExpression ( COMMA log= LogLevel )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1308:5: LOG LPAREN lit= stringExpression ( COMMA log= LogLevel )? RPAREN
            {
            match(input,LOG,FOLLOW_LOG_in_actionLog7091); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionLog7093); if (state.failed) return action;
            pushFollow(FOLLOW_stringExpression_in_actionLog7099);
            lit=stringExpression();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1308:39: ( COMMA log= LogLevel )?
            int alt151=2;
            int LA151_0 = input.LA(1);

            if ( (LA151_0==COMMA) ) {
                alt151=1;
            }
            switch (alt151) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1308:40: COMMA log= LogLevel
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_actionLog7102); if (state.failed) return action;
                    log=(Token)match(input,LogLevel,FOLLOW_LogLevel_in_actionLog7108); if (state.failed) return action;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_actionLog7112); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createLogAction(lit, log, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionLog"


    // $ANTLR start "actionMark"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1312:1: actionMark returns [AbstractRutaAction action = null] : MARK LPAREN type= typeExpression ( COMMA (index= numberExpression )=>index= numberExpression )* RPAREN ;
    public final AbstractRutaAction actionMark() throws RecognitionException {
        AbstractRutaAction action =  null;

        TypeExpression type = null;

        NumberExpression index = null;



        List<NumberExpression> list = new ArrayList<NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1316:5: ( MARK LPAREN type= typeExpression ( COMMA (index= numberExpression )=>index= numberExpression )* RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1317:5: MARK LPAREN type= typeExpression ( COMMA (index= numberExpression )=>index= numberExpression )* RPAREN
            {
            match(input,MARK,FOLLOW_MARK_in_actionMark7151); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionMark7153); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionMark7164);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1319:5: ( COMMA (index= numberExpression )=>index= numberExpression )*
            loop152:
            do {
                int alt152=2;
                int LA152_0 = input.LA(1);

                if ( (LA152_0==COMMA) ) {
                    alt152=1;
                }


                switch (alt152) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1320:9: COMMA (index= numberExpression )=>index= numberExpression
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionMark7180); if (state.failed) return action;
            	    pushFollow(FOLLOW_numberExpression_in_actionMark7196);
            	    index=numberExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      list.add(index);
            	    }

            	    }
            	    break;

            	default :
            	    break loop152;
                }
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionMark7220); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createMarkAction(null, type, list, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionMark"


    // $ANTLR start "actionShift"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1328:1: actionShift returns [AbstractRutaAction action = null] : SHIFT LPAREN type= typeExpression ( COMMA (index= numberExpression )=>index= numberExpression )* RPAREN ;
    public final AbstractRutaAction actionShift() throws RecognitionException {
        AbstractRutaAction action =  null;

        TypeExpression type = null;

        NumberExpression index = null;



        List<NumberExpression> list = new ArrayList<NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1332:5: ( SHIFT LPAREN type= typeExpression ( COMMA (index= numberExpression )=>index= numberExpression )* RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1333:5: SHIFT LPAREN type= typeExpression ( COMMA (index= numberExpression )=>index= numberExpression )* RPAREN
            {
            match(input,SHIFT,FOLLOW_SHIFT_in_actionShift7264); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionShift7266); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionShift7277);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1335:5: ( COMMA (index= numberExpression )=>index= numberExpression )*
            loop153:
            do {
                int alt153=2;
                int LA153_0 = input.LA(1);

                if ( (LA153_0==COMMA) ) {
                    alt153=1;
                }


                switch (alt153) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1336:9: COMMA (index= numberExpression )=>index= numberExpression
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionShift7293); if (state.failed) return action;
            	    pushFollow(FOLLOW_numberExpression_in_actionShift7309);
            	    index=numberExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      list.add(index);
            	    }

            	    }
            	    break;

            	default :
            	    break loop153;
                }
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionShift7333); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createShiftAction(type, list,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionShift"


    // $ANTLR start "actionMarkScore"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1345:1: actionMarkScore returns [AbstractRutaAction action = null] : MARKSCORE LPAREN score= numberExpression COMMA type= typeExpression ( COMMA (index= numberExpression )=>index= numberExpression )* RPAREN ;
    public final AbstractRutaAction actionMarkScore() throws RecognitionException {
        AbstractRutaAction action =  null;

        NumberExpression score = null;

        TypeExpression type = null;

        NumberExpression index = null;



        List<NumberExpression> list = new ArrayList<NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1349:5: ( MARKSCORE LPAREN score= numberExpression COMMA type= typeExpression ( COMMA (index= numberExpression )=>index= numberExpression )* RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1350:5: MARKSCORE LPAREN score= numberExpression COMMA type= typeExpression ( COMMA (index= numberExpression )=>index= numberExpression )* RPAREN
            {
            match(input,MARKSCORE,FOLLOW_MARKSCORE_in_actionMarkScore7378); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionMarkScore7380); if (state.failed) return action;
            pushFollow(FOLLOW_numberExpression_in_actionMarkScore7391);
            score=numberExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionMarkScore7393); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionMarkScore7403);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1353:5: ( COMMA (index= numberExpression )=>index= numberExpression )*
            loop154:
            do {
                int alt154=2;
                int LA154_0 = input.LA(1);

                if ( (LA154_0==COMMA) ) {
                    alt154=1;
                }


                switch (alt154) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1354:9: COMMA (index= numberExpression )=>index= numberExpression
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionMarkScore7419); if (state.failed) return action;
            	    pushFollow(FOLLOW_numberExpression_in_actionMarkScore7435);
            	    index=numberExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      list.add(index);
            	    }

            	    }
            	    break;

            	default :
            	    break loop154;
                }
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionMarkScore7459); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createMarkAction(score, type, list, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionMarkScore"


    // $ANTLR start "actionMarkOnce"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1362:1: actionMarkOnce returns [AbstractRutaAction action = null] : MARKONCE LPAREN ( (score= numberExpression )=>score= numberExpression COMMA )? (type= typeExpression )=>type= typeExpression ( COMMA (index= numberExpression )=>index= numberExpression )* RPAREN ;
    public final AbstractRutaAction actionMarkOnce() throws RecognitionException {
        AbstractRutaAction action =  null;

        NumberExpression score = null;

        TypeExpression type = null;

        NumberExpression index = null;



        List<NumberExpression> list = new ArrayList<NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1366:5: ( MARKONCE LPAREN ( (score= numberExpression )=>score= numberExpression COMMA )? (type= typeExpression )=>type= typeExpression ( COMMA (index= numberExpression )=>index= numberExpression )* RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1367:5: MARKONCE LPAREN ( (score= numberExpression )=>score= numberExpression COMMA )? (type= typeExpression )=>type= typeExpression ( COMMA (index= numberExpression )=>index= numberExpression )* RPAREN
            {
            match(input,MARKONCE,FOLLOW_MARKONCE_in_actionMarkOnce7503); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionMarkOnce7505); if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1367:21: ( (score= numberExpression )=>score= numberExpression COMMA )?
            int alt155=2;
            int LA155_0 = input.LA(1);

            if ( (LA155_0==MINUS) && (synpred33_RutaParser())) {
                alt155=1;
            }
            else if ( (LA155_0==DecimalLiteral) && (synpred33_RutaParser())) {
                alt155=1;
            }
            else if ( (LA155_0==FloatingPointLiteral) && (synpred33_RutaParser())) {
                alt155=1;
            }
            else if ( (LA155_0==Identifier) ) {
                int LA155_4 = input.LA(2);

                if ( (((synpred33_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOAT")))||(synpred33_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLE")))||(synpred33_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INT")))||synpred33_RutaParser())) ) {
                    alt155=1;
                }
            }
            else if ( (LA155_0==LPAREN) && (synpred33_RutaParser())) {
                alt155=1;
            }
            else if ( ((LA155_0>=EXP && LA155_0<=TAN)) && (synpred33_RutaParser())) {
                alt155=1;
            }
            switch (alt155) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1367:22: (score= numberExpression )=>score= numberExpression COMMA
                    {
                    pushFollow(FOLLOW_numberExpression_in_actionMarkOnce7522);
                    score=numberExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    match(input,COMMA,FOLLOW_COMMA_in_actionMarkOnce7524); if (state.failed) return action;

                    }
                    break;

            }

            pushFollow(FOLLOW_typeExpression_in_actionMarkOnce7542);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1368:5: ( COMMA (index= numberExpression )=>index= numberExpression )*
            loop156:
            do {
                int alt156=2;
                int LA156_0 = input.LA(1);

                if ( (LA156_0==COMMA) ) {
                    alt156=1;
                }


                switch (alt156) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1369:9: COMMA (index= numberExpression )=>index= numberExpression
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionMarkOnce7558); if (state.failed) return action;
            	    pushFollow(FOLLOW_numberExpression_in_actionMarkOnce7574);
            	    index=numberExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      list.add(index);
            	    }

            	    }
            	    break;

            	default :
            	    break loop156;
                }
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionMarkOnce7593); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createMarkOnceAction(score, type, list,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionMarkOnce"


    // $ANTLR start "actionMarkFast"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1376:1: actionMarkFast returns [AbstractRutaAction action = null] : MARKFAST LPAREN type= typeExpression COMMA (list1= wordListExpression | list2= stringListExpression ) ( COMMA ignore= booleanExpression ( COMMA ignoreLength= numberExpression ( COMMA ignoreWS= booleanExpression )? )? )? RPAREN ;
    public final AbstractRutaAction actionMarkFast() throws RecognitionException {
        AbstractRutaAction action =  null;

        TypeExpression type = null;

        WordListExpression list1 = null;

        StringListExpression list2 = null;

        BooleanExpression ignore = null;

        NumberExpression ignoreLength = null;

        BooleanExpression ignoreWS = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1377:5: ( MARKFAST LPAREN type= typeExpression COMMA (list1= wordListExpression | list2= stringListExpression ) ( COMMA ignore= booleanExpression ( COMMA ignoreLength= numberExpression ( COMMA ignoreWS= booleanExpression )? )? )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1378:5: MARKFAST LPAREN type= typeExpression COMMA (list1= wordListExpression | list2= stringListExpression ) ( COMMA ignore= booleanExpression ( COMMA ignoreLength= numberExpression ( COMMA ignoreWS= booleanExpression )? )? )? RPAREN
            {
            match(input,MARKFAST,FOLLOW_MARKFAST_in_actionMarkFast7632); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionMarkFast7634); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionMarkFast7640);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionMarkFast7642); if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1378:49: (list1= wordListExpression | list2= stringListExpression )
            int alt157=2;
            switch ( input.LA(1) ) {
            case Identifier:
                {
                int LA157_1 = input.LA(2);

                if ( (!(((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRINGLIST"))))) ) {
                    alt157=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRINGLIST"))) ) {
                    alt157=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return action;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 157, 1, input);

                    throw nvae;
                }
                }
                break;
            case RessourceLiteral:
                {
                alt157=1;
                }
                break;
            case LCURLY:
                {
                alt157=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return action;}
                NoViableAltException nvae =
                    new NoViableAltException("", 157, 0, input);

                throw nvae;
            }

            switch (alt157) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1378:50: list1= wordListExpression
                    {
                    pushFollow(FOLLOW_wordListExpression_in_actionMarkFast7649);
                    list1=wordListExpression();

                    state._fsp--;
                    if (state.failed) return action;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1378:79: list2= stringListExpression
                    {
                    pushFollow(FOLLOW_stringListExpression_in_actionMarkFast7657);
                    list2=stringListExpression();

                    state._fsp--;
                    if (state.failed) return action;

                    }
                    break;

            }

            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1379:5: ( COMMA ignore= booleanExpression ( COMMA ignoreLength= numberExpression ( COMMA ignoreWS= booleanExpression )? )? )?
            int alt160=2;
            int LA160_0 = input.LA(1);

            if ( (LA160_0==COMMA) ) {
                alt160=1;
            }
            switch (alt160) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1379:6: COMMA ignore= booleanExpression ( COMMA ignoreLength= numberExpression ( COMMA ignoreWS= booleanExpression )? )?
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_actionMarkFast7666); if (state.failed) return action;
                    pushFollow(FOLLOW_booleanExpression_in_actionMarkFast7672);
                    ignore=booleanExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1379:39: ( COMMA ignoreLength= numberExpression ( COMMA ignoreWS= booleanExpression )? )?
                    int alt159=2;
                    int LA159_0 = input.LA(1);

                    if ( (LA159_0==COMMA) ) {
                        alt159=1;
                    }
                    switch (alt159) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1379:40: COMMA ignoreLength= numberExpression ( COMMA ignoreWS= booleanExpression )?
                            {
                            match(input,COMMA,FOLLOW_COMMA_in_actionMarkFast7675); if (state.failed) return action;
                            pushFollow(FOLLOW_numberExpression_in_actionMarkFast7681);
                            ignoreLength=numberExpression();

                            state._fsp--;
                            if (state.failed) return action;
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1379:78: ( COMMA ignoreWS= booleanExpression )?
                            int alt158=2;
                            int LA158_0 = input.LA(1);

                            if ( (LA158_0==COMMA) ) {
                                alt158=1;
                            }
                            switch (alt158) {
                                case 1 :
                                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1379:79: COMMA ignoreWS= booleanExpression
                                    {
                                    match(input,COMMA,FOLLOW_COMMA_in_actionMarkFast7684); if (state.failed) return action;
                                    pushFollow(FOLLOW_booleanExpression_in_actionMarkFast7690);
                                    ignoreWS=booleanExpression();

                                    state._fsp--;
                                    if (state.failed) return action;

                                    }
                                    break;

                            }


                            }
                            break;

                    }


                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_actionMarkFast7698); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              if(list1 != null) {
                   action = ActionFactory.createMarkFastAction(type, list1, ignore, ignoreLength, ignoreWS, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
                  } else {
                   action = ActionFactory.createMarkFastAction(type, list2, ignore, ignoreLength, ignoreWS, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
                  }
                  
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionMarkFast"


    // $ANTLR start "actionMarkLast"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1388:1: actionMarkLast returns [AbstractRutaAction action = null] : MARKLAST LPAREN type= typeExpression RPAREN ;
    public final AbstractRutaAction actionMarkLast() throws RecognitionException {
        AbstractRutaAction action =  null;

        TypeExpression type = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1389:5: ( MARKLAST LPAREN type= typeExpression RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1390:5: MARKLAST LPAREN type= typeExpression RPAREN
            {
            match(input,MARKLAST,FOLLOW_MARKLAST_in_actionMarkLast7732); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionMarkLast7734); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionMarkLast7740);
            type=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,RPAREN,FOLLOW_RPAREN_in_actionMarkLast7742); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createMarkLastAction(type, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionMarkLast"


    // $ANTLR start "actionReplace"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1394:1: actionReplace returns [AbstractRutaAction action = null] : REPLACE LPAREN lit= stringExpression RPAREN ;
    public final AbstractRutaAction actionReplace() throws RecognitionException {
        AbstractRutaAction action =  null;

        StringExpression lit = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1395:5: ( REPLACE LPAREN lit= stringExpression RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1396:5: REPLACE LPAREN lit= stringExpression RPAREN
            {
            match(input,REPLACE,FOLLOW_REPLACE_in_actionReplace7776); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionReplace7778); if (state.failed) return action;
            pushFollow(FOLLOW_stringExpression_in_actionReplace7784);
            lit=stringExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,RPAREN,FOLLOW_RPAREN_in_actionReplace7786); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createReplaceAction(lit, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionReplace"


    // $ANTLR start "actionRetainType"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1402:1: actionRetainType returns [AbstractRutaAction action = null] : RETAINTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )? ;
    public final AbstractRutaAction actionRetainType() throws RecognitionException {
        AbstractRutaAction action =  null;

        TypeExpression id = null;



        List<TypeExpression> list = new ArrayList<TypeExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1406:5: ( RETAINTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )? )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1407:5: RETAINTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )?
            {
            match(input,RETAINTYPE,FOLLOW_RETAINTYPE_in_actionRetainType7833); if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1407:16: ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )?
            int alt162=2;
            int LA162_0 = input.LA(1);

            if ( (LA162_0==LPAREN) ) {
                alt162=1;
            }
            switch (alt162) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1407:17: LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN
                    {
                    match(input,LPAREN,FOLLOW_LPAREN_in_actionRetainType7836); if (state.failed) return action;
                    pushFollow(FOLLOW_typeExpression_in_actionRetainType7842);
                    id=typeExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    if ( state.backtracking==0 ) {
                      list.add(id);
                    }
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1407:60: ( COMMA id= typeExpression )*
                    loop161:
                    do {
                        int alt161=2;
                        int LA161_0 = input.LA(1);

                        if ( (LA161_0==COMMA) ) {
                            alt161=1;
                        }


                        switch (alt161) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1407:61: COMMA id= typeExpression
                    	    {
                    	    match(input,COMMA,FOLLOW_COMMA_in_actionRetainType7847); if (state.failed) return action;
                    	    pushFollow(FOLLOW_typeExpression_in_actionRetainType7853);
                    	    id=typeExpression();

                    	    state._fsp--;
                    	    if (state.failed) return action;
                    	    if ( state.backtracking==0 ) {
                    	      list.add(id);
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    break loop161;
                        }
                    } while (true);

                    match(input,RPAREN,FOLLOW_RPAREN_in_actionRetainType7859); if (state.failed) return action;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
              action = ActionFactory.createRetainTypeAction(list, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionRetainType"


    // $ANTLR start "actionFilterType"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1413:1: actionFilterType returns [AbstractRutaAction action = null] : FILTERTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )? ;
    public final AbstractRutaAction actionFilterType() throws RecognitionException {
        AbstractRutaAction action =  null;

        TypeExpression id = null;



        List<TypeExpression> list = new ArrayList<TypeExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1417:5: ( FILTERTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )? )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1418:5: FILTERTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )?
            {
            match(input,FILTERTYPE,FOLLOW_FILTERTYPE_in_actionFilterType7910); if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1418:16: ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )?
            int alt164=2;
            int LA164_0 = input.LA(1);

            if ( (LA164_0==LPAREN) ) {
                alt164=1;
            }
            switch (alt164) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1418:17: LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN
                    {
                    match(input,LPAREN,FOLLOW_LPAREN_in_actionFilterType7913); if (state.failed) return action;
                    pushFollow(FOLLOW_typeExpression_in_actionFilterType7919);
                    id=typeExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    if ( state.backtracking==0 ) {
                      list.add(id);
                    }
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1418:60: ( COMMA id= typeExpression )*
                    loop163:
                    do {
                        int alt163=2;
                        int LA163_0 = input.LA(1);

                        if ( (LA163_0==COMMA) ) {
                            alt163=1;
                        }


                        switch (alt163) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1418:61: COMMA id= typeExpression
                    	    {
                    	    match(input,COMMA,FOLLOW_COMMA_in_actionFilterType7924); if (state.failed) return action;
                    	    pushFollow(FOLLOW_typeExpression_in_actionFilterType7930);
                    	    id=typeExpression();

                    	    state._fsp--;
                    	    if (state.failed) return action;
                    	    if ( state.backtracking==0 ) {
                    	      list.add(id);
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    break loop163;
                        }
                    } while (true);

                    match(input,RPAREN,FOLLOW_RPAREN_in_actionFilterType7936); if (state.failed) return action;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
              action = ActionFactory.createFilterTypeAction(list,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionFilterType"


    // $ANTLR start "actionCall"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1422:1: actionCall returns [AbstractRutaAction action = null] : CALL LPAREN ns= dottedIdentifier RPAREN ;
    public final AbstractRutaAction actionCall() throws RecognitionException {
        AbstractRutaAction action =  null;

        String ns = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1423:5: ( CALL LPAREN ns= dottedIdentifier RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1424:5: CALL LPAREN ns= dottedIdentifier RPAREN
            {
            match(input,CALL,FOLLOW_CALL_in_actionCall7976); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionCall7978); if (state.failed) return action;
            pushFollow(FOLLOW_dottedIdentifier_in_actionCall7984);
            ns=dottedIdentifier();

            state._fsp--;
            if (state.failed) return action;
            match(input,RPAREN,FOLLOW_RPAREN_in_actionCall7986); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createCallAction(ns, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionCall"


    // $ANTLR start "actionConfigure"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1429:1: actionConfigure returns [AbstractRutaAction action = null] : CONFIGURE LPAREN ns= dottedIdentifier COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument ( COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument )* RPAREN ;
    public final AbstractRutaAction actionConfigure() throws RecognitionException {
        AbstractRutaAction action =  null;

        String ns = null;

        StringExpression fname = null;

        RutaExpression obj1 = null;



        	Map<StringExpression, RutaExpression> map = new HashMap<StringExpression, RutaExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1434:5: ( CONFIGURE LPAREN ns= dottedIdentifier COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument ( COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument )* RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1435:5: CONFIGURE LPAREN ns= dottedIdentifier COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument ( COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument )* RPAREN
            {
            match(input,CONFIGURE,FOLLOW_CONFIGURE_in_actionConfigure8024); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionConfigure8026); if (state.failed) return action;
            pushFollow(FOLLOW_dottedIdentifier_in_actionConfigure8032);
            ns=dottedIdentifier();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionConfigure8039); if (state.failed) return action;
            pushFollow(FOLLOW_stringExpression_in_actionConfigure8049);
            fname=stringExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_actionConfigure8051); if (state.failed) return action;
            pushFollow(FOLLOW_argument_in_actionConfigure8057);
            obj1=argument();

            state._fsp--;
            if (state.failed) return action;
            if ( state.backtracking==0 ) {
              map.put(fname,obj1);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1438:5: ( COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument )*
            loop165:
            do {
                int alt165=2;
                int LA165_0 = input.LA(1);

                if ( (LA165_0==COMMA) ) {
                    alt165=1;
                }


                switch (alt165) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1438:6: COMMA fname= stringExpression ASSIGN_EQUAL obj1= argument
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionConfigure8067); if (state.failed) return action;
            	    pushFollow(FOLLOW_stringExpression_in_actionConfigure8073);
            	    fname=stringExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_actionConfigure8075); if (state.failed) return action;
            	    pushFollow(FOLLOW_argument_in_actionConfigure8081);
            	    obj1=argument();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      map.put(fname,obj1);
            	    }

            	    }
            	    break;

            	default :
            	    break loop165;
                }
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionConfigure8091); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createConfigureAction(ns, map, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionConfigure"


    // $ANTLR start "actionExec"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1444:1: actionExec returns [AbstractRutaAction action = null] : EXEC LPAREN ns= dottedIdentifier ( COMMA tl= typeListExpression )? RPAREN ;
    public final AbstractRutaAction actionExec() throws RecognitionException {
        AbstractRutaAction action =  null;

        String ns = null;

        TypeListExpression tl = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1445:5: ( EXEC LPAREN ns= dottedIdentifier ( COMMA tl= typeListExpression )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1446:5: EXEC LPAREN ns= dottedIdentifier ( COMMA tl= typeListExpression )? RPAREN
            {
            match(input,EXEC,FOLLOW_EXEC_in_actionExec8123); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionExec8125); if (state.failed) return action;
            pushFollow(FOLLOW_dottedIdentifier_in_actionExec8131);
            ns=dottedIdentifier();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1446:39: ( COMMA tl= typeListExpression )?
            int alt166=2;
            int LA166_0 = input.LA(1);

            if ( (LA166_0==COMMA) ) {
                alt166=1;
            }
            switch (alt166) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1446:40: COMMA tl= typeListExpression
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_actionExec8134); if (state.failed) return action;
                    pushFollow(FOLLOW_typeListExpression_in_actionExec8140);
                    tl=typeListExpression();

                    state._fsp--;
                    if (state.failed) return action;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_actionExec8144); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createExecAction(ns, tl, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionExec"


    // $ANTLR start "actionAssign"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1450:1: actionAssign returns [AbstractRutaAction action = null] : name= ASSIGN LPAREN ({...}?nv= Identifier COMMA e1= typeExpression | {...}?nv= Identifier COMMA e2= booleanExpression | {...}?nv= Identifier COMMA e3= stringExpression | {...}?nv= Identifier COMMA e4= numberExpression | {...}?nv= Identifier COMMA e6= numberExpression | {...}?nv= Identifier COMMA e5= numberExpression ) RPAREN ;
    public final AbstractRutaAction actionAssign() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        Token nv=null;
        TypeExpression e1 = null;

        BooleanExpression e2 = null;

        StringExpression e3 = null;

        NumberExpression e4 = null;

        NumberExpression e6 = null;

        NumberExpression e5 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1451:5: (name= ASSIGN LPAREN ({...}?nv= Identifier COMMA e1= typeExpression | {...}?nv= Identifier COMMA e2= booleanExpression | {...}?nv= Identifier COMMA e3= stringExpression | {...}?nv= Identifier COMMA e4= numberExpression | {...}?nv= Identifier COMMA e6= numberExpression | {...}?nv= Identifier COMMA e5= numberExpression ) RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1452:5: name= ASSIGN LPAREN ({...}?nv= Identifier COMMA e1= typeExpression | {...}?nv= Identifier COMMA e2= booleanExpression | {...}?nv= Identifier COMMA e3= stringExpression | {...}?nv= Identifier COMMA e4= numberExpression | {...}?nv= Identifier COMMA e6= numberExpression | {...}?nv= Identifier COMMA e5= numberExpression ) RPAREN
            {
            name=(Token)match(input,ASSIGN,FOLLOW_ASSIGN_in_actionAssign8187); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionAssign8189); if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1453:5: ({...}?nv= Identifier COMMA e1= typeExpression | {...}?nv= Identifier COMMA e2= booleanExpression | {...}?nv= Identifier COMMA e3= stringExpression | {...}?nv= Identifier COMMA e4= numberExpression | {...}?nv= Identifier COMMA e6= numberExpression | {...}?nv= Identifier COMMA e5= numberExpression )
            int alt167=6;
            int LA167_0 = input.LA(1);

            if ( (LA167_0==Identifier) ) {
                int LA167_1 = input.LA(2);

                if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "TYPE"))) ) {
                    alt167=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "BOOLEAN"))) ) {
                    alt167=2;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "STRING"))) ) {
                    alt167=3;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "INT"))) ) {
                    alt167=4;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "FLOAT"))) ) {
                    alt167=5;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "DOUBLE"))) ) {
                    alt167=6;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return action;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 167, 1, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return action;}
                NoViableAltException nvae =
                    new NoViableAltException("", 167, 0, input);

                throw nvae;
            }
            switch (alt167) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1454:5: {...}?nv= Identifier COMMA e1= typeExpression
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "TYPE"))) ) {
                        if (state.backtracking>0) {state.failed=true; return action;}
                        throw new FailedPredicateException(input, "actionAssign", "isVariableOfType($blockDeclaration::env, input.LT(1).getText(), \"TYPE\")");
                    }
                    nv=(Token)match(input,Identifier,FOLLOW_Identifier_in_actionAssign8216); if (state.failed) return action;
                    match(input,COMMA,FOLLOW_COMMA_in_actionAssign8218); if (state.failed) return action;
                    pushFollow(FOLLOW_typeExpression_in_actionAssign8224);
                    e1=typeExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    if ( state.backtracking==0 ) {
                      action = ActionFactory.createAssignAction(nv, e1,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1458:5: {...}?nv= Identifier COMMA e2= booleanExpression
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "BOOLEAN"))) ) {
                        if (state.backtracking>0) {state.failed=true; return action;}
                        throw new FailedPredicateException(input, "actionAssign", "isVariableOfType($blockDeclaration::env, input.LT(1).getText(), \"BOOLEAN\")");
                    }
                    nv=(Token)match(input,Identifier,FOLLOW_Identifier_in_actionAssign8262); if (state.failed) return action;
                    match(input,COMMA,FOLLOW_COMMA_in_actionAssign8264); if (state.failed) return action;
                    pushFollow(FOLLOW_booleanExpression_in_actionAssign8270);
                    e2=booleanExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    if ( state.backtracking==0 ) {
                      action = ActionFactory.createAssignAction(nv, e2,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
                    }

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1462:5: {...}?nv= Identifier COMMA e3= stringExpression
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "STRING"))) ) {
                        if (state.backtracking>0) {state.failed=true; return action;}
                        throw new FailedPredicateException(input, "actionAssign", "isVariableOfType($blockDeclaration::env, input.LT(1).getText(), \"STRING\")");
                    }
                    nv=(Token)match(input,Identifier,FOLLOW_Identifier_in_actionAssign8308); if (state.failed) return action;
                    match(input,COMMA,FOLLOW_COMMA_in_actionAssign8310); if (state.failed) return action;
                    pushFollow(FOLLOW_stringExpression_in_actionAssign8316);
                    e3=stringExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    if ( state.backtracking==0 ) {
                      action = ActionFactory.createAssignAction(nv, e3,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
                    }

                    }
                    break;
                case 4 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1466:5: {...}?nv= Identifier COMMA e4= numberExpression
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "INT"))) ) {
                        if (state.backtracking>0) {state.failed=true; return action;}
                        throw new FailedPredicateException(input, "actionAssign", "isVariableOfType($blockDeclaration::env, input.LT(1).getText(), \"INT\")");
                    }
                    nv=(Token)match(input,Identifier,FOLLOW_Identifier_in_actionAssign8354); if (state.failed) return action;
                    match(input,COMMA,FOLLOW_COMMA_in_actionAssign8356); if (state.failed) return action;
                    pushFollow(FOLLOW_numberExpression_in_actionAssign8362);
                    e4=numberExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    if ( state.backtracking==0 ) {
                      action = ActionFactory.createAssignAction(nv, e4,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
                    }

                    }
                    break;
                case 5 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1470:6: {...}?nv= Identifier COMMA e6= numberExpression
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "FLOAT"))) ) {
                        if (state.backtracking>0) {state.failed=true; return action;}
                        throw new FailedPredicateException(input, "actionAssign", "isVariableOfType($blockDeclaration::env, input.LT(1).getText(), \"FLOAT\")");
                    }
                    nv=(Token)match(input,Identifier,FOLLOW_Identifier_in_actionAssign8401); if (state.failed) return action;
                    match(input,COMMA,FOLLOW_COMMA_in_actionAssign8403); if (state.failed) return action;
                    pushFollow(FOLLOW_numberExpression_in_actionAssign8409);
                    e6=numberExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    if ( state.backtracking==0 ) {
                      action = ActionFactory.createAssignAction(nv, e6,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
                    }

                    }
                    break;
                case 6 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1474:5: {...}?nv= Identifier COMMA e5= numberExpression
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env, input.LT(1).getText(), "DOUBLE"))) ) {
                        if (state.backtracking>0) {state.failed=true; return action;}
                        throw new FailedPredicateException(input, "actionAssign", "isVariableOfType($blockDeclaration::env, input.LT(1).getText(), \"DOUBLE\")");
                    }
                    nv=(Token)match(input,Identifier,FOLLOW_Identifier_in_actionAssign8447); if (state.failed) return action;
                    match(input,COMMA,FOLLOW_COMMA_in_actionAssign8449); if (state.failed) return action;
                    pushFollow(FOLLOW_numberExpression_in_actionAssign8455);
                    e5=numberExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    if ( state.backtracking==0 ) {
                      action = ActionFactory.createAssignAction(nv, e5,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
                    }

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_actionAssign8474); if (state.failed) return action;

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionAssign"


    // $ANTLR start "actionSetFeature"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1480:1: actionSetFeature returns [AbstractRutaAction action = null] : name= SETFEATURE LPAREN f= stringExpression COMMA v= argument RPAREN ;
    public final AbstractRutaAction actionSetFeature() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        StringExpression f = null;

        RutaExpression v = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1481:5: (name= SETFEATURE LPAREN f= stringExpression COMMA v= argument RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1482:5: name= SETFEATURE LPAREN f= stringExpression COMMA v= argument RPAREN
            {
            name=(Token)match(input,SETFEATURE,FOLLOW_SETFEATURE_in_actionSetFeature8506); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionSetFeature8508); if (state.failed) return action;
            pushFollow(FOLLOW_stringExpression_in_actionSetFeature8514);
            f=stringExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionSetFeature8516); if (state.failed) return action;
            pushFollow(FOLLOW_argument_in_actionSetFeature8522);
            v=argument();

            state._fsp--;
            if (state.failed) return action;
            match(input,RPAREN,FOLLOW_RPAREN_in_actionSetFeature8524); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createSetFeatureAction(f, v, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionSetFeature"


    // $ANTLR start "actionGetFeature"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1487:1: actionGetFeature returns [AbstractRutaAction action = null] : name= GETFEATURE LPAREN f= stringExpression COMMA v= variable RPAREN ;
    public final AbstractRutaAction actionGetFeature() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        StringExpression f = null;

        Token v = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1488:5: (name= GETFEATURE LPAREN f= stringExpression COMMA v= variable RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1489:5: name= GETFEATURE LPAREN f= stringExpression COMMA v= variable RPAREN
            {
            name=(Token)match(input,GETFEATURE,FOLLOW_GETFEATURE_in_actionGetFeature8563); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionGetFeature8565); if (state.failed) return action;
            pushFollow(FOLLOW_stringExpression_in_actionGetFeature8571);
            f=stringExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionGetFeature8573); if (state.failed) return action;
            pushFollow(FOLLOW_variable_in_actionGetFeature8579);
            v=variable();

            state._fsp--;
            if (state.failed) return action;
            match(input,RPAREN,FOLLOW_RPAREN_in_actionGetFeature8581); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createGetFeatureAction(f, v, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionGetFeature"


    // $ANTLR start "actionDynamicAnchoring"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1494:1: actionDynamicAnchoring returns [AbstractRutaAction action = null] : name= DYNAMICANCHORING LPAREN active= booleanExpression ( COMMA penalty= numberExpression ( COMMA factor= numberExpression )? )? RPAREN ;
    public final AbstractRutaAction actionDynamicAnchoring() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        BooleanExpression active = null;

        NumberExpression penalty = null;

        NumberExpression factor = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1495:5: (name= DYNAMICANCHORING LPAREN active= booleanExpression ( COMMA penalty= numberExpression ( COMMA factor= numberExpression )? )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1496:5: name= DYNAMICANCHORING LPAREN active= booleanExpression ( COMMA penalty= numberExpression ( COMMA factor= numberExpression )? )? RPAREN
            {
            name=(Token)match(input,DYNAMICANCHORING,FOLLOW_DYNAMICANCHORING_in_actionDynamicAnchoring8617); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionDynamicAnchoring8619); if (state.failed) return action;
            pushFollow(FOLLOW_booleanExpression_in_actionDynamicAnchoring8625);
            active=booleanExpression();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1497:5: ( COMMA penalty= numberExpression ( COMMA factor= numberExpression )? )?
            int alt169=2;
            int LA169_0 = input.LA(1);

            if ( (LA169_0==COMMA) ) {
                alt169=1;
            }
            switch (alt169) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1497:6: COMMA penalty= numberExpression ( COMMA factor= numberExpression )?
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_actionDynamicAnchoring8633); if (state.failed) return action;
                    pushFollow(FOLLOW_numberExpression_in_actionDynamicAnchoring8639);
                    penalty=numberExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1498:5: ( COMMA factor= numberExpression )?
                    int alt168=2;
                    int LA168_0 = input.LA(1);

                    if ( (LA168_0==COMMA) ) {
                        alt168=1;
                    }
                    switch (alt168) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1498:6: COMMA factor= numberExpression
                            {
                            match(input,COMMA,FOLLOW_COMMA_in_actionDynamicAnchoring8647); if (state.failed) return action;
                            pushFollow(FOLLOW_numberExpression_in_actionDynamicAnchoring8653);
                            factor=numberExpression();

                            state._fsp--;
                            if (state.failed) return action;

                            }
                            break;

                    }


                    }
                    break;

            }

            if ( state.backtracking==0 ) {
              action = ActionFactory.createDynamicAnchoringAction(active, penalty, factor, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }
            match(input,RPAREN,FOLLOW_RPAREN_in_actionDynamicAnchoring8670); if (state.failed) return action;

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionDynamicAnchoring"


    // $ANTLR start "actionTrim"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1503:1: actionTrim returns [AbstractRutaAction action = null] : name= TRIM LPAREN (typeList= typeListExpression | t1= typeExpression ( COMMA t2= typeExpression )* ) RPAREN ;
    public final AbstractRutaAction actionTrim() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        TypeListExpression typeList = null;

        TypeExpression t1 = null;

        TypeExpression t2 = null;



          List<TypeExpression> types = new ArrayList<TypeExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1507:5: (name= TRIM LPAREN (typeList= typeListExpression | t1= typeExpression ( COMMA t2= typeExpression )* ) RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1508:5: name= TRIM LPAREN (typeList= typeListExpression | t1= typeExpression ( COMMA t2= typeExpression )* ) RPAREN
            {
            name=(Token)match(input,TRIM,FOLLOW_TRIM_in_actionTrim8704); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionTrim8706); if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1509:5: (typeList= typeListExpression | t1= typeExpression ( COMMA t2= typeExpression )* )
            int alt171=2;
            int LA171_0 = input.LA(1);

            if ( (LA171_0==LCURLY) ) {
                alt171=1;
            }
            else if ( (LA171_0==Identifier) ) {
                int LA171_2 = input.LA(2);

                if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))) ) {
                    alt171=1;
                }
                else if ( (true) ) {
                    alt171=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return action;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 171, 2, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return action;}
                NoViableAltException nvae =
                    new NoViableAltException("", 171, 0, input);

                throw nvae;
            }
            switch (alt171) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1510:5: typeList= typeListExpression
                    {
                    pushFollow(FOLLOW_typeListExpression_in_actionTrim8723);
                    typeList=typeListExpression();

                    state._fsp--;
                    if (state.failed) return action;

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1512:5: t1= typeExpression ( COMMA t2= typeExpression )*
                    {
                    pushFollow(FOLLOW_typeExpression_in_actionTrim8739);
                    t1=typeExpression();

                    state._fsp--;
                    if (state.failed) return action;
                    if ( state.backtracking==0 ) {
                      types.add(t1);
                    }
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1512:42: ( COMMA t2= typeExpression )*
                    loop170:
                    do {
                        int alt170=2;
                        int LA170_0 = input.LA(1);

                        if ( (LA170_0==COMMA) ) {
                            alt170=1;
                        }


                        switch (alt170) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1512:43: COMMA t2= typeExpression
                    	    {
                    	    match(input,COMMA,FOLLOW_COMMA_in_actionTrim8744); if (state.failed) return action;
                    	    pushFollow(FOLLOW_typeExpression_in_actionTrim8750);
                    	    t2=typeExpression();

                    	    state._fsp--;
                    	    if (state.failed) return action;
                    	    if ( state.backtracking==0 ) {
                    	      types.add(t2);
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    break loop170;
                        }
                    } while (true);


                    }
                    break;

            }

            if ( state.backtracking==0 ) {
              action = ActionFactory.createTrimAction(types, typeList, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }
            match(input,RPAREN,FOLLOW_RPAREN_in_actionTrim8777); if (state.failed) return action;

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionTrim"


    // $ANTLR start "actionUnmark"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1521:1: actionUnmark returns [AbstractRutaAction action = null] : name= UNMARK LPAREN f= typeExpression ( COMMA ( (b= booleanExpression )=>b= booleanExpression | (index= numberExpression ( COMMA index= numberExpression )* ) ) )? RPAREN ;
    public final AbstractRutaAction actionUnmark() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        TypeExpression f = null;

        BooleanExpression b = null;

        NumberExpression index = null;



        List<NumberExpression> list = new ArrayList<NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1525:5: (name= UNMARK LPAREN f= typeExpression ( COMMA ( (b= booleanExpression )=>b= booleanExpression | (index= numberExpression ( COMMA index= numberExpression )* ) ) )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1526:5: name= UNMARK LPAREN f= typeExpression ( COMMA ( (b= booleanExpression )=>b= booleanExpression | (index= numberExpression ( COMMA index= numberExpression )* ) ) )? RPAREN
            {
            name=(Token)match(input,UNMARK,FOLLOW_UNMARK_in_actionUnmark8813); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionUnmark8815); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionUnmark8831);
            f=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1530:5: ( COMMA ( (b= booleanExpression )=>b= booleanExpression | (index= numberExpression ( COMMA index= numberExpression )* ) ) )?
            int alt174=2;
            int LA174_0 = input.LA(1);

            if ( (LA174_0==COMMA) ) {
                alt174=1;
            }
            switch (alt174) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1530:6: COMMA ( (b= booleanExpression )=>b= booleanExpression | (index= numberExpression ( COMMA index= numberExpression )* ) )
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_actionUnmark8840); if (state.failed) return action;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1531:5: ( (b= booleanExpression )=>b= booleanExpression | (index= numberExpression ( COMMA index= numberExpression )* ) )
                    int alt173=2;
                    alt173 = dfa173.predict(input);
                    switch (alt173) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1532:4: (b= booleanExpression )=>b= booleanExpression
                            {
                            pushFollow(FOLLOW_booleanExpression_in_actionUnmark8865);
                            b=booleanExpression();

                            state._fsp--;
                            if (state.failed) return action;

                            }
                            break;
                        case 2 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1534:4: (index= numberExpression ( COMMA index= numberExpression )* )
                            {
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1534:4: (index= numberExpression ( COMMA index= numberExpression )* )
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1535:4: index= numberExpression ( COMMA index= numberExpression )*
                            {
                            pushFollow(FOLLOW_numberExpression_in_actionUnmark8884);
                            index=numberExpression();

                            state._fsp--;
                            if (state.failed) return action;
                            if ( state.backtracking==0 ) {
                              list.add(index);
                            }
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1536:4: ( COMMA index= numberExpression )*
                            loop172:
                            do {
                                int alt172=2;
                                int LA172_0 = input.LA(1);

                                if ( (LA172_0==COMMA) ) {
                                    alt172=1;
                                }


                                switch (alt172) {
                            	case 1 :
                            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1536:5: COMMA index= numberExpression
                            	    {
                            	    match(input,COMMA,FOLLOW_COMMA_in_actionUnmark8893); if (state.failed) return action;
                            	    pushFollow(FOLLOW_numberExpression_in_actionUnmark8899);
                            	    index=numberExpression();

                            	    state._fsp--;
                            	    if (state.failed) return action;
                            	    if ( state.backtracking==0 ) {
                            	      list.add(index);
                            	    }

                            	    }
                            	    break;

                            	default :
                            	    break loop172;
                                }
                            } while (true);


                            }


                            }
                            break;

                    }


                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_actionUnmark8936); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createUnmarkAction(f, list, b,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionUnmark"


    // $ANTLR start "actionUnmarkAll"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1547:1: actionUnmarkAll returns [AbstractRutaAction action = null] : name= UNMARKALL LPAREN f= typeExpression ( COMMA list= typeListExpression )? RPAREN ;
    public final AbstractRutaAction actionUnmarkAll() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        TypeExpression f = null;

        TypeListExpression list = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1548:5: (name= UNMARKALL LPAREN f= typeExpression ( COMMA list= typeListExpression )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1549:5: name= UNMARKALL LPAREN f= typeExpression ( COMMA list= typeListExpression )? RPAREN
            {
            name=(Token)match(input,UNMARKALL,FOLLOW_UNMARKALL_in_actionUnmarkAll8972); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionUnmarkAll8974); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionUnmarkAll8980);
            f=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1550:5: ( COMMA list= typeListExpression )?
            int alt175=2;
            int LA175_0 = input.LA(1);

            if ( (LA175_0==COMMA) ) {
                alt175=1;
            }
            switch (alt175) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1550:6: COMMA list= typeListExpression
                    {
                    match(input,COMMA,FOLLOW_COMMA_in_actionUnmarkAll8988); if (state.failed) return action;
                    pushFollow(FOLLOW_typeListExpression_in_actionUnmarkAll8994);
                    list=typeListExpression();

                    state._fsp--;
                    if (state.failed) return action;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_actionUnmarkAll8998); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createUnmarkAllAction(f, list, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionUnmarkAll"


    // $ANTLR start "actionTransfer"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1554:1: actionTransfer returns [AbstractRutaAction action = null] : name= TRANSFER LPAREN f= typeExpression RPAREN ;
    public final AbstractRutaAction actionTransfer() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        TypeExpression f = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1555:5: (name= TRANSFER LPAREN f= typeExpression RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1556:5: name= TRANSFER LPAREN f= typeExpression RPAREN
            {
            name=(Token)match(input,TRANSFER,FOLLOW_TRANSFER_in_actionTransfer9033); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionTransfer9035); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionTransfer9041);
            f=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,RPAREN,FOLLOW_RPAREN_in_actionTransfer9043); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createTransferAction(f, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionTransfer"


    // $ANTLR start "actionTrie"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1560:1: actionTrie returns [AbstractRutaAction action = null] : name= TRIE LPAREN key= stringExpression ASSIGN_EQUAL value= typeExpression ( COMMA key= stringExpression ASSIGN_EQUAL value= typeExpression )* COMMA list= wordListExpression COMMA ignoreCase= booleanExpression COMMA ignoreLength= numberExpression COMMA edit= booleanExpression COMMA distance= numberExpression COMMA ignoreChar= stringExpression RPAREN ;
    public final AbstractRutaAction actionTrie() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        StringExpression key = null;

        TypeExpression value = null;

        WordListExpression list = null;

        BooleanExpression ignoreCase = null;

        NumberExpression ignoreLength = null;

        BooleanExpression edit = null;

        NumberExpression distance = null;

        StringExpression ignoreChar = null;



        Map<StringExpression, TypeExpression> map = new HashMap<StringExpression, TypeExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1564:5: (name= TRIE LPAREN key= stringExpression ASSIGN_EQUAL value= typeExpression ( COMMA key= stringExpression ASSIGN_EQUAL value= typeExpression )* COMMA list= wordListExpression COMMA ignoreCase= booleanExpression COMMA ignoreLength= numberExpression COMMA edit= booleanExpression COMMA distance= numberExpression COMMA ignoreChar= stringExpression RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1565:5: name= TRIE LPAREN key= stringExpression ASSIGN_EQUAL value= typeExpression ( COMMA key= stringExpression ASSIGN_EQUAL value= typeExpression )* COMMA list= wordListExpression COMMA ignoreCase= booleanExpression COMMA ignoreLength= numberExpression COMMA edit= booleanExpression COMMA distance= numberExpression COMMA ignoreChar= stringExpression RPAREN
            {
            name=(Token)match(input,TRIE,FOLLOW_TRIE_in_actionTrie9083); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionTrie9085); if (state.failed) return action;
            pushFollow(FOLLOW_stringExpression_in_actionTrie9095);
            key=stringExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_actionTrie9097); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionTrie9103);
            value=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            if ( state.backtracking==0 ) {
              map.put(key,value);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1567:5: ( COMMA key= stringExpression ASSIGN_EQUAL value= typeExpression )*
            loop176:
            do {
                int alt176=2;
                int LA176_0 = input.LA(1);

                if ( (LA176_0==COMMA) ) {
                    int LA176_1 = input.LA(2);

                    if ( (LA176_1==Identifier) ) {
                        int LA176_2 = input.LA(3);

                        if ( (LA176_2==LPAREN||LA176_2==PLUS||LA176_2==ASSIGN_EQUAL) ) {
                            alt176=1;
                        }


                    }
                    else if ( (LA176_1==REMOVESTRING||LA176_1==StringLiteral) ) {
                        alt176=1;
                    }


                }


                switch (alt176) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1567:6: COMMA key= stringExpression ASSIGN_EQUAL value= typeExpression
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionTrie9111); if (state.failed) return action;
            	    pushFollow(FOLLOW_stringExpression_in_actionTrie9117);
            	    key=stringExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_actionTrie9119); if (state.failed) return action;
            	    pushFollow(FOLLOW_typeExpression_in_actionTrie9125);
            	    value=typeExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      map.put(key,value);
            	    }

            	    }
            	    break;

            	default :
            	    break loop176;
                }
            } while (true);

            match(input,COMMA,FOLLOW_COMMA_in_actionTrie9135); if (state.failed) return action;
            pushFollow(FOLLOW_wordListExpression_in_actionTrie9141);
            list=wordListExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionTrie9148); if (state.failed) return action;
            pushFollow(FOLLOW_booleanExpression_in_actionTrie9154);
            ignoreCase=booleanExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionTrie9161); if (state.failed) return action;
            pushFollow(FOLLOW_numberExpression_in_actionTrie9167);
            ignoreLength=numberExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionTrie9174); if (state.failed) return action;
            pushFollow(FOLLOW_booleanExpression_in_actionTrie9180);
            edit=booleanExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionTrie9187); if (state.failed) return action;
            pushFollow(FOLLOW_numberExpression_in_actionTrie9193);
            distance=numberExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionTrie9200); if (state.failed) return action;
            pushFollow(FOLLOW_stringExpression_in_actionTrie9206);
            ignoreChar=stringExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,RPAREN,FOLLOW_RPAREN_in_actionTrie9212); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createTrieAction(list, map, ignoreCase, ignoreLength, edit, distance, ignoreChar,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionTrie"


    // $ANTLR start "actionAdd"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1579:1: actionAdd returns [AbstractRutaAction action = null] : name= ADD LPAREN f= listVariable ( COMMA a= argument )+ RPAREN ;
    public final AbstractRutaAction actionAdd() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        Token f = null;

        RutaExpression a = null;



        	List<RutaExpression> list = new ArrayList<RutaExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1583:5: (name= ADD LPAREN f= listVariable ( COMMA a= argument )+ RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1584:5: name= ADD LPAREN f= listVariable ( COMMA a= argument )+ RPAREN
            {
            name=(Token)match(input,ADD,FOLLOW_ADD_in_actionAdd9257); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionAdd9259); if (state.failed) return action;
            pushFollow(FOLLOW_listVariable_in_actionAdd9265);
            f=listVariable();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1584:40: ( COMMA a= argument )+
            int cnt177=0;
            loop177:
            do {
                int alt177=2;
                int LA177_0 = input.LA(1);

                if ( (LA177_0==COMMA) ) {
                    alt177=1;
                }


                switch (alt177) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1584:41: COMMA a= argument
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionAdd9268); if (state.failed) return action;
            	    pushFollow(FOLLOW_argument_in_actionAdd9274);
            	    a=argument();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      list.add(a);
            	    }

            	    }
            	    break;

            	default :
            	    if ( cnt177 >= 1 ) break loop177;
            	    if (state.backtracking>0) {state.failed=true; return action;}
                        EarlyExitException eee =
                            new EarlyExitException(177, input);
                        throw eee;
                }
                cnt177++;
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionAdd9280); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createAddAction(f, list, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionAdd"


    // $ANTLR start "actionRemove"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1588:1: actionRemove returns [AbstractRutaAction action = null] : name= REMOVE LPAREN f= listVariable ( COMMA a= argument )+ RPAREN ;
    public final AbstractRutaAction actionRemove() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        Token f = null;

        RutaExpression a = null;



        	List<RutaExpression> list = new ArrayList<RutaExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1592:5: (name= REMOVE LPAREN f= listVariable ( COMMA a= argument )+ RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1593:5: name= REMOVE LPAREN f= listVariable ( COMMA a= argument )+ RPAREN
            {
            name=(Token)match(input,REMOVE,FOLLOW_REMOVE_in_actionRemove9320); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionRemove9322); if (state.failed) return action;
            pushFollow(FOLLOW_listVariable_in_actionRemove9328);
            f=listVariable();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1593:43: ( COMMA a= argument )+
            int cnt178=0;
            loop178:
            do {
                int alt178=2;
                int LA178_0 = input.LA(1);

                if ( (LA178_0==COMMA) ) {
                    alt178=1;
                }


                switch (alt178) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1593:44: COMMA a= argument
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionRemove9331); if (state.failed) return action;
            	    pushFollow(FOLLOW_argument_in_actionRemove9337);
            	    a=argument();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      list.add(a);
            	    }

            	    }
            	    break;

            	default :
            	    if ( cnt178 >= 1 ) break loop178;
            	    if (state.backtracking>0) {state.failed=true; return action;}
                        EarlyExitException eee =
                            new EarlyExitException(178, input);
                        throw eee;
                }
                cnt178++;
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionRemove9343); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createRemoveAction(f, list, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionRemove"


    // $ANTLR start "actionRemoveDuplicate"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1597:1: actionRemoveDuplicate returns [AbstractRutaAction action = null] : name= REMOVEDUPLICATE LPAREN f= listVariable RPAREN ;
    public final AbstractRutaAction actionRemoveDuplicate() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        Token f = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1598:5: (name= REMOVEDUPLICATE LPAREN f= listVariable RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1599:5: name= REMOVEDUPLICATE LPAREN f= listVariable RPAREN
            {
            name=(Token)match(input,REMOVEDUPLICATE,FOLLOW_REMOVEDUPLICATE_in_actionRemoveDuplicate9379); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionRemoveDuplicate9381); if (state.failed) return action;
            pushFollow(FOLLOW_listVariable_in_actionRemoveDuplicate9387);
            f=listVariable();

            state._fsp--;
            if (state.failed) return action;
            match(input,RPAREN,FOLLOW_RPAREN_in_actionRemoveDuplicate9389); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createRemoveDuplicateAction(f,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionRemoveDuplicate"


    // $ANTLR start "actionMerge"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1603:1: actionMerge returns [AbstractRutaAction action = null] : name= MERGE LPAREN join= booleanExpression COMMA t= listVariable COMMA f= listExpression ( COMMA f= listExpression )+ RPAREN ;
    public final AbstractRutaAction actionMerge() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        BooleanExpression join = null;

        Token t = null;

        ListExpression f = null;



        	List<ListExpression> list = new ArrayList<ListExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1607:5: (name= MERGE LPAREN join= booleanExpression COMMA t= listVariable COMMA f= listExpression ( COMMA f= listExpression )+ RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1608:5: name= MERGE LPAREN join= booleanExpression COMMA t= listVariable COMMA f= listExpression ( COMMA f= listExpression )+ RPAREN
            {
            name=(Token)match(input,MERGE,FOLLOW_MERGE_in_actionMerge9434); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionMerge9436); if (state.failed) return action;
            pushFollow(FOLLOW_booleanExpression_in_actionMerge9442);
            join=booleanExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionMerge9444); if (state.failed) return action;
            pushFollow(FOLLOW_listVariable_in_actionMerge9450);
            t=listVariable();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionMerge9452); if (state.failed) return action;
            pushFollow(FOLLOW_listExpression_in_actionMerge9458);
            f=listExpression();

            state._fsp--;
            if (state.failed) return action;
            if ( state.backtracking==0 ) {
              list.add(f);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1608:113: ( COMMA f= listExpression )+
            int cnt179=0;
            loop179:
            do {
                int alt179=2;
                int LA179_0 = input.LA(1);

                if ( (LA179_0==COMMA) ) {
                    alt179=1;
                }


                switch (alt179) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1608:114: COMMA f= listExpression
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionMerge9463); if (state.failed) return action;
            	    pushFollow(FOLLOW_listExpression_in_actionMerge9469);
            	    f=listExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      list.add(f);
            	    }

            	    }
            	    break;

            	default :
            	    if ( cnt179 >= 1 ) break loop179;
            	    if (state.backtracking>0) {state.failed=true; return action;}
                        EarlyExitException eee =
                            new EarlyExitException(179, input);
                        throw eee;
                }
                cnt179++;
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionMerge9475); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createMergeAction(join, t, list,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionMerge"


    // $ANTLR start "actionGet"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1612:1: actionGet returns [AbstractRutaAction action = null] : name= GET LPAREN f= listExpression COMMA var= variable COMMA op= stringExpression RPAREN ;
    public final AbstractRutaAction actionGet() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        ListExpression f = null;

        Token var = null;

        StringExpression op = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1613:5: (name= GET LPAREN f= listExpression COMMA var= variable COMMA op= stringExpression RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1614:5: name= GET LPAREN f= listExpression COMMA var= variable COMMA op= stringExpression RPAREN
            {
            name=(Token)match(input,GET,FOLLOW_GET_in_actionGet9510); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionGet9512); if (state.failed) return action;
            pushFollow(FOLLOW_listExpression_in_actionGet9518);
            f=listExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionGet9520); if (state.failed) return action;
            pushFollow(FOLLOW_variable_in_actionGet9526);
            var=variable();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionGet9528); if (state.failed) return action;
            pushFollow(FOLLOW_stringExpression_in_actionGet9534);
            op=stringExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,RPAREN,FOLLOW_RPAREN_in_actionGet9536); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createGetAction(f, var, op,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionGet"


    // $ANTLR start "actionGetList"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1618:1: actionGetList returns [AbstractRutaAction action = null] : name= GETLIST LPAREN var= listVariable COMMA op= stringExpression RPAREN ;
    public final AbstractRutaAction actionGetList() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        Token var = null;

        StringExpression op = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1619:5: (name= GETLIST LPAREN var= listVariable COMMA op= stringExpression RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1620:5: name= GETLIST LPAREN var= listVariable COMMA op= stringExpression RPAREN
            {
            name=(Token)match(input,GETLIST,FOLLOW_GETLIST_in_actionGetList9571); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionGetList9573); if (state.failed) return action;
            pushFollow(FOLLOW_listVariable_in_actionGetList9579);
            var=listVariable();

            state._fsp--;
            if (state.failed) return action;
            match(input,COMMA,FOLLOW_COMMA_in_actionGetList9581); if (state.failed) return action;
            pushFollow(FOLLOW_stringExpression_in_actionGetList9587);
            op=stringExpression();

            state._fsp--;
            if (state.failed) return action;
            match(input,RPAREN,FOLLOW_RPAREN_in_actionGetList9589); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createGetListAction(var, op,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionGetList"


    // $ANTLR start "actionMatchedText"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1624:1: actionMatchedText returns [AbstractRutaAction action = null] : MATCHEDTEXT LPAREN var= variable ( COMMA index= numberExpression )* RPAREN ;
    public final AbstractRutaAction actionMatchedText() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token var = null;

        NumberExpression index = null;



        List<NumberExpression> list = new ArrayList<NumberExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1628:5: ( MATCHEDTEXT LPAREN var= variable ( COMMA index= numberExpression )* RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1629:5: MATCHEDTEXT LPAREN var= variable ( COMMA index= numberExpression )* RPAREN
            {
            match(input,MATCHEDTEXT,FOLLOW_MATCHEDTEXT_in_actionMatchedText9628); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionMatchedText9630); if (state.failed) return action;
            pushFollow(FOLLOW_variable_in_actionMatchedText9641);
            var=variable();

            state._fsp--;
            if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1631:5: ( COMMA index= numberExpression )*
            loop180:
            do {
                int alt180=2;
                int LA180_0 = input.LA(1);

                if ( (LA180_0==COMMA) ) {
                    alt180=1;
                }


                switch (alt180) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1632:9: COMMA index= numberExpression
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionMatchedText9657); if (state.failed) return action;
            	    pushFollow(FOLLOW_numberExpression_in_actionMatchedText9663);
            	    index=numberExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      list.add(index);
            	    }

            	    }
            	    break;

            	default :
            	    break loop180;
                }
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionMatchedText9687); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createMatchedTextAction(var, list, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionMatchedText"


    // $ANTLR start "actionClear"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1640:1: actionClear returns [AbstractRutaAction action = null] : name= CLEAR LPAREN var= listVariable RPAREN ;
    public final AbstractRutaAction actionClear() throws RecognitionException {
        AbstractRutaAction action =  null;

        Token name=null;
        Token var = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1641:5: (name= CLEAR LPAREN var= listVariable RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1642:5: name= CLEAR LPAREN var= listVariable RPAREN
            {
            name=(Token)match(input,CLEAR,FOLLOW_CLEAR_in_actionClear9727); if (state.failed) return action;
            match(input,LPAREN,FOLLOW_LPAREN_in_actionClear9729); if (state.failed) return action;
            pushFollow(FOLLOW_listVariable_in_actionClear9735);
            var=listVariable();

            state._fsp--;
            if (state.failed) return action;
            match(input,RPAREN,FOLLOW_RPAREN_in_actionClear9737); if (state.failed) return action;
            if ( state.backtracking==0 ) {
              action = ActionFactory.createClearAction(var, ((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionClear"


    // $ANTLR start "actionAddRetainType"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1646:1: actionAddRetainType returns [AbstractRutaAction action = null] : ADDRETAINTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN ) ;
    public final AbstractRutaAction actionAddRetainType() throws RecognitionException {
        AbstractRutaAction action =  null;

        TypeExpression id = null;



        List<TypeExpression> list = new ArrayList<TypeExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1650:5: ( ADDRETAINTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN ) )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1651:5: ADDRETAINTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )
            {
            match(input,ADDRETAINTYPE,FOLLOW_ADDRETAINTYPE_in_actionAddRetainType9773); if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1651:19: ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1651:20: LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN
            {
            match(input,LPAREN,FOLLOW_LPAREN_in_actionAddRetainType9776); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionAddRetainType9782);
            id=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            if ( state.backtracking==0 ) {
              list.add(id);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1651:63: ( COMMA id= typeExpression )*
            loop181:
            do {
                int alt181=2;
                int LA181_0 = input.LA(1);

                if ( (LA181_0==COMMA) ) {
                    alt181=1;
                }


                switch (alt181) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1651:64: COMMA id= typeExpression
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionAddRetainType9787); if (state.failed) return action;
            	    pushFollow(FOLLOW_typeExpression_in_actionAddRetainType9793);
            	    id=typeExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      list.add(id);
            	    }

            	    }
            	    break;

            	default :
            	    break loop181;
                }
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionAddRetainType9799); if (state.failed) return action;

            }

            if ( state.backtracking==0 ) {
              action = ActionFactory.createAddRetainTypeAction(list,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionAddRetainType"


    // $ANTLR start "actionRemoveRetainType"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1655:1: actionRemoveRetainType returns [AbstractRutaAction action = null] : REMOVERETAINTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN ) ;
    public final AbstractRutaAction actionRemoveRetainType() throws RecognitionException {
        AbstractRutaAction action =  null;

        TypeExpression id = null;



        List<TypeExpression> list = new ArrayList<TypeExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1659:5: ( REMOVERETAINTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN ) )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1660:5: REMOVERETAINTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )
            {
            match(input,REMOVERETAINTYPE,FOLLOW_REMOVERETAINTYPE_in_actionRemoveRetainType9841); if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1660:22: ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1660:23: LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN
            {
            match(input,LPAREN,FOLLOW_LPAREN_in_actionRemoveRetainType9844); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionRemoveRetainType9850);
            id=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            if ( state.backtracking==0 ) {
              list.add(id);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1660:66: ( COMMA id= typeExpression )*
            loop182:
            do {
                int alt182=2;
                int LA182_0 = input.LA(1);

                if ( (LA182_0==COMMA) ) {
                    alt182=1;
                }


                switch (alt182) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1660:67: COMMA id= typeExpression
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionRemoveRetainType9855); if (state.failed) return action;
            	    pushFollow(FOLLOW_typeExpression_in_actionRemoveRetainType9861);
            	    id=typeExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      list.add(id);
            	    }

            	    }
            	    break;

            	default :
            	    break loop182;
                }
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionRemoveRetainType9867); if (state.failed) return action;

            }

            if ( state.backtracking==0 ) {
              action = ActionFactory.createRemoveRetainTypeAction(list,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionRemoveRetainType"


    // $ANTLR start "actionAddFilterType"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1664:1: actionAddFilterType returns [AbstractRutaAction action = null] : ADDFILTERTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN ) ;
    public final AbstractRutaAction actionAddFilterType() throws RecognitionException {
        AbstractRutaAction action =  null;

        TypeExpression id = null;



        List<TypeExpression> list = new ArrayList<TypeExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1668:5: ( ADDFILTERTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN ) )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1669:5: ADDFILTERTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )
            {
            match(input,ADDFILTERTYPE,FOLLOW_ADDFILTERTYPE_in_actionAddFilterType9907); if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1669:19: ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1669:20: LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN
            {
            match(input,LPAREN,FOLLOW_LPAREN_in_actionAddFilterType9910); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionAddFilterType9916);
            id=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            if ( state.backtracking==0 ) {
              list.add(id);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1669:63: ( COMMA id= typeExpression )*
            loop183:
            do {
                int alt183=2;
                int LA183_0 = input.LA(1);

                if ( (LA183_0==COMMA) ) {
                    alt183=1;
                }


                switch (alt183) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1669:64: COMMA id= typeExpression
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionAddFilterType9921); if (state.failed) return action;
            	    pushFollow(FOLLOW_typeExpression_in_actionAddFilterType9927);
            	    id=typeExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      list.add(id);
            	    }

            	    }
            	    break;

            	default :
            	    break loop183;
                }
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionAddFilterType9933); if (state.failed) return action;

            }

            if ( state.backtracking==0 ) {
              action = ActionFactory.createAddFilterTypeAction(list,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionAddFilterType"


    // $ANTLR start "actionRemoveFilterType"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1673:1: actionRemoveFilterType returns [AbstractRutaAction action = null] : REMOVEFILTERTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN ) ;
    public final AbstractRutaAction actionRemoveFilterType() throws RecognitionException {
        AbstractRutaAction action =  null;

        TypeExpression id = null;



        List<TypeExpression> list = new ArrayList<TypeExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1677:5: ( REMOVEFILTERTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN ) )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1678:5: REMOVEFILTERTYPE ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )
            {
            match(input,REMOVEFILTERTYPE,FOLLOW_REMOVEFILTERTYPE_in_actionRemoveFilterType9973); if (state.failed) return action;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1678:22: ( LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1678:23: LPAREN id= typeExpression ( COMMA id= typeExpression )* RPAREN
            {
            match(input,LPAREN,FOLLOW_LPAREN_in_actionRemoveFilterType9976); if (state.failed) return action;
            pushFollow(FOLLOW_typeExpression_in_actionRemoveFilterType9982);
            id=typeExpression();

            state._fsp--;
            if (state.failed) return action;
            if ( state.backtracking==0 ) {
              list.add(id);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1678:66: ( COMMA id= typeExpression )*
            loop184:
            do {
                int alt184=2;
                int LA184_0 = input.LA(1);

                if ( (LA184_0==COMMA) ) {
                    alt184=1;
                }


                switch (alt184) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1678:67: COMMA id= typeExpression
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_actionRemoveFilterType9987); if (state.failed) return action;
            	    pushFollow(FOLLOW_typeExpression_in_actionRemoveFilterType9993);
            	    id=typeExpression();

            	    state._fsp--;
            	    if (state.failed) return action;
            	    if ( state.backtracking==0 ) {
            	      list.add(id);
            	    }

            	    }
            	    break;

            	default :
            	    break loop184;
                }
            } while (true);

            match(input,RPAREN,FOLLOW_RPAREN_in_actionRemoveFilterType9999); if (state.failed) return action;

            }

            if ( state.backtracking==0 ) {
              action = ActionFactory.createRemoveFilterTypeAction(list,((blockDeclaration_scope)blockDeclaration_stack.peek()).env);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return action;
    }
    // $ANTLR end "actionRemoveFilterType"


    // $ANTLR start "varArgumentList"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1682:1: varArgumentList returns [List args = new ArrayList()] : arg= argument ( COMMA arg= argument )* ;
    public final List varArgumentList() throws RecognitionException {
        List args =  new ArrayList();

        RutaExpression arg = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1683:2: (arg= argument ( COMMA arg= argument )* )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1684:2: arg= argument ( COMMA arg= argument )*
            {
            pushFollow(FOLLOW_argument_in_varArgumentList10034);
            arg=argument();

            state._fsp--;
            if (state.failed) return args;
            if ( state.backtracking==0 ) {
              args.add(arg);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1684:33: ( COMMA arg= argument )*
            loop185:
            do {
                int alt185=2;
                int LA185_0 = input.LA(1);

                if ( (LA185_0==COMMA) ) {
                    alt185=1;
                }


                switch (alt185) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1684:34: COMMA arg= argument
            	    {
            	    match(input,COMMA,FOLLOW_COMMA_in_varArgumentList10038); if (state.failed) return args;
            	    pushFollow(FOLLOW_argument_in_varArgumentList10044);
            	    arg=argument();

            	    state._fsp--;
            	    if (state.failed) return args;
            	    if ( state.backtracking==0 ) {
            	      args.add(arg);
            	    }

            	    }
            	    break;

            	default :
            	    break loop185;
                }
            } while (true);


            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return args;
    }
    // $ANTLR end "varArgumentList"


    // $ANTLR start "argument"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1687:1: argument returns [RutaExpression expr = null] options {backtrack=true; } : (a4= stringExpression | a2= booleanExpression | a3= numberExpression | a1= typeExpression );
    public final RutaExpression argument() throws RecognitionException {
        RutaExpression expr =  null;

        StringExpression a4 = null;

        BooleanExpression a2 = null;

        NumberExpression a3 = null;

        TypeExpression a1 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1691:2: (a4= stringExpression | a2= booleanExpression | a3= numberExpression | a1= typeExpression )
            int alt186=4;
            alt186 = dfa186.predict(input);
            switch (alt186) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1692:2: a4= stringExpression
                    {
                    pushFollow(FOLLOW_stringExpression_in_argument10080);
                    a4=stringExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = a4;
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1693:4: a2= booleanExpression
                    {
                    pushFollow(FOLLOW_booleanExpression_in_argument10091);
                    a2=booleanExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = a2;
                    }

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1694:4: a3= numberExpression
                    {
                    pushFollow(FOLLOW_numberExpression_in_argument10102);
                    a3=numberExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = a3;
                    }

                    }
                    break;
                case 4 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1695:4: a1= typeExpression
                    {
                    pushFollow(FOLLOW_typeExpression_in_argument10113);
                    a1=typeExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = a1;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "argument"


    // $ANTLR start "dottedIdentifier"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1704:1: dottedIdentifier returns [String idString = \"\"] : id= Identifier (dot= DOT idn= Identifier )* ;
    public final String dottedIdentifier() throws RecognitionException {
        String idString =  "";

        Token id=null;
        Token dot=null;
        Token idn=null;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1705:2: (id= Identifier (dot= DOT idn= Identifier )* )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1706:2: id= Identifier (dot= DOT idn= Identifier )*
            {
            id=(Token)match(input,Identifier,FOLLOW_Identifier_in_dottedIdentifier10147); if (state.failed) return idString;
            if ( state.backtracking==0 ) {
              idString += id.getText();
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1707:2: (dot= DOT idn= Identifier )*
            loop187:
            do {
                int alt187=2;
                int LA187_0 = input.LA(1);

                if ( (LA187_0==DOT) ) {
                    alt187=1;
                }


                switch (alt187) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1708:3: dot= DOT idn= Identifier
            	    {
            	    dot=(Token)match(input,DOT,FOLLOW_DOT_in_dottedIdentifier10160); if (state.failed) return idString;
            	    if ( state.backtracking==0 ) {
            	      idString += dot.getText();
            	    }
            	    idn=(Token)match(input,Identifier,FOLLOW_Identifier_in_dottedIdentifier10170); if (state.failed) return idString;
            	    if ( state.backtracking==0 ) {
            	      idString += idn.getText();
            	    }

            	    }
            	    break;

            	default :
            	    break loop187;
                }
            } while (true);


            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return idString;
    }
    // $ANTLR end "dottedIdentifier"


    // $ANTLR start "dottedIdentifier2"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1713:1: dottedIdentifier2 returns [String idString = \"\"] : id= Identifier (dot= ( DOT | MINUS ) idn= Identifier )* ;
    public final String dottedIdentifier2() throws RecognitionException {
        String idString =  "";

        Token id=null;
        Token dot=null;
        Token idn=null;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1714:2: (id= Identifier (dot= ( DOT | MINUS ) idn= Identifier )* )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1715:2: id= Identifier (dot= ( DOT | MINUS ) idn= Identifier )*
            {
            id=(Token)match(input,Identifier,FOLLOW_Identifier_in_dottedIdentifier210196); if (state.failed) return idString;
            if ( state.backtracking==0 ) {
              idString += id.getText();
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1716:2: (dot= ( DOT | MINUS ) idn= Identifier )*
            loop188:
            do {
                int alt188=2;
                int LA188_0 = input.LA(1);

                if ( (LA188_0==DOT||LA188_0==MINUS) ) {
                    alt188=1;
                }


                switch (alt188) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1717:3: dot= ( DOT | MINUS ) idn= Identifier
            	    {
            	    dot=(Token)input.LT(1);
            	    if ( input.LA(1)==DOT||input.LA(1)==MINUS ) {
            	        input.consume();
            	        state.errorRecovery=false;state.failed=false;
            	    }
            	    else {
            	        if (state.backtracking>0) {state.failed=true; return idString;}
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        throw mse;
            	    }

            	    if ( state.backtracking==0 ) {
            	      idString += dot.getText();
            	    }
            	    idn=(Token)match(input,Identifier,FOLLOW_Identifier_in_dottedIdentifier210223); if (state.failed) return idString;
            	    if ( state.backtracking==0 ) {
            	      idString += idn.getText();
            	    }

            	    }
            	    break;

            	default :
            	    break loop188;
                }
            } while (true);


            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return idString;
    }
    // $ANTLR end "dottedIdentifier2"


    // $ANTLR start "dottedId"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1723:1: dottedId returns [Token token = null ] : id= Identifier (dot= DOT id= Identifier )* ;
    public final Token dottedId() throws RecognitionException {
        Token token =  null;

        Token id=null;
        Token dot=null;

        CommonToken ct = null;
        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1725:2: (id= Identifier (dot= DOT id= Identifier )* )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1726:2: id= Identifier (dot= DOT id= Identifier )*
            {
            id=(Token)match(input,Identifier,FOLLOW_Identifier_in_dottedId10255); if (state.failed) return token;
            if ( state.backtracking==0 ) {

              		ct = new CommonToken(id);
              		
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1729:2: (dot= DOT id= Identifier )*
            loop189:
            do {
                int alt189=2;
                int LA189_0 = input.LA(1);

                if ( (LA189_0==DOT) ) {
                    alt189=1;
                }


                switch (alt189) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1730:3: dot= DOT id= Identifier
            	    {
            	    dot=(Token)match(input,DOT,FOLLOW_DOT_in_dottedId10268); if (state.failed) return token;
            	    if ( state.backtracking==0 ) {
            	      ct.setText(ct.getText() + dot.getText());
            	    }
            	    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_dottedId10278); if (state.failed) return token;
            	    if ( state.backtracking==0 ) {
            	      ct.setStopIndex(getBounds(id)[1]);
            	      		                 ct.setText(ct.getText() + id.getText());
            	    }

            	    }
            	    break;

            	default :
            	    break loop189;
                }
            } while (true);

            if ( state.backtracking==0 ) {
              token = ct;
              	 return token;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return token;
    }
    // $ANTLR end "dottedId"


    // $ANTLR start "annotationType"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1738:1: annotationType returns [Token ref = null] : (did= dottedId ) ;
    public final Token annotationType() throws RecognitionException {
        Token ref =  null;

        Token did = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1739:2: ( (did= dottedId ) )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1740:2: (did= dottedId )
            {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1740:2: (did= dottedId )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1741:2: did= dottedId
            {
            pushFollow(FOLLOW_dottedId_in_annotationType10311);
            did=dottedId();

            state._fsp--;
            if (state.failed) return ref;
            if ( state.backtracking==0 ) {
              ref = did;
            }

            }


            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return ref;
    }
    // $ANTLR end "annotationType"


    // $ANTLR start "wordListExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1745:1: wordListExpression returns [WordListExpression expr = null] : (id= Identifier | path= RessourceLiteral );
    public final WordListExpression wordListExpression() throws RecognitionException {
        WordListExpression expr =  null;

        Token id=null;
        Token path=null;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1746:2: (id= Identifier | path= RessourceLiteral )
            int alt190=2;
            int LA190_0 = input.LA(1);

            if ( (LA190_0==Identifier) ) {
                alt190=1;
            }
            else if ( (LA190_0==RessourceLiteral) ) {
                alt190=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 190, 0, input);

                throw nvae;
            }
            switch (alt190) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1747:2: id= Identifier
                    {
                    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_wordListExpression10336); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createReferenceWordListExpression(id);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1750:2: path= RessourceLiteral
                    {
                    path=(Token)match(input,RessourceLiteral,FOLLOW_RessourceLiteral_in_wordListExpression10349); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createLiteralWordListExpression(path);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "wordListExpression"


    // $ANTLR start "wordTableExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1755:1: wordTableExpression returns [WordTableExpression expr = null] : (id= Identifier | path= RessourceLiteral );
    public final WordTableExpression wordTableExpression() throws RecognitionException {
        WordTableExpression expr =  null;

        Token id=null;
        Token path=null;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1756:2: (id= Identifier | path= RessourceLiteral )
            int alt191=2;
            int LA191_0 = input.LA(1);

            if ( (LA191_0==Identifier) ) {
                alt191=1;
            }
            else if ( (LA191_0==RessourceLiteral) ) {
                alt191=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 191, 0, input);

                throw nvae;
            }
            switch (alt191) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1757:2: id= Identifier
                    {
                    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_wordTableExpression10373); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createReferenceWordTableExpression(id);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1760:2: path= RessourceLiteral
                    {
                    path=(Token)match(input,RessourceLiteral,FOLLOW_RessourceLiteral_in_wordTableExpression10386); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createLiteralWordTableExpression(path);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "wordTableExpression"


    // $ANTLR start "numberFunction"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1765:1: numberFunction returns [NumberExpression expr = null] : ( (op= ( EXP | LOGN | SIN | COS | TAN ) numExprP= numberExpressionInPar ) | (e= externalNumberFunction )=>e= externalNumberFunction );
    public final NumberExpression numberFunction() throws RecognitionException {
        NumberExpression expr =  null;

        Token op=null;
        NumberExpression numExprP = null;

        NumberExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1766:2: ( (op= ( EXP | LOGN | SIN | COS | TAN ) numExprP= numberExpressionInPar ) | (e= externalNumberFunction )=>e= externalNumberFunction )
            int alt192=2;
            int LA192_0 = input.LA(1);

            if ( ((LA192_0>=EXP && LA192_0<=TAN)) ) {
                alt192=1;
            }
            else if ( (LA192_0==Identifier) && (synpred40_RutaParser())) {
                alt192=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 192, 0, input);

                throw nvae;
            }
            switch (alt192) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1767:2: (op= ( EXP | LOGN | SIN | COS | TAN ) numExprP= numberExpressionInPar )
                    {
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1767:2: (op= ( EXP | LOGN | SIN | COS | TAN ) numExprP= numberExpressionInPar )
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1767:3: op= ( EXP | LOGN | SIN | COS | TAN ) numExprP= numberExpressionInPar
                    {
                    op=(Token)input.LT(1);
                    if ( (input.LA(1)>=EXP && input.LA(1)<=TAN) ) {
                        input.consume();
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return expr;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }

                    pushFollow(FOLLOW_numberExpressionInPar_in_numberFunction10431);
                    numExprP=numberExpressionInPar();

                    state._fsp--;
                    if (state.failed) return expr;

                    }

                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createComposedNumberExpression(numExprP,op);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1770:4: (e= externalNumberFunction )=>e= externalNumberFunction
                    {
                    pushFollow(FOLLOW_externalNumberFunction_in_numberFunction10455);
                    e=externalNumberFunction();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "numberFunction"


    // $ANTLR start "externalNumberFunction"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1775:1: externalNumberFunction returns [NumberExpression expr = null] : id= Identifier LPAREN (args= varArgumentList )? RPAREN ;
    public final NumberExpression externalNumberFunction() throws RecognitionException {
        NumberExpression expr =  null;

        Token id=null;
        List args = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1776:2: (id= Identifier LPAREN (args= varArgumentList )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1778:2: id= Identifier LPAREN (args= varArgumentList )? RPAREN
            {
            id=(Token)match(input,Identifier,FOLLOW_Identifier_in_externalNumberFunction10481); if (state.failed) return expr;
            match(input,LPAREN,FOLLOW_LPAREN_in_externalNumberFunction10483); if (state.failed) return expr;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1779:7: (args= varArgumentList )?
            int alt193=2;
            int LA193_0 = input.LA(1);

            if ( (LA193_0==REMOVESTRING||(LA193_0>=EXP && LA193_0<=FALSE)||LA193_0==DecimalLiteral||LA193_0==FloatingPointLiteral||LA193_0==StringLiteral||(LA193_0>=Identifier && LA193_0<=LPAREN)||LA193_0==MINUS) ) {
                alt193=1;
            }
            switch (alt193) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1779:7: args= varArgumentList
                    {
                    pushFollow(FOLLOW_varArgumentList_in_externalNumberFunction10490);
                    args=varArgumentList();

                    state._fsp--;
                    if (state.failed) return expr;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_externalNumberFunction10493); if (state.failed) return expr;
            if ( state.backtracking==0 ) {

              		expr = external.createExternalNumberFunction(id, args);
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "externalNumberFunction"


    // $ANTLR start "numberVariable"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1785:1: numberVariable returns [Token ref = null] : ({...}?token1= Identifier | {...}?token2= Identifier | {...}?token2= Identifier );
    public final Token numberVariable() throws RecognitionException {
        Token ref =  null;

        Token token1=null;
        Token token2=null;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1786:2: ({...}?token1= Identifier | {...}?token2= Identifier | {...}?token2= Identifier )
            int alt194=3;
            int LA194_0 = input.LA(1);

            if ( (LA194_0==Identifier) ) {
                int LA194_1 = input.LA(2);

                if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INT"))) ) {
                    alt194=1;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLE"))) ) {
                    alt194=2;
                }
                else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOAT"))) ) {
                    alt194=3;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ref;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 194, 1, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ref;}
                NoViableAltException nvae =
                    new NoViableAltException("", 194, 0, input);

                throw nvae;
            }
            switch (alt194) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1787:2: {...}?token1= Identifier
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INT"))) ) {
                        if (state.backtracking>0) {state.failed=true; return ref;}
                        throw new FailedPredicateException(input, "numberVariable", "isVariableOfType($blockDeclaration::env,input.LT(1).getText(), \"INT\")");
                    }
                    token1=(Token)match(input,Identifier,FOLLOW_Identifier_in_numberVariable10518); if (state.failed) return ref;
                    if ( state.backtracking==0 ) {
                      ref = token1;
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1788:4: {...}?token2= Identifier
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLE"))) ) {
                        if (state.backtracking>0) {state.failed=true; return ref;}
                        throw new FailedPredicateException(input, "numberVariable", "isVariableOfType($blockDeclaration::env,input.LT(1).getText(), \"DOUBLE\")");
                    }
                    token2=(Token)match(input,Identifier,FOLLOW_Identifier_in_numberVariable10531); if (state.failed) return ref;
                    if ( state.backtracking==0 ) {
                      ref = token2;
                    }

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1789:4: {...}?token2= Identifier
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOAT"))) ) {
                        if (state.backtracking>0) {state.failed=true; return ref;}
                        throw new FailedPredicateException(input, "numberVariable", "isVariableOfType($blockDeclaration::env,input.LT(1).getText(), \"FLOAT\")");
                    }
                    token2=(Token)match(input,Identifier,FOLLOW_Identifier_in_numberVariable10544); if (state.failed) return ref;
                    if ( state.backtracking==0 ) {
                      ref = token2;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return ref;
    }
    // $ANTLR end "numberVariable"


    // $ANTLR start "additiveExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1793:1: additiveExpression returns [NumberExpression expr = null] : e= multiplicativeExpression (op= ( PLUS | MINUS ) e= multiplicativeExpression )* ;
    public final NumberExpression additiveExpression() throws RecognitionException {
        NumberExpression expr =  null;

        Token op=null;
        NumberExpression e = null;


        List<NumberExpression> exprs = new ArrayList<NumberExpression>();
        	List<Token> ops = new ArrayList<Token>();
        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1796:2: (e= multiplicativeExpression (op= ( PLUS | MINUS ) e= multiplicativeExpression )* )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1797:2: e= multiplicativeExpression (op= ( PLUS | MINUS ) e= multiplicativeExpression )*
            {
            pushFollow(FOLLOW_multiplicativeExpression_in_additiveExpression10574);
            e=multiplicativeExpression();

            state._fsp--;
            if (state.failed) return expr;
            if ( state.backtracking==0 ) {
              exprs.add(e);
            }
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1797:46: (op= ( PLUS | MINUS ) e= multiplicativeExpression )*
            loop195:
            do {
                int alt195=2;
                int LA195_0 = input.LA(1);

                if ( ((LA195_0>=PLUS && LA195_0<=MINUS)) ) {
                    alt195=1;
                }


                switch (alt195) {
            	case 1 :
            	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1797:48: op= ( PLUS | MINUS ) e= multiplicativeExpression
            	    {
            	    op=(Token)input.LT(1);
            	    if ( (input.LA(1)>=PLUS && input.LA(1)<=MINUS) ) {
            	        input.consume();
            	        state.errorRecovery=false;state.failed=false;
            	    }
            	    else {
            	        if (state.backtracking>0) {state.failed=true; return expr;}
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        throw mse;
            	    }

            	    if ( state.backtracking==0 ) {
            	      ops.add(op);
            	    }
            	    pushFollow(FOLLOW_multiplicativeExpression_in_additiveExpression10596);
            	    e=multiplicativeExpression();

            	    state._fsp--;
            	    if (state.failed) return expr;
            	    if ( state.backtracking==0 ) {
            	      exprs.add(e);
            	    }

            	    }
            	    break;

            	default :
            	    break loop195;
                }
            } while (true);

            if ( state.backtracking==0 ) {
              expr = ExpressionFactory.createComposedNumberExpression(exprs,ops);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "additiveExpression"


    // $ANTLR start "multiplicativeExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1801:1: multiplicativeExpression returns [NumberExpression expr = null] : (e= simpleNumberExpression (op= ( STAR | SLASH | PERCENT ) e= simpleNumberExpression )* | e1= numberFunction ) ;
    public final NumberExpression multiplicativeExpression() throws RecognitionException {
        NumberExpression expr =  null;

        Token op=null;
        NumberExpression e = null;

        NumberExpression e1 = null;


        List<NumberExpression> exprs = new ArrayList<NumberExpression>();
        	List<Token> ops = new ArrayList<Token>();
        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1804:2: ( (e= simpleNumberExpression (op= ( STAR | SLASH | PERCENT ) e= simpleNumberExpression )* | e1= numberFunction ) )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1805:2: (e= simpleNumberExpression (op= ( STAR | SLASH | PERCENT ) e= simpleNumberExpression )* | e1= numberFunction )
            {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1805:2: (e= simpleNumberExpression (op= ( STAR | SLASH | PERCENT ) e= simpleNumberExpression )* | e1= numberFunction )
            int alt197=2;
            switch ( input.LA(1) ) {
            case DecimalLiteral:
            case FloatingPointLiteral:
            case LPAREN:
            case MINUS:
                {
                alt197=1;
                }
                break;
            case Identifier:
                {
                int LA197_2 = input.LA(2);

                if ( (LA197_2==LPAREN) ) {
                    alt197=2;
                }
                else if ( (LA197_2==EOF||LA197_2==RPAREN||LA197_2==RBRACK||(LA197_2>=COMMA && LA197_2<=SLASH)||(LA197_2>=LESS && LA197_2<=PERCENT)||(LA197_2>=EQUAL && LA197_2<=NOTEQUAL)||(LA197_2>=LESSEQUAL && LA197_2<=GREATEREQUAL)) ) {
                    alt197=1;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return expr;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 197, 2, input);

                    throw nvae;
                }
                }
                break;
            case EXP:
            case LOGN:
            case SIN:
            case COS:
            case TAN:
                {
                alt197=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 197, 0, input);

                throw nvae;
            }

            switch (alt197) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1805:3: e= simpleNumberExpression (op= ( STAR | SLASH | PERCENT ) e= simpleNumberExpression )*
                    {
                    pushFollow(FOLLOW_simpleNumberExpression_in_multiplicativeExpression10629);
                    e=simpleNumberExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      exprs.add(e);
                    }
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1805:45: (op= ( STAR | SLASH | PERCENT ) e= simpleNumberExpression )*
                    loop196:
                    do {
                        int alt196=2;
                        int LA196_0 = input.LA(1);

                        if ( ((LA196_0>=STAR && LA196_0<=SLASH)||LA196_0==PERCENT) ) {
                            alt196=1;
                        }


                        switch (alt196) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1805:47: op= ( STAR | SLASH | PERCENT ) e= simpleNumberExpression
                    	    {
                    	    op=(Token)input.LT(1);
                    	    if ( (input.LA(1)>=STAR && input.LA(1)<=SLASH)||input.LA(1)==PERCENT ) {
                    	        input.consume();
                    	        state.errorRecovery=false;state.failed=false;
                    	    }
                    	    else {
                    	        if (state.backtracking>0) {state.failed=true; return expr;}
                    	        MismatchedSetException mse = new MismatchedSetException(null,input);
                    	        throw mse;
                    	    }

                    	    if ( state.backtracking==0 ) {
                    	      ops.add(op);
                    	    }
                    	    pushFollow(FOLLOW_simpleNumberExpression_in_multiplicativeExpression10657);
                    	    e=simpleNumberExpression();

                    	    state._fsp--;
                    	    if (state.failed) return expr;
                    	    if ( state.backtracking==0 ) {
                    	      exprs.add(e);
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    break loop196;
                        }
                    } while (true);

                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createComposedNumberExpression(exprs,ops);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1807:6: e1= numberFunction
                    {
                    pushFollow(FOLLOW_numberFunction_in_multiplicativeExpression10675);
                    e1=numberFunction();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e1;
                    }

                    }
                    break;

            }


            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "multiplicativeExpression"


    // $ANTLR start "numberExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1810:1: numberExpression returns [NumberExpression expr = null] : e= additiveExpression ;
    public final NumberExpression numberExpression() throws RecognitionException {
        NumberExpression expr =  null;

        NumberExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1811:2: (e= additiveExpression )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1812:2: e= additiveExpression
            {
            pushFollow(FOLLOW_additiveExpression_in_numberExpression10698);
            e=additiveExpression();

            state._fsp--;
            if (state.failed) return expr;
            if ( state.backtracking==0 ) {
              expr = e;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "numberExpression"


    // $ANTLR start "numberExpressionInPar"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1815:1: numberExpressionInPar returns [NumberExpression expr = null] : LPAREN e= additiveExpression RPAREN ;
    public final NumberExpression numberExpressionInPar() throws RecognitionException {
        NumberExpression expr =  null;

        NumberExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1816:2: ( LPAREN e= additiveExpression RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1817:2: LPAREN e= additiveExpression RPAREN
            {
            match(input,LPAREN,FOLLOW_LPAREN_in_numberExpressionInPar10716); if (state.failed) return expr;
            pushFollow(FOLLOW_additiveExpression_in_numberExpressionInPar10723);
            e=additiveExpression();

            state._fsp--;
            if (state.failed) return expr;
            match(input,RPAREN,FOLLOW_RPAREN_in_numberExpressionInPar10725); if (state.failed) return expr;
            if ( state.backtracking==0 ) {
              expr = e;
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "numberExpressionInPar"


    // $ANTLR start "simpleNumberExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1820:1: simpleNumberExpression returns [NumberExpression expr = null] : ( (m= MINUS )? lit= DecimalLiteral | (m= MINUS )? lit= FloatingPointLiteral | (m= MINUS )? var= numberVariable | e= numberExpressionInPar );
    public final NumberExpression simpleNumberExpression() throws RecognitionException {
        NumberExpression expr =  null;

        Token m=null;
        Token lit=null;
        Token var = null;

        NumberExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1821:2: ( (m= MINUS )? lit= DecimalLiteral | (m= MINUS )? lit= FloatingPointLiteral | (m= MINUS )? var= numberVariable | e= numberExpressionInPar )
            int alt201=4;
            switch ( input.LA(1) ) {
            case MINUS:
                {
                switch ( input.LA(2) ) {
                case FloatingPointLiteral:
                    {
                    alt201=2;
                    }
                    break;
                case Identifier:
                    {
                    alt201=3;
                    }
                    break;
                case DecimalLiteral:
                    {
                    alt201=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return expr;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 201, 1, input);

                    throw nvae;
                }

                }
                break;
            case DecimalLiteral:
                {
                alt201=1;
                }
                break;
            case FloatingPointLiteral:
                {
                alt201=2;
                }
                break;
            case Identifier:
                {
                alt201=3;
                }
                break;
            case LPAREN:
                {
                alt201=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 201, 0, input);

                throw nvae;
            }

            switch (alt201) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1822:2: (m= MINUS )? lit= DecimalLiteral
                    {
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1822:4: (m= MINUS )?
                    int alt198=2;
                    int LA198_0 = input.LA(1);

                    if ( (LA198_0==MINUS) ) {
                        alt198=1;
                    }
                    switch (alt198) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1822:4: m= MINUS
                            {
                            m=(Token)match(input,MINUS,FOLLOW_MINUS_in_simpleNumberExpression10748); if (state.failed) return expr;

                            }
                            break;

                    }

                    lit=(Token)match(input,DecimalLiteral,FOLLOW_DecimalLiteral_in_simpleNumberExpression10755); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createIntegerExpression(lit,m);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1824:4: (m= MINUS )? lit= FloatingPointLiteral
                    {
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1824:6: (m= MINUS )?
                    int alt199=2;
                    int LA199_0 = input.LA(1);

                    if ( (LA199_0==MINUS) ) {
                        alt199=1;
                    }
                    switch (alt199) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1824:6: m= MINUS
                            {
                            m=(Token)match(input,MINUS,FOLLOW_MINUS_in_simpleNumberExpression10769); if (state.failed) return expr;

                            }
                            break;

                    }

                    lit=(Token)match(input,FloatingPointLiteral,FOLLOW_FloatingPointLiteral_in_simpleNumberExpression10776); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createDoubleExpression(lit,m);
                    }

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1825:4: (m= MINUS )? var= numberVariable
                    {
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1825:6: (m= MINUS )?
                    int alt200=2;
                    int LA200_0 = input.LA(1);

                    if ( (LA200_0==MINUS) ) {
                        alt200=1;
                    }
                    switch (alt200) {
                        case 1 :
                            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1825:6: m= MINUS
                            {
                            m=(Token)match(input,MINUS,FOLLOW_MINUS_in_simpleNumberExpression10787); if (state.failed) return expr;

                            }
                            break;

                    }

                    pushFollow(FOLLOW_numberVariable_in_simpleNumberExpression10794);
                    var=numberVariable();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createReferenceNumberExpression(var,m);
                    }

                    }
                    break;
                case 4 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1826:4: e= numberExpressionInPar
                    {
                    pushFollow(FOLLOW_numberExpressionInPar_in_simpleNumberExpression10805);
                    e=numberExpressionInPar();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "simpleNumberExpression"


    // $ANTLR start "stringExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1829:1: stringExpression returns [StringExpression expr = null] options {backtrack=true; } : (e= simpleStringExpression ( PLUS (e1= simpleStringExpression | e2= numberExpressionInPar | be= simpleBooleanExpression | te= typeExpression | le= listExpression ) )* | (e= stringFunction )=>e= stringFunction );
    public final StringExpression stringExpression() throws RecognitionException {
        StringExpression expr =  null;

        StringExpression e = null;

        StringExpression e1 = null;

        NumberExpression e2 = null;

        BooleanExpression be = null;

        TypeExpression te = null;

        ListExpression le = null;



        List<StringExpression> exprs = new ArrayList<StringExpression>();

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1836:2: (e= simpleStringExpression ( PLUS (e1= simpleStringExpression | e2= numberExpressionInPar | be= simpleBooleanExpression | te= typeExpression | le= listExpression ) )* | (e= stringFunction )=>e= stringFunction )
            int alt204=2;
            int LA204_0 = input.LA(1);

            if ( (LA204_0==StringLiteral) ) {
                alt204=1;
            }
            else if ( (LA204_0==Identifier) ) {
                int LA204_2 = input.LA(2);

                if ( (LA204_2==LPAREN) && (synpred42_RutaParser())) {
                    alt204=2;
                }
                else if ( (LA204_2==EOF||LA204_2==THEN||LA204_2==RPAREN||(LA204_2>=COMMA && LA204_2<=PLUS)||LA204_2==ASSIGN_EQUAL) ) {
                    alt204=1;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return expr;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 204, 2, input);

                    throw nvae;
                }
            }
            else if ( (LA204_0==REMOVESTRING) && (synpred42_RutaParser())) {
                alt204=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 204, 0, input);

                throw nvae;
            }
            switch (alt204) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1837:2: e= simpleStringExpression ( PLUS (e1= simpleStringExpression | e2= numberExpressionInPar | be= simpleBooleanExpression | te= typeExpression | le= listExpression ) )*
                    {
                    pushFollow(FOLLOW_simpleStringExpression_in_stringExpression10845);
                    e=simpleStringExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      exprs.add(e);
                    }
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1838:2: ( PLUS (e1= simpleStringExpression | e2= numberExpressionInPar | be= simpleBooleanExpression | te= typeExpression | le= listExpression ) )*
                    loop203:
                    do {
                        int alt203=2;
                        int LA203_0 = input.LA(1);

                        if ( (LA203_0==PLUS) ) {
                            alt203=1;
                        }


                        switch (alt203) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1838:3: PLUS (e1= simpleStringExpression | e2= numberExpressionInPar | be= simpleBooleanExpression | te= typeExpression | le= listExpression )
                    	    {
                    	    match(input,PLUS,FOLLOW_PLUS_in_stringExpression10852); if (state.failed) return expr;
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1838:8: (e1= simpleStringExpression | e2= numberExpressionInPar | be= simpleBooleanExpression | te= typeExpression | le= listExpression )
                    	    int alt202=5;
                    	    switch ( input.LA(1) ) {
                    	    case StringLiteral:
                    	        {
                    	        alt202=1;
                    	        }
                    	        break;
                    	    case Identifier:
                    	        {
                    	        int LA202_2 = input.LA(2);

                    	        if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRING"))) ) {
                    	            alt202=1;
                    	        }
                    	        else if ( ((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEAN"))) ) {
                    	            alt202=3;
                    	        }
                    	        else if ( (!((((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRING"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLELIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOATLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRINGLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INTLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEANLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEAN")))))) ) {
                    	            alt202=4;
                    	        }
                    	        else if ( (((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPELIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLELIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOATLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRINGLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEANLIST"))||(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INTLIST")))) ) {
                    	            alt202=5;
                    	        }
                    	        else {
                    	            if (state.backtracking>0) {state.failed=true; return expr;}
                    	            NoViableAltException nvae =
                    	                new NoViableAltException("", 202, 2, input);

                    	            throw nvae;
                    	        }
                    	        }
                    	        break;
                    	    case LPAREN:
                    	        {
                    	        alt202=2;
                    	        }
                    	        break;
                    	    case TRUE:
                    	    case FALSE:
                    	        {
                    	        alt202=3;
                    	        }
                    	        break;
                    	    case LCURLY:
                    	        {
                    	        alt202=5;
                    	        }
                    	        break;
                    	    default:
                    	        if (state.backtracking>0) {state.failed=true; return expr;}
                    	        NoViableAltException nvae =
                    	            new NoViableAltException("", 202, 0, input);

                    	        throw nvae;
                    	    }

                    	    switch (alt202) {
                    	        case 1 :
                    	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1838:9: e1= simpleStringExpression
                    	            {
                    	            pushFollow(FOLLOW_simpleStringExpression_in_stringExpression10859);
                    	            e1=simpleStringExpression();

                    	            state._fsp--;
                    	            if (state.failed) return expr;
                    	            if ( state.backtracking==0 ) {
                    	              exprs.add(e1);
                    	            }

                    	            }
                    	            break;
                    	        case 2 :
                    	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1839:5: e2= numberExpressionInPar
                    	            {
                    	            pushFollow(FOLLOW_numberExpressionInPar_in_stringExpression10872);
                    	            e2=numberExpressionInPar();

                    	            state._fsp--;
                    	            if (state.failed) return expr;
                    	            if ( state.backtracking==0 ) {
                    	              exprs.add(e2);
                    	            }

                    	            }
                    	            break;
                    	        case 3 :
                    	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1840:5: be= simpleBooleanExpression
                    	            {
                    	            pushFollow(FOLLOW_simpleBooleanExpression_in_stringExpression10884);
                    	            be=simpleBooleanExpression();

                    	            state._fsp--;
                    	            if (state.failed) return expr;
                    	            if ( state.backtracking==0 ) {
                    	              exprs.add(be);
                    	            }

                    	            }
                    	            break;
                    	        case 4 :
                    	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1841:5: te= typeExpression
                    	            {
                    	            pushFollow(FOLLOW_typeExpression_in_stringExpression10896);
                    	            te=typeExpression();

                    	            state._fsp--;
                    	            if (state.failed) return expr;
                    	            if ( state.backtracking==0 ) {
                    	              exprs.add(te);
                    	            }

                    	            }
                    	            break;
                    	        case 5 :
                    	            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1842:5: le= listExpression
                    	            {
                    	            pushFollow(FOLLOW_listExpression_in_stringExpression10908);
                    	            le=listExpression();

                    	            state._fsp--;
                    	            if (state.failed) return expr;
                    	            if ( state.backtracking==0 ) {
                    	              exprs.add(le);
                    	            }

                    	            }
                    	            break;

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop203;
                        }
                    } while (true);

                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createComposedStringExpression(exprs);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1845:3: (e= stringFunction )=>e= stringFunction
                    {
                    pushFollow(FOLLOW_stringFunction_in_stringExpression10936);
                    e=stringFunction();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "stringExpression"


    // $ANTLR start "stringFunction"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1849:1: stringFunction returns [StringExpression expr = null] : (name= REMOVESTRING LPAREN var= variable ( COMMA t= stringExpression )+ RPAREN | (e= externalStringFunction )=>e= externalStringFunction );
    public final StringExpression stringFunction() throws RecognitionException {
        StringExpression expr =  null;

        Token name=null;
        Token var = null;

        StringExpression t = null;

        StringExpression e = null;


        List<StringExpression> list = new ArrayList<StringExpression>();
        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1851:1: (name= REMOVESTRING LPAREN var= variable ( COMMA t= stringExpression )+ RPAREN | (e= externalStringFunction )=>e= externalStringFunction )
            int alt206=2;
            int LA206_0 = input.LA(1);

            if ( (LA206_0==REMOVESTRING) ) {
                alt206=1;
            }
            else if ( (LA206_0==Identifier) && (synpred43_RutaParser())) {
                alt206=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 206, 0, input);

                throw nvae;
            }
            switch (alt206) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1852:2: name= REMOVESTRING LPAREN var= variable ( COMMA t= stringExpression )+ RPAREN
                    {
                    name=(Token)match(input,REMOVESTRING,FOLLOW_REMOVESTRING_in_stringFunction10963); if (state.failed) return expr;
                    match(input,LPAREN,FOLLOW_LPAREN_in_stringFunction10965); if (state.failed) return expr;
                    pushFollow(FOLLOW_variable_in_stringFunction10971);
                    var=variable();

                    state._fsp--;
                    if (state.failed) return expr;
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1852:44: ( COMMA t= stringExpression )+
                    int cnt205=0;
                    loop205:
                    do {
                        int alt205=2;
                        int LA205_0 = input.LA(1);

                        if ( (LA205_0==COMMA) ) {
                            alt205=1;
                        }


                        switch (alt205) {
                    	case 1 :
                    	    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1852:45: COMMA t= stringExpression
                    	    {
                    	    match(input,COMMA,FOLLOW_COMMA_in_stringFunction10974); if (state.failed) return expr;
                    	    pushFollow(FOLLOW_stringExpression_in_stringFunction10980);
                    	    t=stringExpression();

                    	    state._fsp--;
                    	    if (state.failed) return expr;
                    	    if ( state.backtracking==0 ) {
                    	      list.add(t);
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt205 >= 1 ) break loop205;
                    	    if (state.backtracking>0) {state.failed=true; return expr;}
                                EarlyExitException eee =
                                    new EarlyExitException(205, input);
                                throw eee;
                        }
                        cnt205++;
                    } while (true);

                    match(input,RPAREN,FOLLOW_RPAREN_in_stringFunction10986); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = StringFunctionFactory.createRemoveFunction(var,list);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1855:2: (e= externalStringFunction )=>e= externalStringFunction
                    {
                    pushFollow(FOLLOW_externalStringFunction_in_stringFunction11008);
                    e=externalStringFunction();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "stringFunction"


    // $ANTLR start "externalStringFunction"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1859:1: externalStringFunction returns [StringExpression expr = null] : id= Identifier LPAREN (args= varArgumentList )? RPAREN ;
    public final StringExpression externalStringFunction() throws RecognitionException {
        StringExpression expr =  null;

        Token id=null;
        List args = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1860:2: (id= Identifier LPAREN (args= varArgumentList )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1862:2: id= Identifier LPAREN (args= varArgumentList )? RPAREN
            {
            id=(Token)match(input,Identifier,FOLLOW_Identifier_in_externalStringFunction11033); if (state.failed) return expr;
            match(input,LPAREN,FOLLOW_LPAREN_in_externalStringFunction11035); if (state.failed) return expr;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1863:7: (args= varArgumentList )?
            int alt207=2;
            int LA207_0 = input.LA(1);

            if ( (LA207_0==REMOVESTRING||(LA207_0>=EXP && LA207_0<=FALSE)||LA207_0==DecimalLiteral||LA207_0==FloatingPointLiteral||LA207_0==StringLiteral||(LA207_0>=Identifier && LA207_0<=LPAREN)||LA207_0==MINUS) ) {
                alt207=1;
            }
            switch (alt207) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1863:7: args= varArgumentList
                    {
                    pushFollow(FOLLOW_varArgumentList_in_externalStringFunction11042);
                    args=varArgumentList();

                    state._fsp--;
                    if (state.failed) return expr;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_externalStringFunction11045); if (state.failed) return expr;
            if ( state.backtracking==0 ) {

              		expr = external.createExternalStringFunction(id, args);
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "externalStringFunction"


    // $ANTLR start "simpleStringExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1869:1: simpleStringExpression returns [StringExpression expr = null] : (lit= StringLiteral | {...}?id= Identifier );
    public final StringExpression simpleStringExpression() throws RecognitionException {
        StringExpression expr =  null;

        Token lit=null;
        Token id=null;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1870:2: (lit= StringLiteral | {...}?id= Identifier )
            int alt208=2;
            int LA208_0 = input.LA(1);

            if ( (LA208_0==StringLiteral) ) {
                alt208=1;
            }
            else if ( (LA208_0==Identifier) ) {
                alt208=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 208, 0, input);

                throw nvae;
            }
            switch (alt208) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1871:2: lit= StringLiteral
                    {
                    lit=(Token)match(input,StringLiteral,FOLLOW_StringLiteral_in_simpleStringExpression11069); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createSimpleStringExpression(lit);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1872:4: {...}?id= Identifier
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRING"))) ) {
                        if (state.backtracking>0) {state.failed=true; return expr;}
                        throw new FailedPredicateException(input, "simpleStringExpression", "isVariableOfType($blockDeclaration::env,input.LT(1).getText(), \"STRING\")");
                    }
                    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_simpleStringExpression11083); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createReferenceStringExpression(id);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "simpleStringExpression"


    // $ANTLR start "booleanExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1876:1: booleanExpression returns [BooleanExpression expr = null] : ( (e= composedBooleanExpression )=>e= composedBooleanExpression | sbE= simpleBooleanExpression );
    public final BooleanExpression booleanExpression() throws RecognitionException {
        BooleanExpression expr =  null;

        BooleanExpression e = null;

        BooleanExpression sbE = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1877:2: ( (e= composedBooleanExpression )=>e= composedBooleanExpression | sbE= simpleBooleanExpression )
            int alt209=2;
            alt209 = dfa209.predict(input);
            switch (alt209) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1878:2: (e= composedBooleanExpression )=>e= composedBooleanExpression
                    {
                    pushFollow(FOLLOW_composedBooleanExpression_in_booleanExpression11116);
                    e=composedBooleanExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e;
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1879:3: sbE= simpleBooleanExpression
                    {
                    pushFollow(FOLLOW_simpleBooleanExpression_in_booleanExpression11127);
                    sbE=simpleBooleanExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = sbE;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "booleanExpression"


    // $ANTLR start "simpleBooleanExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1882:1: simpleBooleanExpression returns [BooleanExpression expr = null] : (e= literalBooleanExpression | {...}?id= Identifier );
    public final BooleanExpression simpleBooleanExpression() throws RecognitionException {
        BooleanExpression expr =  null;

        Token id=null;
        BooleanExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1883:2: (e= literalBooleanExpression | {...}?id= Identifier )
            int alt210=2;
            int LA210_0 = input.LA(1);

            if ( ((LA210_0>=TRUE && LA210_0<=FALSE)) ) {
                alt210=1;
            }
            else if ( (LA210_0==Identifier) ) {
                alt210=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 210, 0, input);

                throw nvae;
            }
            switch (alt210) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1884:3: e= literalBooleanExpression
                    {
                    pushFollow(FOLLOW_literalBooleanExpression_in_simpleBooleanExpression11150);
                    e=literalBooleanExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e;
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1885:4: {...}?id= Identifier
                    {
                    if ( !((isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEAN"))) ) {
                        if (state.backtracking>0) {state.failed=true; return expr;}
                        throw new FailedPredicateException(input, "simpleBooleanExpression", "isVariableOfType($blockDeclaration::env,input.LT(1).getText(), \"BOOLEAN\")");
                    }
                    id=(Token)match(input,Identifier,FOLLOW_Identifier_in_simpleBooleanExpression11165); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createReferenceBooleanExpression(id);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "simpleBooleanExpression"


    // $ANTLR start "composedBooleanExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1890:1: composedBooleanExpression returns [BooleanExpression expr = null] : ( (e2= booleanCompare )=>e2= booleanCompare | (bte= booleanTypeExpression )=>bte= booleanTypeExpression | (bne= booleanNumberExpression )=>bne= booleanNumberExpression | e1= booleanFunction );
    public final BooleanExpression composedBooleanExpression() throws RecognitionException {
        BooleanExpression expr =  null;

        BooleanExpression e2 = null;

        BooleanExpression bte = null;

        BooleanExpression bne = null;

        BooleanExpression e1 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1892:2: ( (e2= booleanCompare )=>e2= booleanCompare | (bte= booleanTypeExpression )=>bte= booleanTypeExpression | (bne= booleanNumberExpression )=>bne= booleanNumberExpression | e1= booleanFunction )
            int alt211=4;
            int LA211_0 = input.LA(1);

            if ( (LA211_0==TRUE) && (synpred45_RutaParser())) {
                alt211=1;
            }
            else if ( (LA211_0==FALSE) && (synpred45_RutaParser())) {
                alt211=1;
            }
            else if ( (LA211_0==Identifier) ) {
                int LA211_3 = input.LA(2);

                if ( ((synpred45_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEAN")))) ) {
                    alt211=1;
                }
                else if ( (((synpred46_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPE")))||synpred46_RutaParser())) ) {
                    alt211=2;
                }
                else if ( (true) ) {
                    alt211=4;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return expr;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 211, 3, input);

                    throw nvae;
                }
            }
            else if ( (LA211_0==LPAREN) && (synpred47_RutaParser())) {
                alt211=3;
            }
            else if ( (LA211_0==XOR) ) {
                alt211=4;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 211, 0, input);

                throw nvae;
            }
            switch (alt211) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1893:2: (e2= booleanCompare )=>e2= booleanCompare
                    {
                    pushFollow(FOLLOW_booleanCompare_in_composedBooleanExpression11199);
                    e2=booleanCompare();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e2;
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1894:4: (bte= booleanTypeExpression )=>bte= booleanTypeExpression
                    {
                    pushFollow(FOLLOW_booleanTypeExpression_in_composedBooleanExpression11219);
                    bte=booleanTypeExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = bte;
                    }

                    }
                    break;
                case 3 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1895:4: (bne= booleanNumberExpression )=>bne= booleanNumberExpression
                    {
                    pushFollow(FOLLOW_booleanNumberExpression_in_composedBooleanExpression11238);
                    bne=booleanNumberExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = bne;
                    }

                    }
                    break;
                case 4 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1896:4: e1= booleanFunction
                    {
                    pushFollow(FOLLOW_booleanFunction_in_composedBooleanExpression11248);
                    e1=booleanFunction();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e1;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "composedBooleanExpression"


    // $ANTLR start "booleanFunction"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1900:1: booleanFunction returns [BooleanExpression expr = null] : ( (op= XOR LPAREN e1= booleanExpression COMMA e2= booleanExpression RPAREN ) | (e= externalBooleanFunction )=>e= externalBooleanFunction );
    public final BooleanExpression booleanFunction() throws RecognitionException {
        BooleanExpression expr =  null;

        Token op=null;
        BooleanExpression e1 = null;

        BooleanExpression e2 = null;

        BooleanExpression e = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1902:2: ( (op= XOR LPAREN e1= booleanExpression COMMA e2= booleanExpression RPAREN ) | (e= externalBooleanFunction )=>e= externalBooleanFunction )
            int alt212=2;
            int LA212_0 = input.LA(1);

            if ( (LA212_0==XOR) ) {
                alt212=1;
            }
            else if ( (LA212_0==Identifier) && (synpred48_RutaParser())) {
                alt212=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 212, 0, input);

                throw nvae;
            }
            switch (alt212) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1903:2: (op= XOR LPAREN e1= booleanExpression COMMA e2= booleanExpression RPAREN )
                    {
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1903:2: (op= XOR LPAREN e1= booleanExpression COMMA e2= booleanExpression RPAREN )
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1903:3: op= XOR LPAREN e1= booleanExpression COMMA e2= booleanExpression RPAREN
                    {
                    op=(Token)match(input,XOR,FOLLOW_XOR_in_booleanFunction11273); if (state.failed) return expr;
                    match(input,LPAREN,FOLLOW_LPAREN_in_booleanFunction11275); if (state.failed) return expr;
                    pushFollow(FOLLOW_booleanExpression_in_booleanFunction11281);
                    e1=booleanExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    match(input,COMMA,FOLLOW_COMMA_in_booleanFunction11283); if (state.failed) return expr;
                    pushFollow(FOLLOW_booleanExpression_in_booleanFunction11289);
                    e2=booleanExpression();

                    state._fsp--;
                    if (state.failed) return expr;
                    match(input,RPAREN,FOLLOW_RPAREN_in_booleanFunction11291); if (state.failed) return expr;

                    }

                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createBooleanFunction(op,e1,e2);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1905:4: (e= externalBooleanFunction )=>e= externalBooleanFunction
                    {
                    pushFollow(FOLLOW_externalBooleanFunction_in_booleanFunction11313);
                    e=externalBooleanFunction();

                    state._fsp--;
                    if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = e;
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "booleanFunction"


    // $ANTLR start "externalBooleanFunction"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1909:1: externalBooleanFunction returns [BooleanExpression expr = null] : id= Identifier LPAREN (args= varArgumentList )? RPAREN ;
    public final BooleanExpression externalBooleanFunction() throws RecognitionException {
        BooleanExpression expr =  null;

        Token id=null;
        List args = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1910:2: (id= Identifier LPAREN (args= varArgumentList )? RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1912:2: id= Identifier LPAREN (args= varArgumentList )? RPAREN
            {
            id=(Token)match(input,Identifier,FOLLOW_Identifier_in_externalBooleanFunction11338); if (state.failed) return expr;
            match(input,LPAREN,FOLLOW_LPAREN_in_externalBooleanFunction11340); if (state.failed) return expr;
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1913:7: (args= varArgumentList )?
            int alt213=2;
            int LA213_0 = input.LA(1);

            if ( (LA213_0==REMOVESTRING||(LA213_0>=EXP && LA213_0<=FALSE)||LA213_0==DecimalLiteral||LA213_0==FloatingPointLiteral||LA213_0==StringLiteral||(LA213_0>=Identifier && LA213_0<=LPAREN)||LA213_0==MINUS) ) {
                alt213=1;
            }
            switch (alt213) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1913:7: args= varArgumentList
                    {
                    pushFollow(FOLLOW_varArgumentList_in_externalBooleanFunction11347);
                    args=varArgumentList();

                    state._fsp--;
                    if (state.failed) return expr;

                    }
                    break;

            }

            match(input,RPAREN,FOLLOW_RPAREN_in_externalBooleanFunction11350); if (state.failed) return expr;
            if ( state.backtracking==0 ) {

              		expr = external.createExternalBooleanFunction(id, args);
              	
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "externalBooleanFunction"


    // $ANTLR start "booleanCompare"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1920:1: booleanCompare returns [BooleanExpression expr = null] : (e1= simpleBooleanExpression op= ( EQUAL | NOTEQUAL ) e2= booleanExpression ) ;
    public final BooleanExpression booleanCompare() throws RecognitionException {
        BooleanExpression expr =  null;

        Token op=null;
        BooleanExpression e1 = null;

        BooleanExpression e2 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1921:2: ( (e1= simpleBooleanExpression op= ( EQUAL | NOTEQUAL ) e2= booleanExpression ) )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1922:2: (e1= simpleBooleanExpression op= ( EQUAL | NOTEQUAL ) e2= booleanExpression )
            {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1922:2: (e1= simpleBooleanExpression op= ( EQUAL | NOTEQUAL ) e2= booleanExpression )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1922:3: e1= simpleBooleanExpression op= ( EQUAL | NOTEQUAL ) e2= booleanExpression
            {
            pushFollow(FOLLOW_simpleBooleanExpression_in_booleanCompare11375);
            e1=simpleBooleanExpression();

            state._fsp--;
            if (state.failed) return expr;
            op=(Token)input.LT(1);
            if ( (input.LA(1)>=EQUAL && input.LA(1)<=NOTEQUAL) ) {
                input.consume();
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            pushFollow(FOLLOW_booleanExpression_in_booleanCompare11393);
            e2=booleanExpression();

            state._fsp--;
            if (state.failed) return expr;

            }

            if ( state.backtracking==0 ) {
              expr = ExpressionFactory.createBooleanFunction(op,e1,e2);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "booleanCompare"


    // $ANTLR start "literalBooleanExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1927:1: literalBooleanExpression returns [BooleanExpression expr = null] : (v= TRUE | v= FALSE );
    public final BooleanExpression literalBooleanExpression() throws RecognitionException {
        BooleanExpression expr =  null;

        Token v=null;

        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1928:2: (v= TRUE | v= FALSE )
            int alt214=2;
            int LA214_0 = input.LA(1);

            if ( (LA214_0==TRUE) ) {
                alt214=1;
            }
            else if ( (LA214_0==FALSE) ) {
                alt214=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                NoViableAltException nvae =
                    new NoViableAltException("", 214, 0, input);

                throw nvae;
            }
            switch (alt214) {
                case 1 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1929:2: v= TRUE
                    {
                    v=(Token)match(input,TRUE,FOLLOW_TRUE_in_literalBooleanExpression11419); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createSimpleBooleanExpression(v);
                    }

                    }
                    break;
                case 2 :
                    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1930:4: v= FALSE
                    {
                    v=(Token)match(input,FALSE,FOLLOW_FALSE_in_literalBooleanExpression11431); if (state.failed) return expr;
                    if ( state.backtracking==0 ) {
                      expr = ExpressionFactory.createSimpleBooleanExpression(v);
                    }

                    }
                    break;

            }
        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "literalBooleanExpression"


    // $ANTLR start "booleanTypeExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1935:1: booleanTypeExpression returns [BooleanExpression expr = null] : e1= typeExpression op= ( EQUAL | NOTEQUAL ) e2= typeExpression ;
    public final BooleanExpression booleanTypeExpression() throws RecognitionException {
        BooleanExpression expr =  null;

        Token op=null;
        TypeExpression e1 = null;

        TypeExpression e2 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1936:2: (e1= typeExpression op= ( EQUAL | NOTEQUAL ) e2= typeExpression )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1937:2: e1= typeExpression op= ( EQUAL | NOTEQUAL ) e2= typeExpression
            {
            pushFollow(FOLLOW_typeExpression_in_booleanTypeExpression11457);
            e1=typeExpression();

            state._fsp--;
            if (state.failed) return expr;
            op=(Token)input.LT(1);
            if ( (input.LA(1)>=EQUAL && input.LA(1)<=NOTEQUAL) ) {
                input.consume();
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            pushFollow(FOLLOW_typeExpression_in_booleanTypeExpression11477);
            e2=typeExpression();

            state._fsp--;
            if (state.failed) return expr;
            if ( state.backtracking==0 ) {
              expr = ExpressionFactory.createBooleanTypeExpression(e1,op,e2);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "booleanTypeExpression"


    // $ANTLR start "booleanNumberExpression"
    // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1943:1: booleanNumberExpression returns [BooleanExpression expr = null] : LPAREN e1= numberExpression op= ( LESS | GREATER | GREATEREQUAL | LESSEQUAL | EQUAL | NOTEQUAL ) e2= numberExpression RPAREN ;
    public final BooleanExpression booleanNumberExpression() throws RecognitionException {
        BooleanExpression expr =  null;

        Token op=null;
        NumberExpression e1 = null;

        NumberExpression e2 = null;


        try {
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1944:2: ( LPAREN e1= numberExpression op= ( LESS | GREATER | GREATEREQUAL | LESSEQUAL | EQUAL | NOTEQUAL ) e2= numberExpression RPAREN )
            // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1945:2: LPAREN e1= numberExpression op= ( LESS | GREATER | GREATEREQUAL | LESSEQUAL | EQUAL | NOTEQUAL ) e2= numberExpression RPAREN
            {
            match(input,LPAREN,FOLLOW_LPAREN_in_booleanNumberExpression11499); if (state.failed) return expr;
            pushFollow(FOLLOW_numberExpression_in_booleanNumberExpression11506);
            e1=numberExpression();

            state._fsp--;
            if (state.failed) return expr;
            op=(Token)input.LT(1);
            if ( (input.LA(1)>=LESS && input.LA(1)<=GREATER)||(input.LA(1)>=EQUAL && input.LA(1)<=NOTEQUAL)||(input.LA(1)>=LESSEQUAL && input.LA(1)<=GREATEREQUAL) ) {
                input.consume();
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return expr;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            pushFollow(FOLLOW_numberExpression_in_booleanNumberExpression11542);
            e2=numberExpression();

            state._fsp--;
            if (state.failed) return expr;
            match(input,RPAREN,FOLLOW_RPAREN_in_booleanNumberExpression11545); if (state.failed) return expr;
            if ( state.backtracking==0 ) {
              expr = ExpressionFactory.createBooleanNumberExpression(e1,op,e2);
            }

            }

        }

        	catch (RecognitionException exception1) {
        		emitErrorMessage(exception1.toString());
        	}
        	catch (Throwable exception2) {
        		emitErrorMessage(exception2.toString());
        	}
        finally {
        }
        return expr;
    }
    // $ANTLR end "booleanNumberExpression"

    // $ANTLR start synpred1_RutaParser
    public final void synpred1_RutaParser_fragment() throws RecognitionException {   
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:513:2: ( regexpRule )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:513:3: regexpRule
        {
        pushFollow(FOLLOW_regexpRule_in_synpred1_RutaParser1666);
        regexpRule();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred1_RutaParser

    // $ANTLR start synpred2_RutaParser
    public final void synpred2_RutaParser_fragment() throws RecognitionException {   
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:536:2: ( numberExpression ASSIGN_EQUAL )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:536:3: numberExpression ASSIGN_EQUAL
        {
        pushFollow(FOLLOW_numberExpression_in_synpred2_RutaParser1744);
        numberExpression();

        state._fsp--;
        if (state.failed) return ;
        match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_synpred2_RutaParser1746); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred2_RutaParser

    // $ANTLR start synpred3_RutaParser
    public final void synpred3_RutaParser_fragment() throws RecognitionException {   
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:543:2: ( numberExpression ASSIGN_EQUAL )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:543:3: numberExpression ASSIGN_EQUAL
        {
        pushFollow(FOLLOW_numberExpression_in_synpred3_RutaParser1792);
        numberExpression();

        state._fsp--;
        if (state.failed) return ;
        match(input,ASSIGN_EQUAL,FOLLOW_ASSIGN_EQUAL_in_synpred3_RutaParser1794); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred3_RutaParser

    // $ANTLR start synpred4_RutaParser
    public final void synpred4_RutaParser_fragment() throws RecognitionException {   
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:569:4: ( ruleElementComposed[null] )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:569:5: ruleElementComposed[null]
        {
        pushFollow(FOLLOW_ruleElementComposed_in_synpred4_RutaParser1926);
        ruleElementComposed(null);

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred4_RutaParser

    // $ANTLR start synpred5_RutaParser
    public final void synpred5_RutaParser_fragment() throws RecognitionException {   
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:570:4: ( ruleElementDisjunctive[null] )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:570:5: ruleElementDisjunctive[null]
        {
        pushFollow(FOLLOW_ruleElementDisjunctive_in_synpred5_RutaParser1943);
        ruleElementDisjunctive(null);

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred5_RutaParser

    // $ANTLR start synpred6_RutaParser
    public final void synpred6_RutaParser_fragment() throws RecognitionException {   
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:571:4: ( ruleElementWildCard[null] )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:571:5: ruleElementWildCard[null]
        {
        pushFollow(FOLLOW_ruleElementWildCard_in_synpred6_RutaParser1961);
        ruleElementWildCard(null);

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred6_RutaParser

    // $ANTLR start synpred11_RutaParser
    public final void synpred11_RutaParser_fragment() throws RecognitionException {   
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:715:2: ( booleanListExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:715:3: booleanListExpression
        {
        pushFollow(FOLLOW_booleanListExpression_in_synpred11_RutaParser2695);
        booleanListExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred11_RutaParser

    // $ANTLR start synpred12_RutaParser
    public final void synpred12_RutaParser_fragment() throws RecognitionException {   
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:716:4: ( intListExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:716:5: intListExpression
        {
        pushFollow(FOLLOW_intListExpression_in_synpred12_RutaParser2711);
        intListExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred12_RutaParser

    // $ANTLR start synpred13_RutaParser
    public final void synpred13_RutaParser_fragment() throws RecognitionException {   
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:717:4: ( doubleListExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:717:5: doubleListExpression
        {
        pushFollow(FOLLOW_doubleListExpression_in_synpred13_RutaParser2727);
        doubleListExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred13_RutaParser

    // $ANTLR start synpred14_RutaParser
    public final void synpred14_RutaParser_fragment() throws RecognitionException {   
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:718:4: ( floatListExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:718:5: floatListExpression
        {
        pushFollow(FOLLOW_floatListExpression_in_synpred14_RutaParser2743);
        floatListExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred14_RutaParser

    // $ANTLR start synpred15_RutaParser
    public final void synpred15_RutaParser_fragment() throws RecognitionException {   
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:719:4: ( stringListExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:719:5: stringListExpression
        {
        pushFollow(FOLLOW_stringListExpression_in_synpred15_RutaParser2759);
        stringListExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred15_RutaParser

    // $ANTLR start synpred16_RutaParser
    public final void synpred16_RutaParser_fragment() throws RecognitionException {   
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:720:4: ( typeListExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:720:5: typeListExpression
        {
        pushFollow(FOLLOW_typeListExpression_in_synpred16_RutaParser2775);
        typeListExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred16_RutaParser

    // $ANTLR start synpred17_RutaParser
    public final void synpred17_RutaParser_fragment() throws RecognitionException {   
        NumberListExpression e1 = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:759:2: (e1= doubleListExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:759:3: e1= doubleListExpression
        {
        pushFollow(FOLLOW_doubleListExpression_in_synpred17_RutaParser2982);
        e1=doubleListExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred17_RutaParser

    // $ANTLR start synpred18_RutaParser
    public final void synpred18_RutaParser_fragment() throws RecognitionException {   
        NumberListExpression e1 = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:761:2: (e1= floatListExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:761:3: e1= floatListExpression
        {
        pushFollow(FOLLOW_floatListExpression_in_synpred18_RutaParser3003);
        e1=floatListExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred18_RutaParser

    // $ANTLR start synpred19_RutaParser
    public final void synpred19_RutaParser_fragment() throws RecognitionException {   
        TypeExpression tf = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:838:2: (tf= typeFunction )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:838:2: tf= typeFunction
        {
        pushFollow(FOLLOW_typeFunction_in_synpred19_RutaParser3411);
        tf=typeFunction();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred19_RutaParser

    // $ANTLR start synpred21_RutaParser
    public final void synpred21_RutaParser_fragment() throws RecognitionException {   
        AbstractRutaCondition c = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:948:4: (c= externalCondition )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:948:5: c= externalCondition
        {
        pushFollow(FOLLOW_externalCondition_in_synpred21_RutaParser3975);
        c=externalCondition();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred21_RutaParser

    // $ANTLR start synpred22_RutaParser
    public final void synpred22_RutaParser_fragment() throws RecognitionException {   
        ListExpression type = null;

        RutaExpression a = null;

        NumberExpression min = null;

        NumberExpression max = null;

        Token var = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:999:5: ( COUNT LPAREN type= listExpression COMMA a= argument ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:999:5: COUNT LPAREN type= listExpression COMMA a= argument ( COMMA min= numberExpression COMMA max= numberExpression )? ( COMMA var= numberVariable )? RPAREN
        {
        match(input,COUNT,FOLLOW_COUNT_in_synpred22_RutaParser4312); if (state.failed) return ;
        match(input,LPAREN,FOLLOW_LPAREN_in_synpred22_RutaParser4314); if (state.failed) return ;
        pushFollow(FOLLOW_listExpression_in_synpred22_RutaParser4320);
        type=listExpression();

        state._fsp--;
        if (state.failed) return ;
        match(input,COMMA,FOLLOW_COMMA_in_synpred22_RutaParser4322); if (state.failed) return ;
        pushFollow(FOLLOW_argument_in_synpred22_RutaParser4328);
        a=argument();

        state._fsp--;
        if (state.failed) return ;
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:999:59: ( COMMA min= numberExpression COMMA max= numberExpression )?
        int alt216=2;
        int LA216_0 = input.LA(1);

        if ( (LA216_0==COMMA) ) {
            int LA216_1 = input.LA(2);

            if ( ((LA216_1>=EXP && LA216_1<=TAN)||LA216_1==DecimalLiteral||LA216_1==FloatingPointLiteral||LA216_1==LPAREN||LA216_1==MINUS) ) {
                alt216=1;
            }
            else if ( (LA216_1==Identifier) ) {
                int LA216_4 = input.LA(3);

                if ( (LA216_4==LPAREN||LA216_4==COMMA||(LA216_4>=PLUS && LA216_4<=SLASH)||LA216_4==PERCENT) ) {
                    alt216=1;
                }
            }
        }
        switch (alt216) {
            case 1 :
                // org\\apache\\uima\\ruta\\parser\\RutaParser.g:999:60: COMMA min= numberExpression COMMA max= numberExpression
                {
                match(input,COMMA,FOLLOW_COMMA_in_synpred22_RutaParser4331); if (state.failed) return ;
                pushFollow(FOLLOW_numberExpression_in_synpred22_RutaParser4337);
                min=numberExpression();

                state._fsp--;
                if (state.failed) return ;
                match(input,COMMA,FOLLOW_COMMA_in_synpred22_RutaParser4339); if (state.failed) return ;
                pushFollow(FOLLOW_numberExpression_in_synpred22_RutaParser4345);
                max=numberExpression();

                state._fsp--;
                if (state.failed) return ;

                }
                break;

        }

        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1000:5: ( COMMA var= numberVariable )?
        int alt217=2;
        int LA217_0 = input.LA(1);

        if ( (LA217_0==COMMA) ) {
            alt217=1;
        }
        switch (alt217) {
            case 1 :
                // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1000:6: COMMA var= numberVariable
                {
                match(input,COMMA,FOLLOW_COMMA_in_synpred22_RutaParser4355); if (state.failed) return ;
                pushFollow(FOLLOW_numberVariable_in_synpred22_RutaParser4361);
                var=numberVariable();

                state._fsp--;
                if (state.failed) return ;

                }
                break;

        }

        match(input,RPAREN,FOLLOW_RPAREN_in_synpred22_RutaParser4365); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred22_RutaParser

    // $ANTLR start synpred23_RutaParser
    public final void synpred23_RutaParser_fragment() throws RecognitionException {   
        StringListExpression list2 = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1024:20: (list2= stringListExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1024:21: list2= stringListExpression
        {
        pushFollow(FOLLOW_stringListExpression_in_synpred23_RutaParser4639);
        list2=stringListExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred23_RutaParser

    // $ANTLR start synpred24_RutaParser
    public final void synpred24_RutaParser_fragment() throws RecognitionException {   
        AbstractRutaAction a = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1191:4: (a= externalAction )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1191:5: a= externalAction
        {
        pushFollow(FOLLOW_externalAction_in_synpred24_RutaParser6195);
        a=externalAction();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred24_RutaParser

    // $ANTLR start synpred25_RutaParser
    public final void synpred25_RutaParser_fragment() throws RecognitionException {   
        NumberExpression index = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1226:5: (index= numberExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1226:6: index= numberExpression
        {
        pushFollow(FOLLOW_numberExpression_in_synpred25_RutaParser6323);
        index=numberExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred25_RutaParser

    // $ANTLR start synpred26_RutaParser
    public final void synpred26_RutaParser_fragment() throws RecognitionException {   
        NumberExpression index = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1226:81: ( COMMA index= numberExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1226:82: COMMA index= numberExpression
        {
        match(input,COMMA,FOLLOW_COMMA_in_synpred26_RutaParser6336); if (state.failed) return ;
        pushFollow(FOLLOW_numberExpression_in_synpred26_RutaParser6342);
        index=numberExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred26_RutaParser

    // $ANTLR start synpred27_RutaParser
    public final void synpred27_RutaParser_fragment() throws RecognitionException {   
        BooleanExpression ignoreCase = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1243:14: (ignoreCase= booleanExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1243:15: ignoreCase= booleanExpression
        {
        pushFollow(FOLLOW_booleanExpression_in_synpred27_RutaParser6515);
        ignoreCase=booleanExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred27_RutaParser

    // $ANTLR start synpred28_RutaParser
    public final void synpred28_RutaParser_fragment() throws RecognitionException {   
        NumberExpression index = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1264:6: (index= numberExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1264:7: index= numberExpression
        {
        pushFollow(FOLLOW_numberExpression_in_synpred28_RutaParser6689);
        index=numberExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred28_RutaParser

    // $ANTLR start synpred29_RutaParser
    public final void synpred29_RutaParser_fragment() throws RecognitionException {   
        NumberExpression index = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1264:82: ( COMMA index= numberExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1264:83: COMMA index= numberExpression
        {
        match(input,COMMA,FOLLOW_COMMA_in_synpred29_RutaParser6702); if (state.failed) return ;
        pushFollow(FOLLOW_numberExpression_in_synpred29_RutaParser6708);
        index=numberExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred29_RutaParser

    // $ANTLR start synpred33_RutaParser
    public final void synpred33_RutaParser_fragment() throws RecognitionException {   
        NumberExpression score = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1367:22: (score= numberExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1367:23: score= numberExpression
        {
        pushFollow(FOLLOW_numberExpression_in_synpred33_RutaParser7513);
        score=numberExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred33_RutaParser

    // $ANTLR start synpred34_RutaParser
    public final void synpred34_RutaParser_fragment() throws RecognitionException {   
        TypeExpression type = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1367:85: (type= typeExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1367:86: type= typeExpression
        {
        pushFollow(FOLLOW_typeExpression_in_synpred34_RutaParser7533);
        type=typeExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred34_RutaParser

    // $ANTLR start synpred36_RutaParser
    public final void synpred36_RutaParser_fragment() throws RecognitionException {   
        BooleanExpression b = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1532:4: (b= booleanExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1532:5: b= booleanExpression
        {
        pushFollow(FOLLOW_booleanExpression_in_synpred36_RutaParser8857);
        b=booleanExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred36_RutaParser

    // $ANTLR start synpred37_RutaParser
    public final void synpred37_RutaParser_fragment() throws RecognitionException {   
        StringExpression a4 = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1692:2: (a4= stringExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1692:2: a4= stringExpression
        {
        pushFollow(FOLLOW_stringExpression_in_synpred37_RutaParser10080);
        a4=stringExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred37_RutaParser

    // $ANTLR start synpred38_RutaParser
    public final void synpred38_RutaParser_fragment() throws RecognitionException {   
        BooleanExpression a2 = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1693:4: (a2= booleanExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1693:4: a2= booleanExpression
        {
        pushFollow(FOLLOW_booleanExpression_in_synpred38_RutaParser10091);
        a2=booleanExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred38_RutaParser

    // $ANTLR start synpred39_RutaParser
    public final void synpred39_RutaParser_fragment() throws RecognitionException {   
        NumberExpression a3 = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1694:4: (a3= numberExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1694:4: a3= numberExpression
        {
        pushFollow(FOLLOW_numberExpression_in_synpred39_RutaParser10102);
        a3=numberExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred39_RutaParser

    // $ANTLR start synpred40_RutaParser
    public final void synpred40_RutaParser_fragment() throws RecognitionException {   
        NumberExpression e = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1770:4: (e= externalNumberFunction )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1770:5: e= externalNumberFunction
        {
        pushFollow(FOLLOW_externalNumberFunction_in_synpred40_RutaParser10447);
        e=externalNumberFunction();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred40_RutaParser

    // $ANTLR start synpred42_RutaParser
    public final void synpred42_RutaParser_fragment() throws RecognitionException {   
        StringExpression e = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1845:3: (e= stringFunction )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1845:4: e= stringFunction
        {
        pushFollow(FOLLOW_stringFunction_in_synpred42_RutaParser10928);
        e=stringFunction();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred42_RutaParser

    // $ANTLR start synpred43_RutaParser
    public final void synpred43_RutaParser_fragment() throws RecognitionException {   
        StringExpression e = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1855:2: (e= externalStringFunction )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1855:3: e= externalStringFunction
        {
        pushFollow(FOLLOW_externalStringFunction_in_synpred43_RutaParser11000);
        e=externalStringFunction();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred43_RutaParser

    // $ANTLR start synpred44_RutaParser
    public final void synpred44_RutaParser_fragment() throws RecognitionException {   
        BooleanExpression e = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1878:2: (e= composedBooleanExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1878:3: e= composedBooleanExpression
        {
        pushFollow(FOLLOW_composedBooleanExpression_in_synpred44_RutaParser11108);
        e=composedBooleanExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred44_RutaParser

    // $ANTLR start synpred45_RutaParser
    public final void synpred45_RutaParser_fragment() throws RecognitionException {   
        BooleanExpression e2 = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1893:2: (e2= booleanCompare )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1893:3: e2= booleanCompare
        {
        pushFollow(FOLLOW_booleanCompare_in_synpred45_RutaParser11191);
        e2=booleanCompare();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred45_RutaParser

    // $ANTLR start synpred46_RutaParser
    public final void synpred46_RutaParser_fragment() throws RecognitionException {   
        BooleanExpression bte = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1894:4: (bte= booleanTypeExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1894:5: bte= booleanTypeExpression
        {
        pushFollow(FOLLOW_booleanTypeExpression_in_synpred46_RutaParser11211);
        bte=booleanTypeExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred46_RutaParser

    // $ANTLR start synpred47_RutaParser
    public final void synpred47_RutaParser_fragment() throws RecognitionException {   
        BooleanExpression bne = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1895:4: (bne= booleanNumberExpression )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1895:5: bne= booleanNumberExpression
        {
        pushFollow(FOLLOW_booleanNumberExpression_in_synpred47_RutaParser11230);
        bne=booleanNumberExpression();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred47_RutaParser

    // $ANTLR start synpred48_RutaParser
    public final void synpred48_RutaParser_fragment() throws RecognitionException {   
        BooleanExpression e = null;


        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1905:4: (e= externalBooleanFunction )
        // org\\apache\\uima\\ruta\\parser\\RutaParser.g:1905:5: e= externalBooleanFunction
        {
        pushFollow(FOLLOW_externalBooleanFunction_in_synpred48_RutaParser11305);
        e=externalBooleanFunction();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred48_RutaParser

    // Delegated rules

    public final boolean synpred29_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred29_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred28_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred28_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred15_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred15_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred22_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred22_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred47_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred47_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred40_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred40_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred44_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred44_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred27_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred27_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred37_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred37_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred6_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred6_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred21_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred21_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred25_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred25_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred4_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred4_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred43_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred43_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred11_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred11_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred26_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred26_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred3_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred3_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred19_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred19_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred18_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred18_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred23_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred23_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred48_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred48_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred16_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred16_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred34_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred34_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred46_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred46_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred36_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred36_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred14_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred14_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred33_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred33_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred2_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred2_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred17_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred17_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred12_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred12_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred1_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred1_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred13_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred13_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred24_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred24_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred45_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred45_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred42_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred42_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred39_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred39_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred5_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred5_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred38_RutaParser() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred38_RutaParser_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


    protected DFA31 dfa31 = new DFA31(this);
    protected DFA96 dfa96 = new DFA96(this);
    protected DFA132 dfa132 = new DFA132(this);
    protected DFA135 dfa135 = new DFA135(this);
    protected DFA142 dfa142 = new DFA142(this);
    protected DFA173 dfa173 = new DFA173(this);
    protected DFA186 dfa186 = new DFA186(this);
    protected DFA209 dfa209 = new DFA209(this);
    static final String DFA31_eotS =
        "\10\uffff";
    static final String DFA31_eofS =
        "\10\uffff";
    static final String DFA31_minS =
        "\1\11\3\177\1\u0080\1\uffff\1\177\1\uffff";
    static final String DFA31_maxS =
        "\1\11\1\177\1\u008b\1\177\1\u008b\1\uffff\1\u0088\1\uffff";
    static final String DFA31_acceptS =
        "\5\uffff\1\1\1\uffff\1\2";
    static final String DFA31_specialS =
        "\10\uffff}>";
    static final String[] DFA31_transitionS = {
            "\1\1",
            "\1\2",
            "\1\4\10\uffff\1\3\1\uffff\2\5",
            "\1\6",
            "\1\7\11\uffff\2\5",
            "",
            "\1\4\10\uffff\1\3",
            ""
    };

    static final short[] DFA31_eot = DFA.unpackEncodedString(DFA31_eotS);
    static final short[] DFA31_eof = DFA.unpackEncodedString(DFA31_eofS);
    static final char[] DFA31_min = DFA.unpackEncodedStringToUnsignedChars(DFA31_minS);
    static final char[] DFA31_max = DFA.unpackEncodedStringToUnsignedChars(DFA31_maxS);
    static final short[] DFA31_accept = DFA.unpackEncodedString(DFA31_acceptS);
    static final short[] DFA31_special = DFA.unpackEncodedString(DFA31_specialS);
    static final short[][] DFA31_transition;

    static {
        int numStates = DFA31_transitionS.length;
        DFA31_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA31_transition[i] = DFA.unpackEncodedString(DFA31_transitionS[i]);
        }
    }

    class DFA31 extends DFA {

        public DFA31(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 31;
            this.eot = DFA31_eot;
            this.eof = DFA31_eof;
            this.min = DFA31_min;
            this.max = DFA31_max;
            this.accept = DFA31_accept;
            this.special = DFA31_special;
            this.transition = DFA31_transition;
        }
        public String getDescription() {
            return "361:2: ( DECLARE (lazyParent= annotationType )? id= Identifier ( COMMA id= Identifier )* SEMI | DECLARE type= annotationType newName= Identifier ( LPAREN (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier ( COMMA (obj1= annotationType | obj2= StringString | obj3= DoubleString | obj6= FloatString | obj4= IntString | obj5= BooleanString ) fname= Identifier )* RPAREN ) SEMI )";
        }
    }
    static final String DFA96_eotS =
        "\35\uffff";
    static final String DFA96_eofS =
        "\35\uffff";
    static final String DFA96_minS =
        "\1\10\34\uffff";
    static final String DFA96_maxS =
        "\1\u008d\34\uffff";
    static final String DFA96_acceptS =
        "\1\uffff\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1"+
        "\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27\1\30\1\31"+
        "\1\32\1\33\1\34";
    static final String DFA96_specialS =
        "\1\0\34\uffff}>";
    static final String[] DFA96_transitionS = {
            "\1\2\3\uffff\1\1\1\3\1\4\1\20\1\5\1\6\1\7\1\10\1\11\1\13\1"+
            "\14\1\32\1\15\1\16\1\17\1\21\1\22\1\23\1\24\34\uffff\1\26\1"+
            "\27\1\25\1\30\1\31\4\uffff\1\12\6\uffff\1\33\63\uffff\1\34\15"+
            "\uffff\1\12",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA96_eot = DFA.unpackEncodedString(DFA96_eotS);
    static final short[] DFA96_eof = DFA.unpackEncodedString(DFA96_eofS);
    static final char[] DFA96_min = DFA.unpackEncodedStringToUnsignedChars(DFA96_minS);
    static final char[] DFA96_max = DFA.unpackEncodedStringToUnsignedChars(DFA96_maxS);
    static final short[] DFA96_accept = DFA.unpackEncodedString(DFA96_acceptS);
    static final short[] DFA96_special = DFA.unpackEncodedString(DFA96_specialS);
    static final short[][] DFA96_transition;

    static {
        int numStates = DFA96_transitionS.length;
        DFA96_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA96_transition[i] = DFA.unpackEncodedString(DFA96_transitionS[i]);
        }
    }

    class DFA96 extends DFA {

        public DFA96(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 96;
            this.eot = DFA96_eot;
            this.eof = DFA96_eof;
            this.min = DFA96_min;
            this.max = DFA96_max;
            this.accept = DFA96_accept;
            this.special = DFA96_special;
            this.transition = DFA96_transition;
        }
        public String getDescription() {
            return "920:2: (c= conditionAnd | c= conditionContains | c= conditionContextCount | c= conditionCount | c= conditionCurrentCount | c= conditionInList | c= conditionLast | c= conditionMofN | c= conditionNear | c= conditionNot | c= conditionOr | c= conditionPartOf | c= conditionPosition | c= conditionRegExp | c= conditionScore | c= conditionTotalCount | c= conditionVote | c= conditionIf | c= conditionFeature | c= conditionParse | c= conditionIs | c= conditionBefore | c= conditionAfter | c= conditionStartsWith | c= conditionEndsWith | c= conditionPartOfNeq | c= conditionSize | (c= externalCondition )=>c= externalCondition )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA96_0 = input.LA(1);

                         
                        int index96_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA96_0==AND) ) {s = 1;}

                        else if ( (LA96_0==CONTAINS) ) {s = 2;}

                        else if ( (LA96_0==CONTEXTCOUNT) ) {s = 3;}

                        else if ( (LA96_0==COUNT) ) {s = 4;}

                        else if ( (LA96_0==CURRENTCOUNT) ) {s = 5;}

                        else if ( (LA96_0==INLIST) ) {s = 6;}

                        else if ( (LA96_0==LAST) ) {s = 7;}

                        else if ( (LA96_0==MOFN) ) {s = 8;}

                        else if ( (LA96_0==NEAR) ) {s = 9;}

                        else if ( (LA96_0==NOT||LA96_0==MINUS) ) {s = 10;}

                        else if ( (LA96_0==OR) ) {s = 11;}

                        else if ( (LA96_0==PARTOF) ) {s = 12;}

                        else if ( (LA96_0==POSITION) ) {s = 13;}

                        else if ( (LA96_0==REGEXP) ) {s = 14;}

                        else if ( (LA96_0==SCORE) ) {s = 15;}

                        else if ( (LA96_0==TOTALCOUNT) ) {s = 16;}

                        else if ( (LA96_0==VOTE) ) {s = 17;}

                        else if ( (LA96_0==IF) ) {s = 18;}

                        else if ( (LA96_0==FEATURE) ) {s = 19;}

                        else if ( (LA96_0==PARSE) ) {s = 20;}

                        else if ( (LA96_0==IS) ) {s = 21;}

                        else if ( (LA96_0==BEFORE) ) {s = 22;}

                        else if ( (LA96_0==AFTER) ) {s = 23;}

                        else if ( (LA96_0==STARTSWITH) ) {s = 24;}

                        else if ( (LA96_0==ENDSWITH) ) {s = 25;}

                        else if ( (LA96_0==PARTOFNEQ) ) {s = 26;}

                        else if ( (LA96_0==SIZE) ) {s = 27;}

                        else if ( (LA96_0==Identifier) && (synpred21_RutaParser())) {s = 28;}

                         
                        input.seek(index96_0);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 96, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA132_eotS =
        "\52\uffff";
    static final String DFA132_eofS =
        "\52\uffff";
    static final String DFA132_minS =
        "\1\7\51\uffff";
    static final String DFA132_maxS =
        "\1\177\51\uffff";
    static final String DFA132_acceptS =
        "\1\uffff\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1"+
        "\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27\1\30\1\31"+
        "\1\32\1\33\1\34\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44\1\45\1\46"+
        "\1\47\1\50\1\51";
    static final String DFA132_specialS =
        "\1\0\51\uffff}>";
    static final String[] DFA132_transitionS = {
            "\1\25\27\uffff\1\13\1\26\1\14\1\uffff\1\1\1\2\1\3\1\4\1\5\1"+
            "\24\1\6\1\30\1\7\1\10\1\12\1\11\1\15\1\27\1\42\1\16\1\17\1\20"+
            "\1\21\1\22\1\23\1\41\1\43\1\44\5\uffff\1\45\1\46\1\47\1\50\1"+
            "\uffff\1\31\1\32\1\33\1\34\1\35\1\36\1\uffff\1\37\1\uffff\1"+
            "\40\60\uffff\1\51",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA132_eot = DFA.unpackEncodedString(DFA132_eotS);
    static final short[] DFA132_eof = DFA.unpackEncodedString(DFA132_eofS);
    static final char[] DFA132_min = DFA.unpackEncodedStringToUnsignedChars(DFA132_minS);
    static final char[] DFA132_max = DFA.unpackEncodedStringToUnsignedChars(DFA132_maxS);
    static final short[] DFA132_accept = DFA.unpackEncodedString(DFA132_acceptS);
    static final short[] DFA132_special = DFA.unpackEncodedString(DFA132_specialS);
    static final short[][] DFA132_transition;

    static {
        int numStates = DFA132_transitionS.length;
        DFA132_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA132_transition[i] = DFA.unpackEncodedString(DFA132_transitionS[i]);
        }
    }

    class DFA132 extends DFA {

        public DFA132(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 132;
            this.eot = DFA132_eot;
            this.eof = DFA132_eof;
            this.min = DFA132_min;
            this.max = DFA132_max;
            this.accept = DFA132_accept;
            this.special = DFA132_special;
            this.transition = DFA132_transition;
        }
        public String getDescription() {
            return "1150:2: (a= actionColor | a= actionDel | a= actionLog | a= actionMark | a= actionMarkScore | a= actionMarkFast | a= actionMarkLast | a= actionReplace | a= actionFilterType | a= actionRetainType | a= actionCreate | a= actionFill | a= actionCall | a= actionAssign | a= actionSetFeature | a= actionGetFeature | a= actionUnmark | a= actionUnmarkAll | a= actionTransfer | a= actionMarkOnce | a= actionTrie | a= actionGather | a= actionExec | a= actionMarkTable | a= actionAdd | a= actionRemove | a= actionRemoveDuplicate | a= actionMerge | a= actionGet | a= actionGetList | a= actionMatchedText | a= actionClear | a= actionShift | a= actionConfigure | a= actionDynamicAnchoring | a= actionTrim | a= actionAddRetainType | a= actionRemoveRetainType | a= actionAddFilterType | a= actionRemoveFilterType | (a= externalAction )=>a= externalAction )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA132_0 = input.LA(1);

                         
                        int index132_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA132_0==COLOR) ) {s = 1;}

                        else if ( (LA132_0==DEL) ) {s = 2;}

                        else if ( (LA132_0==LOG) ) {s = 3;}

                        else if ( (LA132_0==MARK) ) {s = 4;}

                        else if ( (LA132_0==MARKSCORE) ) {s = 5;}

                        else if ( (LA132_0==MARKFAST) ) {s = 6;}

                        else if ( (LA132_0==MARKLAST) ) {s = 7;}

                        else if ( (LA132_0==REPLACE) ) {s = 8;}

                        else if ( (LA132_0==FILTERTYPE) ) {s = 9;}

                        else if ( (LA132_0==RETAINTYPE) ) {s = 10;}

                        else if ( (LA132_0==CREATE) ) {s = 11;}

                        else if ( (LA132_0==FILL) ) {s = 12;}

                        else if ( (LA132_0==CALL) ) {s = 13;}

                        else if ( (LA132_0==ASSIGN) ) {s = 14;}

                        else if ( (LA132_0==SETFEATURE) ) {s = 15;}

                        else if ( (LA132_0==GETFEATURE) ) {s = 16;}

                        else if ( (LA132_0==UNMARK) ) {s = 17;}

                        else if ( (LA132_0==UNMARKALL) ) {s = 18;}

                        else if ( (LA132_0==TRANSFER) ) {s = 19;}

                        else if ( (LA132_0==MARKONCE) ) {s = 20;}

                        else if ( (LA132_0==TRIE) ) {s = 21;}

                        else if ( (LA132_0==GATHER) ) {s = 22;}

                        else if ( (LA132_0==EXEC) ) {s = 23;}

                        else if ( (LA132_0==MARKTABLE) ) {s = 24;}

                        else if ( (LA132_0==ADD) ) {s = 25;}

                        else if ( (LA132_0==REMOVE) ) {s = 26;}

                        else if ( (LA132_0==REMOVEDUPLICATE) ) {s = 27;}

                        else if ( (LA132_0==MERGE) ) {s = 28;}

                        else if ( (LA132_0==GET) ) {s = 29;}

                        else if ( (LA132_0==GETLIST) ) {s = 30;}

                        else if ( (LA132_0==MATCHEDTEXT) ) {s = 31;}

                        else if ( (LA132_0==CLEAR) ) {s = 32;}

                        else if ( (LA132_0==SHIFT) ) {s = 33;}

                        else if ( (LA132_0==CONFIGURE) ) {s = 34;}

                        else if ( (LA132_0==DYNAMICANCHORING) ) {s = 35;}

                        else if ( (LA132_0==TRIM) ) {s = 36;}

                        else if ( (LA132_0==ADDRETAINTYPE) ) {s = 37;}

                        else if ( (LA132_0==REMOVERETAINTYPE) ) {s = 38;}

                        else if ( (LA132_0==ADDFILTERTYPE) ) {s = 39;}

                        else if ( (LA132_0==REMOVEFILTERTYPE) ) {s = 40;}

                        else if ( (LA132_0==Identifier) && (synpred24_RutaParser())) {s = 41;}

                         
                        input.seek(index132_0);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 132, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA135_eotS =
        "\12\uffff";
    static final String DFA135_eofS =
        "\12\uffff";
    static final String DFA135_minS =
        "\1\115\3\uffff\1\0\5\uffff";
    static final String DFA135_maxS =
        "\1\u008d\3\uffff\1\0\5\uffff";
    static final String DFA135_acceptS =
        "\1\uffff\3\1\1\uffff\2\1\1\2\2\uffff";
    static final String DFA135_specialS =
        "\1\0\3\uffff\1\1\5\uffff}>";
    static final String[] DFA135_transitionS = {
            "\1\7\31\uffff\5\6\6\uffff\1\2\3\uffff\1\3\2\uffff\1\7\5\uffff"+
            "\1\4\1\5\1\7\13\uffff\1\1",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA135_eot = DFA.unpackEncodedString(DFA135_eotS);
    static final short[] DFA135_eof = DFA.unpackEncodedString(DFA135_eofS);
    static final char[] DFA135_min = DFA.unpackEncodedStringToUnsignedChars(DFA135_minS);
    static final char[] DFA135_max = DFA.unpackEncodedStringToUnsignedChars(DFA135_maxS);
    static final short[] DFA135_accept = DFA.unpackEncodedString(DFA135_acceptS);
    static final short[] DFA135_special = DFA.unpackEncodedString(DFA135_specialS);
    static final short[][] DFA135_transition;

    static {
        int numStates = DFA135_transitionS.length;
        DFA135_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA135_transition[i] = DFA.unpackEncodedString(DFA135_transitionS[i]);
        }
    }

    class DFA135 extends DFA {

        public DFA135(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 135;
            this.eot = DFA135_eot;
            this.eof = DFA135_eof;
            this.min = DFA135_min;
            this.max = DFA135_max;
            this.accept = DFA135_accept;
            this.special = DFA135_special;
            this.transition = DFA135_transition;
        }
        public String getDescription() {
            return "1225:5: ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA135_0 = input.LA(1);

                         
                        int index135_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA135_0==MINUS) && (synpred25_RutaParser())) {s = 1;}

                        else if ( (LA135_0==DecimalLiteral) && (synpred25_RutaParser())) {s = 2;}

                        else if ( (LA135_0==FloatingPointLiteral) && (synpred25_RutaParser())) {s = 3;}

                        else if ( (LA135_0==Identifier) ) {s = 4;}

                        else if ( (LA135_0==LPAREN) && (synpred25_RutaParser())) {s = 5;}

                        else if ( ((LA135_0>=EXP && LA135_0<=TAN)) && (synpred25_RutaParser())) {s = 6;}

                        else if ( (LA135_0==REMOVESTRING||LA135_0==StringLiteral||LA135_0==RPAREN) ) {s = 7;}

                         
                        input.seek(index135_0);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA135_4 = input.LA(1);

                         
                        int index135_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (((synpred25_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOAT")))||(synpred25_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLE")))||(synpred25_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INT")))||synpred25_RutaParser())) ) {s = 6;}

                        else if ( (true) ) {s = 7;}

                         
                        input.seek(index135_4);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 135, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA142_eotS =
        "\12\uffff";
    static final String DFA142_eofS =
        "\12\uffff";
    static final String DFA142_minS =
        "\1\115\3\uffff\1\0\5\uffff";
    static final String DFA142_maxS =
        "\1\u008d\3\uffff\1\0\5\uffff";
    static final String DFA142_acceptS =
        "\1\uffff\3\1\1\uffff\2\1\1\2\2\uffff";
    static final String DFA142_specialS =
        "\1\0\3\uffff\1\1\5\uffff}>";
    static final String[] DFA142_transitionS = {
            "\1\7\31\uffff\5\6\6\uffff\1\2\3\uffff\1\3\2\uffff\1\7\5\uffff"+
            "\1\4\1\5\1\7\13\uffff\1\1",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA142_eot = DFA.unpackEncodedString(DFA142_eotS);
    static final short[] DFA142_eof = DFA.unpackEncodedString(DFA142_eofS);
    static final char[] DFA142_min = DFA.unpackEncodedStringToUnsignedChars(DFA142_minS);
    static final char[] DFA142_max = DFA.unpackEncodedStringToUnsignedChars(DFA142_maxS);
    static final short[] DFA142_accept = DFA.unpackEncodedString(DFA142_acceptS);
    static final short[] DFA142_special = DFA.unpackEncodedString(DFA142_specialS);
    static final short[][] DFA142_transition;

    static {
        int numStates = DFA142_transitionS.length;
        DFA142_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA142_transition[i] = DFA.unpackEncodedString(DFA142_transitionS[i]);
        }
    }

    class DFA142 extends DFA {

        public DFA142(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 142;
            this.eot = DFA142_eot;
            this.eof = DFA142_eof;
            this.min = DFA142_min;
            this.max = DFA142_max;
            this.accept = DFA142_accept;
            this.special = DFA142_special;
            this.transition = DFA142_transition;
        }
        public String getDescription() {
            return "1264:5: ( (index= numberExpression )=>index= numberExpression ( ( COMMA index= numberExpression )=> ( COMMA index= numberExpression ) )* COMMA )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA142_0 = input.LA(1);

                         
                        int index142_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA142_0==MINUS) && (synpred28_RutaParser())) {s = 1;}

                        else if ( (LA142_0==DecimalLiteral) && (synpred28_RutaParser())) {s = 2;}

                        else if ( (LA142_0==FloatingPointLiteral) && (synpred28_RutaParser())) {s = 3;}

                        else if ( (LA142_0==Identifier) ) {s = 4;}

                        else if ( (LA142_0==LPAREN) && (synpred28_RutaParser())) {s = 5;}

                        else if ( ((LA142_0>=EXP && LA142_0<=TAN)) && (synpred28_RutaParser())) {s = 6;}

                        else if ( (LA142_0==REMOVESTRING||LA142_0==StringLiteral||LA142_0==RPAREN) ) {s = 7;}

                         
                        input.seek(index142_0);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA142_4 = input.LA(1);

                         
                        int index142_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( ((synpred28_RutaParser()||(synpred28_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLE")))||(synpred28_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INT")))||(synpred28_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOAT"))))) ) {s = 6;}

                        else if ( (true) ) {s = 7;}

                         
                        input.seek(index142_4);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 142, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA173_eotS =
        "\12\uffff";
    static final String DFA173_eofS =
        "\12\uffff";
    static final String DFA173_minS =
        "\1\147\2\uffff\2\0\5\uffff";
    static final String DFA173_maxS =
        "\1\u008d\2\uffff\2\0\5\uffff";
    static final String DFA173_acceptS =
        "\1\uffff\2\1\2\uffff\1\1\1\2\3\uffff";
    static final String DFA173_specialS =
        "\1\0\2\uffff\1\1\1\2\5\uffff}>";
    static final String[] DFA173_transitionS = {
            "\5\6\1\5\1\1\1\2\3\uffff\1\6\3\uffff\1\6\10\uffff\1\3\1\4\14"+
            "\uffff\1\6",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA173_eot = DFA.unpackEncodedString(DFA173_eotS);
    static final short[] DFA173_eof = DFA.unpackEncodedString(DFA173_eofS);
    static final char[] DFA173_min = DFA.unpackEncodedStringToUnsignedChars(DFA173_minS);
    static final char[] DFA173_max = DFA.unpackEncodedStringToUnsignedChars(DFA173_maxS);
    static final short[] DFA173_accept = DFA.unpackEncodedString(DFA173_acceptS);
    static final short[] DFA173_special = DFA.unpackEncodedString(DFA173_specialS);
    static final short[][] DFA173_transition;

    static {
        int numStates = DFA173_transitionS.length;
        DFA173_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA173_transition[i] = DFA.unpackEncodedString(DFA173_transitionS[i]);
        }
    }

    class DFA173 extends DFA {

        public DFA173(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 173;
            this.eot = DFA173_eot;
            this.eof = DFA173_eof;
            this.min = DFA173_min;
            this.max = DFA173_max;
            this.accept = DFA173_accept;
            this.special = DFA173_special;
            this.transition = DFA173_transition;
        }
        public String getDescription() {
            return "1531:5: ( (b= booleanExpression )=>b= booleanExpression | (index= numberExpression ( COMMA index= numberExpression )* ) )";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA173_0 = input.LA(1);

                         
                        int index173_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA173_0==TRUE) && (synpred36_RutaParser())) {s = 1;}

                        else if ( (LA173_0==FALSE) && (synpred36_RutaParser())) {s = 2;}

                        else if ( (LA173_0==Identifier) ) {s = 3;}

                        else if ( (LA173_0==LPAREN) ) {s = 4;}

                        else if ( (LA173_0==XOR) && (synpred36_RutaParser())) {s = 5;}

                        else if ( ((LA173_0>=EXP && LA173_0<=TAN)||LA173_0==DecimalLiteral||LA173_0==FloatingPointLiteral||LA173_0==MINUS) ) {s = 6;}

                         
                        input.seek(index173_0);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA173_3 = input.LA(1);

                         
                        int index173_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (((synpred36_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEAN")))||(synpred36_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPE")))||(synpred36_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEAN")))||synpred36_RutaParser())) ) {s = 5;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index173_3);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA173_4 = input.LA(1);

                         
                        int index173_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred36_RutaParser()) ) {s = 5;}

                        else if ( (true) ) {s = 6;}

                         
                        input.seek(index173_4);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 173, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA186_eotS =
        "\15\uffff";
    static final String DFA186_eofS =
        "\15\uffff";
    static final String DFA186_minS =
        "\1\115\1\uffff\1\0\3\uffff\1\0\6\uffff";
    static final String DFA186_maxS =
        "\1\u008d\1\uffff\1\0\3\uffff\1\0\6\uffff";
    static final String DFA186_acceptS =
        "\1\uffff\1\1\2\uffff\1\2\3\uffff\1\3\3\uffff\1\4";
    static final String DFA186_specialS =
        "\2\uffff\1\0\3\uffff\1\1\6\uffff}>";
    static final String[] DFA186_transitionS = {
            "\1\1\31\uffff\5\10\3\4\3\uffff\1\10\3\uffff\1\10\2\uffff\1"+
            "\1\5\uffff\1\2\1\6\14\uffff\1\10",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA186_eot = DFA.unpackEncodedString(DFA186_eotS);
    static final short[] DFA186_eof = DFA.unpackEncodedString(DFA186_eofS);
    static final char[] DFA186_min = DFA.unpackEncodedStringToUnsignedChars(DFA186_minS);
    static final char[] DFA186_max = DFA.unpackEncodedStringToUnsignedChars(DFA186_maxS);
    static final short[] DFA186_accept = DFA.unpackEncodedString(DFA186_acceptS);
    static final short[] DFA186_special = DFA.unpackEncodedString(DFA186_specialS);
    static final short[][] DFA186_transition;

    static {
        int numStates = DFA186_transitionS.length;
        DFA186_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA186_transition[i] = DFA.unpackEncodedString(DFA186_transitionS[i]);
        }
    }

    class DFA186 extends DFA {

        public DFA186(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 186;
            this.eot = DFA186_eot;
            this.eof = DFA186_eof;
            this.min = DFA186_min;
            this.max = DFA186_max;
            this.accept = DFA186_accept;
            this.special = DFA186_special;
            this.transition = DFA186_transition;
        }
        public String getDescription() {
            return "1687:1: argument returns [RutaExpression expr = null] options {backtrack=true; } : (a4= stringExpression | a2= booleanExpression | a3= numberExpression | a1= typeExpression );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA186_2 = input.LA(1);

                         
                        int index186_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( ((synpred37_RutaParser()||(synpred37_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "STRING"))))) ) {s = 1;}

                        else if ( (((synpred38_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEAN")))||(synpred38_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "TYPE")))||(synpred38_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "BOOLEAN")))||synpred38_RutaParser())) ) {s = 4;}

                        else if ( (((synpred39_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "INT")))||(synpred39_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "DOUBLE")))||synpred39_RutaParser()||(synpred39_RutaParser()&&(isVariableOfType(((blockDeclaration_scope)blockDeclaration_stack.peek()).env,input.LT(1).getText(), "FLOAT"))))) ) {s = 8;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index186_2);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA186_6 = input.LA(1);

                         
                        int index186_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred38_RutaParser()) ) {s = 4;}

                        else if ( (synpred39_RutaParser()) ) {s = 8;}

                         
                        input.seek(index186_6);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 186, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA209_eotS =
        "\13\uffff";
    static final String DFA209_eofS =
        "\1\uffff\3\6\7\uffff";
    static final String DFA209_minS =
        "\1\154\2\u0081\1\u0080\7\uffff";
    static final String DFA209_maxS =
        "\1\u0080\3\u0098\7\uffff";
    static final String DFA209_acceptS =
        "\4\uffff\2\1\1\2\4\1";
    static final String DFA209_specialS =
        "\1\1\1\3\1\2\1\0\7\uffff}>";
    static final String[] DFA209_transitionS = {
            "\1\5\1\1\1\2\20\uffff\1\3\1\4",
            "\1\6\10\uffff\2\6\13\uffff\2\7",
            "\1\6\10\uffff\2\6\13\uffff\2\7",
            "\1\10\1\6\6\uffff\1\12\1\uffff\2\6\13\uffff\2\11",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA209_eot = DFA.unpackEncodedString(DFA209_eotS);
    static final short[] DFA209_eof = DFA.unpackEncodedString(DFA209_eofS);
    static final char[] DFA209_min = DFA.unpackEncodedStringToUnsignedChars(DFA209_minS);
    static final char[] DFA209_max = DFA.unpackEncodedStringToUnsignedChars(DFA209_maxS);
    static final short[] DFA209_accept = DFA.unpackEncodedString(DFA209_acceptS);
    static final short[] DFA209_special = DFA.unpackEncodedString(DFA209_specialS);
    static final short[][] DFA209_transition;

    static {
        int numStates = DFA209_transitionS.length;
        DFA209_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA209_transition[i] = DFA.unpackEncodedString(DFA209_transitionS[i]);
        }
    }

    class DFA209 extends DFA {

        public DFA209(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 209;
            this.eot = DFA209_eot;
            this.eof = DFA209_eof;
            this.min = DFA209_min;
            this.max = DFA209_max;
            this.accept = DFA209_accept;
            this.special = DFA209_special;
            this.transition = DFA209_transition;
        }
        public String getDescription() {
            return "1876:1: booleanExpression returns [BooleanExpression expr = null] : ( (e= composedBooleanExpression )=>e= composedBooleanExpression | sbE= simpleBooleanExpression );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA209_3 = input.LA(1);

                         
                        int index209_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA209_3==LPAREN) && (synpred44_RutaParser())) {s = 8;}

                        else if ( ((LA209_3>=EQUAL && LA209_3<=NOTEQUAL)) && (synpred44_RutaParser())) {s = 9;}

                        else if ( (LA209_3==EOF||LA209_3==RPAREN||(LA209_3>=COMMA && LA209_3<=SEMI)) ) {s = 6;}

                        else if ( (LA209_3==DOT) && (synpred44_RutaParser())) {s = 10;}

                         
                        input.seek(index209_3);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA209_0 = input.LA(1);

                         
                        int index209_0 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA209_0==TRUE) ) {s = 1;}

                        else if ( (LA209_0==FALSE) ) {s = 2;}

                        else if ( (LA209_0==Identifier) ) {s = 3;}

                        else if ( (LA209_0==LPAREN) && (synpred44_RutaParser())) {s = 4;}

                        else if ( (LA209_0==XOR) && (synpred44_RutaParser())) {s = 5;}

                         
                        input.seek(index209_0);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA209_2 = input.LA(1);

                         
                        int index209_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( ((LA209_2>=EQUAL && LA209_2<=NOTEQUAL)) && (synpred44_RutaParser())) {s = 7;}

                        else if ( (LA209_2==EOF||LA209_2==RPAREN||(LA209_2>=COMMA && LA209_2<=SEMI)) ) {s = 6;}

                         
                        input.seek(index209_2);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA209_1 = input.LA(1);

                         
                        int index209_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (LA209_1==EOF||LA209_1==RPAREN||(LA209_1>=COMMA && LA209_1<=SEMI)) ) {s = 6;}

                        else if ( ((LA209_1>=EQUAL && LA209_1<=NOTEQUAL)) && (synpred44_RutaParser())) {s = 7;}

                         
                        input.seek(index209_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 209, _s, input);
            error(nvae);
            throw nvae;
        }
    }
 

    public static final BitSet FOLLOW_packageDeclaration_in_file_input75 = new BitSet(new long[]{0x0000000000000E00L,0x8200007E3FF82000L,0x0000000010000001L});
    public static final BitSet FOLLOW_globalStatements_in_file_input91 = new BitSet(new long[]{0x0000000000000E00L,0x8200007E1FE02000L,0x0000000010000001L});
    public static final BitSet FOLLOW_statements_in_file_input100 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_file_input108 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PackageString_in_packageDeclaration123 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_dottedIdentifier_in_packageDeclaration129 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_packageDeclaration131 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_statement_in_statements154 = new BitSet(new long[]{0x0000000000000E02L,0x8200007E1FE02000L,0x0000000010000001L});
    public static final BitSet FOLLOW_globalStatement_in_globalStatements179 = new BitSet(new long[]{0x0000000000000002L,0x0000000020180000L});
    public static final BitSet FOLLOW_importStatement_in_globalStatement203 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_declaration_in_statement229 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_variableDeclaration_in_statement240 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleStatement_in_statement251 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_blockDeclaration_in_statement262 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_automataDeclaration_in_statement273 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IntString_in_variableDeclaration303 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration312 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100C00L});
    public static final BitSet FOLLOW_COMMA_in_variableDeclaration319 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration327 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100C00L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration337 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_variableDeclaration343 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration350 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DoubleString_in_variableDeclaration360 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration369 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100C00L});
    public static final BitSet FOLLOW_COMMA_in_variableDeclaration376 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration384 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100C00L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration395 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_variableDeclaration401 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration407 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FloatString_in_variableDeclaration417 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration426 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100C00L});
    public static final BitSet FOLLOW_COMMA_in_variableDeclaration433 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration441 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100C00L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration452 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_variableDeclaration458 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration464 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_StringString_in_variableDeclaration474 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration483 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100C00L});
    public static final BitSet FOLLOW_COMMA_in_variableDeclaration490 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration498 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100C00L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration509 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_variableDeclaration515 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration521 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BooleanString_in_variableDeclaration531 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration540 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100C00L});
    public static final BitSet FOLLOW_COMMA_in_variableDeclaration547 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration555 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100C00L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration566 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_variableDeclaration572 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration578 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TypeString_in_variableDeclaration588 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration597 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100C00L});
    public static final BitSet FOLLOW_COMMA_in_variableDeclaration604 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration612 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100C00L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration623 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_variableDeclaration629 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration635 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WORDLIST_in_variableDeclaration645 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration657 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100800L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration660 = new BitSet(new long[]{0x0000000000000000L,0x8400000000000000L});
    public static final BitSet FOLLOW_wordListExpression_in_variableDeclaration666 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration670 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WORDTABLE_in_variableDeclaration684 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration696 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100800L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration699 = new BitSet(new long[]{0x0000000000000000L,0x8400000000000000L});
    public static final BitSet FOLLOW_wordTableExpression_in_variableDeclaration705 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration709 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BOOLEANLIST_in_variableDeclaration721 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration733 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100800L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration736 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_booleanListExpression_in_variableDeclaration742 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration746 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRINGLIST_in_variableDeclaration759 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration771 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100800L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration774 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_stringListExpression_in_variableDeclaration780 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration784 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INTLIST_in_variableDeclaration797 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration809 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100800L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration812 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_numberListExpression_in_variableDeclaration818 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration822 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DOUBLELIST_in_variableDeclaration835 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration847 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100800L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration850 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_numberListExpression_in_variableDeclaration856 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration860 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FLOATLIST_in_variableDeclaration873 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration885 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100800L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration888 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_numberListExpression_in_variableDeclaration894 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration898 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TYPELIST_in_variableDeclaration911 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_variableDeclaration923 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100800L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_variableDeclaration926 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_typeListExpression_in_variableDeclaration932 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_variableDeclaration936 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TypeSystemString_in_importStatement983 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_dottedIdentifier2_in_importStatement989 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_importStatement992 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ScriptString_in_importStatement997 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_dottedIdentifier2_in_importStatement1003 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_importStatement1006 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EngineString_in_importStatement1011 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_dottedIdentifier2_in_importStatement1017 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_importStatement1020 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DECLARE_in_declaration1044 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_annotationType_in_declaration1054 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_declaration1062 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000C00L});
    public static final BitSet FOLLOW_COMMA_in_declaration1069 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_declaration1083 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000C00L});
    public static final BitSet FOLLOW_SEMI_in_declaration1092 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DECLARE_in_declaration1099 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_annotationType_in_declaration1105 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_declaration1111 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_declaration1117 = new BitSet(new long[]{0x0000000000000000L,0x800000001F000000L});
    public static final BitSet FOLLOW_annotationType_in_declaration1132 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_StringString_in_declaration1145 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_DoubleString_in_declaration1158 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_FloatString_in_declaration1170 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_IntString_in_declaration1182 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_BooleanString_in_declaration1194 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_declaration1210 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_declaration1222 = new BitSet(new long[]{0x0000000000000000L,0x800000001F000000L});
    public static final BitSet FOLLOW_annotationType_in_declaration1237 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_StringString_in_declaration1250 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_DoubleString_in_declaration1263 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_FloatString_in_declaration1275 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_IntString_in_declaration1287 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_BooleanString_in_declaration1299 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_declaration1315 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_declaration1323 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_declaration1326 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BlockString_in_blockDeclaration1384 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_blockDeclaration1388 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_blockDeclaration1395 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_blockDeclaration1399 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_ruleElementWithCA_in_blockDeclaration1412 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_LCURLY_in_blockDeclaration1423 = new BitSet(new long[]{0x0000000000000E00L,0x8200007E1FE02000L,0x0000000010000021L});
    public static final BitSet FOLLOW_statements_in_blockDeclaration1429 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_RCURLY_in_blockDeclaration1431 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_AutomataBlockString_in_automataDeclaration1483 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_automataDeclaration1487 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_automataDeclaration1494 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_automataDeclaration1498 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_ruleElementWithCA_in_automataDeclaration1511 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_LCURLY_in_automataDeclaration1520 = new BitSet(new long[]{0x0000000000000E00L,0x8200007E1FE02000L,0x0000000010000021L});
    public static final BitSet FOLLOW_statements_in_automataDeclaration1526 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_RCURLY_in_automataDeclaration1528 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeExpression_in_ruleElementWithCA1565 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000405014L});
    public static final BitSet FOLLOW_quantifierPart_in_ruleElementWithCA1582 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_LCURLY_in_ruleElementWithCA1594 = new BitSet(new long[]{0xF80000007FFFF100L,0x8000000000008810L,0x0000000000002020L});
    public static final BitSet FOLLOW_conditions_in_ruleElementWithCA1600 = new BitSet(new long[]{0x0000000000000000L,0x0000000000008000L,0x0000000000000020L});
    public static final BitSet FOLLOW_THEN_in_ruleElementWithCA1604 = new BitSet(new long[]{0x07FFFFFB80000080L,0x80000000000057EFL});
    public static final BitSet FOLLOW_actions_in_ruleElementWithCA1610 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_RCURLY_in_ruleElementWithCA1614 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_regexpRule_in_simpleStatement1674 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleElements_in_simpleStatement1696 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_SEMI_in_simpleStatement1699 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringExpression_in_regexpRule1735 = new BitSet(new long[]{0x0000000000000000L,0x0000000000008000L});
    public static final BitSet FOLLOW_THEN_in_regexpRule1737 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_regexpRule1754 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_regexpRule1756 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_regexpRule1762 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000C00L});
    public static final BitSet FOLLOW_typeExpression_in_regexpRule1774 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000C00L});
    public static final BitSet FOLLOW_COMMA_in_regexpRule1785 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_regexpRule1802 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_regexpRule1804 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_regexpRule1810 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000C00L});
    public static final BitSet FOLLOW_typeExpression_in_regexpRule1822 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000C00L});
    public static final BitSet FOLLOW_SEMI_in_regexpRule1837 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleElement_in_ruleElements1866 = new BitSet(new long[]{0x0000000000000002L,0x8200000000002000L,0x0000000010000001L});
    public static final BitSet FOLLOW_ruleElement_in_ruleElements1876 = new BitSet(new long[]{0x0000000000000002L,0x8200000000002000L,0x0000000010000001L});
    public static final BitSet FOLLOW_ruleElementType_in_ruleElement1905 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleElementLiteral_in_ruleElement1917 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleElementComposed_in_ruleElement1934 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleElementDisjunctive_in_ruleElement1952 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleElementWildCard_in_ruleElement1970 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WILDCARD_in_ruleElementWildCard2007 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_LCURLY_in_ruleElementWildCard2027 = new BitSet(new long[]{0xF80000007FFFF100L,0x8000000000008810L,0x0000000000002020L});
    public static final BitSet FOLLOW_conditions_in_ruleElementWildCard2033 = new BitSet(new long[]{0x0000000000000000L,0x0000000000008000L,0x0000000000000020L});
    public static final BitSet FOLLOW_THEN_in_ruleElementWildCard2037 = new BitSet(new long[]{0x07FFFFFB80000080L,0x80000000000057EFL});
    public static final BitSet FOLLOW_actions_in_ruleElementWildCard2043 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_RCURLY_in_ruleElementWildCard2047 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_ruleElementDisjunctive2086 = new BitSet(new long[]{0x0000000000000000L,0x8200000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_ruleElementDisjunctive2110 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_simpleStringExpression_in_ruleElementDisjunctive2117 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_VBAR_in_ruleElementDisjunctive2132 = new BitSet(new long[]{0x0000000000000000L,0x8200000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_ruleElementDisjunctive2138 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000010002L});
    public static final BitSet FOLLOW_simpleStringExpression_in_ruleElementDisjunctive2145 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000010002L});
    public static final BitSet FOLLOW_VBAR_in_ruleElementDisjunctive2166 = new BitSet(new long[]{0x0000000000000000L,0x8200000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_ruleElementDisjunctive2173 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000010002L});
    public static final BitSet FOLLOW_simpleStringExpression_in_ruleElementDisjunctive2180 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000010002L});
    public static final BitSet FOLLOW_RPAREN_in_ruleElementDisjunctive2202 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000405014L});
    public static final BitSet FOLLOW_quantifierPart_in_ruleElementDisjunctive2228 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_LCURLY_in_ruleElementDisjunctive2241 = new BitSet(new long[]{0xF80000007FFFF100L,0x8000000000008810L,0x0000000000002020L});
    public static final BitSet FOLLOW_conditions_in_ruleElementDisjunctive2247 = new BitSet(new long[]{0x0000000000000000L,0x0000000000008000L,0x0000000000000020L});
    public static final BitSet FOLLOW_THEN_in_ruleElementDisjunctive2251 = new BitSet(new long[]{0x07FFFFFB80000080L,0x80000000000057EFL});
    public static final BitSet FOLLOW_actions_in_ruleElementDisjunctive2257 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_RCURLY_in_ruleElementDisjunctive2261 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_ruleElementComposed2302 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L,0x0000000010000001L});
    public static final BitSet FOLLOW_ruleElements_in_ruleElementComposed2330 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_ruleElementComposed2340 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000405014L});
    public static final BitSet FOLLOW_quantifierPart_in_ruleElementComposed2346 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_LCURLY_in_ruleElementComposed2350 = new BitSet(new long[]{0xF80000007FFFF100L,0x8000000000008810L,0x0000000000002020L});
    public static final BitSet FOLLOW_conditions_in_ruleElementComposed2356 = new BitSet(new long[]{0x0000000000000000L,0x0000000000008000L,0x0000000000000020L});
    public static final BitSet FOLLOW_THEN_in_ruleElementComposed2360 = new BitSet(new long[]{0x07FFFFFB80000080L,0x80000000000057EFL});
    public static final BitSet FOLLOW_actions_in_ruleElementComposed2366 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_RCURLY_in_ruleElementComposed2370 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeExpression_in_ruleElementType2413 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000405014L});
    public static final BitSet FOLLOW_quantifierPart_in_ruleElementType2432 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_LCURLY_in_ruleElementType2445 = new BitSet(new long[]{0xF80000007FFFF100L,0x8000000000008810L,0x0000000000002020L});
    public static final BitSet FOLLOW_conditions_in_ruleElementType2451 = new BitSet(new long[]{0x0000000000000000L,0x0000000000008000L,0x0000000000000020L});
    public static final BitSet FOLLOW_THEN_in_ruleElementType2455 = new BitSet(new long[]{0x07FFFFFB80000080L,0x80000000000057EFL});
    public static final BitSet FOLLOW_actions_in_ruleElementType2461 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_RCURLY_in_ruleElementType2465 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleStringExpression_in_ruleElementLiteral2512 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000405014L});
    public static final BitSet FOLLOW_quantifierPart_in_ruleElementLiteral2536 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_LCURLY_in_ruleElementLiteral2549 = new BitSet(new long[]{0xF80000007FFFF100L,0x8000000000008810L,0x0000000000002020L});
    public static final BitSet FOLLOW_conditions_in_ruleElementLiteral2555 = new BitSet(new long[]{0x0000000000000000L,0x0000000000008000L,0x0000000000000020L});
    public static final BitSet FOLLOW_THEN_in_ruleElementLiteral2559 = new BitSet(new long[]{0x07FFFFFB80000080L,0x80000000000057EFL});
    public static final BitSet FOLLOW_actions_in_ruleElementLiteral2565 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_RCURLY_in_ruleElementLiteral2569 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condition_in_conditions2607 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditions2612 = new BitSet(new long[]{0xF80000007FFFF100L,0x8000000000000810L,0x0000000000002000L});
    public static final BitSet FOLLOW_condition_in_conditions2618 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_action_in_actions2656 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actions2661 = new BitSet(new long[]{0x07FFFFFB80000080L,0x80000000000057EFL});
    public static final BitSet FOLLOW_action_in_actions2667 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_booleanListExpression_in_listExpression2703 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_intListExpression_in_listExpression2719 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_doubleListExpression_in_listExpression2735 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_floatListExpression_in_listExpression2751 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringListExpression_in_listExpression2767 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeListExpression_in_listExpression2783 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleBooleanListExpression_in_booleanListExpression2805 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_simpleBooleanListExpression2826 = new BitSet(new long[]{0x0000000000000000L,0x8000600000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_simpleBooleanExpression_in_simpleBooleanListExpression2833 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_COMMA_in_simpleBooleanListExpression2838 = new BitSet(new long[]{0x0000000000000000L,0x8000600000000000L});
    public static final BitSet FOLLOW_simpleBooleanExpression_in_simpleBooleanListExpression2844 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_RCURLY_in_simpleBooleanListExpression2853 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_simpleBooleanListExpression2868 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleIntListExpression_in_intListExpression2893 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_simpleIntListExpression2914 = new BitSet(new long[]{0x0000000000000000L,0x8044000000000000L,0x0000000000002021L});
    public static final BitSet FOLLOW_simpleNumberExpression_in_simpleIntListExpression2921 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_COMMA_in_simpleIntListExpression2926 = new BitSet(new long[]{0x0000000000000000L,0x8044000000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_simpleNumberExpression_in_simpleIntListExpression2932 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_RCURLY_in_simpleIntListExpression2941 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_simpleIntListExpression2956 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_doubleListExpression_in_numberListExpression2990 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_floatListExpression_in_numberListExpression3011 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_intListExpression_in_numberListExpression3023 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleDoubleListExpression_in_doubleListExpression3046 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_simpleDoubleListExpression3067 = new BitSet(new long[]{0x0000000000000000L,0x8044000000000000L,0x0000000000002021L});
    public static final BitSet FOLLOW_simpleNumberExpression_in_simpleDoubleListExpression3074 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_COMMA_in_simpleDoubleListExpression3079 = new BitSet(new long[]{0x0000000000000000L,0x8044000000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_simpleNumberExpression_in_simpleDoubleListExpression3085 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_RCURLY_in_simpleDoubleListExpression3094 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_simpleDoubleListExpression3109 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleFloatListExpression_in_floatListExpression3135 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_simpleFloatListExpression3156 = new BitSet(new long[]{0x0000000000000000L,0x8044000000000000L,0x0000000000002021L});
    public static final BitSet FOLLOW_simpleNumberExpression_in_simpleFloatListExpression3163 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_COMMA_in_simpleFloatListExpression3168 = new BitSet(new long[]{0x0000000000000000L,0x8044000000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_simpleNumberExpression_in_simpleFloatListExpression3174 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_RCURLY_in_simpleFloatListExpression3183 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_simpleFloatListExpression3198 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleStringListExpression_in_stringListExpression3222 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_simpleStringListExpression3243 = new BitSet(new long[]{0x0000000000000000L,0x8200000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_simpleStringExpression_in_simpleStringListExpression3250 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_COMMA_in_simpleStringListExpression3255 = new BitSet(new long[]{0x0000000000000000L,0x8200000000000000L});
    public static final BitSet FOLLOW_simpleStringExpression_in_simpleStringListExpression3261 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_RCURLY_in_simpleStringListExpression3270 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_simpleStringListExpression3286 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleTypeListExpression_in_typeListExpression3311 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_simpleTypeListExpression3332 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_simpleTypeExpression_in_simpleTypeListExpression3339 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_COMMA_in_simpleTypeListExpression3344 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_simpleTypeExpression_in_simpleTypeListExpression3350 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000420L});
    public static final BitSet FOLLOW_RCURLY_in_simpleTypeListExpression3359 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_simpleTypeListExpression3374 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeFunction_in_typeExpression3411 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleTypeExpression_in_typeExpression3422 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_externalTypeFunction_in_typeFunction3456 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_externalTypeFunction3481 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_externalTypeFunction3483 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002003L});
    public static final BitSet FOLLOW_varArgumentList_in_externalTypeFunction3490 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_externalTypeFunction3493 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_simpleTypeExpression3518 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotationType_in_simpleTypeExpression3532 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_variable3558 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_listVariable3582 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_quantifierPart3616 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000400000L});
    public static final BitSet FOLLOW_QUESTION_in_quantifierPart3622 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLUS_in_quantifierPart3633 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000400000L});
    public static final BitSet FOLLOW_QUESTION_in_quantifierPart3639 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QUESTION_in_quantifierPart3649 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000400000L});
    public static final BitSet FOLLOW_QUESTION_in_quantifierPart3655 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LBRACK_in_quantifierPart3666 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_quantifierPart3672 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000408L});
    public static final BitSet FOLLOW_COMMA_in_quantifierPart3679 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002009L});
    public static final BitSet FOLLOW_numberExpression_in_quantifierPart3686 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_RBRACK_in_quantifierPart3692 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000400000L});
    public static final BitSet FOLLOW_QUESTION_in_quantifierPart3698 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionAnd_in_condition3729 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionContains_in_condition3738 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionContextCount_in_condition3747 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionCount_in_condition3756 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionCurrentCount_in_condition3765 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionInList_in_condition3774 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionLast_in_condition3783 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionMofN_in_condition3792 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionNear_in_condition3801 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionNot_in_condition3810 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionOr_in_condition3819 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionPartOf_in_condition3828 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionPosition_in_condition3837 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionRegExp_in_condition3846 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionScore_in_condition3855 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionTotalCount_in_condition3864 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionVote_in_condition3873 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionIf_in_condition3882 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionFeature_in_condition3891 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionParse_in_condition3900 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionIs_in_condition3909 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionBefore_in_condition3918 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionAfter_in_condition3927 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionStartsWith_in_condition3937 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionEndsWith_in_condition3946 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionPartOfNeq_in_condition3955 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionSize_in_condition3964 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_externalCondition_in_condition3983 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_externalCondition4023 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_externalCondition4025 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002003L});
    public static final BitSet FOLLOW_varArgumentList_in_externalCondition4031 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_externalCondition4034 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_AND_in_conditionAnd4063 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionAnd4065 = new BitSet(new long[]{0xF80000007FFFF100L,0x8000000000000810L,0x0000000000002000L});
    public static final BitSet FOLLOW_conditions_in_conditionAnd4071 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionAnd4073 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONTAINS_in_conditionContains4125 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionContains4127 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_typeExpression_in_conditionContains4134 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_listExpression_in_conditionContains4142 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionContains4144 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_conditionContains4150 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionContains4159 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionContains4165 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionContains4167 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionContains4173 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionContains4176 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_conditionContains4182 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionContains4188 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONTEXTCOUNT_in_conditionContextCount4221 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionContextCount4223 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_conditionContextCount4229 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionContextCount4232 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionContextCount4238 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionContextCount4240 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionContextCount4246 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionContextCount4256 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000002000L});
    public static final BitSet FOLLOW_numberVariable_in_conditionContextCount4262 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionContextCount4266 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COUNT_in_conditionCount4312 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionCount4314 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_listExpression_in_conditionCount4320 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionCount4322 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_conditionCount4328 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionCount4331 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionCount4337 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionCount4339 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionCount4345 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionCount4355 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000002000L});
    public static final BitSet FOLLOW_numberVariable_in_conditionCount4361 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionCount4365 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COUNT_in_conditionCount4383 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionCount4385 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_conditionCount4391 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionCount4394 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionCount4400 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionCount4402 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionCount4408 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionCount4418 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000002000L});
    public static final BitSet FOLLOW_numberVariable_in_conditionCount4424 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionCount4428 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TOTALCOUNT_in_conditionTotalCount4464 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionTotalCount4466 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_conditionTotalCount4472 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionTotalCount4475 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionTotalCount4481 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionTotalCount4483 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionTotalCount4489 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionTotalCount4498 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000002000L});
    public static final BitSet FOLLOW_numberVariable_in_conditionTotalCount4504 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionTotalCount4508 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CURRENTCOUNT_in_conditionCurrentCount4541 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionCurrentCount4543 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_conditionCurrentCount4549 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionCurrentCount4552 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionCurrentCount4558 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionCurrentCount4560 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionCurrentCount4566 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionCurrentCount4576 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000002000L});
    public static final BitSet FOLLOW_numberVariable_in_conditionCurrentCount4582 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionCurrentCount4586 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INLIST_in_conditionInList4629 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionInList4631 = new BitSet(new long[]{0x0000000000000000L,0x8400000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_stringListExpression_in_conditionInList4646 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_wordListExpression_in_conditionInList4654 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionInList4658 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionInList4664 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionInList4667 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_conditionInList4673 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionInList4679 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LAST_in_conditionLast4718 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionLast4720 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_conditionLast4726 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionLast4728 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MOFN_in_conditionMofN4775 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionMofN4777 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionMofN4783 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionMofN4785 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionMofN4791 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionMofN4793 = new BitSet(new long[]{0xF80000007FFFF100L,0x8000000000000810L,0x0000000000002000L});
    public static final BitSet FOLLOW_conditions_in_conditionMofN4799 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionMofN4801 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NEAR_in_conditionNear4836 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionNear4838 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_conditionNear4844 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionNear4846 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionNear4852 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionNear4854 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionNear4860 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionNear4863 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_conditionNear4869 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionNear4872 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_conditionNear4878 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionNear4884 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_conditionNot4920 = new BitSet(new long[]{0xF80000007FFFF100L,0x8000000000000810L,0x0000000000002000L});
    public static final BitSet FOLLOW_condition_in_conditionNot4926 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NOT_in_conditionNot4933 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionNot4935 = new BitSet(new long[]{0xF80000007FFFF100L,0x8000000000000810L,0x0000000000002000L});
    public static final BitSet FOLLOW_condition_in_conditionNot4941 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionNot4943 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OR_in_conditionOr4982 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionOr4984 = new BitSet(new long[]{0xF80000007FFFF100L,0x8000000000000810L,0x0000000000002000L});
    public static final BitSet FOLLOW_conditions_in_conditionOr4990 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionOr4992 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PARTOF_in_conditionPartOf5022 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionPartOf5024 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_typeExpression_in_conditionPartOf5031 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_typeListExpression_in_conditionPartOf5037 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionPartOf5040 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PARTOFNEQ_in_conditionPartOfNeq5070 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionPartOfNeq5072 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_typeExpression_in_conditionPartOfNeq5079 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_typeListExpression_in_conditionPartOfNeq5085 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionPartOfNeq5088 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_POSITION_in_conditionPosition5122 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionPosition5124 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_conditionPosition5130 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionPosition5132 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionPosition5138 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionPosition5141 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_conditionPosition5147 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionPosition5151 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REGEXP_in_conditionRegExp5181 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionRegExp5183 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_variable_in_conditionRegExp5190 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionRegExp5192 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_conditionRegExp5200 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionRegExp5203 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_conditionRegExp5209 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionRegExp5213 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SCORE_in_conditionScore5248 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionScore5250 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionScore5256 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionScore5259 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionScore5265 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionScore5272 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000002000L});
    public static final BitSet FOLLOW_numberVariable_in_conditionScore5278 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionScore5285 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VOTE_in_conditionVote5320 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionVote5322 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_conditionVote5328 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionVote5330 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_conditionVote5336 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionVote5338 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IF_in_conditionIf5376 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionIf5378 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_conditionIf5384 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionIf5386 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FEATURE_in_conditionFeature5420 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionFeature5422 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_conditionFeature5428 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionFeature5430 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_conditionFeature5436 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionFeature5438 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PARSE_in_conditionParse5472 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionParse5474 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_conditionParse5482 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionParse5484 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IS_in_conditionIs5515 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionIs5517 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_typeExpression_in_conditionIs5524 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_typeListExpression_in_conditionIs5530 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionIs5533 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BEFORE_in_conditionBefore5564 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionBefore5566 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_typeExpression_in_conditionBefore5573 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_typeListExpression_in_conditionBefore5579 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionBefore5582 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_AFTER_in_conditionAfter5613 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionAfter5615 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_typeExpression_in_conditionAfter5622 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_typeListExpression_in_conditionAfter5628 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionAfter5631 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STARTSWITH_in_conditionStartsWith5662 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionStartsWith5664 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_typeExpression_in_conditionStartsWith5671 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_typeListExpression_in_conditionStartsWith5677 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionStartsWith5680 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ENDSWITH_in_conditionEndsWith5711 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionEndsWith5713 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_typeExpression_in_conditionEndsWith5720 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_typeListExpression_in_conditionEndsWith5726 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionEndsWith5729 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SIZE_in_conditionSize5760 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_conditionSize5762 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_listExpression_in_conditionSize5768 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionSize5771 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionSize5777 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_conditionSize5779 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_conditionSize5785 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_conditionSize5790 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000002000L});
    public static final BitSet FOLLOW_numberVariable_in_conditionSize5796 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_conditionSize5800 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionColor_in_action5833 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionDel_in_action5842 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionLog_in_action5851 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionMark_in_action5860 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionMarkScore_in_action5869 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionMarkFast_in_action5878 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionMarkLast_in_action5887 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionReplace_in_action5896 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionFilterType_in_action5905 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionRetainType_in_action5914 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionCreate_in_action5923 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionFill_in_action5932 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionCall_in_action5941 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionAssign_in_action5950 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionSetFeature_in_action5959 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionGetFeature_in_action5968 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionUnmark_in_action5977 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionUnmarkAll_in_action5986 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionTransfer_in_action5995 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionMarkOnce_in_action6004 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionTrie_in_action6013 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionGather_in_action6022 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionExec_in_action6031 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionMarkTable_in_action6040 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionAdd_in_action6049 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionRemove_in_action6058 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionRemoveDuplicate_in_action6067 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionMerge_in_action6076 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionGet_in_action6085 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionGetList_in_action6094 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionMatchedText_in_action6103 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionClear_in_action6112 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionShift_in_action6121 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionConfigure_in_action6130 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionDynamicAnchoring_in_action6139 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionTrim_in_action6148 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionAddRetainType_in_action6158 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionRemoveRetainType_in_action6167 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionAddFilterType_in_action6176 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_actionRemoveFilterType_in_action6185 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_externalAction_in_action6203 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_externalAction6243 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_externalAction6245 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002003L});
    public static final BitSet FOLLOW_varArgumentList_in_externalAction6251 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_externalAction6254 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CREATE_in_actionCreate6290 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionCreate6292 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionCreate6298 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionCreate6305 = new BitSet(new long[]{0x0000000000000000L,0x82440F8000002000L,0x0000000000002003L});
    public static final BitSet FOLLOW_numberExpression_in_actionCreate6330 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionCreate6347 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionCreate6353 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionCreate6360 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L,0x0000000000000002L});
    public static final BitSet FOLLOW_stringExpression_in_actionCreate6373 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_actionCreate6375 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_actionCreate6381 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionCreate6391 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionCreate6397 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_actionCreate6399 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_actionCreate6405 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionCreate6420 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MARKTABLE_in_actionMarkTable6461 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionMarkTable6463 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionMarkTable6474 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkTable6476 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionMarkTable6487 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkTable6489 = new BitSet(new long[]{0x0000000000000000L,0x8400000000000000L});
    public static final BitSet FOLLOW_wordTableExpression_in_actionMarkTable6499 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkTable6506 = new BitSet(new long[]{0x0000000000000000L,0x8200700000002000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_actionMarkTable6522 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkTable6529 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionMarkTable6535 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkTable6542 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionMarkTable6548 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkTable6554 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionMarkTable6560 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkTable6562 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionMarkTable6575 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_actionMarkTable6577 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionMarkTable6583 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkTable6593 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionMarkTable6599 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_actionMarkTable6601 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionMarkTable6607 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionMarkTable6618 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_GATHER_in_actionGather6661 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionGather6663 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionGather6669 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionGather6676 = new BitSet(new long[]{0x0000000000000000L,0x82440F8000002000L,0x0000000000002003L});
    public static final BitSet FOLLOW_numberExpression_in_actionGather6696 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionGather6712 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionGather6718 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionGather6725 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L,0x0000000000000002L});
    public static final BitSet FOLLOW_stringExpression_in_actionGather6738 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_actionGather6740 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002011L});
    public static final BitSet FOLLOW_numberExpression_in_actionGather6747 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_numberListExpression_in_actionGather6755 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionGather6766 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionGather6772 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_actionGather6774 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002011L});
    public static final BitSet FOLLOW_numberExpression_in_actionGather6781 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_numberListExpression_in_actionGather6789 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionGather6805 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FILL_in_actionFill6847 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionFill6849 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionFill6855 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionFill6858 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionFill6864 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_actionFill6866 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_actionFill6883 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionFill6900 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COLOR_in_actionColor6938 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionColor6940 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionColor6946 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionColor6958 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionColor6969 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionColor6977 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionColor6987 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionColor6995 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_actionColor7005 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionColor7015 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DEL_in_actionDel7049 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LOG_in_actionLog7091 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionLog7093 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionLog7099 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionLog7102 = new BitSet(new long[]{0x0000000000000000L,0x0000000000010000L});
    public static final BitSet FOLLOW_LogLevel_in_actionLog7108 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionLog7112 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MARK_in_actionMark7151 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionMark7153 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionMark7164 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionMark7180 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionMark7196 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionMark7220 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SHIFT_in_actionShift7264 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionShift7266 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionShift7277 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionShift7293 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionShift7309 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionShift7333 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MARKSCORE_in_actionMarkScore7378 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionMarkScore7380 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionMarkScore7391 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkScore7393 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionMarkScore7403 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkScore7419 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionMarkScore7435 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionMarkScore7459 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MARKONCE_in_actionMarkOnce7503 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionMarkOnce7505 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionMarkOnce7522 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkOnce7524 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionMarkOnce7542 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkOnce7558 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionMarkOnce7574 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionMarkOnce7593 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MARKFAST_in_actionMarkFast7632 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionMarkFast7634 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionMarkFast7640 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkFast7642 = new BitSet(new long[]{0x0000000000000000L,0x8400000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_wordListExpression_in_actionMarkFast7649 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_stringListExpression_in_actionMarkFast7657 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkFast7666 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_actionMarkFast7672 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkFast7675 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionMarkFast7681 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionMarkFast7684 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_actionMarkFast7690 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionMarkFast7698 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MARKLAST_in_actionMarkLast7732 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionMarkLast7734 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionMarkLast7740 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionMarkLast7742 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REPLACE_in_actionReplace7776 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionReplace7778 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionReplace7784 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionReplace7786 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RETAINTYPE_in_actionRetainType7833 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionRetainType7836 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionRetainType7842 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionRetainType7847 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionRetainType7853 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionRetainType7859 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FILTERTYPE_in_actionFilterType7910 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionFilterType7913 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionFilterType7919 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionFilterType7924 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionFilterType7930 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionFilterType7936 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CALL_in_actionCall7976 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionCall7978 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_dottedIdentifier_in_actionCall7984 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionCall7986 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CONFIGURE_in_actionConfigure8024 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionConfigure8026 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_dottedIdentifier_in_actionConfigure8032 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionConfigure8039 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionConfigure8049 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_actionConfigure8051 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_actionConfigure8057 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionConfigure8067 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionConfigure8073 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_actionConfigure8075 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_actionConfigure8081 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionConfigure8091 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EXEC_in_actionExec8123 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionExec8125 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_dottedIdentifier_in_actionExec8131 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionExec8134 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_typeListExpression_in_actionExec8140 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionExec8144 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ASSIGN_in_actionAssign8187 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionAssign8189 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_actionAssign8216 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionAssign8218 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionAssign8224 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_actionAssign8262 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionAssign8264 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_actionAssign8270 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_actionAssign8308 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionAssign8310 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionAssign8316 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_actionAssign8354 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionAssign8356 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionAssign8362 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_actionAssign8401 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionAssign8403 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionAssign8409 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_actionAssign8447 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionAssign8449 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionAssign8455 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionAssign8474 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SETFEATURE_in_actionSetFeature8506 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionSetFeature8508 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionSetFeature8514 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionSetFeature8516 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_actionSetFeature8522 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionSetFeature8524 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_GETFEATURE_in_actionGetFeature8563 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionGetFeature8565 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionGetFeature8571 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionGetFeature8573 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_variable_in_actionGetFeature8579 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionGetFeature8581 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DYNAMICANCHORING_in_actionDynamicAnchoring8617 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionDynamicAnchoring8619 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_actionDynamicAnchoring8625 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionDynamicAnchoring8633 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionDynamicAnchoring8639 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionDynamicAnchoring8647 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionDynamicAnchoring8653 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionDynamicAnchoring8670 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRIM_in_actionTrim8704 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionTrim8706 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_typeListExpression_in_actionTrim8723 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_typeExpression_in_actionTrim8739 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionTrim8744 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionTrim8750 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionTrim8777 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_UNMARK_in_actionUnmark8813 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionUnmark8815 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionUnmark8831 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionUnmark8840 = new BitSet(new long[]{0x0000000000000000L,0x80447F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_booleanExpression_in_actionUnmark8865 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_numberExpression_in_actionUnmark8884 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionUnmark8893 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionUnmark8899 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionUnmark8936 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_UNMARKALL_in_actionUnmarkAll8972 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionUnmarkAll8974 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionUnmarkAll8980 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionUnmarkAll8988 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_typeListExpression_in_actionUnmarkAll8994 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionUnmarkAll8998 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRANSFER_in_actionTransfer9033 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionTransfer9035 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionTransfer9041 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionTransfer9043 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRIE_in_actionTrie9083 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionTrie9085 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionTrie9095 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_actionTrie9097 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionTrie9103 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionTrie9111 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionTrie9117 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_actionTrie9119 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionTrie9125 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionTrie9135 = new BitSet(new long[]{0x0000000000000000L,0x8400000000000000L});
    public static final BitSet FOLLOW_wordListExpression_in_actionTrie9141 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionTrie9148 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_actionTrie9154 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionTrie9161 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionTrie9167 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionTrie9174 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_actionTrie9180 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionTrie9187 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionTrie9193 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionTrie9200 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionTrie9206 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionTrie9212 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ADD_in_actionAdd9257 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionAdd9259 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_listVariable_in_actionAdd9265 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionAdd9268 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_actionAdd9274 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionAdd9280 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REMOVE_in_actionRemove9320 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionRemove9322 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_listVariable_in_actionRemove9328 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionRemove9331 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_actionRemove9337 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionRemove9343 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REMOVEDUPLICATE_in_actionRemoveDuplicate9379 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionRemoveDuplicate9381 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_listVariable_in_actionRemoveDuplicate9387 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionRemoveDuplicate9389 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MERGE_in_actionMerge9434 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionMerge9436 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_actionMerge9442 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMerge9444 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_listVariable_in_actionMerge9450 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMerge9452 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_listExpression_in_actionMerge9458 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionMerge9463 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_listExpression_in_actionMerge9469 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionMerge9475 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_GET_in_actionGet9510 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionGet9512 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_listExpression_in_actionGet9518 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionGet9520 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_variable_in_actionGet9526 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionGet9528 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionGet9534 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionGet9536 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_GETLIST_in_actionGetList9571 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionGetList9573 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_listVariable_in_actionGetList9579 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_actionGetList9581 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_actionGetList9587 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionGetList9589 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MATCHEDTEXT_in_actionMatchedText9628 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionMatchedText9630 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_variable_in_actionMatchedText9641 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionMatchedText9657 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_actionMatchedText9663 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionMatchedText9687 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CLEAR_in_actionClear9727 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionClear9729 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_listVariable_in_actionClear9735 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_actionClear9737 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ADDRETAINTYPE_in_actionAddRetainType9773 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionAddRetainType9776 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionAddRetainType9782 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionAddRetainType9787 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionAddRetainType9793 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionAddRetainType9799 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REMOVERETAINTYPE_in_actionRemoveRetainType9841 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionRemoveRetainType9844 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionRemoveRetainType9850 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionRemoveRetainType9855 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionRemoveRetainType9861 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionRemoveRetainType9867 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ADDFILTERTYPE_in_actionAddFilterType9907 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionAddFilterType9910 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionAddFilterType9916 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionAddFilterType9921 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionAddFilterType9927 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionAddFilterType9933 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REMOVEFILTERTYPE_in_actionRemoveFilterType9973 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_actionRemoveFilterType9976 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionRemoveFilterType9982 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_actionRemoveFilterType9987 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_actionRemoveFilterType9993 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_actionRemoveFilterType9999 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_argument_in_varArgumentList10034 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_varArgumentList10038 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_varArgumentList10044 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_stringExpression_in_argument10080 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanExpression_in_argument10091 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numberExpression_in_argument10102 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeExpression_in_argument10113 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_dottedIdentifier10147 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000100L});
    public static final BitSet FOLLOW_DOT_in_dottedIdentifier10160 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_dottedIdentifier10170 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000100L});
    public static final BitSet FOLLOW_Identifier_in_dottedIdentifier210196 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000002100L});
    public static final BitSet FOLLOW_set_in_dottedIdentifier210209 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_dottedIdentifier210223 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000002100L});
    public static final BitSet FOLLOW_Identifier_in_dottedId10255 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000100L});
    public static final BitSet FOLLOW_DOT_in_dottedId10268 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_Identifier_in_dottedId10278 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000100L});
    public static final BitSet FOLLOW_dottedId_in_annotationType10311 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_wordListExpression10336 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RessourceLiteral_in_wordListExpression10349 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_wordTableExpression10373 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RessourceLiteral_in_wordTableExpression10386 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_numberFunction10409 = new BitSet(new long[]{0x0000000000000000L,0x8044000000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpressionInPar_in_numberFunction10431 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_externalNumberFunction_in_numberFunction10455 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_externalNumberFunction10481 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_externalNumberFunction10483 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002003L});
    public static final BitSet FOLLOW_varArgumentList_in_externalNumberFunction10490 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_externalNumberFunction10493 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_numberVariable10518 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_numberVariable10531 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_numberVariable10544 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_additiveExpression10574 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000003000L});
    public static final BitSet FOLLOW_set_in_additiveExpression10583 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_additiveExpression10596 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000003000L});
    public static final BitSet FOLLOW_simpleNumberExpression_in_multiplicativeExpression10629 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x000000000020C000L});
    public static final BitSet FOLLOW_set_in_multiplicativeExpression10638 = new BitSet(new long[]{0x0000000000000000L,0x8044000000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_simpleNumberExpression_in_multiplicativeExpression10657 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x000000000020C000L});
    public static final BitSet FOLLOW_numberFunction_in_multiplicativeExpression10675 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_additiveExpression_in_numberExpression10698 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_numberExpressionInPar10716 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_additiveExpression_in_numberExpressionInPar10723 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_numberExpressionInPar10725 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_simpleNumberExpression10748 = new BitSet(new long[]{0x0000000000000000L,0x0004000000000000L});
    public static final BitSet FOLLOW_DecimalLiteral_in_simpleNumberExpression10755 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_simpleNumberExpression10769 = new BitSet(new long[]{0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_FloatingPointLiteral_in_simpleNumberExpression10776 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_simpleNumberExpression10787 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000002000L});
    public static final BitSet FOLLOW_numberVariable_in_simpleNumberExpression10794 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numberExpressionInPar_in_simpleNumberExpression10805 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleStringExpression_in_stringExpression10845 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_PLUS_in_stringExpression10852 = new BitSet(new long[]{0x0000000000000000L,0x8244600000000000L,0x0000000000002011L});
    public static final BitSet FOLLOW_simpleStringExpression_in_stringExpression10859 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_numberExpressionInPar_in_stringExpression10872 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_simpleBooleanExpression_in_stringExpression10884 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_typeExpression_in_stringExpression10896 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_listExpression_in_stringExpression10908 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_stringFunction_in_stringExpression10936 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REMOVESTRING_in_stringFunction10963 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_stringFunction10965 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_variable_in_stringFunction10971 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_stringFunction10974 = new BitSet(new long[]{0x0000000000000000L,0x8200000000002000L});
    public static final BitSet FOLLOW_stringExpression_in_stringFunction10980 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_RPAREN_in_stringFunction10986 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_externalStringFunction_in_stringFunction11008 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_externalStringFunction11033 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_externalStringFunction11035 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002003L});
    public static final BitSet FOLLOW_varArgumentList_in_externalStringFunction11042 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_externalStringFunction11045 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_StringLiteral_in_simpleStringExpression11069 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_simpleStringExpression11083 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_composedBooleanExpression_in_booleanExpression11116 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleBooleanExpression_in_booleanExpression11127 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_literalBooleanExpression_in_simpleBooleanExpression11150 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_simpleBooleanExpression11165 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanCompare_in_composedBooleanExpression11199 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanTypeExpression_in_composedBooleanExpression11219 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanNumberExpression_in_composedBooleanExpression11238 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanFunction_in_composedBooleanExpression11248 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_XOR_in_booleanFunction11273 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_booleanFunction11275 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_booleanFunction11281 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_booleanFunction11283 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_booleanFunction11289 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_booleanFunction11291 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_externalBooleanFunction_in_booleanFunction11313 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_externalBooleanFunction11338 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_externalBooleanFunction11340 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002003L});
    public static final BitSet FOLLOW_varArgumentList_in_externalBooleanFunction11347 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_externalBooleanFunction11350 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_simpleBooleanExpression_in_booleanCompare11375 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000001800000L});
    public static final BitSet FOLLOW_set_in_booleanCompare11381 = new BitSet(new long[]{0x0000000000000000L,0x8000700000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_booleanExpression_in_booleanCompare11393 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRUE_in_literalBooleanExpression11419 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FALSE_in_literalBooleanExpression11431 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeExpression_in_booleanTypeExpression11457 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000001800000L});
    public static final BitSet FOLLOW_set_in_booleanTypeExpression11464 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L});
    public static final BitSet FOLLOW_typeExpression_in_booleanTypeExpression11477 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_booleanNumberExpression11499 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_booleanNumberExpression11506 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x000000000D8C0000L});
    public static final BitSet FOLLOW_set_in_booleanNumberExpression11513 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_booleanNumberExpression11542 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_booleanNumberExpression11545 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_regexpRule_in_synpred1_RutaParser1666 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numberExpression_in_synpred2_RutaParser1744 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_synpred2_RutaParser1746 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numberExpression_in_synpred3_RutaParser1792 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_ASSIGN_EQUAL_in_synpred3_RutaParser1794 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleElementComposed_in_synpred4_RutaParser1926 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleElementDisjunctive_in_synpred5_RutaParser1943 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleElementWildCard_in_synpred6_RutaParser1961 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanListExpression_in_synpred11_RutaParser2695 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_intListExpression_in_synpred12_RutaParser2711 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_doubleListExpression_in_synpred13_RutaParser2727 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_floatListExpression_in_synpred14_RutaParser2743 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringListExpression_in_synpred15_RutaParser2759 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeListExpression_in_synpred16_RutaParser2775 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_doubleListExpression_in_synpred17_RutaParser2982 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_floatListExpression_in_synpred18_RutaParser3003 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeFunction_in_synpred19_RutaParser3411 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_externalCondition_in_synpred21_RutaParser3975 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COUNT_in_synpred22_RutaParser4312 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_LPAREN_in_synpred22_RutaParser4314 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_listExpression_in_synpred22_RutaParser4320 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_synpred22_RutaParser4322 = new BitSet(new long[]{0x0000000000000000L,0x82447F8000002000L,0x0000000000002001L});
    public static final BitSet FOLLOW_argument_in_synpred22_RutaParser4328 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_synpred22_RutaParser4331 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_synpred22_RutaParser4337 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000400L});
    public static final BitSet FOLLOW_COMMA_in_synpred22_RutaParser4339 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_synpred22_RutaParser4345 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000402L});
    public static final BitSet FOLLOW_COMMA_in_synpred22_RutaParser4355 = new BitSet(new long[]{0x0000000000000000L,0x8000000000000000L,0x0000000000002000L});
    public static final BitSet FOLLOW_numberVariable_in_synpred22_RutaParser4361 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_RPAREN_in_synpred22_RutaParser4365 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringListExpression_in_synpred23_RutaParser4639 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_externalAction_in_synpred24_RutaParser6195 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numberExpression_in_synpred25_RutaParser6323 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COMMA_in_synpred26_RutaParser6336 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_synpred26_RutaParser6342 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanExpression_in_synpred27_RutaParser6515 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numberExpression_in_synpred28_RutaParser6689 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COMMA_in_synpred29_RutaParser6702 = new BitSet(new long[]{0x0000000000000000L,0x80440F8000000000L,0x0000000000002001L});
    public static final BitSet FOLLOW_numberExpression_in_synpred29_RutaParser6708 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numberExpression_in_synpred33_RutaParser7513 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeExpression_in_synpred34_RutaParser7533 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanExpression_in_synpred36_RutaParser8857 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringExpression_in_synpred37_RutaParser10080 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanExpression_in_synpred38_RutaParser10091 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numberExpression_in_synpred39_RutaParser10102 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_externalNumberFunction_in_synpred40_RutaParser10447 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringFunction_in_synpred42_RutaParser10928 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_externalStringFunction_in_synpred43_RutaParser11000 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_composedBooleanExpression_in_synpred44_RutaParser11108 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanCompare_in_synpred45_RutaParser11191 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanTypeExpression_in_synpred46_RutaParser11211 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanNumberExpression_in_synpred47_RutaParser11230 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_externalBooleanFunction_in_synpred48_RutaParser11305 = new BitSet(new long[]{0x0000000000000002L});

}